import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as BookingMeta_c057_ from './booking-meta';
import * as Common_ffba_ from './components/common';
import * as Configurator_2e96_ from './components/configurator';
import * as Cost_250f_ from './components/cost';
import * as CustomerSelection_57c3_ from './components/customerSelection';
import * as Fare_a3ab_ from './components/fare';
import * as State_2db3_ from './components/state';
import * as StateLog_4daf_ from './components/state-log';
import * as Terms_bb95_ from './components/terms';
import * as Units_c404_ from './components/units';
import * as Customer_c745_ from './customer';
import * as Leg_1308_ from './leg';
import * as Product_d23e_ from './product';
export type NullBrand = {
    readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export declare const Null: NullC;
export type Null = t.TypeOf<typeof Null>;
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/booking.json";
export type Id = t.Branded<Units_c404_.Uuid, IdBrand>;
export type IdC = t.BrandC<typeof Units_c404_.Uuid, IdBrand>;
export declare const Id: IdC;
export type IdBrand = {
    readonly Id: unique symbol;
};
export type Fares = t.Branded<Array<Fare_a3ab_.Fare>, FaresBrand>;
export type FaresC = t.BrandC<t.ArrayC<typeof Fare_a3ab_.Fare>, FaresBrand>;
export declare const Fares: FaresC;
export type FaresBrand = {
    readonly Fares: unique symbol;
};
export type Cost = t.Branded<Cost_250f_.Cost, CostBrand>;
export type CostC = t.BrandC<typeof Cost_250f_.Cost, CostBrand>;
export declare const Cost: CostC;
export type CostBrand = {
    readonly Cost: unique symbol;
};
export type Configurator = t.Branded<Configurator_2e96_.Configurator, ConfiguratorBrand>;
export type ConfiguratorC = t.BrandC<typeof Configurator_2e96_.Configurator, ConfiguratorBrand>;
export declare const Configurator: ConfiguratorC;
export type ConfiguratorBrand = {
    readonly Configurator: unique symbol;
};
export type TspId = t.Branded<string, TspIdBrand>;
export type TspIdC = t.BrandC<t.StringC, TspIdBrand>;
export declare const TspId: TspIdC;
export type TspIdBrand = {
    readonly TspId: unique symbol;
};
export type Leg = t.Branded<{
    signature?: Common_ffba_.Signature;
    state?: Leg_1308_.State;
    from?: Leg_1308_.From;
    to?: Leg_1308_.To;
    startTime?: Leg_1308_.StartTime;
    endTime?: Leg_1308_.EndTime;
    mode?: Leg_1308_.Mode;
    stops?: Leg_1308_.Stops;
    departureDelay?: Leg_1308_.DepartureDelay;
    arrivalDelay?: Leg_1308_.ArrivalDelay;
    distance?: Leg_1308_.Distance;
    route?: Leg_1308_.Route;
    routeShortName?: Leg_1308_.RouteShortName;
    routeLongName?: Leg_1308_.RouteLongName;
    agencyId?: Leg_1308_.AgencyId;
    legGeometry?: Leg_1308_.LegGeometry;
    tspProduct?: Leg_1308_.TspProduct;
    productOption?: Leg_1308_.ProductOption;
}, LegBrand>;
export type LegC = t.BrandC<t.PartialC<{
    signature: typeof Common_ffba_.Signature;
    state: typeof Leg_1308_.State;
    from: typeof Leg_1308_.From;
    to: typeof Leg_1308_.To;
    startTime: typeof Leg_1308_.StartTime;
    endTime: typeof Leg_1308_.EndTime;
    mode: typeof Leg_1308_.Mode;
    stops: typeof Leg_1308_.Stops;
    departureDelay: typeof Leg_1308_.DepartureDelay;
    arrivalDelay: typeof Leg_1308_.ArrivalDelay;
    distance: typeof Leg_1308_.Distance;
    route: typeof Leg_1308_.Route;
    routeShortName: typeof Leg_1308_.RouteShortName;
    routeLongName: typeof Leg_1308_.RouteLongName;
    agencyId: typeof Leg_1308_.AgencyId;
    legGeometry: typeof Leg_1308_.LegGeometry;
    tspProduct: typeof Leg_1308_.TspProduct;
    productOption: typeof Leg_1308_.ProductOption;
}>, LegBrand>;
export declare const Leg: LegC;
export type LegBrand = {
    readonly Leg: unique symbol;
};
export type Terms = t.Branded<Terms_bb95_.Terms, TermsBrand>;
export type TermsC = t.BrandC<typeof Terms_bb95_.Terms, TermsBrand>;
export declare const Terms: TermsC;
export type TermsBrand = {
    readonly Terms: unique symbol;
};
export type Token = t.Branded<{
    validityDuration?: {
        startTime?: Units_c404_.Time;
        endTime?: Units_c404_.Time;
    } & Record<string, unknown>;
    data?: Record<string, unknown> & Record<string, unknown>;
    meta?: Record<string, unknown> & Record<string, unknown>;
} & Record<string, unknown>, TokenBrand>;
export type TokenC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        validityDuration: t.IntersectionC<[
            t.PartialC<{
                startTime: typeof Units_c404_.Time;
                endTime: typeof Units_c404_.Time;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        data: t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>;
        meta: t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, TokenBrand>;
export declare const Token: TokenC;
export type TokenBrand = {
    readonly Token: unique symbol;
};
export type Booking = t.Branded<({
    id?: Id;
    tspId?: TspId | Null;
    state?: State_2db3_.BookingState;
    stateLog?: StateLog_4daf_.StateLog;
    fares?: Fares;
    cost?: Cost | Null;
    leg?: Leg;
    token?: Token;
    meta?: BookingMeta_c057_.BookingMeta;
    terms?: Terms;
    unmodifiedTerms?: Terms;
    customer?: Customer_c745_.Customer & (Record<string, unknown> & Record<string, unknown> & {
        identityId: Defined;
    });
    product?: Product_d23e_.Product;
    signature?: Common_ffba_.Signature;
    configurator?: Configurator;
    customerSelection?: CustomerSelection_57c3_.CustomerSelection;
} & Record<string, unknown>) & {
    id: Defined;
    state: Defined;
    leg: Defined;
    meta: Defined;
    terms: Defined;
    token: Defined;
    customer: Defined;
}, BookingBrand>;
export type BookingC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: typeof Id;
            tspId: t.UnionC<[typeof TspId, typeof Null]>;
            state: typeof State_2db3_.BookingState;
            stateLog: typeof StateLog_4daf_.StateLog;
            fares: typeof Fares;
            cost: t.UnionC<[typeof Cost, typeof Null]>;
            leg: typeof Leg;
            token: typeof Token;
            meta: typeof BookingMeta_c057_.BookingMeta;
            terms: typeof Terms;
            unmodifiedTerms: typeof Terms;
            customer: t.IntersectionC<[
                typeof Customer_c745_.Customer,
                t.IntersectionC<[
                    t.UnknownRecordC,
                    t.RecordC<t.StringC, t.UnknownC>,
                    t.TypeC<{
                        identityId: typeof Defined;
                    }>
                ]>
            ]>;
            product: typeof Product_d23e_.Product;
            signature: typeof Common_ffba_.Signature;
            configurator: typeof Configurator;
            customerSelection: typeof CustomerSelection_57c3_.CustomerSelection;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
        state: typeof Defined;
        leg: typeof Defined;
        meta: typeof Defined;
        terms: typeof Defined;
        token: typeof Defined;
        customer: typeof Defined;
    }>
]>, BookingBrand>;
export declare const Booking: BookingC;
export type BookingBrand = {
    readonly Booking: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Booking)).decodeSync(examplesBooking) // => examplesBooking */
export declare const examplesBooking: NonEmptyArray<Booking>;
export default Booking;
