import * as t from 'io-ts';
import * as Address_2d0a_ from './components/address';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/card.json";
export type Card = t.Branded<{
    issuer?: string;
    network?: string;
    expiryMonth?: number;
    expiryYear?: number;
    maskedNumber?: string;
    fundingType?: string & ('credit' | 'debit' | 'prepaid' | 'not_known' | 'not_applicable');
    billingCity?: Address_2d0a_.City;
    billingCountry?: Address_2d0a_.Country;
    billingZip?: Address_2d0a_.ZipCode;
} & {
    id: Defined;
    customerId: Defined;
    status: Defined;
    valid: Defined;
}, CardBrand>;
export type CardC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        issuer: t.StringC;
        network: t.StringC;
        expiryMonth: t.NumberC;
        expiryYear: t.NumberC;
        maskedNumber: t.StringC;
        fundingType: t.IntersectionC<[
            t.StringC,
            t.UnionC<[
                t.LiteralC<'credit'>,
                t.LiteralC<'debit'>,
                t.LiteralC<'prepaid'>,
                t.LiteralC<'not_known'>,
                t.LiteralC<'not_applicable'>
            ]>
        ]>;
        billingCity: typeof Address_2d0a_.City;
        billingCountry: typeof Address_2d0a_.Country;
        billingZip: typeof Address_2d0a_.ZipCode;
    }>,
    t.TypeC<{
        id: typeof Defined;
        customerId: typeof Defined;
        status: typeof Defined;
        valid: typeof Defined;
    }>
]>, CardBrand>;
export declare const Card: CardC;
export type CardBrand = {
    readonly Card: unique symbol;
};
export default Card;
