import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Common_ffba_ from './common';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/address.json";
export type ComponentAddress = t.Branded<string, ComponentAddressBrand>;
export type ComponentAddressC = t.BrandC<t.StringC, ComponentAddressBrand>;
export declare const ComponentAddress: ComponentAddressC;
export type ComponentAddressBrand = {
    readonly ComponentAddress: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ComponentAddress)).decodeSync(examplesComponentAddress) // => examplesComponentAddress */
export declare const examplesComponentAddress: NonEmptyArray<ComponentAddress>;
/** require('io-ts-validator').validator(ComponentAddress).decodeEither("💩")._tag // => 'Left' */
export type PlaceId = t.Branded<string, PlaceIdBrand>;
export type PlaceIdC = t.BrandC<t.StringC, PlaceIdBrand>;
export declare const PlaceId: PlaceIdC;
export type PlaceIdBrand = {
    readonly PlaceId: unique symbol;
};
export type StreetName = t.Branded<string, StreetNameBrand>;
export type StreetNameC = t.BrandC<t.StringC, StreetNameBrand>;
export declare const StreetName: StreetNameC;
export type StreetNameBrand = {
    readonly StreetName: unique symbol;
};
export type City = t.Branded<string, CityBrand>;
export type CityC = t.BrandC<t.StringC, CityBrand>;
export declare const City: CityC;
export type CityBrand = {
    readonly City: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(City)).decodeSync(examplesCity) // => examplesCity */
export declare const examplesCity: NonEmptyArray<City>;
/** require('io-ts-validator').validator(City).decodeEither("")._tag // => 'Left' */
export type State = t.Branded<string, StateBrand>;
export type StateC = t.BrandC<t.StringC, StateBrand>;
export declare const State: StateC;
export type StateBrand = {
    readonly State: unique symbol;
};
export type ZipCode = t.Branded<string, ZipCodeBrand>;
export type ZipCodeC = t.BrandC<t.StringC, ZipCodeBrand>;
export declare const ZipCode: ZipCodeC;
export type ZipCodeBrand = {
    readonly ZipCode: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ZipCode)).decodeSync(examplesZipCode) // => examplesZipCode */
export declare const examplesZipCode: NonEmptyArray<ZipCode>;
/** require('io-ts-validator').validator(ZipCode).decodeEither("")._tag // => 'Left' */
/** require('io-ts-validator').validator(ZipCode).decodeEither("a")._tag // => 'Left' */
export type Country = t.Branded<string, CountryBrand>;
export type CountryC = t.BrandC<t.StringC, CountryBrand>;
export declare const Country: CountryC;
export type CountryBrand = {
    readonly Country: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Country)).decodeSync(examplesCountry) // => examplesCountry */
export declare const examplesCountry: NonEmptyArray<Country>;
/** require('io-ts-validator').validator(Country).decodeEither("")._tag // => 'Left' */
/** require('io-ts-validator').validator(Country).decodeEither("💩")._tag // => 'Left' */
/** require('io-ts-validator').validator(Country).decodeEither("fi")._tag // => 'Left' */
/** require('io-ts-validator').validator(Country).decodeEither("FIN")._tag // => 'Left' */
export type StreetNumber = t.Branded<string, StreetNumberBrand>;
export type StreetNumberC = t.BrandC<t.StringC, StreetNumberBrand>;
export declare const StreetNumber: StreetNumberC;
export type StreetNumberBrand = {
    readonly StreetNumber: unique symbol;
};
export type Ward = t.Branded<string, WardBrand>;
export type WardC = t.BrandC<t.StringC, WardBrand>;
export declare const Ward: WardC;
export type WardBrand = {
    readonly Ward: unique symbol;
};
export type District = t.Branded<string, DistrictBrand>;
export type DistrictC = t.BrandC<t.StringC, DistrictBrand>;
export declare const District: DistrictC;
export type DistrictBrand = {
    readonly District: unique symbol;
};
export type ComponentAddressObject = t.Branded<{
    id?: PlaceId;
    streetName?: StreetName;
    city?: City;
    state?: State;
    zipCode?: ZipCode;
    country?: Country;
    streetNumber?: StreetNumber;
    ward?: Ward;
    district?: District;
} & {
    streetName: Defined;
    streetNumber: Defined;
    zipCode: Defined;
}, ComponentAddressObjectBrand>;
export type ComponentAddressObjectC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof PlaceId;
        streetName: typeof StreetName;
        city: typeof City;
        state: typeof State;
        zipCode: typeof ZipCode;
        country: typeof Country;
        streetNumber: typeof StreetNumber;
        ward: typeof Ward;
        district: typeof District;
    }>,
    t.TypeC<{
        streetName: typeof Defined;
        streetNumber: typeof Defined;
        zipCode: typeof Defined;
    }>
]>, ComponentAddressObjectBrand>;
export declare const ComponentAddressObject: ComponentAddressObjectC;
export type ComponentAddressObjectBrand = {
    readonly ComponentAddressObject: unique symbol;
};
export type PlaceName = t.Branded<string, PlaceNameBrand>;
export type PlaceNameC = t.BrandC<t.StringC, PlaceNameBrand>;
export declare const PlaceName: PlaceNameC;
export type PlaceNameBrand = {
    readonly PlaceName: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(PlaceName)).decodeSync(examplesPlaceName) // => examplesPlaceName */
export declare const examplesPlaceName: NonEmptyArray<PlaceName>;
/** require('io-ts-validator').validator(PlaceName).decodeEither("")._tag // => 'Left' */
export type FirstName = t.Branded<Common_ffba_.PersonalName, FirstNameBrand>;
export type FirstNameC = t.BrandC<typeof Common_ffba_.PersonalName, FirstNameBrand>;
export declare const FirstName: FirstNameC;
export type FirstNameBrand = {
    readonly FirstName: unique symbol;
};
export type LastName = t.Branded<Common_ffba_.PersonalName, LastNameBrand>;
export type LastNameC = t.BrandC<typeof Common_ffba_.PersonalName, LastNameBrand>;
export declare const LastName: LastNameC;
export type LastNameBrand = {
    readonly LastName: unique symbol;
};
export type Phone = t.Branded<Common_ffba_.Phone, PhoneBrand>;
export type PhoneC = t.BrandC<typeof Common_ffba_.Phone, PhoneBrand>;
export declare const Phone: PhoneC;
export type PhoneBrand = {
    readonly Phone: unique symbol;
};
export type Email = t.Branded<Common_ffba_.Email, EmailBrand>;
export type EmailC = t.BrandC<typeof Common_ffba_.Email, EmailBrand>;
export declare const Email: EmailC;
export type EmailBrand = {
    readonly Email: unique symbol;
};
export type Address = t.Branded<string, AddressBrand>;
export type AddressC = t.BrandC<t.StringC, AddressBrand>;
export declare const Address: AddressC;
export type AddressBrand = {
    readonly Address: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Address)).decodeSync(examplesAddress) // => examplesAddress */
export declare const examplesAddress: NonEmptyArray<Address>;
/** require('io-ts-validator').validator(Address).decodeEither("a")._tag // => 'Left' */
export type CountryName = t.Branded<string, CountryNameBrand>;
export type CountryNameC = t.BrandC<t.StringC, CountryNameBrand>;
export declare const CountryName: CountryNameC;
export type CountryNameBrand = {
    readonly CountryName: unique symbol;
};
