import * as t from 'io-ts';
import * as Units_c404_ from './units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/api-common.json";
export type AcceptHeader = t.Branded<string, AcceptHeaderBrand>;
export type AcceptHeaderC = t.BrandC<t.StringC, AcceptHeaderBrand>;
export declare const AcceptHeader: AcceptHeaderC;
export type AcceptHeaderBrand = {
    readonly AcceptHeader: unique symbol;
};
export type UserAgentHeader = t.Branded<string, UserAgentHeaderBrand>;
export type UserAgentHeaderC = t.BrandC<t.StringC, UserAgentHeaderBrand>;
export declare const UserAgentHeader: UserAgentHeaderC;
export type UserAgentHeaderBrand = {
    readonly UserAgentHeader: unique symbol;
};
export type Headers = t.Branded<{
    accept?: AcceptHeader;
    'x-maasglobal-user-agent'?: UserAgentHeader;
} & Record<string, unknown>, HeadersBrand>;
export type HeadersC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        accept: typeof AcceptHeader;
        'x-maasglobal-user-agent': typeof UserAgentHeader;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, HeadersBrand>;
export declare const Headers: HeadersC;
export type HeadersBrand = {
    readonly Headers: unique symbol;
};
export type AppInstanceIdHeader = t.Branded<string, AppInstanceIdHeaderBrand>;
export type AppInstanceIdHeaderC = t.BrandC<t.StringC, AppInstanceIdHeaderBrand>;
export declare const AppInstanceIdHeader: AppInstanceIdHeaderC;
export type AppInstanceIdHeaderBrand = {
    readonly AppInstanceIdHeader: unique symbol;
};
export type TenantHeader = t.Branded<string, TenantHeaderBrand>;
export type TenantHeaderC = t.BrandC<t.StringC, TenantHeaderBrand>;
export declare const TenantHeader: TenantHeaderC;
export type TenantHeaderBrand = {
    readonly TenantHeader: unique symbol;
};
export type StandardApiEndpointHeaders = t.Branded<({
    accept?: AcceptHeader;
    'x-maasglobal-user-agent'?: UserAgentHeader;
    'x-maasglobal-app-instance-id'?: AppInstanceIdHeader;
    'x-maasglobal-edge-tenant'?: TenantHeader;
} & Record<string, unknown>) & {
    accept: Defined;
    'x-maasglobal-user-agent': Defined;
    'x-maasglobal-app-instance-id': Defined;
    'x-maasglobal-edge-tenant': Defined;
}, StandardApiEndpointHeadersBrand>;
export type StandardApiEndpointHeadersC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            accept: typeof AcceptHeader;
            'x-maasglobal-user-agent': typeof UserAgentHeader;
            'x-maasglobal-app-instance-id': typeof AppInstanceIdHeader;
            'x-maasglobal-edge-tenant': typeof TenantHeader;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        accept: typeof Defined;
        'x-maasglobal-user-agent': typeof Defined;
        'x-maasglobal-app-instance-id': typeof Defined;
        'x-maasglobal-edge-tenant': typeof Defined;
    }>
]>, StandardApiEndpointHeadersBrand>;
export declare const StandardApiEndpointHeaders: StandardApiEndpointHeadersC;
export type StandardApiEndpointHeadersBrand = {
    readonly StandardApiEndpointHeaders: unique symbol;
};
export type ApiGatewayAuthorizedRequestContext = t.Branded<({
    requestId?: string;
    authorizer?: ({
        principalId?: Units_c404_.IdentityId;
    } & Record<string, unknown>) & {
        principalId: Defined;
    };
} & Record<string, unknown>) & {
    requestId: Defined;
    authorizer: Defined;
}, ApiGatewayAuthorizedRequestContextBrand>;
export type ApiGatewayAuthorizedRequestContextC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            requestId: t.StringC;
            authorizer: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        principalId: typeof Units_c404_.IdentityId;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    principalId: typeof Defined;
                }>
            ]>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        requestId: typeof Defined;
        authorizer: typeof Defined;
    }>
]>, ApiGatewayAuthorizedRequestContextBrand>;
export declare const ApiGatewayAuthorizedRequestContext: ApiGatewayAuthorizedRequestContextC;
export type ApiGatewayAuthorizedRequestContextBrand = {
    readonly ApiGatewayAuthorizedRequestContext: unique symbol;
};
export type ApiCommon = t.Branded<unknown, ApiCommonBrand>;
export type ApiCommonC = t.BrandC<t.UnknownC, ApiCommonBrand>;
export declare const ApiCommon: ApiCommonC;
export type ApiCommonBrand = {
    readonly ApiCommon: unique symbol;
};
export default ApiCommon;
