import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
export declare const schemaId = "https://schemas.maas.global/core/components/common.json";
export type AgencyId = t.Branded<string, AgencyIdBrand>;
export type AgencyIdC = t.BrandC<t.StringC, AgencyIdBrand>;
export declare const AgencyId: AgencyIdC;
export type AgencyIdBrand = {
    readonly AgencyId: unique symbol;
};
export type DeviceToken = t.Branded<string, DeviceTokenBrand>;
export type DeviceTokenC = t.BrandC<t.StringC, DeviceTokenBrand>;
export declare const DeviceToken: DeviceTokenC;
export type DeviceTokenBrand = {
    readonly DeviceToken: unique symbol;
};
export type Signature = t.Branded<string, SignatureBrand>;
export type SignatureC = t.BrandC<t.StringC, SignatureBrand>;
export declare const Signature: SignatureC;
export type SignatureBrand = {
    readonly Signature: unique symbol;
};
export type HtmlBlock = t.Branded<string, HtmlBlockBrand>;
export type HtmlBlockC = t.BrandC<t.StringC, HtmlBlockBrand>;
export declare const HtmlBlock: HtmlBlockC;
export type HtmlBlockBrand = {
    readonly HtmlBlock: unique symbol;
};
export type JsonParam = t.Branded<string, JsonParamBrand>;
export type JsonParamC = t.BrandC<t.StringC, JsonParamBrand>;
export declare const JsonParam: JsonParamC;
export type JsonParamBrand = {
    readonly JsonParam: unique symbol;
};
export type MetaCurrency = t.Branded<string & ('WMP' | 'TOKEN'), MetaCurrencyBrand>;
export type MetaCurrencyC = t.BrandC<t.IntersectionC<[t.StringC, t.UnionC<[t.LiteralC<'WMP'>, t.LiteralC<'TOKEN'>]>]>, MetaCurrencyBrand>;
export declare const MetaCurrency: MetaCurrencyC;
export type MetaCurrencyBrand = {
    readonly MetaCurrency: unique symbol;
};
export type MetaCurrencyWMP = t.Branded<MetaCurrency & 'WMP', MetaCurrencyWMPBrand>;
export type MetaCurrencyWMPC = t.BrandC<t.IntersectionC<[typeof MetaCurrency, t.LiteralC<'WMP'>]>, MetaCurrencyWMPBrand>;
export declare const MetaCurrencyWMP: MetaCurrencyWMPC;
export type MetaCurrencyWMPBrand = {
    readonly MetaCurrencyWMP: unique symbol;
};
/** require('io-ts-validator').validator(MetaCurrencyWMP).decodeSync(defaultMetaCurrencyWMP) // => defaultMetaCurrencyWMP */
export declare const defaultMetaCurrencyWMP: MetaCurrencyWMP;
export type MetaCurrencyTOKEN = t.Branded<MetaCurrency & 'TOKEN', MetaCurrencyTOKENBrand>;
export type MetaCurrencyTOKENC = t.BrandC<t.IntersectionC<[typeof MetaCurrency, t.LiteralC<'TOKEN'>]>, MetaCurrencyTOKENBrand>;
export declare const MetaCurrencyTOKEN: MetaCurrencyTOKENC;
export type MetaCurrencyTOKENBrand = {
    readonly MetaCurrencyTOKEN: unique symbol;
};
/** require('io-ts-validator').validator(MetaCurrencyTOKEN).decodeSync(defaultMetaCurrencyTOKEN) // => defaultMetaCurrencyTOKEN */
export declare const defaultMetaCurrencyTOKEN: MetaCurrencyTOKEN;
export type PersonalName = t.Branded<string, PersonalNameBrand>;
export type PersonalNameC = t.BrandC<t.StringC, PersonalNameBrand>;
export declare const PersonalName: PersonalNameC;
export type PersonalNameBrand = {
    readonly PersonalName: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(PersonalName)).decodeSync(examplesPersonalName) // => examplesPersonalName */
export declare const examplesPersonalName: NonEmptyArray<PersonalName>;
/** require('io-ts-validator').validator(PersonalName).decodeEither(123123)._tag // => 'Left' */
/** require('io-ts-validator').validator(PersonalName).decodeEither("123123")._tag // => 'Left' */
/** require('io-ts-validator').validator(PersonalName).decodeEither("+123123")._tag // => 'Left' */
/** require('io-ts-validator').validator(PersonalName).decodeEither("\"#\"€\"€#\"")._tag // => 'Left' */
/** require('io-ts-validator').validator(PersonalName).decodeEither("")._tag // => 'Left' */
/** require('io-ts-validator').validator(PersonalName).decodeEither("💩")._tag // => 'Left' */
export type Phone = t.Branded<string, PhoneBrand>;
export type PhoneC = t.BrandC<t.StringC, PhoneBrand>;
export declare const Phone: PhoneC;
export type PhoneBrand = {
    readonly Phone: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Phone)).decodeSync(examplesPhone) // => examplesPhone */
export declare const examplesPhone: NonEmptyArray<Phone>;
/** require('io-ts-validator').validator(Phone).decodeEither("358401234567")._tag // => 'Left' */
/** require('io-ts-validator').validator(Phone).decodeEither("💩")._tag // => 'Left' */
/** require('io-ts-validator').validator(Phone).decodeEither("")._tag // => 'Left' */
/** require('io-ts-validator').validator(Phone).decodeEither("sdfdsf")._tag // => 'Left' */
/** require('io-ts-validator').validator(Phone).decodeEither("+358123456789012345678")._tag // => 'Left' */
export type RawPhone = t.Branded<string, RawPhoneBrand>;
export type RawPhoneC = t.BrandC<t.StringC, RawPhoneBrand>;
export declare const RawPhone: RawPhoneC;
export type RawPhoneBrand = {
    readonly RawPhone: unique symbol;
};
export type LoosePhone = t.Branded<string, LoosePhoneBrand>;
export type LoosePhoneC = t.BrandC<t.StringC, LoosePhoneBrand>;
export declare const LoosePhone: LoosePhoneC;
export type LoosePhoneBrand = {
    readonly LoosePhone: unique symbol;
};
export type Email = t.Branded<string, EmailBrand>;
export type EmailC = t.BrandC<t.StringC, EmailBrand>;
export declare const Email: EmailC;
export type EmailBrand = {
    readonly Email: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Email)).decodeSync(examplesEmail) // => examplesEmail */
export declare const examplesEmail: NonEmptyArray<Email>;
export type PaymentSourceId = t.Branded<string, PaymentSourceIdBrand>;
export type PaymentSourceIdC = t.BrandC<t.StringC, PaymentSourceIdBrand>;
export declare const PaymentSourceId: PaymentSourceIdC;
export type PaymentSourceIdBrand = {
    readonly PaymentSourceId: unique symbol;
};
export type AppInstanceId = t.Branded<string, AppInstanceIdBrand>;
export type AppInstanceIdC = t.BrandC<t.StringC, AppInstanceIdBrand>;
export declare const AppInstanceId: AppInstanceIdC;
export type AppInstanceIdBrand = {
    readonly AppInstanceId: unique symbol;
};
export type OpaqueId = t.Branded<string, OpaqueIdBrand>;
export type OpaqueIdC = t.BrandC<t.StringC, OpaqueIdBrand>;
export declare const OpaqueId: OpaqueIdC;
export type OpaqueIdBrand = {
    readonly OpaqueId: unique symbol;
};
export type OpaqueIdShort = t.Branded<string, OpaqueIdShortBrand>;
export type OpaqueIdShortC = t.BrandC<t.StringC, OpaqueIdShortBrand>;
export declare const OpaqueIdShort: OpaqueIdShortC;
export type OpaqueIdShortBrand = {
    readonly OpaqueIdShort: unique symbol;
};
export type ClientId = t.Branded<string & ('whim' | 'wechat'), ClientIdBrand>;
export type ClientIdC = t.BrandC<t.IntersectionC<[t.StringC, t.UnionC<[t.LiteralC<'whim'>, t.LiteralC<'wechat'>]>]>, ClientIdBrand>;
export declare const ClientId: ClientIdC;
export type ClientIdBrand = {
    readonly ClientId: unique symbol;
};
export type ClientIdWHIM = t.Branded<ClientId & 'whim', ClientIdWHIMBrand>;
export type ClientIdWHIMC = t.BrandC<t.IntersectionC<[typeof ClientId, t.LiteralC<'whim'>]>, ClientIdWHIMBrand>;
export declare const ClientIdWHIM: ClientIdWHIMC;
export type ClientIdWHIMBrand = {
    readonly ClientIdWHIM: unique symbol;
};
/** require('io-ts-validator').validator(ClientIdWHIM).decodeSync(defaultClientIdWHIM) // => defaultClientIdWHIM */
export declare const defaultClientIdWHIM: ClientIdWHIM;
export type ClientIdWECHAT = t.Branded<ClientId & 'wechat', ClientIdWECHATBrand>;
export type ClientIdWECHATC = t.BrandC<t.IntersectionC<[typeof ClientId, t.LiteralC<'wechat'>]>, ClientIdWECHATBrand>;
export declare const ClientIdWECHAT: ClientIdWECHATC;
export type ClientIdWECHATBrand = {
    readonly ClientIdWECHAT: unique symbol;
};
/** require('io-ts-validator').validator(ClientIdWECHAT).decodeSync(defaultClientIdWECHAT) // => defaultClientIdWECHAT */
export declare const defaultClientIdWECHAT: ClientIdWECHAT;
export type Ssid = t.Branded<string, SsidBrand>;
export type SsidC = t.BrandC<t.StringC, SsidBrand>;
export declare const Ssid: SsidC;
export type SsidBrand = {
    readonly Ssid: unique symbol;
};
export type SsidFI = t.Branded<string, SsidFIBrand>;
export type SsidFIC = t.BrandC<t.StringC, SsidFIBrand>;
export declare const SsidFI: SsidFIC;
export type SsidFIBrand = {
    readonly SsidFI: unique symbol;
};
export type EncodedQueryParam = t.Branded<string, EncodedQueryParamBrand>;
export type EncodedQueryParamC = t.BrandC<t.StringC, EncodedQueryParamBrand>;
export declare const EncodedQueryParam: EncodedQueryParamC;
export type EncodedQueryParamBrand = {
    readonly EncodedQueryParam: unique symbol;
};
export type ErrorKey = t.Branded<string, ErrorKeyBrand>;
export type ErrorKeyC = t.BrandC<t.StringC, ErrorKeyBrand>;
export declare const ErrorKey: ErrorKeyC;
export type ErrorKeyBrand = {
    readonly ErrorKey: unique symbol;
};
export type WhimDeepLink = t.Branded<string, WhimDeepLinkBrand>;
export type WhimDeepLinkC = t.BrandC<t.StringC, WhimDeepLinkBrand>;
export declare const WhimDeepLink: WhimDeepLinkC;
export type WhimDeepLinkBrand = {
    readonly WhimDeepLink: unique symbol;
};
export type EmptyObject = t.Branded<{}, EmptyObjectBrand>;
export type EmptyObjectC = t.BrandC<t.PartialC<{}>, EmptyObjectBrand>;
export declare const EmptyObject: EmptyObjectC;
export type EmptyObjectBrand = {
    readonly EmptyObject: unique symbol;
};
export type Common = t.Branded<unknown, CommonBrand>;
export type CommonC = t.BrandC<t.UnknownC, CommonBrand>;
export declare const Common: CommonC;
export type CommonBrand = {
    readonly Common: unique symbol;
};
export default Common;
