import * as t from 'io-ts';
import * as BookingMeta_c057_ from '../booking-meta';
import * as Cost_250f_ from './cost';
import * as Fare_a3ab_ from './fare';
import * as Terms_bb95_ from './terms';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/configuratorCommon.json";
export type Choice = t.Branded<({
    id?: string;
    name?: string;
    description?: string;
    default?: boolean;
    cost?: Cost_250f_.Cost;
    fares?: Array<Fare_a3ab_.Fare>;
    terms?: Terms_bb95_.Terms;
    unmodifiedTerms?: Terms_bb95_.Terms;
    meta?: BookingMeta_c057_.BookingMeta;
} & Record<string, unknown>) & {
    id: Defined;
    name: Defined;
    default: Defined;
}, ChoiceBrand>;
export type ChoiceC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: t.StringC;
            name: t.StringC;
            description: t.StringC;
            default: t.BooleanC;
            cost: typeof Cost_250f_.Cost;
            fares: t.ArrayC<typeof Fare_a3ab_.Fare>;
            terms: typeof Terms_bb95_.Terms;
            unmodifiedTerms: typeof Terms_bb95_.Terms;
            meta: typeof BookingMeta_c057_.BookingMeta;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
        name: typeof Defined;
        default: typeof Defined;
    }>
]>, ChoiceBrand>;
export declare const Choice: ChoiceC;
export type ChoiceBrand = {
    readonly Choice: unique symbol;
};
export type Config = t.Branded<({
    type?: 'oneOf' | 'someOf' | 'allOf' | 'oneOrNoneOf' | 'someOrNoneOf';
    name?: string;
    description?: string;
    choices?: Array<Choice>;
} & Record<string, unknown>) & {
    type: Defined;
    name: Defined;
    choices: Defined;
}, ConfigBrand>;
export type ConfigC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            type: t.UnionC<[
                t.LiteralC<'oneOf'>,
                t.LiteralC<'someOf'>,
                t.LiteralC<'allOf'>,
                t.LiteralC<'oneOrNoneOf'>,
                t.LiteralC<'someOrNoneOf'>
            ]>;
            name: t.StringC;
            description: t.StringC;
            choices: t.ArrayC<typeof Choice>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        type: typeof Defined;
        name: typeof Defined;
        choices: typeof Defined;
    }>
]>, ConfigBrand>;
export declare const Config: ConfigC;
export type ConfigBrand = {
    readonly Config: unique symbol;
};
export type Text = t.Branded<({
    type?: 'text';
    name?: string;
    description?: string;
    input?: string;
} & Record<string, unknown>) & {
    type: Defined;
    name: Defined;
}, TextBrand>;
export type TextC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            type: t.LiteralC<'text'>;
            name: t.StringC;
            description: t.StringC;
            input: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        type: typeof Defined;
        name: typeof Defined;
    }>
]>, TextBrand>;
export declare const Text: TextC;
export type TextBrand = {
    readonly Text: unique symbol;
};
export type ConfiguratorCommon = t.Branded<unknown, ConfiguratorCommonBrand>;
export type ConfiguratorCommonC = t.BrandC<t.UnknownC, ConfiguratorCommonBrand>;
export declare const ConfiguratorCommon: ConfiguratorCommonC;
export type ConfiguratorCommonBrand = {
    readonly ConfiguratorCommon: unique symbol;
};
export default ConfiguratorCommon;
