import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as ConfiguratorCommon_749d_ from './configuratorCommon';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/configuratorV1.json";
export type ConfiguratorV1 = t.Branded<{
    seatDirection?: ConfiguratorCommon_749d_.Config;
    seatPosition?: ConfiguratorCommon_749d_.Config;
    seatType?: ConfiguratorCommon_749d_.Config;
    seatFeatures?: ConfiguratorCommon_749d_.Config;
    stations?: ConfiguratorCommon_749d_.Config;
    outboundSingle?: ConfiguratorCommon_749d_.Config;
    inboundSingle?: ConfiguratorCommon_749d_.Config;
    openReturn?: ConfiguratorCommon_749d_.Config;
    freeReturn?: ConfiguratorCommon_749d_.Config;
    ticketCollectionPoint?: ConfiguratorCommon_749d_.Text;
} & ({
    seatDirection: Defined;
} | {
    seatPosition: Defined;
} | {
    seatType: Defined;
} | {
    seatFeatures: Defined;
} | {
    stations: Defined;
} | {
    outboundSingle: Defined;
} | {
    inboundSingle: Defined;
} | {
    openReturn: Defined;
} | {
    freeReturn: Defined;
} | {
    ticketCollectionPoint: Defined;
}), ConfiguratorV1Brand>;
export type ConfiguratorV1C = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        seatDirection: typeof ConfiguratorCommon_749d_.Config;
        seatPosition: typeof ConfiguratorCommon_749d_.Config;
        seatType: typeof ConfiguratorCommon_749d_.Config;
        seatFeatures: typeof ConfiguratorCommon_749d_.Config;
        stations: typeof ConfiguratorCommon_749d_.Config;
        outboundSingle: typeof ConfiguratorCommon_749d_.Config;
        inboundSingle: typeof ConfiguratorCommon_749d_.Config;
        openReturn: typeof ConfiguratorCommon_749d_.Config;
        freeReturn: typeof ConfiguratorCommon_749d_.Config;
        ticketCollectionPoint: typeof ConfiguratorCommon_749d_.Text;
    }>,
    t.UnionC<[
        t.TypeC<{
            seatDirection: typeof Defined;
        }>,
        t.TypeC<{
            seatPosition: typeof Defined;
        }>,
        t.TypeC<{
            seatType: typeof Defined;
        }>,
        t.TypeC<{
            seatFeatures: typeof Defined;
        }>,
        t.TypeC<{
            stations: typeof Defined;
        }>,
        t.TypeC<{
            outboundSingle: typeof Defined;
        }>,
        t.TypeC<{
            inboundSingle: typeof Defined;
        }>,
        t.TypeC<{
            openReturn: typeof Defined;
        }>,
        t.TypeC<{
            freeReturn: typeof Defined;
        }>,
        t.TypeC<{
            ticketCollectionPoint: typeof Defined;
        }>
    ]>
]>, ConfiguratorV1Brand>;
export declare const ConfiguratorV1: ConfiguratorV1C;
export type ConfiguratorV1Brand = {
    readonly ConfiguratorV1: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ConfiguratorV1)).decodeSync(examplesConfiguratorV1) // => examplesConfiguratorV1 */
export declare const examplesConfiguratorV1: NonEmptyArray<ConfiguratorV1>;
export default ConfiguratorV1;
import "jest";
