import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as ConfiguratorCommon_749d_ from './configuratorCommon';
import * as Cost_250f_ from './cost';
import * as CustomerSelectionV2_411b_ from './customerSelectionV2';
import * as Fare_a3ab_ from './fare';
import * as Units_c404_ from './units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/configuratorV2.json";
export type ConfiguratorV2 = t.Branded<({
    version?: string;
    estimatable?: boolean;
    purchasable?: boolean;
    validUntil?: Units_c404_.Time | 0;
    configuratorSelection?: CustomerSelectionV2_411b_.CustomerSelectionV2;
    configurations?: Record<string, ConfiguratorCommon_749d_.Config> & Record<string, unknown>;
    cost?: Cost_250f_.Cost;
    fares?: Array<Fare_a3ab_.Fare>;
} & Record<string, unknown>) & {
    version: Defined;
    estimatable: Defined;
    purchasable: Defined;
    validUntil: Defined;
    configuratorSelection: Defined;
    configurations: Defined;
}, ConfiguratorV2Brand>;
export type ConfiguratorV2C = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            version: t.StringC;
            estimatable: t.BooleanC;
            purchasable: t.BooleanC;
            validUntil: t.UnionC<[typeof Units_c404_.Time, t.LiteralC<0>]>;
            configuratorSelection: typeof CustomerSelectionV2_411b_.CustomerSelectionV2;
            configurations: t.IntersectionC<[
                t.RecordC<t.StringC, typeof ConfiguratorCommon_749d_.Config>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>;
            cost: typeof Cost_250f_.Cost;
            fares: t.ArrayC<typeof Fare_a3ab_.Fare>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        version: typeof Defined;
        estimatable: typeof Defined;
        purchasable: typeof Defined;
        validUntil: typeof Defined;
        configuratorSelection: typeof Defined;
        configurations: typeof Defined;
    }>
]>, ConfiguratorV2Brand>;
export declare const ConfiguratorV2: ConfiguratorV2C;
export type ConfiguratorV2Brand = {
    readonly ConfiguratorV2: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ConfiguratorV2)).decodeSync(examplesConfiguratorV2) // => examplesConfiguratorV2 */
export declare const examplesConfiguratorV2: NonEmptyArray<ConfiguratorV2>;
export default ConfiguratorV2;
import "jest";
