import * as t from 'io-ts';
import * as Units_c404_ from './units';
export type NullBrand = {
    readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export declare const Null: NullC;
export type Null = t.TypeOf<typeof Null>;
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/cost.json";
export type Cost = t.Branded<{
    amount?: number | Null;
    originalAmount?: number | Null;
    discount?: number;
    taxes?: number;
    isFixedPrice?: boolean;
    currency?: Units_c404_.Currency | Null;
    type?: string & 'promotional_credits';
} & {
    amount: Defined;
    currency: Defined;
}, CostBrand>;
export type CostC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        amount: t.UnionC<[t.NumberC, typeof Null]>;
        originalAmount: t.UnionC<[t.NumberC, typeof Null]>;
        discount: t.NumberC;
        taxes: t.NumberC;
        isFixedPrice: t.BooleanC;
        currency: t.UnionC<[typeof Units_c404_.Currency, typeof Null]>;
        type: t.IntersectionC<[t.StringC, t.LiteralC<'promotional_credits'>]>;
    }>,
    t.TypeC<{
        amount: typeof Defined;
        currency: typeof Defined;
    }>
]>, CostBrand>;
export declare const Cost: CostC;
export type CostBrand = {
    readonly Cost: unique symbol;
};
export default Cost;
