import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Common_ffba_ from './common';
import * as Units_c404_ from './units';
export type NullBrand = {
    readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export declare const Null: NullC;
export type Null = t.TypeOf<typeof Null>;
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/fare.json";
export type TokenId = t.Branded<string, TokenIdBrand>;
export type TokenIdC = t.BrandC<t.StringC, TokenIdBrand>;
export declare const TokenId: TokenIdC;
export type TokenIdBrand = {
    readonly TokenId: unique symbol;
};
export type FareType = t.Branded<string & ('charge' | 'refund'), FareTypeBrand>;
export type FareTypeC = t.BrandC<t.IntersectionC<[t.StringC, t.UnionC<[t.LiteralC<'charge'>, t.LiteralC<'refund'>]>]>, FareTypeBrand>;
export declare const FareType: FareTypeC;
export type FareTypeBrand = {
    readonly FareType: unique symbol;
};
export type FareTypeCHARGE = t.Branded<FareType & 'charge', FareTypeCHARGEBrand>;
export type FareTypeCHARGEC = t.BrandC<t.IntersectionC<[typeof FareType, t.LiteralC<'charge'>]>, FareTypeCHARGEBrand>;
export declare const FareTypeCHARGE: FareTypeCHARGEC;
export type FareTypeCHARGEBrand = {
    readonly FareTypeCHARGE: unique symbol;
};
/** require('io-ts-validator').validator(FareTypeCHARGE).decodeSync(defaultFareTypeCHARGE) // => defaultFareTypeCHARGE */
export declare const defaultFareTypeCHARGE: FareTypeCHARGE;
export type FareTypeREFUND = t.Branded<FareType & 'refund', FareTypeREFUNDBrand>;
export type FareTypeREFUNDC = t.BrandC<t.IntersectionC<[typeof FareType, t.LiteralC<'refund'>]>, FareTypeREFUNDBrand>;
export declare const FareTypeREFUND: FareTypeREFUNDC;
export type FareTypeREFUNDBrand = {
    readonly FareTypeREFUND: unique symbol;
};
/** require('io-ts-validator').validator(FareTypeREFUND).decodeSync(defaultFareTypeREFUND) // => defaultFareTypeREFUND */
export declare const defaultFareTypeREFUND: FareTypeREFUND;
export type Fare = t.Branded<{
    amount?: number | Null;
    currency?: Units_c404_.Currency | Common_ffba_.MetaCurrency | TokenId;
    tokenId?: TokenId;
    hidden?: boolean;
    originalAmount?: number | Null;
    productionAmount?: number | Null;
    type?: FareType;
} & {
    amount: Defined;
    currency: Defined;
}, FareBrand>;
export type FareC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        amount: t.UnionC<[t.NumberC, typeof Null]>;
        currency: t.UnionC<[
            typeof Units_c404_.Currency,
            typeof Common_ffba_.MetaCurrency,
            typeof TokenId
        ]>;
        tokenId: typeof TokenId;
        hidden: t.BooleanC;
        originalAmount: t.UnionC<[t.NumberC, typeof Null]>;
        productionAmount: t.UnionC<[t.NumberC, typeof Null]>;
        type: typeof FareType;
    }>,
    t.TypeC<{
        amount: typeof Defined;
        currency: typeof Defined;
    }>
]>, FareBrand>;
export declare const Fare: FareC;
export type FareBrand = {
    readonly Fare: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Fare)).decodeSync(examplesFare) // => examplesFare */
export declare const examplesFare: NonEmptyArray<Fare>;
export default Fare;
