import * as t from 'io-ts';
import * as Address_2d0a_ from './address';
import * as UnitsGeo_3e31_ from './units-geo';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/geolocation.json";
export type Geometry = t.Branded<{
    type?: 'Point';
    coordinates?: UnitsGeo_3e31_.ShortLocation;
} & {
    type: Defined;
    coordinates: Defined;
}, GeometryBrand>;
export type GeometryC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        type: t.LiteralC<'Point'>;
        coordinates: typeof UnitsGeo_3e31_.ShortLocation;
    }>,
    t.TypeC<{
        type: typeof Defined;
        coordinates: typeof Defined;
    }>
]>, GeometryBrand>;
export declare const Geometry: GeometryC;
export type GeometryBrand = {
    readonly Geometry: unique symbol;
};
export type Properties = t.Branded<({
    name?: string;
    streetNumber?: string;
    streetName?: string;
    city?: string;
    country?: string;
    countryCode?: string;
    houseNumber?: string;
    zipcode?: Address_2d0a_.ZipCode;
} & Record<string, unknown>) & {
    name: Defined;
}, PropertiesBrand>;
export type PropertiesC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            name: t.StringC;
            streetNumber: t.StringC;
            streetName: t.StringC;
            city: t.StringC;
            country: t.StringC;
            countryCode: t.StringC;
            houseNumber: t.StringC;
            zipcode: typeof Address_2d0a_.ZipCode;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        name: typeof Defined;
    }>
]>, PropertiesBrand>;
export declare const Properties: PropertiesC;
export type PropertiesBrand = {
    readonly Properties: unique symbol;
};
export type Feature = t.Branded<{
    type?: 'Feature';
    geometry?: Geometry;
    properties?: Properties;
} & {
    type: Defined;
    geometry: Defined;
    properties: Defined;
}, FeatureBrand>;
export type FeatureC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        type: t.LiteralC<'Feature'>;
        geometry: typeof Geometry;
        properties: typeof Properties;
    }>,
    t.TypeC<{
        type: typeof Defined;
        geometry: typeof Defined;
        properties: typeof Defined;
    }>
]>, FeatureBrand>;
export declare const Feature: FeatureC;
export type FeatureBrand = {
    readonly Feature: unique symbol;
};
export type FeatureCollection = t.Branded<({
    type?: 'FeatureCollection';
    features?: Array<Feature>;
} & Record<string, unknown>) & {
    type: Defined;
    features: Defined;
}, FeatureCollectionBrand>;
export type FeatureCollectionC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            type: t.LiteralC<'FeatureCollection'>;
            features: t.ArrayC<typeof Feature>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        type: typeof Defined;
        features: typeof Defined;
    }>
]>, FeatureCollectionBrand>;
export declare const FeatureCollection: FeatureCollectionC;
export type FeatureCollectionBrand = {
    readonly FeatureCollection: unique symbol;
};
export type Geolocation = t.Branded<unknown, GeolocationBrand>;
export type GeolocationC = t.BrandC<t.UnknownC, GeolocationBrand>;
export declare const Geolocation: GeolocationC;
export type GeolocationBrand = {
    readonly Geolocation: unique symbol;
};
export default Geolocation;
