import * as t from 'io-ts';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/message.json";
export type Message = t.Branded<{
    text?: string;
    mode?: string & ('MODE_WALK' | 'MODE_BICYCLE' | 'MODE_CAR' | 'MODE_TRAM' | 'MODE_SUBWAY' | 'MODE_RAIL' | 'MODE_BUS' | 'MODE_FERRY' | 'MODE_CABLE_CAR' | 'MODE_GONDOLA' | 'MODE_FUNICULAR' | 'MODE_SHARED_BICYCLE' | 'MODE_SHARED_E_BICYCLE' | 'MODE_SHARED_CAR' | 'MODE_TRANSIT' | 'MODE_TRAIN' | 'MODE_TRAINISH' | 'MODE_BUSISH' | 'MODE_TAXI' | 'MODE_SCOOTER');
    property?: string;
} & {
    text: Defined;
    mode: Defined;
    property: Defined;
}, MessageBrand>;
export type MessageC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        text: t.StringC;
        mode: t.IntersectionC<[
            t.StringC,
            t.UnionC<[
                t.LiteralC<'MODE_WALK'>,
                t.LiteralC<'MODE_BICYCLE'>,
                t.LiteralC<'MODE_CAR'>,
                t.LiteralC<'MODE_TRAM'>,
                t.LiteralC<'MODE_SUBWAY'>,
                t.LiteralC<'MODE_RAIL'>,
                t.LiteralC<'MODE_BUS'>,
                t.LiteralC<'MODE_FERRY'>,
                t.LiteralC<'MODE_CABLE_CAR'>,
                t.LiteralC<'MODE_GONDOLA'>,
                t.LiteralC<'MODE_FUNICULAR'>,
                t.LiteralC<'MODE_SHARED_BICYCLE'>,
                t.LiteralC<'MODE_SHARED_E_BICYCLE'>,
                t.LiteralC<'MODE_SHARED_CAR'>,
                t.LiteralC<'MODE_TRANSIT'>,
                t.LiteralC<'MODE_TRAIN'>,
                t.LiteralC<'MODE_TRAINISH'>,
                t.LiteralC<'MODE_BUSISH'>,
                t.LiteralC<'MODE_TAXI'>,
                t.LiteralC<'MODE_SCOOTER'>
            ]>
        ]>;
        property: t.StringC;
    }>,
    t.TypeC<{
        text: typeof Defined;
        mode: typeof Defined;
        property: typeof Defined;
    }>
]>, MessageBrand>;
export declare const Message: MessageC;
export type MessageBrand = {
    readonly Message: unique symbol;
};
export default Message;
