import * as t from 'io-ts';
import * as Units_c404_ from './units';
export declare const schemaId = "https://schemas.maas.global/core/components/payment-parameters.json";
export type StripePaymentParameters = t.Branded<{
    bookingId?: Units_c404_.Uuid;
    clientSecret?: string;
} & Record<string, unknown>, StripePaymentParametersBrand>;
export type StripePaymentParametersC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        bookingId: typeof Units_c404_.Uuid;
        clientSecret: t.StringC;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, StripePaymentParametersBrand>;
export declare const StripePaymentParameters: StripePaymentParametersC;
export type StripePaymentParametersBrand = {
    readonly StripePaymentParameters: unique symbol;
};
export type AvainpayPaymentParameters = t.Branded<({
    return_code?: string;
    appid?: string;
    sub_appid?: string;
    mch_id?: string;
    sub_mch_id?: string;
    nonce_str?: string;
    result_code?: string;
    prepay_id?: string;
    trade_type?: string;
    code_url?: string;
    sign?: string;
    paySign?: string;
    timeStamp?: string;
} & Record<string, unknown>) | ({
    appId?: string;
    timeStamp?: string;
    nonceStr?: string;
    package?: string;
    signType?: string;
    paySign?: string;
} & Record<string, unknown>) | ({
    return_code?: string;
    appid?: string;
    mch_id?: string;
    sub_mch_id?: string;
    nonce_str?: string;
    result_code?: string;
    prepay_id?: string;
    trade_type?: string;
    code_url?: string;
    sign?: string;
} & Record<string, unknown>), AvainpayPaymentParametersBrand>;
export type AvainpayPaymentParametersC = t.BrandC<t.UnionC<[
    t.IntersectionC<[
        t.PartialC<{
            return_code: t.StringC;
            appid: t.StringC;
            sub_appid: t.StringC;
            mch_id: t.StringC;
            sub_mch_id: t.StringC;
            nonce_str: t.StringC;
            result_code: t.StringC;
            prepay_id: t.StringC;
            trade_type: t.StringC;
            code_url: t.StringC;
            sign: t.StringC;
            paySign: t.StringC;
            timeStamp: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.IntersectionC<[
        t.PartialC<{
            appId: t.StringC;
            timeStamp: t.StringC;
            nonceStr: t.StringC;
            package: t.StringC;
            signType: t.StringC;
            paySign: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.IntersectionC<[
        t.PartialC<{
            return_code: t.StringC;
            appid: t.StringC;
            mch_id: t.StringC;
            sub_mch_id: t.StringC;
            nonce_str: t.StringC;
            result_code: t.StringC;
            prepay_id: t.StringC;
            trade_type: t.StringC;
            code_url: t.StringC;
            sign: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>
]>, AvainpayPaymentParametersBrand>;
export declare const AvainpayPaymentParameters: AvainpayPaymentParametersC;
export type AvainpayPaymentParametersBrand = {
    readonly AvainpayPaymentParameters: unique symbol;
};
export type PaymentParameters = t.Branded<unknown, PaymentParametersBrand>;
export type PaymentParametersC = t.BrandC<t.UnknownC, PaymentParametersBrand>;
export declare const PaymentParameters: PaymentParametersC;
export type PaymentParametersBrand = {
    readonly PaymentParameters: unique symbol;
};
export default PaymentParameters;
