import * as t from 'io-ts';
export declare const schemaId = "https://schemas.maas.global/core/components/personalDataValidation.json";
export type PersonalDataValidation = t.Branded<{
    id?: number;
    name?: string;
    type?: 'value' | 'enum' | 'length' | 'regex' | 'date' | 'dateDurationUntilNow';
    operator?: '>' | '>=' | '<' | '<=' | '=' | '!=' | 'in';
    config?: {
        path?: string;
        remoteSource?: string;
        value?: string | number | boolean;
        enum?: Array<{
            value?: string | number | boolean;
            name?: string;
            description?: string;
            meta?: Record<string, unknown> & Record<string, unknown>;
        } & Record<string, unknown>>;
        length?: number;
        regex?: string;
        date?: string | number;
        dateDurationUntilNow?: {
            month?: number;
            day?: number;
            hour?: number;
        } & Record<string, unknown>;
        meta?: Record<string, unknown> & Record<string, unknown>;
    } & Record<string, unknown>;
    errorCode?: string;
} & Record<string, unknown>, PersonalDataValidationBrand>;
export type PersonalDataValidationC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: t.NumberC;
        name: t.StringC;
        type: t.UnionC<[
            t.LiteralC<'value'>,
            t.LiteralC<'enum'>,
            t.LiteralC<'length'>,
            t.LiteralC<'regex'>,
            t.LiteralC<'date'>,
            t.LiteralC<'dateDurationUntilNow'>
        ]>;
        operator: t.UnionC<[
            t.LiteralC<'>'>,
            t.LiteralC<'>='>,
            t.LiteralC<'<'>,
            t.LiteralC<'<='>,
            t.LiteralC<'='>,
            t.LiteralC<'!='>,
            t.LiteralC<'in'>
        ]>;
        config: t.IntersectionC<[
            t.PartialC<{
                path: t.StringC;
                remoteSource: t.StringC;
                value: t.UnionC<[t.StringC, t.NumberC, t.BooleanC]>;
                enum: t.ArrayC<t.IntersectionC<[
                    t.PartialC<{
                        value: t.UnionC<[t.StringC, t.NumberC, t.BooleanC]>;
                        name: t.StringC;
                        description: t.StringC;
                        meta: t.IntersectionC<[
                            t.UnknownRecordC,
                            t.RecordC<t.StringC, t.UnknownC>
                        ]>;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>>;
                length: t.NumberC;
                regex: t.StringC;
                date: t.UnionC<[t.StringC, t.NumberC]>;
                dateDurationUntilNow: t.IntersectionC<[
                    t.PartialC<{
                        month: t.NumberC;
                        day: t.NumberC;
                        hour: t.NumberC;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>;
                meta: t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        errorCode: t.StringC;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, PersonalDataValidationBrand>;
export declare const PersonalDataValidation: PersonalDataValidationC;
export type PersonalDataValidationBrand = {
    readonly PersonalDataValidation: unique symbol;
};
export default PersonalDataValidation;
