import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
export declare const schemaId = "https://schemas.maas.global/core/components/spaceDemand.json";
export type SpaceDemandObject = t.Branded<{
    adults?: number;
    children?: number;
    infants?: number;
    bags?: number;
} & Record<string, unknown>, SpaceDemandObjectBrand>;
export type SpaceDemandObjectC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        adults: t.NumberC;
        children: t.NumberC;
        infants: t.NumberC;
        bags: t.NumberC;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, SpaceDemandObjectBrand>;
export declare const SpaceDemandObject: SpaceDemandObjectC;
export type SpaceDemandObjectBrand = {
    readonly SpaceDemandObject: unique symbol;
};
export type SpaceDemandString = t.Branded<string, SpaceDemandStringBrand>;
export type SpaceDemandStringC = t.BrandC<t.StringC, SpaceDemandStringBrand>;
export declare const SpaceDemandString: SpaceDemandStringC;
export type SpaceDemandStringBrand = {
    readonly SpaceDemandString: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(SpaceDemandString)).decodeSync(examplesSpaceDemandString) // => examplesSpaceDemandString */
export declare const examplesSpaceDemandString: NonEmptyArray<SpaceDemandString>;
export type SpaceDemand = t.Branded<unknown, SpaceDemandBrand>;
export type SpaceDemandC = t.BrandC<t.UnknownC, SpaceDemandBrand>;
export declare const SpaceDemand: SpaceDemandC;
export type SpaceDemandBrand = {
    readonly SpaceDemand: unique symbol;
};
export default SpaceDemand;
