import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Error_b620_ from '../error';
import * as State_2db3_ from './state';
import * as Units_c404_ from './units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/state-log.json";
export type ObsoleteTime = t.Branded<string, ObsoleteTimeBrand>;
export type ObsoleteTimeC = t.BrandC<t.StringC, ObsoleteTimeBrand>;
export declare const ObsoleteTime: ObsoleteTimeC;
export type ObsoleteTimeBrand = {
    readonly ObsoleteTime: unique symbol;
};
export type BookingStateTransition = t.Branded<({
    timestamp?: Units_c404_.Time | ObsoleteTime;
    oldState?: State_2db3_.BookingState;
    newState?: State_2db3_.BookingState;
    invalid?: boolean;
    reason?: Error_b620_.Reason;
} & Record<string, unknown>) & {
    newState: Defined;
    oldState: Defined;
    timestamp: Defined;
}, BookingStateTransitionBrand>;
export type BookingStateTransitionC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            timestamp: t.UnionC<[typeof Units_c404_.Time, typeof ObsoleteTime]>;
            oldState: typeof State_2db3_.BookingState;
            newState: typeof State_2db3_.BookingState;
            invalid: t.BooleanC;
            reason: typeof Error_b620_.Reason;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        newState: typeof Defined;
        oldState: typeof Defined;
        timestamp: typeof Defined;
    }>
]>, BookingStateTransitionBrand>;
export declare const BookingStateTransition: BookingStateTransitionC;
export type BookingStateTransitionBrand = {
    readonly BookingStateTransition: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(BookingStateTransition)).decodeSync(examplesBookingStateTransition) // => examplesBookingStateTransition */
export declare const examplesBookingStateTransition: NonEmptyArray<BookingStateTransition>;
export type StateLog = t.Branded<Array<BookingStateTransition>, StateLogBrand>;
export type StateLogC = t.BrandC<t.ArrayC<typeof BookingStateTransition>, StateLogBrand>;
export declare const StateLog: StateLogC;
export type StateLogBrand = {
    readonly StateLog: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(StateLog)).decodeSync(examplesStateLog) // => examplesStateLog */
export declare const examplesStateLog: NonEmptyArray<StateLog>;
export default StateLog;
import "jest";
