import * as t from 'io-ts';
export declare const schemaId = "https://schemas.maas.global/core/components/state.json";
export type BookingState = t.Branded<string & ('START' | 'PENDING' | 'PAID' | 'PENDING_RESERVATION' | 'RESERVED' | 'CONFIRMED' | 'ARRIVED' | 'ACTIVATED' | 'ON_HOLD' | 'CANCELLED' | 'EXPIRED' | 'REJECTED' | 'FINISHED' | 'UNKNOWN'), BookingStateBrand>;
export type BookingStateC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'START'>,
        t.LiteralC<'PENDING'>,
        t.LiteralC<'PAID'>,
        t.LiteralC<'PENDING_RESERVATION'>,
        t.LiteralC<'RESERVED'>,
        t.LiteralC<'CONFIRMED'>,
        t.LiteralC<'ARRIVED'>,
        t.LiteralC<'ACTIVATED'>,
        t.LiteralC<'ON_HOLD'>,
        t.LiteralC<'CANCELLED'>,
        t.LiteralC<'EXPIRED'>,
        t.LiteralC<'REJECTED'>,
        t.LiteralC<'FINISHED'>,
        t.LiteralC<'UNKNOWN'>
    ]>
]>, BookingStateBrand>;
export declare const BookingState: BookingStateC;
export type BookingStateBrand = {
    readonly BookingState: unique symbol;
};
export type BookingStateSTART = t.Branded<BookingState & 'START', BookingStateSTARTBrand>;
export type BookingStateSTARTC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'START'>]>, BookingStateSTARTBrand>;
export declare const BookingStateSTART: BookingStateSTARTC;
export type BookingStateSTARTBrand = {
    readonly BookingStateSTART: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateSTART).decodeSync(defaultBookingStateSTART) // => defaultBookingStateSTART */
export declare const defaultBookingStateSTART: BookingStateSTART;
export type BookingStatePENDING = t.Branded<BookingState & 'PENDING', BookingStatePENDINGBrand>;
export type BookingStatePENDINGC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'PENDING'>]>, BookingStatePENDINGBrand>;
export declare const BookingStatePENDING: BookingStatePENDINGC;
export type BookingStatePENDINGBrand = {
    readonly BookingStatePENDING: unique symbol;
};
/** require('io-ts-validator').validator(BookingStatePENDING).decodeSync(defaultBookingStatePENDING) // => defaultBookingStatePENDING */
export declare const defaultBookingStatePENDING: BookingStatePENDING;
export type BookingStatePAID = t.Branded<BookingState & 'PAID', BookingStatePAIDBrand>;
export type BookingStatePAIDC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'PAID'>]>, BookingStatePAIDBrand>;
export declare const BookingStatePAID: BookingStatePAIDC;
export type BookingStatePAIDBrand = {
    readonly BookingStatePAID: unique symbol;
};
/** require('io-ts-validator').validator(BookingStatePAID).decodeSync(defaultBookingStatePAID) // => defaultBookingStatePAID */
export declare const defaultBookingStatePAID: BookingStatePAID;
export type BookingStatePENDING_RESERVATION = t.Branded<BookingState & 'PENDING_RESERVATION', BookingStatePENDING_RESERVATIONBrand>;
export type BookingStatePENDING_RESERVATIONC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'PENDING_RESERVATION'>]>, BookingStatePENDING_RESERVATIONBrand>;
export declare const BookingStatePENDING_RESERVATION: BookingStatePENDING_RESERVATIONC;
export type BookingStatePENDING_RESERVATIONBrand = {
    readonly BookingStatePENDING_RESERVATION: unique symbol;
};
/** require('io-ts-validator').validator(BookingStatePENDING_RESERVATION).decodeSync(defaultBookingStatePENDING_RESERVATION) // => defaultBookingStatePENDING_RESERVATION */
export declare const defaultBookingStatePENDING_RESERVATION: BookingStatePENDING_RESERVATION;
export type BookingStateRESERVED = t.Branded<BookingState & 'RESERVED', BookingStateRESERVEDBrand>;
export type BookingStateRESERVEDC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'RESERVED'>]>, BookingStateRESERVEDBrand>;
export declare const BookingStateRESERVED: BookingStateRESERVEDC;
export type BookingStateRESERVEDBrand = {
    readonly BookingStateRESERVED: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateRESERVED).decodeSync(defaultBookingStateRESERVED) // => defaultBookingStateRESERVED */
export declare const defaultBookingStateRESERVED: BookingStateRESERVED;
export type BookingStateCONFIRMED = t.Branded<BookingState & 'CONFIRMED', BookingStateCONFIRMEDBrand>;
export type BookingStateCONFIRMEDC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'CONFIRMED'>]>, BookingStateCONFIRMEDBrand>;
export declare const BookingStateCONFIRMED: BookingStateCONFIRMEDC;
export type BookingStateCONFIRMEDBrand = {
    readonly BookingStateCONFIRMED: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateCONFIRMED).decodeSync(defaultBookingStateCONFIRMED) // => defaultBookingStateCONFIRMED */
export declare const defaultBookingStateCONFIRMED: BookingStateCONFIRMED;
export type BookingStateARRIVED = t.Branded<BookingState & 'ARRIVED', BookingStateARRIVEDBrand>;
export type BookingStateARRIVEDC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'ARRIVED'>]>, BookingStateARRIVEDBrand>;
export declare const BookingStateARRIVED: BookingStateARRIVEDC;
export type BookingStateARRIVEDBrand = {
    readonly BookingStateARRIVED: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateARRIVED).decodeSync(defaultBookingStateARRIVED) // => defaultBookingStateARRIVED */
export declare const defaultBookingStateARRIVED: BookingStateARRIVED;
export type BookingStateACTIVATED = t.Branded<BookingState & 'ACTIVATED', BookingStateACTIVATEDBrand>;
export type BookingStateACTIVATEDC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'ACTIVATED'>]>, BookingStateACTIVATEDBrand>;
export declare const BookingStateACTIVATED: BookingStateACTIVATEDC;
export type BookingStateACTIVATEDBrand = {
    readonly BookingStateACTIVATED: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateACTIVATED).decodeSync(defaultBookingStateACTIVATED) // => defaultBookingStateACTIVATED */
export declare const defaultBookingStateACTIVATED: BookingStateACTIVATED;
export type BookingStateON_HOLD = t.Branded<BookingState & 'ON_HOLD', BookingStateON_HOLDBrand>;
export type BookingStateON_HOLDC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'ON_HOLD'>]>, BookingStateON_HOLDBrand>;
export declare const BookingStateON_HOLD: BookingStateON_HOLDC;
export type BookingStateON_HOLDBrand = {
    readonly BookingStateON_HOLD: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateON_HOLD).decodeSync(defaultBookingStateON_HOLD) // => defaultBookingStateON_HOLD */
export declare const defaultBookingStateON_HOLD: BookingStateON_HOLD;
export type BookingStateCANCELLED = t.Branded<BookingState & 'CANCELLED', BookingStateCANCELLEDBrand>;
export type BookingStateCANCELLEDC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'CANCELLED'>]>, BookingStateCANCELLEDBrand>;
export declare const BookingStateCANCELLED: BookingStateCANCELLEDC;
export type BookingStateCANCELLEDBrand = {
    readonly BookingStateCANCELLED: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateCANCELLED).decodeSync(defaultBookingStateCANCELLED) // => defaultBookingStateCANCELLED */
export declare const defaultBookingStateCANCELLED: BookingStateCANCELLED;
export type BookingStateEXPIRED = t.Branded<BookingState & 'EXPIRED', BookingStateEXPIREDBrand>;
export type BookingStateEXPIREDC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'EXPIRED'>]>, BookingStateEXPIREDBrand>;
export declare const BookingStateEXPIRED: BookingStateEXPIREDC;
export type BookingStateEXPIREDBrand = {
    readonly BookingStateEXPIRED: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateEXPIRED).decodeSync(defaultBookingStateEXPIRED) // => defaultBookingStateEXPIRED */
export declare const defaultBookingStateEXPIRED: BookingStateEXPIRED;
export type BookingStateREJECTED = t.Branded<BookingState & 'REJECTED', BookingStateREJECTEDBrand>;
export type BookingStateREJECTEDC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'REJECTED'>]>, BookingStateREJECTEDBrand>;
export declare const BookingStateREJECTED: BookingStateREJECTEDC;
export type BookingStateREJECTEDBrand = {
    readonly BookingStateREJECTED: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateREJECTED).decodeSync(defaultBookingStateREJECTED) // => defaultBookingStateREJECTED */
export declare const defaultBookingStateREJECTED: BookingStateREJECTED;
export type BookingStateFINISHED = t.Branded<BookingState & 'FINISHED', BookingStateFINISHEDBrand>;
export type BookingStateFINISHEDC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'FINISHED'>]>, BookingStateFINISHEDBrand>;
export declare const BookingStateFINISHED: BookingStateFINISHEDC;
export type BookingStateFINISHEDBrand = {
    readonly BookingStateFINISHED: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateFINISHED).decodeSync(defaultBookingStateFINISHED) // => defaultBookingStateFINISHED */
export declare const defaultBookingStateFINISHED: BookingStateFINISHED;
export type BookingStateUNKNOWN = t.Branded<BookingState & 'UNKNOWN', BookingStateUNKNOWNBrand>;
export type BookingStateUNKNOWNC = t.BrandC<t.IntersectionC<[typeof BookingState, t.LiteralC<'UNKNOWN'>]>, BookingStateUNKNOWNBrand>;
export declare const BookingStateUNKNOWN: BookingStateUNKNOWNC;
export type BookingStateUNKNOWNBrand = {
    readonly BookingStateUNKNOWN: unique symbol;
};
/** require('io-ts-validator').validator(BookingStateUNKNOWN).decodeSync(defaultBookingStateUNKNOWN) // => defaultBookingStateUNKNOWN */
export declare const defaultBookingStateUNKNOWN: BookingStateUNKNOWN;
export type LegState = t.Branded<string & ('START' | 'PLANNED' | 'PAID' | 'ACTIVATED' | 'CANCELLED' | 'CANCELLED_WITH_ERRORS' | 'FINISHED'), LegStateBrand>;
export type LegStateC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'START'>,
        t.LiteralC<'PLANNED'>,
        t.LiteralC<'PAID'>,
        t.LiteralC<'ACTIVATED'>,
        t.LiteralC<'CANCELLED'>,
        t.LiteralC<'CANCELLED_WITH_ERRORS'>,
        t.LiteralC<'FINISHED'>
    ]>
]>, LegStateBrand>;
export declare const LegState: LegStateC;
export type LegStateBrand = {
    readonly LegState: unique symbol;
};
export type LegStateSTART = t.Branded<LegState & 'START', LegStateSTARTBrand>;
export type LegStateSTARTC = t.BrandC<t.IntersectionC<[typeof LegState, t.LiteralC<'START'>]>, LegStateSTARTBrand>;
export declare const LegStateSTART: LegStateSTARTC;
export type LegStateSTARTBrand = {
    readonly LegStateSTART: unique symbol;
};
/** require('io-ts-validator').validator(LegStateSTART).decodeSync(defaultLegStateSTART) // => defaultLegStateSTART */
export declare const defaultLegStateSTART: LegStateSTART;
export type LegStatePLANNED = t.Branded<LegState & 'PLANNED', LegStatePLANNEDBrand>;
export type LegStatePLANNEDC = t.BrandC<t.IntersectionC<[typeof LegState, t.LiteralC<'PLANNED'>]>, LegStatePLANNEDBrand>;
export declare const LegStatePLANNED: LegStatePLANNEDC;
export type LegStatePLANNEDBrand = {
    readonly LegStatePLANNED: unique symbol;
};
/** require('io-ts-validator').validator(LegStatePLANNED).decodeSync(defaultLegStatePLANNED) // => defaultLegStatePLANNED */
export declare const defaultLegStatePLANNED: LegStatePLANNED;
export type LegStatePAID = t.Branded<LegState & 'PAID', LegStatePAIDBrand>;
export type LegStatePAIDC = t.BrandC<t.IntersectionC<[typeof LegState, t.LiteralC<'PAID'>]>, LegStatePAIDBrand>;
export declare const LegStatePAID: LegStatePAIDC;
export type LegStatePAIDBrand = {
    readonly LegStatePAID: unique symbol;
};
/** require('io-ts-validator').validator(LegStatePAID).decodeSync(defaultLegStatePAID) // => defaultLegStatePAID */
export declare const defaultLegStatePAID: LegStatePAID;
export type LegStateACTIVATED = t.Branded<LegState & 'ACTIVATED', LegStateACTIVATEDBrand>;
export type LegStateACTIVATEDC = t.BrandC<t.IntersectionC<[typeof LegState, t.LiteralC<'ACTIVATED'>]>, LegStateACTIVATEDBrand>;
export declare const LegStateACTIVATED: LegStateACTIVATEDC;
export type LegStateACTIVATEDBrand = {
    readonly LegStateACTIVATED: unique symbol;
};
/** require('io-ts-validator').validator(LegStateACTIVATED).decodeSync(defaultLegStateACTIVATED) // => defaultLegStateACTIVATED */
export declare const defaultLegStateACTIVATED: LegStateACTIVATED;
export type LegStateCANCELLED = t.Branded<LegState & 'CANCELLED', LegStateCANCELLEDBrand>;
export type LegStateCANCELLEDC = t.BrandC<t.IntersectionC<[typeof LegState, t.LiteralC<'CANCELLED'>]>, LegStateCANCELLEDBrand>;
export declare const LegStateCANCELLED: LegStateCANCELLEDC;
export type LegStateCANCELLEDBrand = {
    readonly LegStateCANCELLED: unique symbol;
};
/** require('io-ts-validator').validator(LegStateCANCELLED).decodeSync(defaultLegStateCANCELLED) // => defaultLegStateCANCELLED */
export declare const defaultLegStateCANCELLED: LegStateCANCELLED;
export type LegStateCANCELLED_WITH_ERRORS = t.Branded<LegState & 'CANCELLED_WITH_ERRORS', LegStateCANCELLED_WITH_ERRORSBrand>;
export type LegStateCANCELLED_WITH_ERRORSC = t.BrandC<t.IntersectionC<[typeof LegState, t.LiteralC<'CANCELLED_WITH_ERRORS'>]>, LegStateCANCELLED_WITH_ERRORSBrand>;
export declare const LegStateCANCELLED_WITH_ERRORS: LegStateCANCELLED_WITH_ERRORSC;
export type LegStateCANCELLED_WITH_ERRORSBrand = {
    readonly LegStateCANCELLED_WITH_ERRORS: unique symbol;
};
/** require('io-ts-validator').validator(LegStateCANCELLED_WITH_ERRORS).decodeSync(defaultLegStateCANCELLED_WITH_ERRORS) // => defaultLegStateCANCELLED_WITH_ERRORS */
export declare const defaultLegStateCANCELLED_WITH_ERRORS: LegStateCANCELLED_WITH_ERRORS;
export type LegStateFINISHED = t.Branded<LegState & 'FINISHED', LegStateFINISHEDBrand>;
export type LegStateFINISHEDC = t.BrandC<t.IntersectionC<[typeof LegState, t.LiteralC<'FINISHED'>]>, LegStateFINISHEDBrand>;
export declare const LegStateFINISHED: LegStateFINISHEDC;
export type LegStateFINISHEDBrand = {
    readonly LegStateFINISHED: unique symbol;
};
/** require('io-ts-validator').validator(LegStateFINISHED).decodeSync(defaultLegStateFINISHED) // => defaultLegStateFINISHED */
export declare const defaultLegStateFINISHED: LegStateFINISHED;
export type ItineraryState = t.Branded<string & ('START' | 'PLANNED' | 'PAID' | 'ACTIVATED' | 'CANCELLED' | 'CANCELLED_WITH_ERRORS' | 'FINISHED'), ItineraryStateBrand>;
export type ItineraryStateC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'START'>,
        t.LiteralC<'PLANNED'>,
        t.LiteralC<'PAID'>,
        t.LiteralC<'ACTIVATED'>,
        t.LiteralC<'CANCELLED'>,
        t.LiteralC<'CANCELLED_WITH_ERRORS'>,
        t.LiteralC<'FINISHED'>
    ]>
]>, ItineraryStateBrand>;
export declare const ItineraryState: ItineraryStateC;
export type ItineraryStateBrand = {
    readonly ItineraryState: unique symbol;
};
export type ItineraryStateSTART = t.Branded<ItineraryState & 'START', ItineraryStateSTARTBrand>;
export type ItineraryStateSTARTC = t.BrandC<t.IntersectionC<[typeof ItineraryState, t.LiteralC<'START'>]>, ItineraryStateSTARTBrand>;
export declare const ItineraryStateSTART: ItineraryStateSTARTC;
export type ItineraryStateSTARTBrand = {
    readonly ItineraryStateSTART: unique symbol;
};
/** require('io-ts-validator').validator(ItineraryStateSTART).decodeSync(defaultItineraryStateSTART) // => defaultItineraryStateSTART */
export declare const defaultItineraryStateSTART: ItineraryStateSTART;
export type ItineraryStatePLANNED = t.Branded<ItineraryState & 'PLANNED', ItineraryStatePLANNEDBrand>;
export type ItineraryStatePLANNEDC = t.BrandC<t.IntersectionC<[typeof ItineraryState, t.LiteralC<'PLANNED'>]>, ItineraryStatePLANNEDBrand>;
export declare const ItineraryStatePLANNED: ItineraryStatePLANNEDC;
export type ItineraryStatePLANNEDBrand = {
    readonly ItineraryStatePLANNED: unique symbol;
};
/** require('io-ts-validator').validator(ItineraryStatePLANNED).decodeSync(defaultItineraryStatePLANNED) // => defaultItineraryStatePLANNED */
export declare const defaultItineraryStatePLANNED: ItineraryStatePLANNED;
export type ItineraryStatePAID = t.Branded<ItineraryState & 'PAID', ItineraryStatePAIDBrand>;
export type ItineraryStatePAIDC = t.BrandC<t.IntersectionC<[typeof ItineraryState, t.LiteralC<'PAID'>]>, ItineraryStatePAIDBrand>;
export declare const ItineraryStatePAID: ItineraryStatePAIDC;
export type ItineraryStatePAIDBrand = {
    readonly ItineraryStatePAID: unique symbol;
};
/** require('io-ts-validator').validator(ItineraryStatePAID).decodeSync(defaultItineraryStatePAID) // => defaultItineraryStatePAID */
export declare const defaultItineraryStatePAID: ItineraryStatePAID;
export type ItineraryStateACTIVATED = t.Branded<ItineraryState & 'ACTIVATED', ItineraryStateACTIVATEDBrand>;
export type ItineraryStateACTIVATEDC = t.BrandC<t.IntersectionC<[typeof ItineraryState, t.LiteralC<'ACTIVATED'>]>, ItineraryStateACTIVATEDBrand>;
export declare const ItineraryStateACTIVATED: ItineraryStateACTIVATEDC;
export type ItineraryStateACTIVATEDBrand = {
    readonly ItineraryStateACTIVATED: unique symbol;
};
/** require('io-ts-validator').validator(ItineraryStateACTIVATED).decodeSync(defaultItineraryStateACTIVATED) // => defaultItineraryStateACTIVATED */
export declare const defaultItineraryStateACTIVATED: ItineraryStateACTIVATED;
export type ItineraryStateCANCELLED = t.Branded<ItineraryState & 'CANCELLED', ItineraryStateCANCELLEDBrand>;
export type ItineraryStateCANCELLEDC = t.BrandC<t.IntersectionC<[typeof ItineraryState, t.LiteralC<'CANCELLED'>]>, ItineraryStateCANCELLEDBrand>;
export declare const ItineraryStateCANCELLED: ItineraryStateCANCELLEDC;
export type ItineraryStateCANCELLEDBrand = {
    readonly ItineraryStateCANCELLED: unique symbol;
};
/** require('io-ts-validator').validator(ItineraryStateCANCELLED).decodeSync(defaultItineraryStateCANCELLED) // => defaultItineraryStateCANCELLED */
export declare const defaultItineraryStateCANCELLED: ItineraryStateCANCELLED;
export type ItineraryStateCANCELLED_WITH_ERRORS = t.Branded<ItineraryState & 'CANCELLED_WITH_ERRORS', ItineraryStateCANCELLED_WITH_ERRORSBrand>;
export type ItineraryStateCANCELLED_WITH_ERRORSC = t.BrandC<t.IntersectionC<[typeof ItineraryState, t.LiteralC<'CANCELLED_WITH_ERRORS'>]>, ItineraryStateCANCELLED_WITH_ERRORSBrand>;
export declare const ItineraryStateCANCELLED_WITH_ERRORS: ItineraryStateCANCELLED_WITH_ERRORSC;
export type ItineraryStateCANCELLED_WITH_ERRORSBrand = {
    readonly ItineraryStateCANCELLED_WITH_ERRORS: unique symbol;
};
/** require('io-ts-validator').validator(ItineraryStateCANCELLED_WITH_ERRORS).decodeSync(defaultItineraryStateCANCELLED_WITH_ERRORS) // => defaultItineraryStateCANCELLED_WITH_ERRORS */
export declare const defaultItineraryStateCANCELLED_WITH_ERRORS: ItineraryStateCANCELLED_WITH_ERRORS;
export type ItineraryStateFINISHED = t.Branded<ItineraryState & 'FINISHED', ItineraryStateFINISHEDBrand>;
export type ItineraryStateFINISHEDC = t.BrandC<t.IntersectionC<[typeof ItineraryState, t.LiteralC<'FINISHED'>]>, ItineraryStateFINISHEDBrand>;
export declare const ItineraryStateFINISHED: ItineraryStateFINISHEDC;
export type ItineraryStateFINISHEDBrand = {
    readonly ItineraryStateFINISHED: unique symbol;
};
/** require('io-ts-validator').validator(ItineraryStateFINISHED).decodeSync(defaultItineraryStateFINISHED) // => defaultItineraryStateFINISHED */
export declare const defaultItineraryStateFINISHED: ItineraryStateFINISHED;
export type SubscriptionIntentState = t.Branded<string & ('START' | 'DETAILS' | 'CUSTOMISATION' | 'PAYMENT' | 'VERIFICATION' | 'AUTH' | 'CANCELLED' | 'CANCELLED_WITH_ERRORS' | 'FINISHED'), SubscriptionIntentStateBrand>;
export type SubscriptionIntentStateC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'START'>,
        t.LiteralC<'DETAILS'>,
        t.LiteralC<'CUSTOMISATION'>,
        t.LiteralC<'PAYMENT'>,
        t.LiteralC<'VERIFICATION'>,
        t.LiteralC<'AUTH'>,
        t.LiteralC<'CANCELLED'>,
        t.LiteralC<'CANCELLED_WITH_ERRORS'>,
        t.LiteralC<'FINISHED'>
    ]>
]>, SubscriptionIntentStateBrand>;
export declare const SubscriptionIntentState: SubscriptionIntentStateC;
export type SubscriptionIntentStateBrand = {
    readonly SubscriptionIntentState: unique symbol;
};
export type SubscriptionIntentStateSTART = t.Branded<SubscriptionIntentState & 'START', SubscriptionIntentStateSTARTBrand>;
export type SubscriptionIntentStateSTARTC = t.BrandC<t.IntersectionC<[typeof SubscriptionIntentState, t.LiteralC<'START'>]>, SubscriptionIntentStateSTARTBrand>;
export declare const SubscriptionIntentStateSTART: SubscriptionIntentStateSTARTC;
export type SubscriptionIntentStateSTARTBrand = {
    readonly SubscriptionIntentStateSTART: unique symbol;
};
/** require('io-ts-validator').validator(SubscriptionIntentStateSTART).decodeSync(defaultSubscriptionIntentStateSTART) // => defaultSubscriptionIntentStateSTART */
export declare const defaultSubscriptionIntentStateSTART: SubscriptionIntentStateSTART;
export type SubscriptionIntentStateDETAILS = t.Branded<SubscriptionIntentState & 'DETAILS', SubscriptionIntentStateDETAILSBrand>;
export type SubscriptionIntentStateDETAILSC = t.BrandC<t.IntersectionC<[typeof SubscriptionIntentState, t.LiteralC<'DETAILS'>]>, SubscriptionIntentStateDETAILSBrand>;
export declare const SubscriptionIntentStateDETAILS: SubscriptionIntentStateDETAILSC;
export type SubscriptionIntentStateDETAILSBrand = {
    readonly SubscriptionIntentStateDETAILS: unique symbol;
};
/** require('io-ts-validator').validator(SubscriptionIntentStateDETAILS).decodeSync(defaultSubscriptionIntentStateDETAILS) // => defaultSubscriptionIntentStateDETAILS */
export declare const defaultSubscriptionIntentStateDETAILS: SubscriptionIntentStateDETAILS;
export type SubscriptionIntentStateCUSTOMISATION = t.Branded<SubscriptionIntentState & 'CUSTOMISATION', SubscriptionIntentStateCUSTOMISATIONBrand>;
export type SubscriptionIntentStateCUSTOMISATIONC = t.BrandC<t.IntersectionC<[typeof SubscriptionIntentState, t.LiteralC<'CUSTOMISATION'>]>, SubscriptionIntentStateCUSTOMISATIONBrand>;
export declare const SubscriptionIntentStateCUSTOMISATION: SubscriptionIntentStateCUSTOMISATIONC;
export type SubscriptionIntentStateCUSTOMISATIONBrand = {
    readonly SubscriptionIntentStateCUSTOMISATION: unique symbol;
};
/** require('io-ts-validator').validator(SubscriptionIntentStateCUSTOMISATION).decodeSync(defaultSubscriptionIntentStateCUSTOMISATION) // => defaultSubscriptionIntentStateCUSTOMISATION */
export declare const defaultSubscriptionIntentStateCUSTOMISATION: SubscriptionIntentStateCUSTOMISATION;
export type SubscriptionIntentStatePAYMENT = t.Branded<SubscriptionIntentState & 'PAYMENT', SubscriptionIntentStatePAYMENTBrand>;
export type SubscriptionIntentStatePAYMENTC = t.BrandC<t.IntersectionC<[typeof SubscriptionIntentState, t.LiteralC<'PAYMENT'>]>, SubscriptionIntentStatePAYMENTBrand>;
export declare const SubscriptionIntentStatePAYMENT: SubscriptionIntentStatePAYMENTC;
export type SubscriptionIntentStatePAYMENTBrand = {
    readonly SubscriptionIntentStatePAYMENT: unique symbol;
};
/** require('io-ts-validator').validator(SubscriptionIntentStatePAYMENT).decodeSync(defaultSubscriptionIntentStatePAYMENT) // => defaultSubscriptionIntentStatePAYMENT */
export declare const defaultSubscriptionIntentStatePAYMENT: SubscriptionIntentStatePAYMENT;
export type SubscriptionIntentStateVERIFICATION = t.Branded<SubscriptionIntentState & 'VERIFICATION', SubscriptionIntentStateVERIFICATIONBrand>;
export type SubscriptionIntentStateVERIFICATIONC = t.BrandC<t.IntersectionC<[typeof SubscriptionIntentState, t.LiteralC<'VERIFICATION'>]>, SubscriptionIntentStateVERIFICATIONBrand>;
export declare const SubscriptionIntentStateVERIFICATION: SubscriptionIntentStateVERIFICATIONC;
export type SubscriptionIntentStateVERIFICATIONBrand = {
    readonly SubscriptionIntentStateVERIFICATION: unique symbol;
};
/** require('io-ts-validator').validator(SubscriptionIntentStateVERIFICATION).decodeSync(defaultSubscriptionIntentStateVERIFICATION) // => defaultSubscriptionIntentStateVERIFICATION */
export declare const defaultSubscriptionIntentStateVERIFICATION: SubscriptionIntentStateVERIFICATION;
export type SubscriptionIntentStateAUTH = t.Branded<SubscriptionIntentState & 'AUTH', SubscriptionIntentStateAUTHBrand>;
export type SubscriptionIntentStateAUTHC = t.BrandC<t.IntersectionC<[typeof SubscriptionIntentState, t.LiteralC<'AUTH'>]>, SubscriptionIntentStateAUTHBrand>;
export declare const SubscriptionIntentStateAUTH: SubscriptionIntentStateAUTHC;
export type SubscriptionIntentStateAUTHBrand = {
    readonly SubscriptionIntentStateAUTH: unique symbol;
};
/** require('io-ts-validator').validator(SubscriptionIntentStateAUTH).decodeSync(defaultSubscriptionIntentStateAUTH) // => defaultSubscriptionIntentStateAUTH */
export declare const defaultSubscriptionIntentStateAUTH: SubscriptionIntentStateAUTH;
export type SubscriptionIntentStateCANCELLED = t.Branded<SubscriptionIntentState & 'CANCELLED', SubscriptionIntentStateCANCELLEDBrand>;
export type SubscriptionIntentStateCANCELLEDC = t.BrandC<t.IntersectionC<[typeof SubscriptionIntentState, t.LiteralC<'CANCELLED'>]>, SubscriptionIntentStateCANCELLEDBrand>;
export declare const SubscriptionIntentStateCANCELLED: SubscriptionIntentStateCANCELLEDC;
export type SubscriptionIntentStateCANCELLEDBrand = {
    readonly SubscriptionIntentStateCANCELLED: unique symbol;
};
/** require('io-ts-validator').validator(SubscriptionIntentStateCANCELLED).decodeSync(defaultSubscriptionIntentStateCANCELLED) // => defaultSubscriptionIntentStateCANCELLED */
export declare const defaultSubscriptionIntentStateCANCELLED: SubscriptionIntentStateCANCELLED;
export type SubscriptionIntentStateCANCELLED_WITH_ERRORS = t.Branded<SubscriptionIntentState & 'CANCELLED_WITH_ERRORS', SubscriptionIntentStateCANCELLED_WITH_ERRORSBrand>;
export type SubscriptionIntentStateCANCELLED_WITH_ERRORSC = t.BrandC<t.IntersectionC<[typeof SubscriptionIntentState, t.LiteralC<'CANCELLED_WITH_ERRORS'>]>, SubscriptionIntentStateCANCELLED_WITH_ERRORSBrand>;
export declare const SubscriptionIntentStateCANCELLED_WITH_ERRORS: SubscriptionIntentStateCANCELLED_WITH_ERRORSC;
export type SubscriptionIntentStateCANCELLED_WITH_ERRORSBrand = {
    readonly SubscriptionIntentStateCANCELLED_WITH_ERRORS: unique symbol;
};
/** require('io-ts-validator').validator(SubscriptionIntentStateCANCELLED_WITH_ERRORS).decodeSync(defaultSubscriptionIntentStateCANCELLED_WITH_ERRORS) // => defaultSubscriptionIntentStateCANCELLED_WITH_ERRORS */
export declare const defaultSubscriptionIntentStateCANCELLED_WITH_ERRORS: SubscriptionIntentStateCANCELLED_WITH_ERRORS;
export type SubscriptionIntentStateFINISHED = t.Branded<SubscriptionIntentState & 'FINISHED', SubscriptionIntentStateFINISHEDBrand>;
export type SubscriptionIntentStateFINISHEDC = t.BrandC<t.IntersectionC<[typeof SubscriptionIntentState, t.LiteralC<'FINISHED'>]>, SubscriptionIntentStateFINISHEDBrand>;
export declare const SubscriptionIntentStateFINISHED: SubscriptionIntentStateFINISHEDC;
export type SubscriptionIntentStateFINISHEDBrand = {
    readonly SubscriptionIntentStateFINISHED: unique symbol;
};
/** require('io-ts-validator').validator(SubscriptionIntentStateFINISHED).decodeSync(defaultSubscriptionIntentStateFINISHED) // => defaultSubscriptionIntentStateFINISHED */
export declare const defaultSubscriptionIntentStateFINISHED: SubscriptionIntentStateFINISHED;
export type VerificationState = t.Branded<string & ('START' | 'PENDING' | 'STARTED' | 'SUBMITTED' | 'APPROVED' | 'DECLINED' | 'EXPIRED' | 'RESUBMISSION_REQUESTED' | 'ABANDONED'), VerificationStateBrand>;
export type VerificationStateC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'START'>,
        t.LiteralC<'PENDING'>,
        t.LiteralC<'STARTED'>,
        t.LiteralC<'SUBMITTED'>,
        t.LiteralC<'APPROVED'>,
        t.LiteralC<'DECLINED'>,
        t.LiteralC<'EXPIRED'>,
        t.LiteralC<'RESUBMISSION_REQUESTED'>,
        t.LiteralC<'ABANDONED'>
    ]>
]>, VerificationStateBrand>;
export declare const VerificationState: VerificationStateC;
export type VerificationStateBrand = {
    readonly VerificationState: unique symbol;
};
export type VerificationStateSTART = t.Branded<VerificationState & 'START', VerificationStateSTARTBrand>;
export type VerificationStateSTARTC = t.BrandC<t.IntersectionC<[typeof VerificationState, t.LiteralC<'START'>]>, VerificationStateSTARTBrand>;
export declare const VerificationStateSTART: VerificationStateSTARTC;
export type VerificationStateSTARTBrand = {
    readonly VerificationStateSTART: unique symbol;
};
/** require('io-ts-validator').validator(VerificationStateSTART).decodeSync(defaultVerificationStateSTART) // => defaultVerificationStateSTART */
export declare const defaultVerificationStateSTART: VerificationStateSTART;
export type VerificationStatePENDING = t.Branded<VerificationState & 'PENDING', VerificationStatePENDINGBrand>;
export type VerificationStatePENDINGC = t.BrandC<t.IntersectionC<[typeof VerificationState, t.LiteralC<'PENDING'>]>, VerificationStatePENDINGBrand>;
export declare const VerificationStatePENDING: VerificationStatePENDINGC;
export type VerificationStatePENDINGBrand = {
    readonly VerificationStatePENDING: unique symbol;
};
/** require('io-ts-validator').validator(VerificationStatePENDING).decodeSync(defaultVerificationStatePENDING) // => defaultVerificationStatePENDING */
export declare const defaultVerificationStatePENDING: VerificationStatePENDING;
export type VerificationStateSTARTED = t.Branded<VerificationState & 'STARTED', VerificationStateSTARTEDBrand>;
export type VerificationStateSTARTEDC = t.BrandC<t.IntersectionC<[typeof VerificationState, t.LiteralC<'STARTED'>]>, VerificationStateSTARTEDBrand>;
export declare const VerificationStateSTARTED: VerificationStateSTARTEDC;
export type VerificationStateSTARTEDBrand = {
    readonly VerificationStateSTARTED: unique symbol;
};
/** require('io-ts-validator').validator(VerificationStateSTARTED).decodeSync(defaultVerificationStateSTARTED) // => defaultVerificationStateSTARTED */
export declare const defaultVerificationStateSTARTED: VerificationStateSTARTED;
export type VerificationStateSUBMITTED = t.Branded<VerificationState & 'SUBMITTED', VerificationStateSUBMITTEDBrand>;
export type VerificationStateSUBMITTEDC = t.BrandC<t.IntersectionC<[typeof VerificationState, t.LiteralC<'SUBMITTED'>]>, VerificationStateSUBMITTEDBrand>;
export declare const VerificationStateSUBMITTED: VerificationStateSUBMITTEDC;
export type VerificationStateSUBMITTEDBrand = {
    readonly VerificationStateSUBMITTED: unique symbol;
};
/** require('io-ts-validator').validator(VerificationStateSUBMITTED).decodeSync(defaultVerificationStateSUBMITTED) // => defaultVerificationStateSUBMITTED */
export declare const defaultVerificationStateSUBMITTED: VerificationStateSUBMITTED;
export type VerificationStateAPPROVED = t.Branded<VerificationState & 'APPROVED', VerificationStateAPPROVEDBrand>;
export type VerificationStateAPPROVEDC = t.BrandC<t.IntersectionC<[typeof VerificationState, t.LiteralC<'APPROVED'>]>, VerificationStateAPPROVEDBrand>;
export declare const VerificationStateAPPROVED: VerificationStateAPPROVEDC;
export type VerificationStateAPPROVEDBrand = {
    readonly VerificationStateAPPROVED: unique symbol;
};
/** require('io-ts-validator').validator(VerificationStateAPPROVED).decodeSync(defaultVerificationStateAPPROVED) // => defaultVerificationStateAPPROVED */
export declare const defaultVerificationStateAPPROVED: VerificationStateAPPROVED;
export type VerificationStateDECLINED = t.Branded<VerificationState & 'DECLINED', VerificationStateDECLINEDBrand>;
export type VerificationStateDECLINEDC = t.BrandC<t.IntersectionC<[typeof VerificationState, t.LiteralC<'DECLINED'>]>, VerificationStateDECLINEDBrand>;
export declare const VerificationStateDECLINED: VerificationStateDECLINEDC;
export type VerificationStateDECLINEDBrand = {
    readonly VerificationStateDECLINED: unique symbol;
};
/** require('io-ts-validator').validator(VerificationStateDECLINED).decodeSync(defaultVerificationStateDECLINED) // => defaultVerificationStateDECLINED */
export declare const defaultVerificationStateDECLINED: VerificationStateDECLINED;
export type VerificationStateEXPIRED = t.Branded<VerificationState & 'EXPIRED', VerificationStateEXPIREDBrand>;
export type VerificationStateEXPIREDC = t.BrandC<t.IntersectionC<[typeof VerificationState, t.LiteralC<'EXPIRED'>]>, VerificationStateEXPIREDBrand>;
export declare const VerificationStateEXPIRED: VerificationStateEXPIREDC;
export type VerificationStateEXPIREDBrand = {
    readonly VerificationStateEXPIRED: unique symbol;
};
/** require('io-ts-validator').validator(VerificationStateEXPIRED).decodeSync(defaultVerificationStateEXPIRED) // => defaultVerificationStateEXPIRED */
export declare const defaultVerificationStateEXPIRED: VerificationStateEXPIRED;
export type VerificationStateRESUBMISSION_REQUESTED = t.Branded<VerificationState & 'RESUBMISSION_REQUESTED', VerificationStateRESUBMISSION_REQUESTEDBrand>;
export type VerificationStateRESUBMISSION_REQUESTEDC = t.BrandC<t.IntersectionC<[typeof VerificationState, t.LiteralC<'RESUBMISSION_REQUESTED'>]>, VerificationStateRESUBMISSION_REQUESTEDBrand>;
export declare const VerificationStateRESUBMISSION_REQUESTED: VerificationStateRESUBMISSION_REQUESTEDC;
export type VerificationStateRESUBMISSION_REQUESTEDBrand = {
    readonly VerificationStateRESUBMISSION_REQUESTED: unique symbol;
};
/** require('io-ts-validator').validator(VerificationStateRESUBMISSION_REQUESTED).decodeSync(defaultVerificationStateRESUBMISSION_REQUESTED) // => defaultVerificationStateRESUBMISSION_REQUESTED */
export declare const defaultVerificationStateRESUBMISSION_REQUESTED: VerificationStateRESUBMISSION_REQUESTED;
export type VerificationStateABANDONED = t.Branded<VerificationState & 'ABANDONED', VerificationStateABANDONEDBrand>;
export type VerificationStateABANDONEDC = t.BrandC<t.IntersectionC<[typeof VerificationState, t.LiteralC<'ABANDONED'>]>, VerificationStateABANDONEDBrand>;
export declare const VerificationStateABANDONED: VerificationStateABANDONEDC;
export type VerificationStateABANDONEDBrand = {
    readonly VerificationStateABANDONED: unique symbol;
};
/** require('io-ts-validator').validator(VerificationStateABANDONED).decodeSync(defaultVerificationStateABANDONED) // => defaultVerificationStateABANDONED */
export declare const defaultVerificationStateABANDONED: VerificationStateABANDONED;
export type State = t.Branded<unknown, StateBrand>;
export type StateC = t.BrandC<t.UnknownC, StateBrand>;
export declare const State: StateC;
export type StateBrand = {
    readonly State: unique symbol;
};
export default State;
