import * as t from 'io-ts';
import * as Address_2d0a_ from './address';
import * as Common_ffba_ from './common';
import * as TravelMode_5e34_ from './travel-mode';
import * as Units_c404_ from './units';
import * as UnitsGeo_3e31_ from './units-geo';
export declare const schemaId = "https://schemas.maas.global/core/components/station.json";
export type Id = t.Branded<string, IdBrand>;
export type IdC = t.BrandC<t.StringC, IdBrand>;
export declare const Id: IdC;
export type IdBrand = {
    readonly Id: unique symbol;
};
export type Code = t.Branded<string, CodeBrand>;
export type CodeC = t.BrandC<t.StringC, CodeBrand>;
export declare const Code: CodeC;
export type CodeBrand = {
    readonly Code: unique symbol;
};
export type Name = t.Branded<string, NameBrand>;
export type NameC = t.BrandC<t.StringC, NameBrand>;
export declare const Name: NameC;
export type NameBrand = {
    readonly Name: unique symbol;
};
export type Location = t.Branded<UnitsGeo_3e31_.ShortLocationString, LocationBrand>;
export type LocationC = t.BrandC<typeof UnitsGeo_3e31_.ShortLocationString, LocationBrand>;
export declare const Location: LocationC;
export type LocationBrand = {
    readonly Location: unique symbol;
};
export type Address = t.Branded<Address_2d0a_.Address, AddressBrand>;
export type AddressC = t.BrandC<typeof Address_2d0a_.Address, AddressBrand>;
export declare const Address: AddressC;
export type AddressBrand = {
    readonly Address: unique symbol;
};
export type City = t.Branded<Address_2d0a_.City, CityBrand>;
export type CityC = t.BrandC<typeof Address_2d0a_.City, CityBrand>;
export declare const City: CityC;
export type CityBrand = {
    readonly City: unique symbol;
};
export type Country = t.Branded<Address_2d0a_.Country, CountryBrand>;
export type CountryC = t.BrandC<typeof Address_2d0a_.Country, CountryBrand>;
export declare const Country: CountryC;
export type CountryBrand = {
    readonly Country: unique symbol;
};
export type AgencyId = t.Branded<Common_ffba_.AgencyId, AgencyIdBrand>;
export type AgencyIdC = t.BrandC<typeof Common_ffba_.AgencyId, AgencyIdBrand>;
export declare const AgencyId: AgencyIdC;
export type AgencyIdBrand = {
    readonly AgencyId: unique symbol;
};
export type OpeningHours = t.Branded<Record<string, unknown> & Record<string, unknown>, OpeningHoursBrand>;
export type OpeningHoursC = t.BrandC<t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>, OpeningHoursBrand>;
export declare const OpeningHours: OpeningHoursC;
export type OpeningHoursBrand = {
    readonly OpeningHours: unique symbol;
};
export type Facilities = t.Branded<Array<string>, FacilitiesBrand>;
export type FacilitiesC = t.BrandC<t.ArrayC<t.StringC>, FacilitiesBrand>;
export declare const Facilities: FacilitiesC;
export type FacilitiesBrand = {
    readonly Facilities: unique symbol;
};
export type Services = t.Branded<Array<TravelMode_5e34_.TravelMode>, ServicesBrand>;
export type ServicesC = t.BrandC<t.ArrayC<typeof TravelMode_5e34_.TravelMode>, ServicesBrand>;
export declare const Services: ServicesC;
export type ServicesBrand = {
    readonly Services: unique symbol;
};
export type Timetables = t.Branded<Array<{
    id?: string;
    mode?: TravelMode_5e34_.TravelMode;
    name?: string;
    longName?: string;
    schedule?: Units_c404_.Time;
    realtime?: Units_c404_.Time;
    isRealtime?: boolean;
} & Record<string, unknown>>, TimetablesBrand>;
export type TimetablesC = t.BrandC<t.ArrayC<t.IntersectionC<[
    t.PartialC<{
        id: t.StringC;
        mode: typeof TravelMode_5e34_.TravelMode;
        name: t.StringC;
        longName: t.StringC;
        schedule: typeof Units_c404_.Time;
        realtime: typeof Units_c404_.Time;
        isRealtime: t.BooleanC;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>>, TimetablesBrand>;
export declare const Timetables: TimetablesC;
export type TimetablesBrand = {
    readonly Timetables: unique symbol;
};
export type Zone = t.Branded<number | string, ZoneBrand>;
export type ZoneC = t.BrandC<t.UnionC<[t.NumberC, t.StringC]>, ZoneBrand>;
export declare const Zone: ZoneC;
export type ZoneBrand = {
    readonly Zone: unique symbol;
};
export type PlatformCode = t.Branded<number | string, PlatformCodeBrand>;
export type PlatformCodeC = t.BrandC<t.UnionC<[t.NumberC, t.StringC]>, PlatformCodeBrand>;
export declare const PlatformCode: PlatformCodeC;
export type PlatformCodeBrand = {
    readonly PlatformCode: unique symbol;
};
export type Station = t.Branded<Record<string, unknown> & Record<string, unknown>, StationBrand>;
export type StationC = t.BrandC<t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>, StationBrand>;
export declare const Station: StationC;
export type StationBrand = {
    readonly Station: unique symbol;
};
export default Station;
