import * as t from 'io-ts';
import * as Units_c404_ from './units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/subscriptionChangeState.json";
export type State = t.Branded<string & ('IN_PROGRESS' | 'COMPLETED' | 'FAILED'), StateBrand>;
export type StateC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'IN_PROGRESS'>,
        t.LiteralC<'COMPLETED'>,
        t.LiteralC<'FAILED'>
    ]>
]>, StateBrand>;
export declare const State: StateC;
export type StateBrand = {
    readonly State: unique symbol;
};
export type StateIN_PROGRESS = t.Branded<State & 'IN_PROGRESS', StateIN_PROGRESSBrand>;
export type StateIN_PROGRESSC = t.BrandC<t.IntersectionC<[typeof State, t.LiteralC<'IN_PROGRESS'>]>, StateIN_PROGRESSBrand>;
export declare const StateIN_PROGRESS: StateIN_PROGRESSC;
export type StateIN_PROGRESSBrand = {
    readonly StateIN_PROGRESS: unique symbol;
};
/** require('io-ts-validator').validator(StateIN_PROGRESS).decodeSync(defaultStateIN_PROGRESS) // => defaultStateIN_PROGRESS */
export declare const defaultStateIN_PROGRESS: StateIN_PROGRESS;
export type StateCOMPLETED = t.Branded<State & 'COMPLETED', StateCOMPLETEDBrand>;
export type StateCOMPLETEDC = t.BrandC<t.IntersectionC<[typeof State, t.LiteralC<'COMPLETED'>]>, StateCOMPLETEDBrand>;
export declare const StateCOMPLETED: StateCOMPLETEDC;
export type StateCOMPLETEDBrand = {
    readonly StateCOMPLETED: unique symbol;
};
/** require('io-ts-validator').validator(StateCOMPLETED).decodeSync(defaultStateCOMPLETED) // => defaultStateCOMPLETED */
export declare const defaultStateCOMPLETED: StateCOMPLETED;
export type StateFAILED = t.Branded<State & 'FAILED', StateFAILEDBrand>;
export type StateFAILEDC = t.BrandC<t.IntersectionC<[typeof State, t.LiteralC<'FAILED'>]>, StateFAILEDBrand>;
export declare const StateFAILED: StateFAILEDC;
export type StateFAILEDBrand = {
    readonly StateFAILED: unique symbol;
};
/** require('io-ts-validator').validator(StateFAILED).decodeSync(defaultStateFAILED) // => defaultStateFAILED */
export declare const defaultStateFAILED: StateFAILED;
export type FailureKey = t.Branded<string & ('UNKNOWN_ERROR' | 'NOT_ELIGIBLE' | 'EXISTING_TICKET'), FailureKeyBrand>;
export type FailureKeyC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'UNKNOWN_ERROR'>,
        t.LiteralC<'NOT_ELIGIBLE'>,
        t.LiteralC<'EXISTING_TICKET'>
    ]>
]>, FailureKeyBrand>;
export declare const FailureKey: FailureKeyC;
export type FailureKeyBrand = {
    readonly FailureKey: unique symbol;
};
export type FailureKeyUNKNOWN_ERROR = t.Branded<FailureKey & 'UNKNOWN_ERROR', FailureKeyUNKNOWN_ERRORBrand>;
export type FailureKeyUNKNOWN_ERRORC = t.BrandC<t.IntersectionC<[typeof FailureKey, t.LiteralC<'UNKNOWN_ERROR'>]>, FailureKeyUNKNOWN_ERRORBrand>;
export declare const FailureKeyUNKNOWN_ERROR: FailureKeyUNKNOWN_ERRORC;
export type FailureKeyUNKNOWN_ERRORBrand = {
    readonly FailureKeyUNKNOWN_ERROR: unique symbol;
};
/** require('io-ts-validator').validator(FailureKeyUNKNOWN_ERROR).decodeSync(defaultFailureKeyUNKNOWN_ERROR) // => defaultFailureKeyUNKNOWN_ERROR */
export declare const defaultFailureKeyUNKNOWN_ERROR: FailureKeyUNKNOWN_ERROR;
export type FailureKeyNOT_ELIGIBLE = t.Branded<FailureKey & 'NOT_ELIGIBLE', FailureKeyNOT_ELIGIBLEBrand>;
export type FailureKeyNOT_ELIGIBLEC = t.BrandC<t.IntersectionC<[typeof FailureKey, t.LiteralC<'NOT_ELIGIBLE'>]>, FailureKeyNOT_ELIGIBLEBrand>;
export declare const FailureKeyNOT_ELIGIBLE: FailureKeyNOT_ELIGIBLEC;
export type FailureKeyNOT_ELIGIBLEBrand = {
    readonly FailureKeyNOT_ELIGIBLE: unique symbol;
};
/** require('io-ts-validator').validator(FailureKeyNOT_ELIGIBLE).decodeSync(defaultFailureKeyNOT_ELIGIBLE) // => defaultFailureKeyNOT_ELIGIBLE */
export declare const defaultFailureKeyNOT_ELIGIBLE: FailureKeyNOT_ELIGIBLE;
export type FailureKeyEXISTING_TICKET = t.Branded<FailureKey & 'EXISTING_TICKET', FailureKeyEXISTING_TICKETBrand>;
export type FailureKeyEXISTING_TICKETC = t.BrandC<t.IntersectionC<[typeof FailureKey, t.LiteralC<'EXISTING_TICKET'>]>, FailureKeyEXISTING_TICKETBrand>;
export declare const FailureKeyEXISTING_TICKET: FailureKeyEXISTING_TICKETC;
export type FailureKeyEXISTING_TICKETBrand = {
    readonly FailureKeyEXISTING_TICKET: unique symbol;
};
/** require('io-ts-validator').validator(FailureKeyEXISTING_TICKET).decodeSync(defaultFailureKeyEXISTING_TICKET) // => defaultFailureKeyEXISTING_TICKET */
export declare const defaultFailureKeyEXISTING_TICKET: FailureKeyEXISTING_TICKET;
export type SubscriptionChangeState = t.Branded<({
    id?: Units_c404_.Uuid;
    state?: State;
    created?: Units_c404_.Time;
    failureKey?: FailureKey;
} & Record<string, unknown>) & {
    id: Defined;
    state: Defined;
}, SubscriptionChangeStateBrand>;
export type SubscriptionChangeStateC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: typeof Units_c404_.Uuid;
            state: typeof State;
            created: typeof Units_c404_.Time;
            failureKey: typeof FailureKey;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
        state: typeof Defined;
    }>
]>, SubscriptionChangeStateBrand>;
export declare const SubscriptionChangeState: SubscriptionChangeStateC;
export type SubscriptionChangeStateBrand = {
    readonly SubscriptionChangeState: unique symbol;
};
export default SubscriptionChangeState;
