import * as t from 'io-ts';
import * as Cost_250f_ from './cost';
import * as Fare_a3ab_ from './fare';
import * as State_2db3_ from './state';
import * as Units_c404_ from './units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/terms.json";
export type Display = t.Branded<{
    name?: string;
    description?: string;
} & Record<string, unknown>, DisplayBrand>;
export type DisplayC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        name: t.StringC;
        description: t.StringC;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, DisplayBrand>;
export declare const Display: DisplayC;
export type DisplayBrand = {
    readonly Display: unique symbol;
};
export type Seat = t.Branded<{
    route?: string;
    number?: string | number;
    coach?: string | number;
} & Record<string, unknown>, SeatBrand>;
export type SeatC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        route: t.StringC;
        number: t.UnionC<[t.StringC, t.NumberC]>;
        coach: t.UnionC<[t.StringC, t.NumberC]>;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, SeatBrand>;
export declare const Seat: SeatC;
export type SeatBrand = {
    readonly Seat: unique symbol;
};
export type Cancellation = t.Branded<({
    cancellable?: boolean;
    cost?: Cost_250f_.Cost;
    fare?: Fare_a3ab_.Fare;
    refunded?: boolean;
    validity?: ({
        startTime?: Units_c404_.Time;
        endTime?: Units_c404_.Time;
    } & Record<string, unknown>) & {
        endTime: Defined;
    };
    desc?: string;
    expiration?: Units_c404_.Time;
} & Record<string, unknown>) & {
    cancellable: Defined;
    refunded: Defined;
}, CancellationBrand>;
export type CancellationC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            cancellable: t.BooleanC;
            cost: typeof Cost_250f_.Cost;
            fare: typeof Fare_a3ab_.Fare;
            refunded: t.BooleanC;
            validity: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        startTime: typeof Units_c404_.Time;
                        endTime: typeof Units_c404_.Time;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    endTime: typeof Defined;
                }>
            ]>;
            desc: t.StringC;
            expiration: typeof Units_c404_.Time;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        cancellable: typeof Defined;
        refunded: typeof Defined;
    }>
]>, CancellationBrand>;
export declare const Cancellation: CancellationC;
export type CancellationBrand = {
    readonly Cancellation: unique symbol;
};
export type Amendment = t.Branded<({
    amendable?: boolean;
    cost?: Cost_250f_.Cost;
    fare?: Fare_a3ab_.Fare;
} & Record<string, unknown>) & {
    amendable: Defined;
}, AmendmentBrand>;
export type AmendmentC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            amendable: t.BooleanC;
            cost: typeof Cost_250f_.Cost;
            fare: typeof Fare_a3ab_.Fare;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        amendable: typeof Defined;
    }>
]>, AmendmentBrand>;
export declare const Amendment: AmendmentC;
export type AmendmentBrand = {
    readonly Amendment: unique symbol;
};
export type Surcharge = t.Branded<{
    isChargedUpfront?: boolean;
    amount?: number;
    currency?: Units_c404_.Currency;
    percentage?: number;
    minAmount?: number;
    maxAmount?: number;
}, SurchargeBrand>;
export type SurchargeC = t.BrandC<t.PartialC<{
    isChargedUpfront: t.BooleanC;
    amount: t.NumberC;
    currency: typeof Units_c404_.Currency;
    percentage: t.NumberC;
    minAmount: t.NumberC;
    maxAmount: t.NumberC;
}>, SurchargeBrand>;
export declare const Surcharge: SurchargeC;
export type SurchargeBrand = {
    readonly Surcharge: unique symbol;
};
export type Terms = t.Branded<{
    type?: string;
    display?: Display;
    seatings?: Array<Seat>;
    validity?: ({
        startTime?: Units_c404_.Time;
        endTime?: Units_c404_.Time;
        startTimeReturn?: Units_c404_.Time;
        endTimeReturn?: Units_c404_.Time;
    } & Record<string, unknown>) & {
        startTime: Defined;
        endTime: Defined;
    };
    reusable?: boolean;
    reconcilable?: boolean;
    restrictions?: {
        singleDevice?: boolean;
        skipRestrictionCheck?: boolean;
        freeTicket?: Record<string, unknown> & Record<string, unknown>;
        forbidMultipleBookingsActive?: boolean;
    } & Record<string, unknown>;
    surcharges?: {
        midnight?: Surcharge;
        pickup?: Surcharge;
    } & Record<string, unknown>;
    cancellation?: {
        counter?: {
            time?: number;
            fromState?: State_2db3_.BookingState;
        } & Record<string, unknown>;
        cancellationFormActionUrl?: Units_c404_.Url;
        outward?: Cancellation;
        return?: Cancellation;
    } & Record<string, unknown>;
    amendment?: {
        outward?: Amendment;
        return?: Amendment;
    } & Record<string, unknown>;
    prePurchaseGuidanceUrl?: Units_c404_.Url;
    fareRates?: Array<({
        amount?: number;
        currency?: Units_c404_.CurrencyOrToken;
        timeInterval?: number;
        startAt?: number;
        type?: 'maxRate' | 'missedReturnPenalty' | 'extra' | 'perKilometer' | 'perParkMinute' | 'unlockFee';
    } & Record<string, unknown>) & {
        amount: Defined;
        currency: Defined;
    }>;
} & Record<string, unknown>, TermsBrand>;
export type TermsC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        type: t.StringC;
        display: typeof Display;
        seatings: t.ArrayC<typeof Seat>;
        validity: t.IntersectionC<[
            t.IntersectionC<[
                t.PartialC<{
                    startTime: typeof Units_c404_.Time;
                    endTime: typeof Units_c404_.Time;
                    startTimeReturn: typeof Units_c404_.Time;
                    endTimeReturn: typeof Units_c404_.Time;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>,
            t.TypeC<{
                startTime: typeof Defined;
                endTime: typeof Defined;
            }>
        ]>;
        reusable: t.BooleanC;
        reconcilable: t.BooleanC;
        restrictions: t.IntersectionC<[
            t.PartialC<{
                singleDevice: t.BooleanC;
                skipRestrictionCheck: t.BooleanC;
                freeTicket: t.IntersectionC<[
                    t.UnknownRecordC,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>;
                forbidMultipleBookingsActive: t.BooleanC;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        surcharges: t.IntersectionC<[
            t.PartialC<{
                midnight: typeof Surcharge;
                pickup: typeof Surcharge;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        cancellation: t.IntersectionC<[
            t.PartialC<{
                counter: t.IntersectionC<[
                    t.PartialC<{
                        time: t.NumberC;
                        fromState: typeof State_2db3_.BookingState;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>;
                cancellationFormActionUrl: typeof Units_c404_.Url;
                outward: typeof Cancellation;
                return: typeof Cancellation;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        amendment: t.IntersectionC<[
            t.PartialC<{
                outward: typeof Amendment;
                return: typeof Amendment;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        prePurchaseGuidanceUrl: typeof Units_c404_.Url;
        fareRates: t.ArrayC<t.IntersectionC<[
            t.IntersectionC<[
                t.PartialC<{
                    amount: t.NumberC;
                    currency: typeof Units_c404_.CurrencyOrToken;
                    timeInterval: t.NumberC;
                    startAt: t.NumberC;
                    type: t.UnionC<[
                        t.LiteralC<'maxRate'>,
                        t.LiteralC<'missedReturnPenalty'>,
                        t.LiteralC<'extra'>,
                        t.LiteralC<'perKilometer'>,
                        t.LiteralC<'perParkMinute'>,
                        t.LiteralC<'unlockFee'>
                    ]>;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>,
            t.TypeC<{
                amount: typeof Defined;
                currency: typeof Defined;
            }>
        ]>>;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, TermsBrand>;
export declare const Terms: TermsC;
export type TermsBrand = {
    readonly Terms: unique symbol;
};
export default Terms;
