import * as t from 'io-ts';
export declare const schemaId = "https://schemas.maas.global/core/components/travel-mode.json";
export type WaitingMode = t.Branded<string & 'WAIT', WaitingModeBrand>;
export type WaitingModeC = t.BrandC<t.IntersectionC<[t.StringC, t.LiteralC<'WAIT'>]>, WaitingModeBrand>;
export declare const WaitingMode: WaitingModeC;
export type WaitingModeBrand = {
    readonly WaitingMode: unique symbol;
};
export type WaitingModeWAIT = t.Branded<WaitingMode & 'WAIT', WaitingModeWAITBrand>;
export type WaitingModeWAITC = t.BrandC<t.IntersectionC<[typeof WaitingMode, t.LiteralC<'WAIT'>]>, WaitingModeWAITBrand>;
export declare const WaitingModeWAIT: WaitingModeWAITC;
export type WaitingModeWAITBrand = {
    readonly WaitingModeWAIT: unique symbol;
};
/** require('io-ts-validator').validator(WaitingModeWAIT).decodeSync(defaultWaitingModeWAIT) // => defaultWaitingModeWAIT */
export declare const defaultWaitingModeWAIT: WaitingModeWAIT;
export type TransferMode = t.Branded<string & ('LEG_SWITCH' | 'TRANSFER'), TransferModeBrand>;
export type TransferModeC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[t.LiteralC<'LEG_SWITCH'>, t.LiteralC<'TRANSFER'>]>
]>, TransferModeBrand>;
export declare const TransferMode: TransferModeC;
export type TransferModeBrand = {
    readonly TransferMode: unique symbol;
};
export type TransferModeLEG_SWITCH = t.Branded<TransferMode & 'LEG_SWITCH', TransferModeLEG_SWITCHBrand>;
export type TransferModeLEG_SWITCHC = t.BrandC<t.IntersectionC<[typeof TransferMode, t.LiteralC<'LEG_SWITCH'>]>, TransferModeLEG_SWITCHBrand>;
export declare const TransferModeLEG_SWITCH: TransferModeLEG_SWITCHC;
export type TransferModeLEG_SWITCHBrand = {
    readonly TransferModeLEG_SWITCH: unique symbol;
};
/** require('io-ts-validator').validator(TransferModeLEG_SWITCH).decodeSync(defaultTransferModeLEG_SWITCH) // => defaultTransferModeLEG_SWITCH */
export declare const defaultTransferModeLEG_SWITCH: TransferModeLEG_SWITCH;
export type TransferModeTRANSFER = t.Branded<TransferMode & 'TRANSFER', TransferModeTRANSFERBrand>;
export type TransferModeTRANSFERC = t.BrandC<t.IntersectionC<[typeof TransferMode, t.LiteralC<'TRANSFER'>]>, TransferModeTRANSFERBrand>;
export declare const TransferModeTRANSFER: TransferModeTRANSFERC;
export type TransferModeTRANSFERBrand = {
    readonly TransferModeTRANSFER: unique symbol;
};
/** require('io-ts-validator').validator(TransferModeTRANSFER).decodeSync(defaultTransferModeTRANSFER) // => defaultTransferModeTRANSFER */
export declare const defaultTransferModeTRANSFER: TransferModeTRANSFER;
export type PersonalMode = t.Branded<string & ('BICYCLE' | 'CAR' | 'SCOOTER' | 'SHARED_BICYCLE' | 'WALK' | 'SHARED_E_BICYCLE'), PersonalModeBrand>;
export type PersonalModeC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'BICYCLE'>,
        t.LiteralC<'CAR'>,
        t.LiteralC<'SCOOTER'>,
        t.LiteralC<'SHARED_BICYCLE'>,
        t.LiteralC<'WALK'>,
        t.LiteralC<'SHARED_E_BICYCLE'>
    ]>
]>, PersonalModeBrand>;
export declare const PersonalMode: PersonalModeC;
export type PersonalModeBrand = {
    readonly PersonalMode: unique symbol;
};
export type PersonalModeBICYCLE = t.Branded<PersonalMode & 'BICYCLE', PersonalModeBICYCLEBrand>;
export type PersonalModeBICYCLEC = t.BrandC<t.IntersectionC<[typeof PersonalMode, t.LiteralC<'BICYCLE'>]>, PersonalModeBICYCLEBrand>;
export declare const PersonalModeBICYCLE: PersonalModeBICYCLEC;
export type PersonalModeBICYCLEBrand = {
    readonly PersonalModeBICYCLE: unique symbol;
};
/** require('io-ts-validator').validator(PersonalModeBICYCLE).decodeSync(defaultPersonalModeBICYCLE) // => defaultPersonalModeBICYCLE */
export declare const defaultPersonalModeBICYCLE: PersonalModeBICYCLE;
export type PersonalModeCAR = t.Branded<PersonalMode & 'CAR', PersonalModeCARBrand>;
export type PersonalModeCARC = t.BrandC<t.IntersectionC<[typeof PersonalMode, t.LiteralC<'CAR'>]>, PersonalModeCARBrand>;
export declare const PersonalModeCAR: PersonalModeCARC;
export type PersonalModeCARBrand = {
    readonly PersonalModeCAR: unique symbol;
};
/** require('io-ts-validator').validator(PersonalModeCAR).decodeSync(defaultPersonalModeCAR) // => defaultPersonalModeCAR */
export declare const defaultPersonalModeCAR: PersonalModeCAR;
export type PersonalModeSCOOTER = t.Branded<PersonalMode & 'SCOOTER', PersonalModeSCOOTERBrand>;
export type PersonalModeSCOOTERC = t.BrandC<t.IntersectionC<[typeof PersonalMode, t.LiteralC<'SCOOTER'>]>, PersonalModeSCOOTERBrand>;
export declare const PersonalModeSCOOTER: PersonalModeSCOOTERC;
export type PersonalModeSCOOTERBrand = {
    readonly PersonalModeSCOOTER: unique symbol;
};
/** require('io-ts-validator').validator(PersonalModeSCOOTER).decodeSync(defaultPersonalModeSCOOTER) // => defaultPersonalModeSCOOTER */
export declare const defaultPersonalModeSCOOTER: PersonalModeSCOOTER;
export type PersonalModeSHARED_BICYCLE = t.Branded<PersonalMode & 'SHARED_BICYCLE', PersonalModeSHARED_BICYCLEBrand>;
export type PersonalModeSHARED_BICYCLEC = t.BrandC<t.IntersectionC<[typeof PersonalMode, t.LiteralC<'SHARED_BICYCLE'>]>, PersonalModeSHARED_BICYCLEBrand>;
export declare const PersonalModeSHARED_BICYCLE: PersonalModeSHARED_BICYCLEC;
export type PersonalModeSHARED_BICYCLEBrand = {
    readonly PersonalModeSHARED_BICYCLE: unique symbol;
};
/** require('io-ts-validator').validator(PersonalModeSHARED_BICYCLE).decodeSync(defaultPersonalModeSHARED_BICYCLE) // => defaultPersonalModeSHARED_BICYCLE */
export declare const defaultPersonalModeSHARED_BICYCLE: PersonalModeSHARED_BICYCLE;
export type PersonalModeWALK = t.Branded<PersonalMode & 'WALK', PersonalModeWALKBrand>;
export type PersonalModeWALKC = t.BrandC<t.IntersectionC<[typeof PersonalMode, t.LiteralC<'WALK'>]>, PersonalModeWALKBrand>;
export declare const PersonalModeWALK: PersonalModeWALKC;
export type PersonalModeWALKBrand = {
    readonly PersonalModeWALK: unique symbol;
};
/** require('io-ts-validator').validator(PersonalModeWALK).decodeSync(defaultPersonalModeWALK) // => defaultPersonalModeWALK */
export declare const defaultPersonalModeWALK: PersonalModeWALK;
export type PersonalModeSHARED_E_BICYCLE = t.Branded<PersonalMode & 'SHARED_E_BICYCLE', PersonalModeSHARED_E_BICYCLEBrand>;
export type PersonalModeSHARED_E_BICYCLEC = t.BrandC<t.IntersectionC<[typeof PersonalMode, t.LiteralC<'SHARED_E_BICYCLE'>]>, PersonalModeSHARED_E_BICYCLEBrand>;
export declare const PersonalModeSHARED_E_BICYCLE: PersonalModeSHARED_E_BICYCLEC;
export type PersonalModeSHARED_E_BICYCLEBrand = {
    readonly PersonalModeSHARED_E_BICYCLE: unique symbol;
};
/** require('io-ts-validator').validator(PersonalModeSHARED_E_BICYCLE).decodeSync(defaultPersonalModeSHARED_E_BICYCLE) // => defaultPersonalModeSHARED_E_BICYCLE */
export declare const defaultPersonalModeSHARED_E_BICYCLE: PersonalModeSHARED_E_BICYCLE;
export type PublicTransitMode = t.Branded<string & ('AEROPLANE' | 'BUS' | 'FERRY' | 'RAIL' | 'SUBWAY' | 'TRAIN' | 'TRAM' | 'TRANSIT'), PublicTransitModeBrand>;
export type PublicTransitModeC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'AEROPLANE'>,
        t.LiteralC<'BUS'>,
        t.LiteralC<'FERRY'>,
        t.LiteralC<'RAIL'>,
        t.LiteralC<'SUBWAY'>,
        t.LiteralC<'TRAIN'>,
        t.LiteralC<'TRAM'>,
        t.LiteralC<'TRANSIT'>
    ]>
]>, PublicTransitModeBrand>;
export declare const PublicTransitMode: PublicTransitModeC;
export type PublicTransitModeBrand = {
    readonly PublicTransitMode: unique symbol;
};
export type PublicTransitModeAEROPLANE = t.Branded<PublicTransitMode & 'AEROPLANE', PublicTransitModeAEROPLANEBrand>;
export type PublicTransitModeAEROPLANEC = t.BrandC<t.IntersectionC<[typeof PublicTransitMode, t.LiteralC<'AEROPLANE'>]>, PublicTransitModeAEROPLANEBrand>;
export declare const PublicTransitModeAEROPLANE: PublicTransitModeAEROPLANEC;
export type PublicTransitModeAEROPLANEBrand = {
    readonly PublicTransitModeAEROPLANE: unique symbol;
};
/** require('io-ts-validator').validator(PublicTransitModeAEROPLANE).decodeSync(defaultPublicTransitModeAEROPLANE) // => defaultPublicTransitModeAEROPLANE */
export declare const defaultPublicTransitModeAEROPLANE: PublicTransitModeAEROPLANE;
export type PublicTransitModeBUS = t.Branded<PublicTransitMode & 'BUS', PublicTransitModeBUSBrand>;
export type PublicTransitModeBUSC = t.BrandC<t.IntersectionC<[typeof PublicTransitMode, t.LiteralC<'BUS'>]>, PublicTransitModeBUSBrand>;
export declare const PublicTransitModeBUS: PublicTransitModeBUSC;
export type PublicTransitModeBUSBrand = {
    readonly PublicTransitModeBUS: unique symbol;
};
/** require('io-ts-validator').validator(PublicTransitModeBUS).decodeSync(defaultPublicTransitModeBUS) // => defaultPublicTransitModeBUS */
export declare const defaultPublicTransitModeBUS: PublicTransitModeBUS;
export type PublicTransitModeFERRY = t.Branded<PublicTransitMode & 'FERRY', PublicTransitModeFERRYBrand>;
export type PublicTransitModeFERRYC = t.BrandC<t.IntersectionC<[typeof PublicTransitMode, t.LiteralC<'FERRY'>]>, PublicTransitModeFERRYBrand>;
export declare const PublicTransitModeFERRY: PublicTransitModeFERRYC;
export type PublicTransitModeFERRYBrand = {
    readonly PublicTransitModeFERRY: unique symbol;
};
/** require('io-ts-validator').validator(PublicTransitModeFERRY).decodeSync(defaultPublicTransitModeFERRY) // => defaultPublicTransitModeFERRY */
export declare const defaultPublicTransitModeFERRY: PublicTransitModeFERRY;
export type PublicTransitModeRAIL = t.Branded<PublicTransitMode & 'RAIL', PublicTransitModeRAILBrand>;
export type PublicTransitModeRAILC = t.BrandC<t.IntersectionC<[typeof PublicTransitMode, t.LiteralC<'RAIL'>]>, PublicTransitModeRAILBrand>;
export declare const PublicTransitModeRAIL: PublicTransitModeRAILC;
export type PublicTransitModeRAILBrand = {
    readonly PublicTransitModeRAIL: unique symbol;
};
/** require('io-ts-validator').validator(PublicTransitModeRAIL).decodeSync(defaultPublicTransitModeRAIL) // => defaultPublicTransitModeRAIL */
export declare const defaultPublicTransitModeRAIL: PublicTransitModeRAIL;
export type PublicTransitModeSUBWAY = t.Branded<PublicTransitMode & 'SUBWAY', PublicTransitModeSUBWAYBrand>;
export type PublicTransitModeSUBWAYC = t.BrandC<t.IntersectionC<[typeof PublicTransitMode, t.LiteralC<'SUBWAY'>]>, PublicTransitModeSUBWAYBrand>;
export declare const PublicTransitModeSUBWAY: PublicTransitModeSUBWAYC;
export type PublicTransitModeSUBWAYBrand = {
    readonly PublicTransitModeSUBWAY: unique symbol;
};
/** require('io-ts-validator').validator(PublicTransitModeSUBWAY).decodeSync(defaultPublicTransitModeSUBWAY) // => defaultPublicTransitModeSUBWAY */
export declare const defaultPublicTransitModeSUBWAY: PublicTransitModeSUBWAY;
export type PublicTransitModeTRAIN = t.Branded<PublicTransitMode & 'TRAIN', PublicTransitModeTRAINBrand>;
export type PublicTransitModeTRAINC = t.BrandC<t.IntersectionC<[typeof PublicTransitMode, t.LiteralC<'TRAIN'>]>, PublicTransitModeTRAINBrand>;
export declare const PublicTransitModeTRAIN: PublicTransitModeTRAINC;
export type PublicTransitModeTRAINBrand = {
    readonly PublicTransitModeTRAIN: unique symbol;
};
/** require('io-ts-validator').validator(PublicTransitModeTRAIN).decodeSync(defaultPublicTransitModeTRAIN) // => defaultPublicTransitModeTRAIN */
export declare const defaultPublicTransitModeTRAIN: PublicTransitModeTRAIN;
export type PublicTransitModeTRAM = t.Branded<PublicTransitMode & 'TRAM', PublicTransitModeTRAMBrand>;
export type PublicTransitModeTRAMC = t.BrandC<t.IntersectionC<[typeof PublicTransitMode, t.LiteralC<'TRAM'>]>, PublicTransitModeTRAMBrand>;
export declare const PublicTransitModeTRAM: PublicTransitModeTRAMC;
export type PublicTransitModeTRAMBrand = {
    readonly PublicTransitModeTRAM: unique symbol;
};
/** require('io-ts-validator').validator(PublicTransitModeTRAM).decodeSync(defaultPublicTransitModeTRAM) // => defaultPublicTransitModeTRAM */
export declare const defaultPublicTransitModeTRAM: PublicTransitModeTRAM;
export type PublicTransitModeTRANSIT = t.Branded<PublicTransitMode & 'TRANSIT', PublicTransitModeTRANSITBrand>;
export type PublicTransitModeTRANSITC = t.BrandC<t.IntersectionC<[typeof PublicTransitMode, t.LiteralC<'TRANSIT'>]>, PublicTransitModeTRANSITBrand>;
export declare const PublicTransitModeTRANSIT: PublicTransitModeTRANSITC;
export type PublicTransitModeTRANSITBrand = {
    readonly PublicTransitModeTRANSIT: unique symbol;
};
/** require('io-ts-validator').validator(PublicTransitModeTRANSIT).decodeSync(defaultPublicTransitModeTRANSIT) // => defaultPublicTransitModeTRANSIT */
export declare const defaultPublicTransitModeTRANSIT: PublicTransitModeTRANSIT;
export type PrivateTransitMode = t.Branded<string & ('BUSISH' | 'CABLE_CAR' | 'CAR' | 'FUNICULAR' | 'GONDOLA' | 'SHARED_CAR' | 'TAXI' | 'TRAINISH'), PrivateTransitModeBrand>;
export type PrivateTransitModeC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'BUSISH'>,
        t.LiteralC<'CABLE_CAR'>,
        t.LiteralC<'CAR'>,
        t.LiteralC<'FUNICULAR'>,
        t.LiteralC<'GONDOLA'>,
        t.LiteralC<'SHARED_CAR'>,
        t.LiteralC<'TAXI'>,
        t.LiteralC<'TRAINISH'>
    ]>
]>, PrivateTransitModeBrand>;
export declare const PrivateTransitMode: PrivateTransitModeC;
export type PrivateTransitModeBrand = {
    readonly PrivateTransitMode: unique symbol;
};
export type PrivateTransitModeBUSISH = t.Branded<PrivateTransitMode & 'BUSISH', PrivateTransitModeBUSISHBrand>;
export type PrivateTransitModeBUSISHC = t.BrandC<t.IntersectionC<[typeof PrivateTransitMode, t.LiteralC<'BUSISH'>]>, PrivateTransitModeBUSISHBrand>;
export declare const PrivateTransitModeBUSISH: PrivateTransitModeBUSISHC;
export type PrivateTransitModeBUSISHBrand = {
    readonly PrivateTransitModeBUSISH: unique symbol;
};
/** require('io-ts-validator').validator(PrivateTransitModeBUSISH).decodeSync(defaultPrivateTransitModeBUSISH) // => defaultPrivateTransitModeBUSISH */
export declare const defaultPrivateTransitModeBUSISH: PrivateTransitModeBUSISH;
export type PrivateTransitModeCABLE_CAR = t.Branded<PrivateTransitMode & 'CABLE_CAR', PrivateTransitModeCABLE_CARBrand>;
export type PrivateTransitModeCABLE_CARC = t.BrandC<t.IntersectionC<[typeof PrivateTransitMode, t.LiteralC<'CABLE_CAR'>]>, PrivateTransitModeCABLE_CARBrand>;
export declare const PrivateTransitModeCABLE_CAR: PrivateTransitModeCABLE_CARC;
export type PrivateTransitModeCABLE_CARBrand = {
    readonly PrivateTransitModeCABLE_CAR: unique symbol;
};
/** require('io-ts-validator').validator(PrivateTransitModeCABLE_CAR).decodeSync(defaultPrivateTransitModeCABLE_CAR) // => defaultPrivateTransitModeCABLE_CAR */
export declare const defaultPrivateTransitModeCABLE_CAR: PrivateTransitModeCABLE_CAR;
export type PrivateTransitModeCAR = t.Branded<PrivateTransitMode & 'CAR', PrivateTransitModeCARBrand>;
export type PrivateTransitModeCARC = t.BrandC<t.IntersectionC<[typeof PrivateTransitMode, t.LiteralC<'CAR'>]>, PrivateTransitModeCARBrand>;
export declare const PrivateTransitModeCAR: PrivateTransitModeCARC;
export type PrivateTransitModeCARBrand = {
    readonly PrivateTransitModeCAR: unique symbol;
};
/** require('io-ts-validator').validator(PrivateTransitModeCAR).decodeSync(defaultPrivateTransitModeCAR) // => defaultPrivateTransitModeCAR */
export declare const defaultPrivateTransitModeCAR: PrivateTransitModeCAR;
export type PrivateTransitModeFUNICULAR = t.Branded<PrivateTransitMode & 'FUNICULAR', PrivateTransitModeFUNICULARBrand>;
export type PrivateTransitModeFUNICULARC = t.BrandC<t.IntersectionC<[typeof PrivateTransitMode, t.LiteralC<'FUNICULAR'>]>, PrivateTransitModeFUNICULARBrand>;
export declare const PrivateTransitModeFUNICULAR: PrivateTransitModeFUNICULARC;
export type PrivateTransitModeFUNICULARBrand = {
    readonly PrivateTransitModeFUNICULAR: unique symbol;
};
/** require('io-ts-validator').validator(PrivateTransitModeFUNICULAR).decodeSync(defaultPrivateTransitModeFUNICULAR) // => defaultPrivateTransitModeFUNICULAR */
export declare const defaultPrivateTransitModeFUNICULAR: PrivateTransitModeFUNICULAR;
export type PrivateTransitModeGONDOLA = t.Branded<PrivateTransitMode & 'GONDOLA', PrivateTransitModeGONDOLABrand>;
export type PrivateTransitModeGONDOLAC = t.BrandC<t.IntersectionC<[typeof PrivateTransitMode, t.LiteralC<'GONDOLA'>]>, PrivateTransitModeGONDOLABrand>;
export declare const PrivateTransitModeGONDOLA: PrivateTransitModeGONDOLAC;
export type PrivateTransitModeGONDOLABrand = {
    readonly PrivateTransitModeGONDOLA: unique symbol;
};
/** require('io-ts-validator').validator(PrivateTransitModeGONDOLA).decodeSync(defaultPrivateTransitModeGONDOLA) // => defaultPrivateTransitModeGONDOLA */
export declare const defaultPrivateTransitModeGONDOLA: PrivateTransitModeGONDOLA;
export type PrivateTransitModeSHARED_CAR = t.Branded<PrivateTransitMode & 'SHARED_CAR', PrivateTransitModeSHARED_CARBrand>;
export type PrivateTransitModeSHARED_CARC = t.BrandC<t.IntersectionC<[typeof PrivateTransitMode, t.LiteralC<'SHARED_CAR'>]>, PrivateTransitModeSHARED_CARBrand>;
export declare const PrivateTransitModeSHARED_CAR: PrivateTransitModeSHARED_CARC;
export type PrivateTransitModeSHARED_CARBrand = {
    readonly PrivateTransitModeSHARED_CAR: unique symbol;
};
/** require('io-ts-validator').validator(PrivateTransitModeSHARED_CAR).decodeSync(defaultPrivateTransitModeSHARED_CAR) // => defaultPrivateTransitModeSHARED_CAR */
export declare const defaultPrivateTransitModeSHARED_CAR: PrivateTransitModeSHARED_CAR;
export type PrivateTransitModeTAXI = t.Branded<PrivateTransitMode & 'TAXI', PrivateTransitModeTAXIBrand>;
export type PrivateTransitModeTAXIC = t.BrandC<t.IntersectionC<[typeof PrivateTransitMode, t.LiteralC<'TAXI'>]>, PrivateTransitModeTAXIBrand>;
export declare const PrivateTransitModeTAXI: PrivateTransitModeTAXIC;
export type PrivateTransitModeTAXIBrand = {
    readonly PrivateTransitModeTAXI: unique symbol;
};
/** require('io-ts-validator').validator(PrivateTransitModeTAXI).decodeSync(defaultPrivateTransitModeTAXI) // => defaultPrivateTransitModeTAXI */
export declare const defaultPrivateTransitModeTAXI: PrivateTransitModeTAXI;
export type PrivateTransitModeTRAINISH = t.Branded<PrivateTransitMode & 'TRAINISH', PrivateTransitModeTRAINISHBrand>;
export type PrivateTransitModeTRAINISHC = t.BrandC<t.IntersectionC<[typeof PrivateTransitMode, t.LiteralC<'TRAINISH'>]>, PrivateTransitModeTRAINISHBrand>;
export declare const PrivateTransitModeTRAINISH: PrivateTransitModeTRAINISHC;
export type PrivateTransitModeTRAINISHBrand = {
    readonly PrivateTransitModeTRAINISH: unique symbol;
};
/** require('io-ts-validator').validator(PrivateTransitModeTRAINISH).decodeSync(defaultPrivateTransitModeTRAINISH) // => defaultPrivateTransitModeTRAINISH */
export declare const defaultPrivateTransitModeTRAINISH: PrivateTransitModeTRAINISH;
export type TravelMode = t.Branded<WaitingMode | TransferMode | PersonalMode | PublicTransitMode | PrivateTransitMode, TravelModeBrand>;
export type TravelModeC = t.BrandC<t.UnionC<[
    typeof WaitingMode,
    typeof TransferMode,
    typeof PersonalMode,
    typeof PublicTransitMode,
    typeof PrivateTransitMode
]>, TravelModeBrand>;
export declare const TravelMode: TravelModeC;
export type TravelModeBrand = {
    readonly TravelMode: unique symbol;
};
export default TravelMode;
