import * as t from 'io-ts';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/components/units-geo.json";
export type Latitude = t.Branded<number, LatitudeBrand>;
export type LatitudeC = t.BrandC<t.NumberC, LatitudeBrand>;
export declare const Latitude: LatitudeC;
export type LatitudeBrand = {
    readonly Latitude: unique symbol;
};
/** require('io-ts-validator').validator(Latitude).decodeSync(minimumLatitude) // => minimumLatitude */
export declare const minimumLatitude: Latitude;
/** require('io-ts-validator').validator(Latitude).decodeSync(maximumLatitude) // => maximumLatitude */
export declare const maximumLatitude: Latitude;
export type Longitude = t.Branded<number, LongitudeBrand>;
export type LongitudeC = t.BrandC<t.NumberC, LongitudeBrand>;
export declare const Longitude: LongitudeC;
export type LongitudeBrand = {
    readonly Longitude: unique symbol;
};
/** require('io-ts-validator').validator(Longitude).decodeSync(minimumLongitude) // => minimumLongitude */
export declare const minimumLongitude: Longitude;
/** require('io-ts-validator').validator(Longitude).decodeSync(maximumLongitude) // => maximumLongitude */
export declare const maximumLongitude: Longitude;
export type RelaxedLatitude = t.Branded<number, RelaxedLatitudeBrand>;
export type RelaxedLatitudeC = t.BrandC<t.NumberC, RelaxedLatitudeBrand>;
export declare const RelaxedLatitude: RelaxedLatitudeC;
export type RelaxedLatitudeBrand = {
    readonly RelaxedLatitude: unique symbol;
};
/** require('io-ts-validator').validator(RelaxedLatitude).decodeSync(minimumRelaxedLatitude) // => minimumRelaxedLatitude */
export declare const minimumRelaxedLatitude: RelaxedLatitude;
/** require('io-ts-validator').validator(RelaxedLatitude).decodeSync(maximumRelaxedLatitude) // => maximumRelaxedLatitude */
export declare const maximumRelaxedLatitude: RelaxedLatitude;
export type RelaxedLongitude = t.Branded<number, RelaxedLongitudeBrand>;
export type RelaxedLongitudeC = t.BrandC<t.NumberC, RelaxedLongitudeBrand>;
export declare const RelaxedLongitude: RelaxedLongitudeC;
export type RelaxedLongitudeBrand = {
    readonly RelaxedLongitude: unique symbol;
};
/** require('io-ts-validator').validator(RelaxedLongitude).decodeSync(minimumRelaxedLongitude) // => minimumRelaxedLongitude */
export declare const minimumRelaxedLongitude: RelaxedLongitude;
/** require('io-ts-validator').validator(RelaxedLongitude).decodeSync(maximumRelaxedLongitude) // => maximumRelaxedLongitude */
export declare const maximumRelaxedLongitude: RelaxedLongitude;
export type Distance = t.Branded<number, DistanceBrand>;
export type DistanceC = t.BrandC<t.NumberC, DistanceBrand>;
export declare const Distance: DistanceC;
export type DistanceBrand = {
    readonly Distance: unique symbol;
};
/** require('io-ts-validator').validator(Distance).decodeSync(minimumDistance) // => minimumDistance */
export declare const minimumDistance: Distance;
/** require('io-ts-validator').validator(Distance).decodeSync(maximumDistance) // => maximumDistance */
export declare const maximumDistance: Distance;
export type Polyline = t.Branded<string, PolylineBrand>;
export type PolylineC = t.BrandC<t.StringC, PolylineBrand>;
export declare const Polyline: PolylineC;
export type PolylineBrand = {
    readonly Polyline: unique symbol;
};
export type Location = t.Branded<({
    lat?: Latitude;
    lon?: Longitude;
} & Record<string, unknown>) & {
    lat: Defined;
    lon: Defined;
}, LocationBrand>;
export type LocationC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            lat: typeof Latitude;
            lon: typeof Longitude;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        lat: typeof Defined;
        lon: typeof Defined;
    }>
]>, LocationBrand>;
export declare const Location: LocationC;
export type LocationBrand = {
    readonly Location: unique symbol;
};
export type RelaxedLocation = t.Branded<({
    lat?: RelaxedLatitude;
    lon?: RelaxedLongitude;
} & Record<string, unknown>) & {
    lat: Defined;
    lon: Defined;
}, RelaxedLocationBrand>;
export type RelaxedLocationC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            lat: typeof RelaxedLatitude;
            lon: typeof RelaxedLongitude;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        lat: typeof Defined;
        lon: typeof Defined;
    }>
]>, RelaxedLocationBrand>;
export declare const RelaxedLocation: RelaxedLocationC;
export type RelaxedLocationBrand = {
    readonly RelaxedLocation: unique symbol;
};
export type ShortLocation = t.Branded<[Latitude, Longitude], ShortLocationBrand>;
export type ShortLocationC = t.BrandC<t.TupleC<[typeof Latitude, typeof Longitude]>, ShortLocationBrand>;
export declare const ShortLocation: ShortLocationC;
export type ShortLocationBrand = {
    readonly ShortLocation: unique symbol;
};
export type ShortLocationString = t.Branded<string, ShortLocationStringBrand>;
export type ShortLocationStringC = t.BrandC<t.StringC, ShortLocationStringBrand>;
export declare const ShortLocationString: ShortLocationStringC;
export type ShortLocationStringBrand = {
    readonly ShortLocationString: unique symbol;
};
export type UnitsGeo = t.Branded<unknown, UnitsGeoBrand>;
export type UnitsGeoC = t.BrandC<t.UnknownC, UnitsGeoBrand>;
export declare const UnitsGeo: UnitsGeoC;
export type UnitsGeoBrand = {
    readonly UnitsGeo: unique symbol;
};
export default UnitsGeo;
