import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
export declare const schemaId = "https://schemas.maas.global/core/components/units.json";
export type Uuid = t.Branded<string, UuidBrand>;
export type UuidC = t.BrandC<t.StringC, UuidBrand>;
export declare const Uuid: UuidC;
export type UuidBrand = {
    readonly Uuid: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Uuid)).decodeSync(examplesUuid) // => examplesUuid */
export declare const examplesUuid: NonEmptyArray<Uuid>;
export type HostnameLabel = t.Branded<string, HostnameLabelBrand>;
export type HostnameLabelC = t.BrandC<t.StringC, HostnameLabelBrand>;
export declare const HostnameLabel: HostnameLabelC;
export type HostnameLabelBrand = {
    readonly HostnameLabel: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(HostnameLabel)).decodeSync(examplesHostnameLabel) // => examplesHostnameLabel */
export declare const examplesHostnameLabel: NonEmptyArray<HostnameLabel>;
export type HostnameDelimiter = t.Branded<string & '.', HostnameDelimiterBrand>;
export type HostnameDelimiterC = t.BrandC<t.IntersectionC<[t.StringC, t.LiteralC<'.'>]>, HostnameDelimiterBrand>;
export declare const HostnameDelimiter: HostnameDelimiterC;
export type HostnameDelimiterBrand = {
    readonly HostnameDelimiter: unique symbol;
};
/** require('io-ts-validator').validator(HostnameDelimiter).decodeSync(defaultHostnameDelimiter) // => defaultHostnameDelimiter */
export declare const defaultHostnameDelimiter: HostnameDelimiter;
export type Hostname = t.Branded<string, HostnameBrand>;
export type HostnameC = t.BrandC<t.StringC, HostnameBrand>;
export declare const Hostname: HostnameC;
export type HostnameBrand = {
    readonly Hostname: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Hostname)).decodeSync(examplesHostname) // => examplesHostname */
export declare const examplesHostname: NonEmptyArray<Hostname>;
export type Port = t.Branded<number, PortBrand>;
export type PortC = t.BrandC<t.NumberC, PortBrand>;
export declare const Port: PortC;
export type PortBrand = {
    readonly Port: unique symbol;
};
/** require('io-ts-validator').validator(Port).decodeSync(minimumPort) // => minimumPort */
export declare const minimumPort: Port;
export type HostPortDelimiter = t.Branded<string & ':', HostPortDelimiterBrand>;
export type HostPortDelimiterC = t.BrandC<t.IntersectionC<[t.StringC, t.LiteralC<':'>]>, HostPortDelimiterBrand>;
export declare const HostPortDelimiter: HostPortDelimiterC;
export type HostPortDelimiterBrand = {
    readonly HostPortDelimiter: unique symbol;
};
/** require('io-ts-validator').validator(HostPortDelimiter).decodeSync(defaultHostPortDelimiter) // => defaultHostPortDelimiter */
export declare const defaultHostPortDelimiter: HostPortDelimiter;
export type Authority = t.Branded<string, AuthorityBrand>;
export type AuthorityC = t.BrandC<t.StringC, AuthorityBrand>;
export declare const Authority: AuthorityC;
export type AuthorityBrand = {
    readonly Authority: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Authority)).decodeSync(examplesAuthority) // => examplesAuthority */
export declare const examplesAuthority: NonEmptyArray<Authority>;
export type NetworkSchemeDelimiter = t.Branded<string & '://', NetworkSchemeDelimiterBrand>;
export type NetworkSchemeDelimiterC = t.BrandC<t.IntersectionC<[t.StringC, t.LiteralC<'://'>]>, NetworkSchemeDelimiterBrand>;
export declare const NetworkSchemeDelimiter: NetworkSchemeDelimiterC;
export type NetworkSchemeDelimiterBrand = {
    readonly NetworkSchemeDelimiter: unique symbol;
};
/** require('io-ts-validator').validator(NetworkSchemeDelimiter).decodeSync(defaultNetworkSchemeDelimiter) // => defaultNetworkSchemeDelimiter */
export declare const defaultNetworkSchemeDelimiter: NetworkSchemeDelimiter;
export type Url = t.Branded<string, UrlBrand>;
export type UrlC = t.BrandC<t.StringC, UrlBrand>;
export declare const Url: UrlC;
export type UrlBrand = {
    readonly Url: unique symbol;
};
export type Arn = t.Branded<string, ArnBrand>;
export type ArnC = t.BrandC<t.StringC, ArnBrand>;
export declare const Arn: ArnC;
export type ArnBrand = {
    readonly Arn: unique symbol;
};
export type ObsoleteIdentityId = t.Branded<string, ObsoleteIdentityIdBrand>;
export type ObsoleteIdentityIdC = t.BrandC<t.StringC, ObsoleteIdentityIdBrand>;
export declare const ObsoleteIdentityId: ObsoleteIdentityIdC;
export type ObsoleteIdentityIdBrand = {
    readonly ObsoleteIdentityId: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ObsoleteIdentityId)).decodeSync(examplesObsoleteIdentityId) // => examplesObsoleteIdentityId */
export declare const examplesObsoleteIdentityId: NonEmptyArray<ObsoleteIdentityId>;
export type IdentityId = t.Branded<ObsoleteIdentityId | Uuid, IdentityIdBrand>;
export type IdentityIdC = t.BrandC<t.UnionC<[typeof ObsoleteIdentityId, typeof Uuid]>, IdentityIdBrand>;
export declare const IdentityId: IdentityIdC;
export type IdentityIdBrand = {
    readonly IdentityId: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(IdentityId)).decodeSync(examplesIdentityId) // => examplesIdentityId */
export declare const examplesIdentityId: NonEmptyArray<IdentityId>;
export type Currency = t.Branded<string & ('EUR' | 'GBP' | 'SGD' | 'JPY' | 'CHF' | 'TRY'), CurrencyBrand>;
export type CurrencyC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'EUR'>,
        t.LiteralC<'GBP'>,
        t.LiteralC<'SGD'>,
        t.LiteralC<'JPY'>,
        t.LiteralC<'CHF'>,
        t.LiteralC<'TRY'>
    ]>
]>, CurrencyBrand>;
export declare const Currency: CurrencyC;
export type CurrencyBrand = {
    readonly Currency: unique symbol;
};
export type CurrencyOrToken = t.Branded<Currency | 'TOKEN', CurrencyOrTokenBrand>;
export type CurrencyOrTokenC = t.BrandC<t.UnionC<[typeof Currency, t.LiteralC<'TOKEN'>]>, CurrencyOrTokenBrand>;
export declare const CurrencyOrToken: CurrencyOrTokenC;
export type CurrencyOrTokenBrand = {
    readonly CurrencyOrToken: unique symbol;
};
export type CurrencyEUR = t.Branded<Currency & 'EUR', CurrencyEURBrand>;
export type CurrencyEURC = t.BrandC<t.IntersectionC<[typeof Currency, t.LiteralC<'EUR'>]>, CurrencyEURBrand>;
export declare const CurrencyEUR: CurrencyEURC;
export type CurrencyEURBrand = {
    readonly CurrencyEUR: unique symbol;
};
/** require('io-ts-validator').validator(CurrencyEUR).decodeSync(defaultCurrencyEUR) // => defaultCurrencyEUR */
export declare const defaultCurrencyEUR: CurrencyEUR;
export type CurrencyGBP = t.Branded<Currency & 'GBP', CurrencyGBPBrand>;
export type CurrencyGBPC = t.BrandC<t.IntersectionC<[typeof Currency, t.LiteralC<'GBP'>]>, CurrencyGBPBrand>;
export declare const CurrencyGBP: CurrencyGBPC;
export type CurrencyGBPBrand = {
    readonly CurrencyGBP: unique symbol;
};
/** require('io-ts-validator').validator(CurrencyGBP).decodeSync(defaultCurrencyGBP) // => defaultCurrencyGBP */
export declare const defaultCurrencyGBP: CurrencyGBP;
export type CurrencySGD = t.Branded<Currency & 'SGD', CurrencySGDBrand>;
export type CurrencySGDC = t.BrandC<t.IntersectionC<[typeof Currency, t.LiteralC<'SGD'>]>, CurrencySGDBrand>;
export declare const CurrencySGD: CurrencySGDC;
export type CurrencySGDBrand = {
    readonly CurrencySGD: unique symbol;
};
/** require('io-ts-validator').validator(CurrencySGD).decodeSync(defaultCurrencySGD) // => defaultCurrencySGD */
export declare const defaultCurrencySGD: CurrencySGD;
export type CurrencyJPY = t.Branded<Currency & 'JPY', CurrencyJPYBrand>;
export type CurrencyJPYC = t.BrandC<t.IntersectionC<[typeof Currency, t.LiteralC<'JPY'>]>, CurrencyJPYBrand>;
export declare const CurrencyJPY: CurrencyJPYC;
export type CurrencyJPYBrand = {
    readonly CurrencyJPY: unique symbol;
};
/** require('io-ts-validator').validator(CurrencyJPY).decodeSync(defaultCurrencyJPY) // => defaultCurrencyJPY */
export declare const defaultCurrencyJPY: CurrencyJPY;
export type CurrencyCHF = t.Branded<Currency & 'CHF', CurrencyCHFBrand>;
export type CurrencyCHFC = t.BrandC<t.IntersectionC<[typeof Currency, t.LiteralC<'CHF'>]>, CurrencyCHFBrand>;
export declare const CurrencyCHF: CurrencyCHFC;
export type CurrencyCHFBrand = {
    readonly CurrencyCHF: unique symbol;
};
/** require('io-ts-validator').validator(CurrencyCHF).decodeSync(defaultCurrencyCHF) // => defaultCurrencyCHF */
export declare const defaultCurrencyCHF: CurrencyCHF;
export type CurrencyTRY = t.Branded<Currency & 'TRY', CurrencyTRYBrand>;
export type CurrencyTRYC = t.BrandC<t.IntersectionC<[typeof Currency, t.LiteralC<'TRY'>]>, CurrencyTRYBrand>;
export declare const CurrencyTRY: CurrencyTRYC;
export type CurrencyTRYBrand = {
    readonly CurrencyTRY: unique symbol;
};
/** require('io-ts-validator').validator(CurrencyTRY).decodeSync(defaultCurrencyTRY) // => defaultCurrencyTRY */
export declare const defaultCurrencyTRY: CurrencyTRY;
export type Time = t.Branded<number, TimeBrand>;
export type TimeC = t.BrandC<t.NumberC, TimeBrand>;
export declare const Time: TimeC;
export type TimeBrand = {
    readonly Time: unique symbol;
};
/** require('io-ts-validator').validator(Time).decodeSync(minimumTime) // => minimumTime */
export declare const minimumTime: Time;
/** require('io-ts-validator').validator(Time).decodeSync(maximumTime) // => maximumTime */
export declare const maximumTime: Time;
export type Duration = t.Branded<number, DurationBrand>;
export type DurationC = t.BrandC<t.NumberC, DurationBrand>;
export declare const Duration: DurationC;
export type DurationBrand = {
    readonly Duration: unique symbol;
};
/** require('io-ts-validator').validator(Duration).decodeSync(minimumDuration) // => minimumDuration */
export declare const minimumDuration: Duration;
/** require('io-ts-validator').validator(Duration).decodeSync(maximumDuration) // => maximumDuration */
export declare const maximumDuration: Duration;
export type IsoDate = t.Branded<string, IsoDateBrand>;
export type IsoDateC = t.BrandC<t.StringC, IsoDateBrand>;
export declare const IsoDate: IsoDateC;
export type IsoDateBrand = {
    readonly IsoDate: unique symbol;
};
export type IsoDateTime = t.Branded<string, IsoDateTimeBrand>;
export type IsoDateTimeC = t.BrandC<t.StringC, IsoDateTimeBrand>;
export declare const IsoDateTime: IsoDateTimeC;
export type IsoDateTimeBrand = {
    readonly IsoDateTime: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(IsoDateTime)).decodeSync(examplesIsoDateTime) // => examplesIsoDateTime */
export declare const examplesIsoDateTime: NonEmptyArray<IsoDateTime>;
/** require('io-ts-validator').validator(IsoDateTime).decodeEither("2022-11-30")._tag // => 'Left' */
/** require('io-ts-validator').validator(IsoDateTime).decodeEither("2022-11-30T14:32:25")._tag // => 'Left' */
/** require('io-ts-validator').validator(IsoDateTime).decodeEither("2022-41-30T14:32:25Z")._tag // => 'Left' */
/** require('io-ts-validator').validator(IsoDateTime).decodeEither("2022-11-60T14:32:25Z")._tag // => 'Left' */
/** require('io-ts-validator').validator(IsoDateTime).decodeEither("2022-11-30T74:32:25Z")._tag // => 'Left' */
/** require('io-ts-validator').validator(IsoDateTime).decodeEither("2022-11-30T14:72:25Z")._tag // => 'Left' */
/** require('io-ts-validator').validator(IsoDateTime).decodeEither("2022-11-30T14:32:75Z")._tag // => 'Left' */
export type Units = t.Branded<unknown, UnitsBrand>;
export type UnitsC = t.BrandC<t.UnknownC, UnitsBrand>;
export declare const Units: UnitsC;
export type UnitsBrand = {
    readonly Units: unique symbol;
};
export default Units;
