import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/error.json";
export type ErrorNumber = t.Branded<number, ErrorNumberBrand>;
export type ErrorNumberC = t.BrandC<t.NumberC, ErrorNumberBrand>;
export declare const ErrorNumber: ErrorNumberC;
export type ErrorNumberBrand = {
    readonly ErrorNumber: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ErrorNumber)).decodeSync(examplesErrorNumber) // => examplesErrorNumber */
export declare const examplesErrorNumber: NonEmptyArray<ErrorNumber>;
/** require('io-ts-validator').validator(ErrorNumber).decodeSync(minimumErrorNumber) // => minimumErrorNumber */
export declare const minimumErrorNumber: ErrorNumber;
/** require('io-ts-validator').validator(ErrorNumber).decodeSync(maximumErrorNumber) // => maximumErrorNumber */
export declare const maximumErrorNumber: ErrorNumber;
export type ErrorIdentifier = t.Branded<string, ErrorIdentifierBrand>;
export type ErrorIdentifierC = t.BrandC<t.StringC, ErrorIdentifierBrand>;
export declare const ErrorIdentifier: ErrorIdentifierC;
export type ErrorIdentifierBrand = {
    readonly ErrorIdentifier: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ErrorIdentifier)).decodeSync(examplesErrorIdentifier) // => examplesErrorIdentifier */
export declare const examplesErrorIdentifier: NonEmptyArray<ErrorIdentifier>;
export type ErrorCode = t.Branded<ErrorNumber | ErrorIdentifier, ErrorCodeBrand>;
export type ErrorCodeC = t.BrandC<t.UnionC<[typeof ErrorNumber, typeof ErrorIdentifier]>, ErrorCodeBrand>;
export declare const ErrorCode: ErrorCodeC;
export type ErrorCodeBrand = {
    readonly ErrorCode: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ErrorCode)).decodeSync(examplesErrorCode) // => examplesErrorCode */
export declare const examplesErrorCode: NonEmptyArray<ErrorCode>;
export type ErrorMessage = t.Branded<string, ErrorMessageBrand>;
export type ErrorMessageC = t.BrandC<t.StringC, ErrorMessageBrand>;
export declare const ErrorMessage: ErrorMessageC;
export type ErrorMessageBrand = {
    readonly ErrorMessage: unique symbol;
};
export type Reason = t.Branded<{
    text?: ErrorMessage;
    errorCode?: ErrorCode;
}, ReasonBrand>;
export type ReasonC = t.BrandC<t.PartialC<{
    text: typeof ErrorMessage;
    errorCode: typeof ErrorCode;
}>, ReasonBrand>;
export declare const Reason: ReasonC;
export type ReasonBrand = {
    readonly Reason: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Reason)).decodeSync(examplesReason) // => examplesReason */
export declare const examplesReason: NonEmptyArray<Reason>;
export type ResponseErrorMessage = t.Branded<ErrorMessage, ResponseErrorMessageBrand>;
export type ResponseErrorMessageC = t.BrandC<typeof ErrorMessage, ResponseErrorMessageBrand>;
export declare const ResponseErrorMessage: ResponseErrorMessageC;
export type ResponseErrorMessageBrand = {
    readonly ResponseErrorMessage: unique symbol;
};
export type Response = t.Branded<({
    message?: ResponseErrorMessage;
    code?: ErrorCode;
} & Record<string, unknown>) & {
    message: Defined;
    code: Defined;
}, ResponseBrand>;
export type ResponseC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            message: typeof ResponseErrorMessage;
            code: typeof ErrorCode;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        message: typeof Defined;
        code: typeof Defined;
    }>
]>, ResponseBrand>;
export declare const Response: ResponseC;
export type ResponseBrand = {
    readonly Response: unique symbol;
};
export type Error = t.Branded<unknown, ErrorBrand>;
export type ErrorC = t.BrandC<t.UnknownC, ErrorBrand>;
export declare const Error: ErrorC;
export type ErrorBrand = {
    readonly Error: unique symbol;
};
export default Error;
import "jest";
