import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Booking_4353_ from './booking';
import * as Common_ffba_ from './components/common';
import * as Fare_a3ab_ from './components/fare';
import * as State_2db3_ from './components/state';
import * as Units_c404_ from './components/units';
import * as Leg_1308_ from './leg';
import * as ProductOption_5313_ from './product-option';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/itinerary.json";
export type Id = t.Branded<Units_c404_.Uuid, IdBrand>;
export type IdC = t.BrandC<typeof Units_c404_.Uuid, IdBrand>;
export declare const Id: IdC;
export type IdBrand = {
    readonly Id: unique symbol;
};
export type Itinerary = t.Branded<{
    id?: Id;
    sourcePlanId?: Units_c404_.Uuid;
    isOvertaken?: boolean;
    identityId?: Units_c404_.IdentityId;
    signature?: Common_ffba_.Signature;
    state?: State_2db3_.ItineraryState;
    startTime?: Units_c404_.Time;
    endTime?: Units_c404_.Time;
    co2?: number;
    fares?: Array<Fare_a3ab_.Fare>;
    legs?: Array<Leg_1308_.Leg>;
    productOptions?: Array<ProductOption_5313_.ProductOption>;
    type?: 'outward' | 'return';
    bookings?: Array<Booking_4353_.Booking>;
} & {
    startTime: Defined;
    endTime: Defined;
    legs: Defined;
}, ItineraryBrand>;
export type ItineraryC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof Id;
        sourcePlanId: typeof Units_c404_.Uuid;
        isOvertaken: t.BooleanC;
        identityId: typeof Units_c404_.IdentityId;
        signature: typeof Common_ffba_.Signature;
        state: typeof State_2db3_.ItineraryState;
        startTime: typeof Units_c404_.Time;
        endTime: typeof Units_c404_.Time;
        co2: t.NumberC;
        fares: t.ArrayC<typeof Fare_a3ab_.Fare>;
        legs: t.ArrayC<typeof Leg_1308_.Leg>;
        productOptions: t.ArrayC<typeof ProductOption_5313_.ProductOption>;
        type: t.UnionC<[t.LiteralC<'outward'>, t.LiteralC<'return'>]>;
        bookings: t.ArrayC<typeof Booking_4353_.Booking>;
    }>,
    t.TypeC<{
        startTime: typeof Defined;
        endTime: typeof Defined;
        legs: typeof Defined;
    }>
]>, ItineraryBrand>;
export declare const Itinerary: ItineraryC;
export type ItineraryBrand = {
    readonly Itinerary: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Itinerary)).decodeSync(examplesItinerary) // => examplesItinerary */
export declare const examplesItinerary: NonEmptyArray<Itinerary>;
export default Itinerary;
import "jest";
