import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Booking_4353_ from './booking';
import * as Common_ffba_ from './components/common';
import * as Fare_a3ab_ from './components/fare';
import * as State_2db3_ from './components/state';
import * as Units_c404_ from './components/units';
import * as LegV2_0fbd_ from './legV2';
import * as ProductOptionV2_8170_ from './product-optionV2';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/itineraryV2.json";
export type Id = t.Branded<Units_c404_.Uuid, IdBrand>;
export type IdC = t.BrandC<typeof Units_c404_.Uuid, IdBrand>;
export declare const Id: IdC;
export type IdBrand = {
    readonly Id: unique symbol;
};
export type ItineraryV2Base = t.Branded<({
    isOvertaken?: boolean;
    identityId?: Units_c404_.IdentityId;
    state?: State_2db3_.ItineraryState;
    startTime?: Units_c404_.Time;
    endTime?: Units_c404_.Time;
    co2?: number;
    fares?: Array<Fare_a3ab_.Fare>;
    estimatedTotalFares?: Array<Fare_a3ab_.Fare>;
    legs?: Array<LegV2_0fbd_.LegV2>;
    productOptions?: Array<ProductOptionV2_8170_.ProductOptionV2>;
    type?: 'outward' | 'return';
    bookings?: Array<Booking_4353_.Booking>;
} & Record<string, unknown>) & {
    startTime: Defined;
    endTime: Defined;
    legs: Defined;
    productOptions: Defined;
}, ItineraryV2BaseBrand>;
export type ItineraryV2BaseC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            isOvertaken: t.BooleanC;
            identityId: typeof Units_c404_.IdentityId;
            state: typeof State_2db3_.ItineraryState;
            startTime: typeof Units_c404_.Time;
            endTime: typeof Units_c404_.Time;
            co2: t.NumberC;
            fares: t.ArrayC<typeof Fare_a3ab_.Fare>;
            estimatedTotalFares: t.ArrayC<typeof Fare_a3ab_.Fare>;
            legs: t.ArrayC<typeof LegV2_0fbd_.LegV2>;
            productOptions: t.ArrayC<typeof ProductOptionV2_8170_.ProductOptionV2>;
            type: t.UnionC<[t.LiteralC<'outward'>, t.LiteralC<'return'>]>;
            bookings: t.ArrayC<typeof Booking_4353_.Booking>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        startTime: typeof Defined;
        endTime: typeof Defined;
        legs: typeof Defined;
        productOptions: typeof Defined;
    }>
]>, ItineraryV2BaseBrand>;
export declare const ItineraryV2Base: ItineraryV2BaseC;
export type ItineraryV2BaseBrand = {
    readonly ItineraryV2Base: unique symbol;
};
export type ItineraryV2 = t.Branded<ItineraryV2Base & (({
    version?: string & '2';
    id?: Id;
    sourcePlanId?: Units_c404_.Uuid;
    signature?: Common_ffba_.Signature;
} & Record<string, unknown>) & {
    version: Defined;
    id: Defined;
    sourcePlanId: Defined;
    signature: Defined;
}), ItineraryV2Brand>;
export type ItineraryV2C = t.BrandC<t.IntersectionC<[
    typeof ItineraryV2Base,
    t.IntersectionC<[
        t.IntersectionC<[
            t.PartialC<{
                version: t.IntersectionC<[t.StringC, t.LiteralC<'2'>]>;
                id: typeof Id;
                sourcePlanId: typeof Units_c404_.Uuid;
                signature: typeof Common_ffba_.Signature;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.TypeC<{
            version: typeof Defined;
            id: typeof Defined;
            sourcePlanId: typeof Defined;
            signature: typeof Defined;
        }>
    ]>
]>, ItineraryV2Brand>;
export declare const ItineraryV2: ItineraryV2C;
export type ItineraryV2Brand = {
    readonly ItineraryV2: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ItineraryV2)).decodeSync(examplesItineraryV2) // => examplesItineraryV2 */
export declare const examplesItineraryV2: NonEmptyArray<ItineraryV2>;
export default ItineraryV2;
