import * as t from 'io-ts';
import * as BookingOption_9a80_ from './booking-option';
import * as Common_ffba_ from './components/common';
import * as Place_de2d_ from './components/place';
import * as State_2db3_ from './components/state';
import * as TravelMode_5e34_ from './components/travel-mode';
import * as Units_c404_ from './components/units';
import * as UnitsGeo_3e31_ from './components/units-geo';
import * as Stop_e3e2_ from './stop';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/legV2.json";
export type State = t.Branded<State_2db3_.LegState, StateBrand>;
export type StateC = t.BrandC<typeof State_2db3_.LegState, StateBrand>;
export declare const State: StateC;
export type StateBrand = {
    readonly State: unique symbol;
};
export type From = t.Branded<Place_de2d_.Place, FromBrand>;
export type FromC = t.BrandC<typeof Place_de2d_.Place, FromBrand>;
export declare const From: FromC;
export type FromBrand = {
    readonly From: unique symbol;
};
export type To = t.Branded<Place_de2d_.Place, ToBrand>;
export type ToC = t.BrandC<typeof Place_de2d_.Place, ToBrand>;
export declare const To: ToC;
export type ToBrand = {
    readonly To: unique symbol;
};
export type StartTime = t.Branded<Units_c404_.Time, StartTimeBrand>;
export type StartTimeC = t.BrandC<typeof Units_c404_.Time, StartTimeBrand>;
export declare const StartTime: StartTimeC;
export type StartTimeBrand = {
    readonly StartTime: unique symbol;
};
export type EndTime = t.Branded<Units_c404_.Time, EndTimeBrand>;
export type EndTimeC = t.BrandC<typeof Units_c404_.Time, EndTimeBrand>;
export declare const EndTime: EndTimeC;
export type EndTimeBrand = {
    readonly EndTime: unique symbol;
};
export type Mode = t.Branded<TravelMode_5e34_.TravelMode, ModeBrand>;
export type ModeC = t.BrandC<typeof TravelMode_5e34_.TravelMode, ModeBrand>;
export declare const Mode: ModeC;
export type ModeBrand = {
    readonly Mode: unique symbol;
};
export type Stops = t.Branded<Array<Stop_e3e2_.Stop>, StopsBrand>;
export type StopsC = t.BrandC<t.ArrayC<typeof Stop_e3e2_.Stop>, StopsBrand>;
export declare const Stops: StopsC;
export type StopsBrand = {
    readonly Stops: unique symbol;
};
export type DepartureDelay = t.Branded<Units_c404_.Duration, DepartureDelayBrand>;
export type DepartureDelayC = t.BrandC<typeof Units_c404_.Duration, DepartureDelayBrand>;
export declare const DepartureDelay: DepartureDelayC;
export type DepartureDelayBrand = {
    readonly DepartureDelay: unique symbol;
};
export type ArrivalDelay = t.Branded<Units_c404_.Duration, ArrivalDelayBrand>;
export type ArrivalDelayC = t.BrandC<typeof Units_c404_.Duration, ArrivalDelayBrand>;
export declare const ArrivalDelay: ArrivalDelayC;
export type ArrivalDelayBrand = {
    readonly ArrivalDelay: unique symbol;
};
export type Distance = t.Branded<UnitsGeo_3e31_.Distance, DistanceBrand>;
export type DistanceC = t.BrandC<typeof UnitsGeo_3e31_.Distance, DistanceBrand>;
export declare const Distance: DistanceC;
export type DistanceBrand = {
    readonly Distance: unique symbol;
};
export type Route = t.Branded<string, RouteBrand>;
export type RouteC = t.BrandC<t.StringC, RouteBrand>;
export declare const Route: RouteC;
export type RouteBrand = {
    readonly Route: unique symbol;
};
export type RouteShortName = t.Branded<string, RouteShortNameBrand>;
export type RouteShortNameC = t.BrandC<t.StringC, RouteShortNameBrand>;
export declare const RouteShortName: RouteShortNameC;
export type RouteShortNameBrand = {
    readonly RouteShortName: unique symbol;
};
export type RouteLongName = t.Branded<string, RouteLongNameBrand>;
export type RouteLongNameC = t.BrandC<t.StringC, RouteLongNameBrand>;
export declare const RouteLongName: RouteLongNameC;
export type RouteLongNameBrand = {
    readonly RouteLongName: unique symbol;
};
export type AgencyId = t.Branded<Common_ffba_.AgencyId, AgencyIdBrand>;
export type AgencyIdC = t.BrandC<typeof Common_ffba_.AgencyId, AgencyIdBrand>;
export declare const AgencyId: AgencyIdC;
export type AgencyIdBrand = {
    readonly AgencyId: unique symbol;
};
export type ProviderAgencyId = t.Branded<string, ProviderAgencyIdBrand>;
export type ProviderAgencyIdC = t.BrandC<t.StringC, ProviderAgencyIdBrand>;
export declare const ProviderAgencyId: ProviderAgencyIdC;
export type ProviderAgencyIdBrand = {
    readonly ProviderAgencyId: unique symbol;
};
export type LegGeometry = t.Branded<{
    points?: UnitsGeo_3e31_.Polyline;
} & Record<string, unknown>, LegGeometryBrand>;
export type LegGeometryC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        points: typeof UnitsGeo_3e31_.Polyline;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, LegGeometryBrand>;
export declare const LegGeometry: LegGeometryC;
export type LegGeometryBrand = {
    readonly LegGeometry: unique symbol;
};
export type TspProduct = t.Branded<BookingOption_9a80_.TspProduct, TspProductBrand>;
export type TspProductC = t.BrandC<typeof BookingOption_9a80_.TspProduct, TspProductBrand>;
export declare const TspProduct: TspProductC;
export type TspProductBrand = {
    readonly TspProduct: unique symbol;
};
export type ProductOption = t.Branded<number, ProductOptionBrand>;
export type ProductOptionC = t.BrandC<t.NumberC, ProductOptionBrand>;
export declare const ProductOption: ProductOptionC;
export type ProductOptionBrand = {
    readonly ProductOption: unique symbol;
};
/** require('io-ts-validator').validator(ProductOption).decodeSync(minimumProductOption) // => minimumProductOption */
export declare const minimumProductOption: ProductOption;
export type LegExtensions = t.Branded<{
    id?: Units_c404_.Uuid;
    signature?: Common_ffba_.Signature;
} & Record<string, unknown>, LegExtensionsBrand>;
export type LegExtensionsC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof Units_c404_.Uuid;
        signature: typeof Common_ffba_.Signature;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, LegExtensionsBrand>;
export declare const LegExtensions: LegExtensionsC;
export type LegExtensionsBrand = {
    readonly LegExtensions: unique symbol;
};
export type LegCore = t.Branded<{
    state?: State;
    from?: From;
    to?: To;
    startTime?: StartTime;
    endTime?: EndTime;
    mode?: Mode;
    stops?: Stops;
    departureDelay?: DepartureDelay;
    arrivalDelay?: ArrivalDelay;
    distance?: Distance;
    route?: Route;
    routeShortName?: RouteShortName;
    routeLongName?: RouteLongName;
    agencyId?: AgencyId;
    legGeometry?: LegGeometry;
    tspProduct?: TspProduct;
    productOption?: ProductOption;
} & {
    from: Defined;
    to: Defined;
    mode: Defined;
    startTime: Defined;
    endTime: Defined;
    legGeometry: Defined;
}, LegCoreBrand>;
export type LegCoreC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        state: typeof State;
        from: typeof From;
        to: typeof To;
        startTime: typeof StartTime;
        endTime: typeof EndTime;
        mode: typeof Mode;
        stops: typeof Stops;
        departureDelay: typeof DepartureDelay;
        arrivalDelay: typeof ArrivalDelay;
        distance: typeof Distance;
        route: typeof Route;
        routeShortName: typeof RouteShortName;
        routeLongName: typeof RouteLongName;
        agencyId: typeof AgencyId;
        legGeometry: typeof LegGeometry;
        tspProduct: typeof TspProduct;
        productOption: typeof ProductOption;
    }>,
    t.TypeC<{
        from: typeof Defined;
        to: typeof Defined;
        mode: typeof Defined;
        startTime: typeof Defined;
        endTime: typeof Defined;
        legGeometry: typeof Defined;
    }>
]>, LegCoreBrand>;
export declare const LegCore: LegCoreC;
export type LegCoreBrand = {
    readonly LegCore: unique symbol;
};
export type WaitingLeg = t.Branded<({
    startTime?: Units_c404_.Time;
    endTime?: Units_c404_.Time;
    mode?: TravelMode_5e34_.WaitingMode;
} & Record<string, unknown>) & {
    mode: Defined;
    startTime: Defined;
    endTime: Defined;
}, WaitingLegBrand>;
export type WaitingLegC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            startTime: typeof Units_c404_.Time;
            endTime: typeof Units_c404_.Time;
            mode: typeof TravelMode_5e34_.WaitingMode;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        mode: typeof Defined;
        startTime: typeof Defined;
        endTime: typeof Defined;
    }>
]>, WaitingLegBrand>;
export declare const WaitingLeg: WaitingLegC;
export type WaitingLegBrand = {
    readonly WaitingLeg: unique symbol;
};
export type TransferLeg = t.Branded<({
    startTime?: Units_c404_.Time;
    endTime?: Units_c404_.Time;
    mode?: TravelMode_5e34_.TransferMode;
} & Record<string, unknown>) & {
    mode: Defined;
    startTime: Defined;
    endTime: Defined;
}, TransferLegBrand>;
export type TransferLegC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            startTime: typeof Units_c404_.Time;
            endTime: typeof Units_c404_.Time;
            mode: typeof TravelMode_5e34_.TransferMode;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        mode: typeof Defined;
        startTime: typeof Defined;
        endTime: typeof Defined;
    }>
]>, TransferLegBrand>;
export declare const TransferLeg: TransferLegC;
export type TransferLegBrand = {
    readonly TransferLeg: unique symbol;
};
export type LegV2 = t.Branded<Record<string, unknown> & Record<string, unknown> & (LegExtensions & (LegCore | WaitingLeg | TransferLeg)), LegV2Brand>;
export type LegV2C = t.BrandC<t.IntersectionC<[
    t.UnknownRecordC,
    t.RecordC<t.StringC, t.UnknownC>,
    t.IntersectionC<[
        typeof LegExtensions,
        t.UnionC<[typeof LegCore, typeof WaitingLeg, typeof TransferLeg]>
    ]>
]>, LegV2Brand>;
export declare const LegV2: LegV2C;
export type LegV2Brand = {
    readonly LegV2: unique symbol;
};
export default LegV2;
