import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/multimodal-routes-metadata.json";
export type RoutesConfigModesSpec = t.Branded<{
    modeId?: string;
    label?: string;
    modes?: Array<string & ('TRANSIT' | 'TAXI' | 'CAR' | 'WALK' | 'BICYCLE' | 'BICYCLE_RENT' | 'SCOOTER')>;
} & {
    modeId: Defined;
    label: Defined;
    modes: Defined;
}, RoutesConfigModesSpecBrand>;
export type RoutesConfigModesSpecC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        modeId: t.StringC;
        label: t.StringC;
        modes: t.ArrayC<t.IntersectionC<[
            t.StringC,
            t.UnionC<[
                t.LiteralC<'TRANSIT'>,
                t.LiteralC<'TAXI'>,
                t.LiteralC<'CAR'>,
                t.LiteralC<'WALK'>,
                t.LiteralC<'BICYCLE'>,
                t.LiteralC<'BICYCLE_RENT'>,
                t.LiteralC<'SCOOTER'>
            ]>
        ]>>;
    }>,
    t.TypeC<{
        modeId: typeof Defined;
        label: typeof Defined;
        modes: typeof Defined;
    }>
]>, RoutesConfigModesSpecBrand>;
export declare const RoutesConfigModesSpec: RoutesConfigModesSpecC;
export type RoutesConfigModesSpecBrand = {
    readonly RoutesConfigModesSpec: unique symbol;
};
export type MultimodalRoutesMetadata = t.Branded<{
    availableModes?: Array<RoutesConfigModesSpec>;
    availableAccessibilityFilter?: boolean;
} & {
    availableModes: Defined;
    availableAccessibilityFilter: Defined;
}, MultimodalRoutesMetadataBrand>;
export type MultimodalRoutesMetadataC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        availableModes: t.ArrayC<typeof RoutesConfigModesSpec>;
        availableAccessibilityFilter: t.BooleanC;
    }>,
    t.TypeC<{
        availableModes: typeof Defined;
        availableAccessibilityFilter: typeof Defined;
    }>
]>, MultimodalRoutesMetadataBrand>;
export declare const MultimodalRoutesMetadata: MultimodalRoutesMetadataC;
export type MultimodalRoutesMetadataBrand = {
    readonly MultimodalRoutesMetadata: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(MultimodalRoutesMetadata)).decodeSync(examplesMultimodalRoutesMetadata) // => examplesMultimodalRoutesMetadata */
export declare const examplesMultimodalRoutesMetadata: NonEmptyArray<MultimodalRoutesMetadata>;
export default MultimodalRoutesMetadata;
