import * as t from 'io-ts';
import * as Address_2d0a_ from './components/address';
import * as Common_ffba_ from './components/common';
import * as Station_dfde_ from './components/station';
import * as Units_c404_ from './components/units';
import * as UnitsGeo_3e31_ from './components/units-geo';
export declare const schemaId = "https://schemas.maas.global/core/partialFavoriteLocation.json";
export type FavoriteLocationTypes = t.Branded<string & ('ADDRESS' | 'STOP'), FavoriteLocationTypesBrand>;
export type FavoriteLocationTypesC = t.BrandC<t.IntersectionC<[t.StringC, t.UnionC<[t.LiteralC<'ADDRESS'>, t.LiteralC<'STOP'>]>]>, FavoriteLocationTypesBrand>;
export declare const FavoriteLocationTypes: FavoriteLocationTypesC;
export type FavoriteLocationTypesBrand = {
    readonly FavoriteLocationTypes: unique symbol;
};
export type FavoriteLocationTypesADDRESS = t.Branded<FavoriteLocationTypes & 'ADDRESS', FavoriteLocationTypesADDRESSBrand>;
export type FavoriteLocationTypesADDRESSC = t.BrandC<t.IntersectionC<[typeof FavoriteLocationTypes, t.LiteralC<'ADDRESS'>]>, FavoriteLocationTypesADDRESSBrand>;
export declare const FavoriteLocationTypesADDRESS: FavoriteLocationTypesADDRESSC;
export type FavoriteLocationTypesADDRESSBrand = {
    readonly FavoriteLocationTypesADDRESS: unique symbol;
};
/** require('io-ts-validator').validator(FavoriteLocationTypesADDRESS).decodeSync(defaultFavoriteLocationTypesADDRESS) // => defaultFavoriteLocationTypesADDRESS */
export declare const defaultFavoriteLocationTypesADDRESS: FavoriteLocationTypesADDRESS;
export type FavoriteLocationTypesSTOP = t.Branded<FavoriteLocationTypes & 'STOP', FavoriteLocationTypesSTOPBrand>;
export type FavoriteLocationTypesSTOPC = t.BrandC<t.IntersectionC<[typeof FavoriteLocationTypes, t.LiteralC<'STOP'>]>, FavoriteLocationTypesSTOPBrand>;
export declare const FavoriteLocationTypesSTOP: FavoriteLocationTypesSTOPC;
export type FavoriteLocationTypesSTOPBrand = {
    readonly FavoriteLocationTypesSTOP: unique symbol;
};
/** require('io-ts-validator').validator(FavoriteLocationTypesSTOP).decodeSync(defaultFavoriteLocationTypesSTOP) // => defaultFavoriteLocationTypesSTOP */
export declare const defaultFavoriteLocationTypesSTOP: FavoriteLocationTypesSTOP;
export type PartialFavoriteLocation = t.Branded<{
    id?: number;
    identityId?: Units_c404_.IdentityId;
    type?: FavoriteLocationTypes;
    name?: string;
    location?: UnitsGeo_3e31_.Location;
    streetName?: Address_2d0a_.PlaceName;
    streetNumber?: string;
    city?: Address_2d0a_.City;
    country?: Address_2d0a_.CountryName;
    zipCode?: Address_2d0a_.ZipCode;
    agencyId?: Common_ffba_.AgencyId;
    stopId?: Station_dfde_.Id;
    lineId?: string;
} & Record<string, unknown>, PartialFavoriteLocationBrand>;
export type PartialFavoriteLocationC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: t.NumberC;
        identityId: typeof Units_c404_.IdentityId;
        type: typeof FavoriteLocationTypes;
        name: t.StringC;
        location: typeof UnitsGeo_3e31_.Location;
        streetName: typeof Address_2d0a_.PlaceName;
        streetNumber: t.StringC;
        city: typeof Address_2d0a_.City;
        country: typeof Address_2d0a_.CountryName;
        zipCode: typeof Address_2d0a_.ZipCode;
        agencyId: typeof Common_ffba_.AgencyId;
        stopId: typeof Station_dfde_.Id;
        lineId: t.StringC;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, PartialFavoriteLocationBrand>;
export declare const PartialFavoriteLocation: PartialFavoriteLocationC;
export type PartialFavoriteLocationBrand = {
    readonly PartialFavoriteLocation: unique symbol;
};
export default PartialFavoriteLocation;
