import * as t from 'io-ts';
import * as Card_c994_ from './card';
import * as Units_c404_ from './components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/paymentSource.json";
export type PaymentSourceType = t.Branded<string & ('card' | 'paypal_express_checkout' | 'amazon_payments' | 'direct_debit' | 'generic' | 'alipay' | 'unionpay' | 'apple_pay'), PaymentSourceTypeBrand>;
export type PaymentSourceTypeC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'card'>,
        t.LiteralC<'paypal_express_checkout'>,
        t.LiteralC<'amazon_payments'>,
        t.LiteralC<'direct_debit'>,
        t.LiteralC<'generic'>,
        t.LiteralC<'alipay'>,
        t.LiteralC<'unionpay'>,
        t.LiteralC<'apple_pay'>
    ]>
]>, PaymentSourceTypeBrand>;
export declare const PaymentSourceType: PaymentSourceTypeC;
export type PaymentSourceTypeBrand = {
    readonly PaymentSourceType: unique symbol;
};
export type PaymentSourceTypeCARD = t.Branded<PaymentSourceType & 'card', PaymentSourceTypeCARDBrand>;
export type PaymentSourceTypeCARDC = t.BrandC<t.IntersectionC<[typeof PaymentSourceType, t.LiteralC<'card'>]>, PaymentSourceTypeCARDBrand>;
export declare const PaymentSourceTypeCARD: PaymentSourceTypeCARDC;
export type PaymentSourceTypeCARDBrand = {
    readonly PaymentSourceTypeCARD: unique symbol;
};
/** require('io-ts-validator').validator(PaymentSourceTypeCARD).decodeSync(defaultPaymentSourceTypeCARD) // => defaultPaymentSourceTypeCARD */
export declare const defaultPaymentSourceTypeCARD: PaymentSourceTypeCARD;
export type PaymentSourceTypePAYPAL_EXPRESS_CHECKOUT = t.Branded<PaymentSourceType & 'paypal_express_checkout', PaymentSourceTypePAYPAL_EXPRESS_CHECKOUTBrand>;
export type PaymentSourceTypePAYPAL_EXPRESS_CHECKOUTC = t.BrandC<t.IntersectionC<[typeof PaymentSourceType, t.LiteralC<'paypal_express_checkout'>]>, PaymentSourceTypePAYPAL_EXPRESS_CHECKOUTBrand>;
export declare const PaymentSourceTypePAYPAL_EXPRESS_CHECKOUT: PaymentSourceTypePAYPAL_EXPRESS_CHECKOUTC;
export type PaymentSourceTypePAYPAL_EXPRESS_CHECKOUTBrand = {
    readonly PaymentSourceTypePAYPAL_EXPRESS_CHECKOUT: unique symbol;
};
/** require('io-ts-validator').validator(PaymentSourceTypePAYPAL_EXPRESS_CHECKOUT).decodeSync(defaultPaymentSourceTypePAYPAL_EXPRESS_CHECKOUT) // => defaultPaymentSourceTypePAYPAL_EXPRESS_CHECKOUT */
export declare const defaultPaymentSourceTypePAYPAL_EXPRESS_CHECKOUT: PaymentSourceTypePAYPAL_EXPRESS_CHECKOUT;
export type PaymentSourceTypeAMAZON_PAYMENTS = t.Branded<PaymentSourceType & 'amazon_payments', PaymentSourceTypeAMAZON_PAYMENTSBrand>;
export type PaymentSourceTypeAMAZON_PAYMENTSC = t.BrandC<t.IntersectionC<[typeof PaymentSourceType, t.LiteralC<'amazon_payments'>]>, PaymentSourceTypeAMAZON_PAYMENTSBrand>;
export declare const PaymentSourceTypeAMAZON_PAYMENTS: PaymentSourceTypeAMAZON_PAYMENTSC;
export type PaymentSourceTypeAMAZON_PAYMENTSBrand = {
    readonly PaymentSourceTypeAMAZON_PAYMENTS: unique symbol;
};
/** require('io-ts-validator').validator(PaymentSourceTypeAMAZON_PAYMENTS).decodeSync(defaultPaymentSourceTypeAMAZON_PAYMENTS) // => defaultPaymentSourceTypeAMAZON_PAYMENTS */
export declare const defaultPaymentSourceTypeAMAZON_PAYMENTS: PaymentSourceTypeAMAZON_PAYMENTS;
export type PaymentSourceTypeDIRECT_DEBIT = t.Branded<PaymentSourceType & 'direct_debit', PaymentSourceTypeDIRECT_DEBITBrand>;
export type PaymentSourceTypeDIRECT_DEBITC = t.BrandC<t.IntersectionC<[typeof PaymentSourceType, t.LiteralC<'direct_debit'>]>, PaymentSourceTypeDIRECT_DEBITBrand>;
export declare const PaymentSourceTypeDIRECT_DEBIT: PaymentSourceTypeDIRECT_DEBITC;
export type PaymentSourceTypeDIRECT_DEBITBrand = {
    readonly PaymentSourceTypeDIRECT_DEBIT: unique symbol;
};
/** require('io-ts-validator').validator(PaymentSourceTypeDIRECT_DEBIT).decodeSync(defaultPaymentSourceTypeDIRECT_DEBIT) // => defaultPaymentSourceTypeDIRECT_DEBIT */
export declare const defaultPaymentSourceTypeDIRECT_DEBIT: PaymentSourceTypeDIRECT_DEBIT;
export type PaymentSourceTypeGENERIC = t.Branded<PaymentSourceType & 'generic', PaymentSourceTypeGENERICBrand>;
export type PaymentSourceTypeGENERICC = t.BrandC<t.IntersectionC<[typeof PaymentSourceType, t.LiteralC<'generic'>]>, PaymentSourceTypeGENERICBrand>;
export declare const PaymentSourceTypeGENERIC: PaymentSourceTypeGENERICC;
export type PaymentSourceTypeGENERICBrand = {
    readonly PaymentSourceTypeGENERIC: unique symbol;
};
/** require('io-ts-validator').validator(PaymentSourceTypeGENERIC).decodeSync(defaultPaymentSourceTypeGENERIC) // => defaultPaymentSourceTypeGENERIC */
export declare const defaultPaymentSourceTypeGENERIC: PaymentSourceTypeGENERIC;
export type PaymentSourceTypeALIPAY = t.Branded<PaymentSourceType & 'alipay', PaymentSourceTypeALIPAYBrand>;
export type PaymentSourceTypeALIPAYC = t.BrandC<t.IntersectionC<[typeof PaymentSourceType, t.LiteralC<'alipay'>]>, PaymentSourceTypeALIPAYBrand>;
export declare const PaymentSourceTypeALIPAY: PaymentSourceTypeALIPAYC;
export type PaymentSourceTypeALIPAYBrand = {
    readonly PaymentSourceTypeALIPAY: unique symbol;
};
/** require('io-ts-validator').validator(PaymentSourceTypeALIPAY).decodeSync(defaultPaymentSourceTypeALIPAY) // => defaultPaymentSourceTypeALIPAY */
export declare const defaultPaymentSourceTypeALIPAY: PaymentSourceTypeALIPAY;
export type PaymentSourceTypeUNIONPAY = t.Branded<PaymentSourceType & 'unionpay', PaymentSourceTypeUNIONPAYBrand>;
export type PaymentSourceTypeUNIONPAYC = t.BrandC<t.IntersectionC<[typeof PaymentSourceType, t.LiteralC<'unionpay'>]>, PaymentSourceTypeUNIONPAYBrand>;
export declare const PaymentSourceTypeUNIONPAY: PaymentSourceTypeUNIONPAYC;
export type PaymentSourceTypeUNIONPAYBrand = {
    readonly PaymentSourceTypeUNIONPAY: unique symbol;
};
/** require('io-ts-validator').validator(PaymentSourceTypeUNIONPAY).decodeSync(defaultPaymentSourceTypeUNIONPAY) // => defaultPaymentSourceTypeUNIONPAY */
export declare const defaultPaymentSourceTypeUNIONPAY: PaymentSourceTypeUNIONPAY;
export type PaymentSourceTypeAPPLE_PAY = t.Branded<PaymentSourceType & 'apple_pay', PaymentSourceTypeAPPLE_PAYBrand>;
export type PaymentSourceTypeAPPLE_PAYC = t.BrandC<t.IntersectionC<[typeof PaymentSourceType, t.LiteralC<'apple_pay'>]>, PaymentSourceTypeAPPLE_PAYBrand>;
export declare const PaymentSourceTypeAPPLE_PAY: PaymentSourceTypeAPPLE_PAYC;
export type PaymentSourceTypeAPPLE_PAYBrand = {
    readonly PaymentSourceTypeAPPLE_PAY: unique symbol;
};
/** require('io-ts-validator').validator(PaymentSourceTypeAPPLE_PAY).decodeSync(defaultPaymentSourceTypeAPPLE_PAY) // => defaultPaymentSourceTypeAPPLE_PAY */
export declare const defaultPaymentSourceTypeAPPLE_PAY: PaymentSourceTypeAPPLE_PAY;
export type PaymentSource = t.Branded<{
    id?: string;
    customerId?: Units_c404_.IdentityId;
    type?: PaymentSourceType;
    gateway?: string;
    gatewayId?: string;
    temporaryToken?: string;
    status?: string;
    valid?: boolean;
    card?: Card_c994_.Card;
} & {
    customerId: Defined;
    type: Defined;
}, PaymentSourceBrand>;
export type PaymentSourceC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: t.StringC;
        customerId: typeof Units_c404_.IdentityId;
        type: typeof PaymentSourceType;
        gateway: t.StringC;
        gatewayId: t.StringC;
        temporaryToken: t.StringC;
        status: t.StringC;
        valid: t.BooleanC;
        card: typeof Card_c994_.Card;
    }>,
    t.TypeC<{
        customerId: typeof Defined;
        type: typeof Defined;
    }>
]>, PaymentSourceBrand>;
export declare const PaymentSource: PaymentSourceC;
export type PaymentSourceBrand = {
    readonly PaymentSource: unique symbol;
};
export default PaymentSource;
import "jest";
