import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Common_ffba_ from './components/common';
import * as Units_c404_ from './components/units';
export type NullBrand = {
    readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export declare const Null: NullC;
export type Null = t.TypeOf<typeof Null>;
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/personal-document.json";
export type DocumentId = t.Branded<Units_c404_.Uuid, DocumentIdBrand>;
export type DocumentIdC = t.BrandC<typeof Units_c404_.Uuid, DocumentIdBrand>;
export declare const DocumentId: DocumentIdC;
export type DocumentIdBrand = {
    readonly DocumentId: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(DocumentId)).decodeSync(examplesDocumentId) // => examplesDocumentId */
export declare const examplesDocumentId: NonEmptyArray<DocumentId>;
export type DocumentType = t.Branded<string, DocumentTypeBrand>;
export type DocumentTypeC = t.BrandC<t.StringC, DocumentTypeBrand>;
export declare const DocumentType: DocumentTypeC;
export type DocumentTypeBrand = {
    readonly DocumentType: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(DocumentType)).decodeSync(examplesDocumentType) // => examplesDocumentType */
export declare const examplesDocumentType: NonEmptyArray<DocumentType>;
export type DocumentNumber = t.Branded<string, DocumentNumberBrand>;
export type DocumentNumberC = t.BrandC<t.StringC, DocumentNumberBrand>;
export declare const DocumentNumber: DocumentNumberC;
export type DocumentNumberBrand = {
    readonly DocumentNumber: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(DocumentNumber)).decodeSync(examplesDocumentNumber) // => examplesDocumentNumber */
export declare const examplesDocumentNumber: NonEmptyArray<DocumentNumber>;
export type IssuingCountry = t.Branded<string, IssuingCountryBrand>;
export type IssuingCountryC = t.BrandC<t.StringC, IssuingCountryBrand>;
export declare const IssuingCountry: IssuingCountryC;
export type IssuingCountryBrand = {
    readonly IssuingCountry: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(IssuingCountry)).decodeSync(examplesIssuingCountry) // => examplesIssuingCountry */
export declare const examplesIssuingCountry: NonEmptyArray<IssuingCountry>;
export type DocumentStatus = t.Branded<string & ('PENDING' | 'APPROVED' | 'DECLINED' | 'EXPIRED' | 'RESUBMISSION_REQUESTED' | 'ABANDONED' | 'FAILED_WITH_ERRORS'), DocumentStatusBrand>;
export type DocumentStatusC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'PENDING'>,
        t.LiteralC<'APPROVED'>,
        t.LiteralC<'DECLINED'>,
        t.LiteralC<'EXPIRED'>,
        t.LiteralC<'RESUBMISSION_REQUESTED'>,
        t.LiteralC<'ABANDONED'>,
        t.LiteralC<'FAILED_WITH_ERRORS'>
    ]>
]>, DocumentStatusBrand>;
export declare const DocumentStatus: DocumentStatusC;
export type DocumentStatusBrand = {
    readonly DocumentStatus: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(DocumentStatus)).decodeSync(examplesDocumentStatus) // => examplesDocumentStatus */
export declare const examplesDocumentStatus: NonEmptyArray<DocumentStatus>;
export type DocumentStatusPENDING = t.Branded<DocumentStatus & 'PENDING', DocumentStatusPENDINGBrand>;
export type DocumentStatusPENDINGC = t.BrandC<t.IntersectionC<[typeof DocumentStatus, t.LiteralC<'PENDING'>]>, DocumentStatusPENDINGBrand>;
export declare const DocumentStatusPENDING: DocumentStatusPENDINGC;
export type DocumentStatusPENDINGBrand = {
    readonly DocumentStatusPENDING: unique symbol;
};
/** require('io-ts-validator').validator(DocumentStatusPENDING).decodeSync(defaultDocumentStatusPENDING) // => defaultDocumentStatusPENDING */
export declare const defaultDocumentStatusPENDING: DocumentStatusPENDING;
export type DocumentStatusAPPROVED = t.Branded<DocumentStatus & 'APPROVED', DocumentStatusAPPROVEDBrand>;
export type DocumentStatusAPPROVEDC = t.BrandC<t.IntersectionC<[typeof DocumentStatus, t.LiteralC<'APPROVED'>]>, DocumentStatusAPPROVEDBrand>;
export declare const DocumentStatusAPPROVED: DocumentStatusAPPROVEDC;
export type DocumentStatusAPPROVEDBrand = {
    readonly DocumentStatusAPPROVED: unique symbol;
};
/** require('io-ts-validator').validator(DocumentStatusAPPROVED).decodeSync(defaultDocumentStatusAPPROVED) // => defaultDocumentStatusAPPROVED */
export declare const defaultDocumentStatusAPPROVED: DocumentStatusAPPROVED;
export type DocumentStatusDECLINED = t.Branded<DocumentStatus & 'DECLINED', DocumentStatusDECLINEDBrand>;
export type DocumentStatusDECLINEDC = t.BrandC<t.IntersectionC<[typeof DocumentStatus, t.LiteralC<'DECLINED'>]>, DocumentStatusDECLINEDBrand>;
export declare const DocumentStatusDECLINED: DocumentStatusDECLINEDC;
export type DocumentStatusDECLINEDBrand = {
    readonly DocumentStatusDECLINED: unique symbol;
};
/** require('io-ts-validator').validator(DocumentStatusDECLINED).decodeSync(defaultDocumentStatusDECLINED) // => defaultDocumentStatusDECLINED */
export declare const defaultDocumentStatusDECLINED: DocumentStatusDECLINED;
export type DocumentStatusEXPIRED = t.Branded<DocumentStatus & 'EXPIRED', DocumentStatusEXPIREDBrand>;
export type DocumentStatusEXPIREDC = t.BrandC<t.IntersectionC<[typeof DocumentStatus, t.LiteralC<'EXPIRED'>]>, DocumentStatusEXPIREDBrand>;
export declare const DocumentStatusEXPIRED: DocumentStatusEXPIREDC;
export type DocumentStatusEXPIREDBrand = {
    readonly DocumentStatusEXPIRED: unique symbol;
};
/** require('io-ts-validator').validator(DocumentStatusEXPIRED).decodeSync(defaultDocumentStatusEXPIRED) // => defaultDocumentStatusEXPIRED */
export declare const defaultDocumentStatusEXPIRED: DocumentStatusEXPIRED;
export type DocumentStatusRESUBMISSION_REQUESTED = t.Branded<DocumentStatus & 'RESUBMISSION_REQUESTED', DocumentStatusRESUBMISSION_REQUESTEDBrand>;
export type DocumentStatusRESUBMISSION_REQUESTEDC = t.BrandC<t.IntersectionC<[typeof DocumentStatus, t.LiteralC<'RESUBMISSION_REQUESTED'>]>, DocumentStatusRESUBMISSION_REQUESTEDBrand>;
export declare const DocumentStatusRESUBMISSION_REQUESTED: DocumentStatusRESUBMISSION_REQUESTEDC;
export type DocumentStatusRESUBMISSION_REQUESTEDBrand = {
    readonly DocumentStatusRESUBMISSION_REQUESTED: unique symbol;
};
/** require('io-ts-validator').validator(DocumentStatusRESUBMISSION_REQUESTED).decodeSync(defaultDocumentStatusRESUBMISSION_REQUESTED) // => defaultDocumentStatusRESUBMISSION_REQUESTED */
export declare const defaultDocumentStatusRESUBMISSION_REQUESTED: DocumentStatusRESUBMISSION_REQUESTED;
export type DocumentStatusABANDONED = t.Branded<DocumentStatus & 'ABANDONED', DocumentStatusABANDONEDBrand>;
export type DocumentStatusABANDONEDC = t.BrandC<t.IntersectionC<[typeof DocumentStatus, t.LiteralC<'ABANDONED'>]>, DocumentStatusABANDONEDBrand>;
export declare const DocumentStatusABANDONED: DocumentStatusABANDONEDC;
export type DocumentStatusABANDONEDBrand = {
    readonly DocumentStatusABANDONED: unique symbol;
};
/** require('io-ts-validator').validator(DocumentStatusABANDONED).decodeSync(defaultDocumentStatusABANDONED) // => defaultDocumentStatusABANDONED */
export declare const defaultDocumentStatusABANDONED: DocumentStatusABANDONED;
export type ValidFrom = t.Branded<Units_c404_.IsoDate, ValidFromBrand>;
export type ValidFromC = t.BrandC<typeof Units_c404_.IsoDate, ValidFromBrand>;
export declare const ValidFrom: ValidFromC;
export type ValidFromBrand = {
    readonly ValidFrom: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ValidFrom)).decodeSync(examplesValidFrom) // => examplesValidFrom */
export declare const examplesValidFrom: NonEmptyArray<ValidFrom>;
export type ValidTo = t.Branded<Units_c404_.IsoDate | Null, ValidToBrand>;
export type ValidToC = t.BrandC<t.UnionC<[typeof Units_c404_.IsoDate, typeof Null]>, ValidToBrand>;
export declare const ValidTo: ValidToC;
export type ValidToBrand = {
    readonly ValidTo: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ValidTo)).decodeSync(examplesValidTo) // => examplesValidTo */
export declare const examplesValidTo: NonEmptyArray<ValidTo>;
export type Category = t.Branded<Null | string, CategoryBrand>;
export type CategoryC = t.BrandC<t.UnionC<[typeof Null, t.StringC]>, CategoryBrand>;
export declare const Category: CategoryC;
export type CategoryBrand = {
    readonly Category: unique symbol;
};
export type Details = t.Branded<Record<string, unknown> & Record<string, unknown>, DetailsBrand>;
export type DetailsC = t.BrandC<t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>, DetailsBrand>;
export declare const Details: DetailsC;
export type DetailsBrand = {
    readonly Details: unique symbol;
};
export type MediaItemContent = t.Branded<string, MediaItemContentBrand>;
export type MediaItemContentC = t.BrandC<t.StringC, MediaItemContentBrand>;
export declare const MediaItemContent: MediaItemContentC;
export type MediaItemContentBrand = {
    readonly MediaItemContent: unique symbol;
};
export type MediaItemContext = t.Branded<string, MediaItemContextBrand>;
export type MediaItemContextC = t.BrandC<t.StringC, MediaItemContextBrand>;
export declare const MediaItemContext: MediaItemContextC;
export type MediaItemContextBrand = {
    readonly MediaItemContext: unique symbol;
};
export type MediaItem = t.Branded<{
    content?: MediaItemContent;
    context?: MediaItemContext;
} & {
    content: Defined;
    context: Defined;
}, MediaItemBrand>;
export type MediaItemC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        content: typeof MediaItemContent;
        context: typeof MediaItemContext;
    }>,
    t.TypeC<{
        content: typeof Defined;
        context: typeof Defined;
    }>
]>, MediaItemBrand>;
export declare const MediaItem: MediaItemC;
export type MediaItemBrand = {
    readonly MediaItem: unique symbol;
};
export type Media = t.Branded<Array<MediaItem>, MediaBrand>;
export type MediaC = t.BrandC<t.ArrayC<typeof MediaItem>, MediaBrand>;
export declare const Media: MediaC;
export type MediaBrand = {
    readonly Media: unique symbol;
};
export type KycServiceId = t.Branded<string, KycServiceIdBrand>;
export type KycServiceIdC = t.BrandC<t.StringC, KycServiceIdBrand>;
export declare const KycServiceId: KycServiceIdC;
export type KycServiceIdBrand = {
    readonly KycServiceId: unique symbol;
};
export type FirstName = t.Branded<Common_ffba_.PersonalName, FirstNameBrand>;
export type FirstNameC = t.BrandC<typeof Common_ffba_.PersonalName, FirstNameBrand>;
export declare const FirstName: FirstNameC;
export type FirstNameBrand = {
    readonly FirstName: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(FirstName)).decodeSync(examplesFirstName) // => examplesFirstName */
export declare const examplesFirstName: NonEmptyArray<FirstName>;
export type LastName = t.Branded<Common_ffba_.PersonalName, LastNameBrand>;
export type LastNameC = t.BrandC<typeof Common_ffba_.PersonalName, LastNameBrand>;
export declare const LastName: LastNameC;
export type LastNameBrand = {
    readonly LastName: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(LastName)).decodeSync(examplesLastName) // => examplesLastName */
export declare const examplesLastName: NonEmptyArray<LastName>;
export type PartyId = t.Branded<string, PartyIdBrand>;
export type PartyIdC = t.BrandC<t.StringC, PartyIdBrand>;
export declare const PartyId: PartyIdC;
export type PartyIdBrand = {
    readonly PartyId: unique symbol;
};
export type PartyType = t.Branded<string, PartyTypeBrand>;
export type PartyTypeC = t.BrandC<t.StringC, PartyTypeBrand>;
export declare const PartyType: PartyTypeC;
export type PartyTypeBrand = {
    readonly PartyType: unique symbol;
};
export type PersonalDocument = t.Branded<{
    id?: DocumentId;
    identityId?: Units_c404_.IdentityId;
    type?: DocumentType;
    documentNumber?: DocumentNumber;
    category?: Category;
    issuingCountry?: IssuingCountry;
    status?: DocumentStatus;
    validFrom?: ValidFrom;
    validTo?: ValidTo;
    details?: Details;
    media?: Media;
    kycServiceId?: KycServiceId;
    firstName?: FirstName | Null;
    lastName?: LastName | Null;
} & {
    type: Defined;
    documentNumber: Defined;
    issuingCountry: Defined;
    status: Defined;
    validFrom: Defined;
    validTo: Defined;
}, PersonalDocumentBrand>;
export type PersonalDocumentC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof DocumentId;
        identityId: typeof Units_c404_.IdentityId;
        type: typeof DocumentType;
        documentNumber: typeof DocumentNumber;
        category: typeof Category;
        issuingCountry: typeof IssuingCountry;
        status: typeof DocumentStatus;
        validFrom: typeof ValidFrom;
        validTo: typeof ValidTo;
        details: typeof Details;
        media: typeof Media;
        kycServiceId: typeof KycServiceId;
        firstName: t.UnionC<[typeof FirstName, typeof Null]>;
        lastName: t.UnionC<[typeof LastName, typeof Null]>;
    }>,
    t.TypeC<{
        type: typeof Defined;
        documentNumber: typeof Defined;
        issuingCountry: typeof Defined;
        status: typeof Defined;
        validFrom: typeof Defined;
        validTo: typeof Defined;
    }>
]>, PersonalDocumentBrand>;
export declare const PersonalDocument: PersonalDocumentC;
export type PersonalDocumentBrand = {
    readonly PersonalDocument: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(PersonalDocument)).decodeSync(examplesPersonalDocument) // => examplesPersonalDocument */
export declare const examplesPersonalDocument: NonEmptyArray<PersonalDocument>;
export default PersonalDocument;
