import * as t from 'io-ts';
import * as Place_de2d_ from './components/place';
import * as Units_c404_ from './components/units';
import * as Itinerary_8303_ from './itinerary';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/plan.json";
export type Itineraries = t.Branded<Array<Itinerary_8303_.Itinerary>, ItinerariesBrand>;
export type ItinerariesC = t.BrandC<t.ArrayC<typeof Itinerary_8303_.Itinerary>, ItinerariesBrand>;
export declare const Itineraries: ItinerariesC;
export type ItinerariesBrand = {
    readonly Itineraries: unique symbol;
};
export type Plan1 = t.Branded<({
    from?: Place_de2d_.Place;
    planId?: Units_c404_.Uuid;
    outwards?: Itineraries;
    returns?: Itineraries;
} & Record<string, unknown>) & {
    from: Defined;
    planId: Defined;
    outwards: Defined;
    returns: Defined;
}, Plan1Brand>;
export type Plan1C = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            from: typeof Place_de2d_.Place;
            planId: typeof Units_c404_.Uuid;
            outwards: typeof Itineraries;
            returns: typeof Itineraries;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        from: typeof Defined;
        planId: typeof Defined;
        outwards: typeof Defined;
        returns: typeof Defined;
    }>
]>, Plan1Brand>;
export declare const Plan1: Plan1C;
export type Plan1Brand = {
    readonly Plan1: unique symbol;
};
export type Plan2 = t.Branded<({
    from?: Place_de2d_.Place;
    planId?: Units_c404_.Uuid;
    itineraries?: Itineraries;
} & Record<string, unknown>) & {
    from: Defined;
    planId: Defined;
    itineraries: Defined;
}, Plan2Brand>;
export type Plan2C = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            from: typeof Place_de2d_.Place;
            planId: typeof Units_c404_.Uuid;
            itineraries: typeof Itineraries;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        from: typeof Defined;
        planId: typeof Defined;
        itineraries: typeof Defined;
    }>
]>, Plan2Brand>;
export declare const Plan2: Plan2C;
export type Plan2Brand = {
    readonly Plan2: unique symbol;
};
export type Plan = t.Branded<Plan1 | Plan2, PlanBrand>;
export type PlanC = t.BrandC<t.UnionC<[typeof Plan1, typeof Plan2]>, PlanBrand>;
export declare const Plan: PlanC;
export type PlanBrand = {
    readonly Plan: unique symbol;
};
export default Plan;
