import * as t from 'io-ts';
import * as BookingMeta_c057_ from './booking-meta';
import * as Configurator_2e96_ from './components/configurator';
import * as Fare_a3ab_ from './components/fare';
import * as Terms_bb95_ from './components/terms';
import * as Units_c404_ from './components/units';
import * as Leg_1308_ from './leg';
import * as Product_d23e_ from './product';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/product-optionV2.json";
export type Ref = t.Branded<number, RefBrand>;
export type RefC = t.BrandC<t.NumberC, RefBrand>;
export declare const Ref: RefC;
export type RefBrand = {
    readonly Ref: unique symbol;
};
/** require('io-ts-validator').validator(Ref).decodeSync(minimumRef) // => minimumRef */
export declare const minimumRef: Ref;
export type ProductOptionWithFares = t.Branded<({
    ref?: number;
    customerId?: Units_c404_.IdentityId;
    type?: 'BOOKING_BOOKABLE';
    product?: Product_d23e_.Product;
    terms?: Terms_bb95_.Terms;
    meta?: BookingMeta_c057_.BookingMeta;
    fares?: Array<Fare_a3ab_.Fare>;
} & Record<string, unknown>) & {
    ref: Defined;
    customerId: Defined;
    type: Defined;
    product: Defined;
    terms: Defined;
    meta: Defined;
    fares: Defined;
}, ProductOptionWithFaresBrand>;
export type ProductOptionWithFaresC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            ref: t.NumberC;
            customerId: typeof Units_c404_.IdentityId;
            type: t.LiteralC<'BOOKING_BOOKABLE'>;
            product: typeof Product_d23e_.Product;
            terms: typeof Terms_bb95_.Terms;
            meta: typeof BookingMeta_c057_.BookingMeta;
            fares: t.ArrayC<typeof Fare_a3ab_.Fare>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        ref: typeof Defined;
        customerId: typeof Defined;
        type: typeof Defined;
        product: typeof Defined;
        terms: typeof Defined;
        meta: typeof Defined;
        fares: typeof Defined;
    }>
]>, ProductOptionWithFaresBrand>;
export declare const ProductOptionWithFares: ProductOptionWithFaresC;
export type ProductOptionWithFaresBrand = {
    readonly ProductOptionWithFares: unique symbol;
};
export type ProductOptionWithFaresExistingBooking = t.Branded<ProductOptionWithFares & (({
    bookingId?: Units_c404_.Uuid;
} & Record<string, unknown>) & {
    bookingId: Defined;
}), ProductOptionWithFaresExistingBookingBrand>;
export type ProductOptionWithFaresExistingBookingC = t.BrandC<t.IntersectionC<[
    typeof ProductOptionWithFares,
    t.IntersectionC<[
        t.IntersectionC<[
            t.PartialC<{
                bookingId: typeof Units_c404_.Uuid;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.TypeC<{
            bookingId: typeof Defined;
        }>
    ]>
]>, ProductOptionWithFaresExistingBookingBrand>;
export declare const ProductOptionWithFaresExistingBooking: ProductOptionWithFaresExistingBookingC;
export type ProductOptionWithFaresExistingBookingBrand = {
    readonly ProductOptionWithFaresExistingBooking: unique symbol;
};
export type ProductOptionWithConfigurator = t.Branded<({
    ref?: Ref;
    customerId?: Units_c404_.IdentityId;
    type?: 'BOOKING_BOOKABLE' | 'BOOKING_ESTIMATABLE';
    product?: Product_d23e_.Product;
    terms?: Terms_bb95_.Terms;
    meta?: BookingMeta_c057_.BookingMeta;
    configurator?: Configurator_2e96_.Configurator;
} & Record<string, unknown>) & {
    ref: Defined;
    customerId: Defined;
    type: Defined;
    product: Defined;
    terms: Defined;
    meta: Defined;
    configurator: Defined;
}, ProductOptionWithConfiguratorBrand>;
export type ProductOptionWithConfiguratorC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            ref: typeof Ref;
            customerId: typeof Units_c404_.IdentityId;
            type: t.UnionC<[
                t.LiteralC<'BOOKING_BOOKABLE'>,
                t.LiteralC<'BOOKING_ESTIMATABLE'>
            ]>;
            product: typeof Product_d23e_.Product;
            terms: typeof Terms_bb95_.Terms;
            meta: typeof BookingMeta_c057_.BookingMeta;
            configurator: typeof Configurator_2e96_.Configurator;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        ref: typeof Defined;
        customerId: typeof Defined;
        type: typeof Defined;
        product: typeof Defined;
        terms: typeof Defined;
        meta: typeof Defined;
        configurator: typeof Defined;
    }>
]>, ProductOptionWithConfiguratorBrand>;
export declare const ProductOptionWithConfigurator: ProductOptionWithConfiguratorC;
export type ProductOptionWithConfiguratorBrand = {
    readonly ProductOptionWithConfigurator: unique symbol;
};
export type ProductOptionWithConfiguratorExistingBooking = t.Branded<ProductOptionWithConfigurator & (({
    bookingId?: Units_c404_.Uuid;
} & Record<string, unknown>) & {
    bookingId: Defined;
}), ProductOptionWithConfiguratorExistingBookingBrand>;
export type ProductOptionWithConfiguratorExistingBookingC = t.BrandC<t.IntersectionC<[
    typeof ProductOptionWithConfigurator,
    t.IntersectionC<[
        t.IntersectionC<[
            t.PartialC<{
                bookingId: typeof Units_c404_.Uuid;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.TypeC<{
            bookingId: typeof Defined;
        }>
    ]>
]>, ProductOptionWithConfiguratorExistingBookingBrand>;
export declare const ProductOptionWithConfiguratorExistingBooking: ProductOptionWithConfiguratorExistingBookingC;
export type ProductOptionWithConfiguratorExistingBookingBrand = {
    readonly ProductOptionWithConfiguratorExistingBooking: unique symbol;
};
export type ProductOptionUnnecessary = t.Branded<({
    ref?: number;
    customerId?: Units_c404_.IdentityId;
    type?: 'BOOKING_UNNECESSARY';
} & Record<string, unknown>) & {
    ref: Defined;
    customerId: Defined;
    type: Defined;
}, ProductOptionUnnecessaryBrand>;
export type ProductOptionUnnecessaryC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            ref: t.NumberC;
            customerId: typeof Units_c404_.IdentityId;
            type: t.LiteralC<'BOOKING_UNNECESSARY'>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        ref: typeof Defined;
        customerId: typeof Defined;
        type: typeof Defined;
    }>
]>, ProductOptionUnnecessaryBrand>;
export declare const ProductOptionUnnecessary: ProductOptionUnnecessaryC;
export type ProductOptionUnnecessaryBrand = {
    readonly ProductOptionUnnecessary: unique symbol;
};
export type ProductOptionUnavailable = t.Branded<({
    ref?: number;
    customerId?: Units_c404_.IdentityId;
    type?: 'BOOKING_UNAVAILABLE';
    agencyId?: Leg_1308_.AgencyId;
} & Record<string, unknown>) & {
    ref: Defined;
    customerId: Defined;
    type: Defined;
    agencyId: Defined;
}, ProductOptionUnavailableBrand>;
export type ProductOptionUnavailableC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            ref: t.NumberC;
            customerId: typeof Units_c404_.IdentityId;
            type: t.LiteralC<'BOOKING_UNAVAILABLE'>;
            agencyId: typeof Leg_1308_.AgencyId;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        ref: typeof Defined;
        customerId: typeof Defined;
        type: typeof Defined;
        agencyId: typeof Defined;
    }>
]>, ProductOptionUnavailableBrand>;
export declare const ProductOptionUnavailable: ProductOptionUnavailableC;
export type ProductOptionUnavailableBrand = {
    readonly ProductOptionUnavailable: unique symbol;
};
export type ProductOptionAvailable = t.Branded<({
    ref?: number;
    customerId?: Units_c404_.IdentityId;
    type?: 'BOOKING_AVAILABLE';
    agencyId?: Leg_1308_.AgencyId;
    productId?: Product_d23e_.Id;
    estimatedFares?: Array<Fare_a3ab_.Fare>;
} & Record<string, unknown>) & {
    ref: Defined;
    customerId: Defined;
    type: Defined;
    agencyId: Defined;
    productId: Defined;
    estimatedFares: Defined;
}, ProductOptionAvailableBrand>;
export type ProductOptionAvailableC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            ref: t.NumberC;
            customerId: typeof Units_c404_.IdentityId;
            type: t.LiteralC<'BOOKING_AVAILABLE'>;
            agencyId: typeof Leg_1308_.AgencyId;
            productId: typeof Product_d23e_.Id;
            estimatedFares: t.ArrayC<typeof Fare_a3ab_.Fare>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        ref: typeof Defined;
        customerId: typeof Defined;
        type: typeof Defined;
        agencyId: typeof Defined;
        productId: typeof Defined;
        estimatedFares: typeof Defined;
    }>
]>, ProductOptionAvailableBrand>;
export declare const ProductOptionAvailable: ProductOptionAvailableC;
export type ProductOptionAvailableBrand = {
    readonly ProductOptionAvailable: unique symbol;
};
export type ProductOptionOwnAsset = t.Branded<({
    ref?: number;
    customerId?: Units_c404_.IdentityId;
    type?: 'BOOKING_OWN_ASSET';
    description?: string;
} & Record<string, unknown>) & {
    ref: Defined;
    customerId: Defined;
    type: Defined;
    description: Defined;
}, ProductOptionOwnAssetBrand>;
export type ProductOptionOwnAssetC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            ref: t.NumberC;
            customerId: typeof Units_c404_.IdentityId;
            type: t.LiteralC<'BOOKING_OWN_ASSET'>;
            description: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        ref: typeof Defined;
        customerId: typeof Defined;
        type: typeof Defined;
        description: typeof Defined;
    }>
]>, ProductOptionOwnAssetBrand>;
export declare const ProductOptionOwnAsset: ProductOptionOwnAssetC;
export type ProductOptionOwnAssetBrand = {
    readonly ProductOptionOwnAsset: unique symbol;
};
export type ProductOptionV2 = t.Branded<ProductOptionWithFares | ProductOptionWithFaresExistingBooking | ProductOptionWithConfigurator | ProductOptionWithConfiguratorExistingBooking | ProductOptionUnnecessary | ProductOptionUnavailable | ProductOptionAvailable | ProductOptionOwnAsset, ProductOptionV2Brand>;
export type ProductOptionV2C = t.BrandC<t.UnionC<[
    typeof ProductOptionWithFares,
    typeof ProductOptionWithFaresExistingBooking,
    typeof ProductOptionWithConfigurator,
    typeof ProductOptionWithConfiguratorExistingBooking,
    typeof ProductOptionUnnecessary,
    typeof ProductOptionUnavailable,
    typeof ProductOptionAvailable,
    typeof ProductOptionOwnAsset
]>, ProductOptionV2Brand>;
export declare const ProductOptionV2: ProductOptionV2C;
export type ProductOptionV2Brand = {
    readonly ProductOptionV2: unique symbol;
};
export default ProductOptionV2;
