import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Common_ffba_ from './components/common';
import * as Fare_a3ab_ from './components/fare';
export type NullBrand = {
    readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export declare const Null: NullC;
export type Null = t.TypeOf<typeof Null>;
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/product.json";
export type Id = t.Branded<string, IdBrand>;
export type IdC = t.BrandC<t.StringC, IdBrand>;
export declare const Id: IdC;
export type IdBrand = {
    readonly Id: unique symbol;
};
export type PreAuthBuffer = t.Branded<{
    percentageExtra?: number;
    minimumExtra?: Fare_a3ab_.Fare;
} | Null, PreAuthBufferBrand>;
export type PreAuthBufferC = t.BrandC<t.UnionC<[
    t.PartialC<{
        percentageExtra: t.NumberC;
        minimumExtra: typeof Fare_a3ab_.Fare;
    }>,
    typeof Null
]>, PreAuthBufferBrand>;
export declare const PreAuthBuffer: PreAuthBufferC;
export type PreAuthBufferBrand = {
    readonly PreAuthBuffer: unique symbol;
};
export type Product = t.Branded<({
    id?: Id;
    name?: string;
    description?: string;
    icon?: string;
    priority?: number;
    agencyId?: Common_ffba_.AgencyId;
    tspProductId?: string;
    allowFinishTrip?: boolean;
    preAuthBuffer?: PreAuthBuffer;
    paymentInstruction?: string;
} & Record<string, unknown>) & {
    id: Defined;
    tspProductId: Defined;
    name: Defined;
}, ProductBrand>;
export type ProductC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: typeof Id;
            name: t.StringC;
            description: t.StringC;
            icon: t.StringC;
            priority: t.NumberC;
            agencyId: typeof Common_ffba_.AgencyId;
            tspProductId: t.StringC;
            allowFinishTrip: t.BooleanC;
            preAuthBuffer: typeof PreAuthBuffer;
            paymentInstruction: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
        tspProductId: typeof Defined;
        name: typeof Defined;
    }>
]>, ProductBrand>;
export declare const Product: ProductC;
export type ProductBrand = {
    readonly Product: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Product)).decodeSync(examplesProduct) // => examplesProduct */
export declare const examplesProduct: NonEmptyArray<Product>;
export default Product;
