import * as t from 'io-ts';
import * as Address_2d0a_ from './components/address';
import * as Common_ffba_ from './components/common';
import * as Fare_a3ab_ from './components/fare';
import * as Place_de2d_ from './components/place';
import * as PointCost_5d0d_ from './components/point-cost';
import * as Units_c404_ from './components/units';
import * as Region_ad49_ from './region';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/profile.json";
export type BookingOptionsReference = t.Branded<number, BookingOptionsReferenceBrand>;
export type BookingOptionsReferenceC = t.BrandC<t.NumberC, BookingOptionsReferenceBrand>;
export declare const BookingOptionsReference: BookingOptionsReferenceC;
export type BookingOptionsReferenceBrand = {
    readonly BookingOptionsReference: unique symbol;
};
/** require('io-ts-validator').validator(BookingOptionsReference).decodeSync(minimumBookingOptionsReference) // => minimumBookingOptionsReference */
export declare const minimumBookingOptionsReference: BookingOptionsReference;
export type SubscriptionInstance = t.Branded<({
    id?: BookingOptionsReference | Units_c404_.IdentityId;
    name?: string;
    plan?: {
        id?: string;
    } & {
        id: Defined;
    };
    addons?: Array<string>;
    coupons?: Array<string>;
    wmpGrant?: number;
    creditGrant?: number;
    creditCurrency?: Units_c404_.Currency;
    level?: number;
    active?: boolean;
    pointCost?: PointCost_5d0d_.PointCost;
    description?: string;
    availability?: number;
} & Record<string, unknown>) & {
    plan: Defined;
    addons: Defined;
    coupons: Defined;
    pointCost: Defined;
}, SubscriptionInstanceBrand>;
export type SubscriptionInstanceC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: t.UnionC<[typeof BookingOptionsReference, typeof Units_c404_.IdentityId]>;
            name: t.StringC;
            plan: t.IntersectionC<[
                t.PartialC<{
                    id: t.StringC;
                }>,
                t.TypeC<{
                    id: typeof Defined;
                }>
            ]>;
            addons: t.ArrayC<t.StringC>;
            coupons: t.ArrayC<t.StringC>;
            wmpGrant: t.NumberC;
            creditGrant: t.NumberC;
            creditCurrency: typeof Units_c404_.Currency;
            level: t.NumberC;
            active: t.BooleanC;
            pointCost: typeof PointCost_5d0d_.PointCost;
            description: t.StringC;
            availability: t.NumberC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        plan: typeof Defined;
        addons: typeof Defined;
        coupons: typeof Defined;
        pointCost: typeof Defined;
    }>
]>, SubscriptionInstanceBrand>;
export declare const SubscriptionInstance: SubscriptionInstanceC;
export type SubscriptionInstanceBrand = {
    readonly SubscriptionInstance: unique symbol;
};
export type Profile = t.Branded<{
    id?: number;
    identityId?: Units_c404_.IdentityId;
    phone?: Common_ffba_.Phone;
    email?: Common_ffba_.Email;
    firstName?: Common_ffba_.PersonalName;
    lastName?: Common_ffba_.PersonalName;
    city?: Address_2d0a_.City;
    country?: Address_2d0a_.Country;
    zipCode?: Address_2d0a_.ZipCode;
    regionId?: string;
    region?: Region_ad49_.Region;
    profileImageUrl?: string;
    favoriteLocations?: Array<Place_de2d_.Place>;
    paymentMethod?: ({
        type?: string & ('unknown' | 'card' | 'stripe');
        valid?: boolean;
        maskedNumber?: string;
        network?: string;
        issuer?: string;
        expiry?: Units_c404_.Time;
    } & Record<string, unknown>) & {
        type: Defined;
        valid: Defined;
    };
    subscription?: Record<string, unknown> & Record<string, unknown>;
    subscriptionInstance?: SubscriptionInstance;
    balances?: Array<Fare_a3ab_.Fare>;
    created?: Units_c404_.Time;
    modified?: Units_c404_.Time;
} & {
    identityId: Defined;
    phone: Defined;
    favoriteLocations: Defined;
    paymentMethod: Defined;
    subscriptionInstance: Defined;
    balances: Defined;
}, ProfileBrand>;
export type ProfileC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: t.NumberC;
        identityId: typeof Units_c404_.IdentityId;
        phone: typeof Common_ffba_.Phone;
        email: typeof Common_ffba_.Email;
        firstName: typeof Common_ffba_.PersonalName;
        lastName: typeof Common_ffba_.PersonalName;
        city: typeof Address_2d0a_.City;
        country: typeof Address_2d0a_.Country;
        zipCode: typeof Address_2d0a_.ZipCode;
        regionId: t.StringC;
        region: typeof Region_ad49_.Region;
        profileImageUrl: t.StringC;
        favoriteLocations: t.ArrayC<typeof Place_de2d_.Place>;
        paymentMethod: t.IntersectionC<[
            t.IntersectionC<[
                t.PartialC<{
                    type: t.IntersectionC<[
                        t.StringC,
                        t.UnionC<[
                            t.LiteralC<'unknown'>,
                            t.LiteralC<'card'>,
                            t.LiteralC<'stripe'>
                        ]>
                    ]>;
                    valid: t.BooleanC;
                    maskedNumber: t.StringC;
                    network: t.StringC;
                    issuer: t.StringC;
                    expiry: typeof Units_c404_.Time;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>,
            t.TypeC<{
                type: typeof Defined;
                valid: typeof Defined;
            }>
        ]>;
        subscription: t.IntersectionC<[
            t.UnknownRecordC,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        subscriptionInstance: typeof SubscriptionInstance;
        balances: t.ArrayC<typeof Fare_a3ab_.Fare>;
        created: typeof Units_c404_.Time;
        modified: typeof Units_c404_.Time;
    }>,
    t.TypeC<{
        identityId: typeof Defined;
        phone: typeof Defined;
        favoriteLocations: typeof Defined;
        paymentMethod: typeof Defined;
        subscriptionInstance: typeof Defined;
        balances: typeof Defined;
    }>
]>, ProfileBrand>;
export declare const Profile: ProfileC;
export type ProfileBrand = {
    readonly Profile: unique symbol;
};
export default Profile;
