import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Address_2d0a_ from './components/address';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/core/region.json";
export type RegionId = t.Branded<string, RegionIdBrand>;
export type RegionIdC = t.BrandC<t.StringC, RegionIdBrand>;
export declare const RegionId: RegionIdC;
export type RegionIdBrand = {
    readonly RegionId: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(RegionId)).decodeSync(examplesRegionId) // => examplesRegionId */
export declare const examplesRegionId: NonEmptyArray<RegionId>;
export type RegionName = t.Branded<string, RegionNameBrand>;
export type RegionNameC = t.BrandC<t.StringC, RegionNameBrand>;
export declare const RegionName: RegionNameC;
export type RegionNameBrand = {
    readonly RegionName: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(RegionName)).decodeSync(examplesRegionName) // => examplesRegionName */
export declare const examplesRegionName: NonEmptyArray<RegionName>;
export type CountryCode = t.Branded<Address_2d0a_.Country, CountryCodeBrand>;
export type CountryCodeC = t.BrandC<typeof Address_2d0a_.Country, CountryCodeBrand>;
export declare const CountryCode: CountryCodeC;
export type CountryCodeBrand = {
    readonly CountryCode: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(CountryCode)).decodeSync(examplesCountryCode) // => examplesCountryCode */
export declare const examplesCountryCode: NonEmptyArray<CountryCode>;
export type ZipCode = t.Branded<Address_2d0a_.ZipCode, ZipCodeBrand>;
export type ZipCodeC = t.BrandC<typeof Address_2d0a_.ZipCode, ZipCodeBrand>;
export declare const ZipCode: ZipCodeC;
export type ZipCodeBrand = {
    readonly ZipCode: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(ZipCode)).decodeSync(examplesZipCode) // => examplesZipCode */
export declare const examplesZipCode: NonEmptyArray<ZipCode>;
export type Availability = t.Branded<Record<string, unknown>, AvailabilityBrand>;
export type AvailabilityC = t.BrandC<t.RecordC<t.StringC, t.UnknownC>, AvailabilityBrand>;
export declare const Availability: AvailabilityC;
export type AvailabilityBrand = {
    readonly Availability: unique symbol;
};
export type Region = t.Branded<({
    id?: RegionId;
    name?: RegionName;
    countryCode?: CountryCode;
    zipCode?: ZipCode;
    availability?: Availability;
} & Record<string, unknown>) & {
    id: Defined;
    countryCode: Defined;
    zipCode: Defined;
}, RegionBrand>;
export type RegionC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: typeof RegionId;
            name: typeof RegionName;
            countryCode: typeof CountryCode;
            zipCode: typeof ZipCode;
            availability: typeof Availability;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
        countryCode: typeof Defined;
        zipCode: typeof Defined;
    }>
]>, RegionBrand>;
export declare const Region: RegionC;
export type RegionBrand = {
    readonly Region: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Region)).decodeSync(examplesRegion) // => examplesRegion */
export declare const examplesRegion: NonEmptyArray<Region>;
export default Region;
import "jest";
