import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Units_c404_ from '../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/environments/accounts.json";
export type AccountId = t.Branded<string, AccountIdBrand>;
export type AccountIdC = t.BrandC<t.StringC, AccountIdBrand>;
export declare const AccountId: AccountIdC;
export type AccountIdBrand = {
    readonly AccountId: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(AccountId)).decodeSync(examplesAccountId) // => examplesAccountId */
export declare const examplesAccountId: NonEmptyArray<AccountId>;
export type AccountAlias = t.Branded<string & Units_c404_.HostnameLabel, AccountAliasBrand>;
export type AccountAliasC = t.BrandC<t.IntersectionC<[t.StringC, typeof Units_c404_.HostnameLabel]>, AccountAliasBrand>;
export declare const AccountAlias: AccountAliasC;
export type AccountAliasBrand = {
    readonly AccountAlias: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(AccountAlias)).decodeSync(examplesAccountAlias) // => examplesAccountAlias */
export declare const examplesAccountAlias: NonEmptyArray<AccountAlias>;
export type AccountName = t.Branded<string, AccountNameBrand>;
export type AccountNameC = t.BrandC<t.StringC, AccountNameBrand>;
export declare const AccountName: AccountNameC;
export type AccountNameBrand = {
    readonly AccountName: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(AccountName)).decodeSync(examplesAccountName) // => examplesAccountName */
export declare const examplesAccountName: NonEmptyArray<AccountName>;
export type AccountDescription = t.Branded<string, AccountDescriptionBrand>;
export type AccountDescriptionC = t.BrandC<t.StringC, AccountDescriptionBrand>;
export declare const AccountDescription: AccountDescriptionC;
export type AccountDescriptionBrand = {
    readonly AccountDescription: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(AccountDescription)).decodeSync(examplesAccountDescription) // => examplesAccountDescription */
export declare const examplesAccountDescription: NonEmptyArray<AccountDescription>;
export type Account = t.Branded<({
    id?: AccountId;
    name?: AccountName;
    description?: AccountDescription;
} & Record<string, unknown>) & {
    id: Defined;
}, AccountBrand>;
export type AccountC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: typeof AccountId;
            name: typeof AccountName;
            description: typeof AccountDescription;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
    }>
]>, AccountBrand>;
export declare const Account: AccountC;
export type AccountBrand = {
    readonly Account: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Account)).decodeSync(examplesAccount) // => examplesAccount */
export declare const examplesAccount: NonEmptyArray<Account>;
export type AccountIndex = t.Branded<Record<AccountAlias, unknown> & Record<string, Account>, AccountIndexBrand>;
export type AccountIndexC = t.BrandC<t.IntersectionC<[
    t.RecordC<typeof AccountAlias, t.UnknownC>,
    t.RecordC<t.StringC, typeof Account>
]>, AccountIndexBrand>;
export declare const AccountIndex: AccountIndexC;
export type AccountIndexBrand = {
    readonly AccountIndex: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(AccountIndex)).decodeSync(examplesAccountIndex) // => examplesAccountIndex */
export declare const examplesAccountIndex: NonEmptyArray<AccountIndex>;
export type Accounts = t.Branded<unknown, AccountsBrand>;
export type AccountsC = t.BrandC<t.UnknownC, AccountsBrand>;
export declare const Accounts: AccountsC;
export type AccountsBrand = {
    readonly Accounts: unique symbol;
};
export default Accounts;
import "jest";
