import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Units_c404_ from '../core/components/units';
import * as Accounts_8a1b_ from './accounts';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/environments/environments.json";
export type EnvironmentId = t.Branded<string & Units_c404_.HostnameLabel, EnvironmentIdBrand>;
export type EnvironmentIdC = t.BrandC<t.IntersectionC<[t.StringC, typeof Units_c404_.HostnameLabel]>, EnvironmentIdBrand>;
export declare const EnvironmentId: EnvironmentIdC;
export type EnvironmentIdBrand = {
    readonly EnvironmentId: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(EnvironmentId)).decodeSync(examplesEnvironmentId) // => examplesEnvironmentId */
export declare const examplesEnvironmentId: NonEmptyArray<EnvironmentId>;
export type EnvironmentLive = t.Branded<boolean, EnvironmentLiveBrand>;
export type EnvironmentLiveC = t.BrandC<t.BooleanC, EnvironmentLiveBrand>;
export declare const EnvironmentLive: EnvironmentLiveC;
export type EnvironmentLiveBrand = {
    readonly EnvironmentLive: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(EnvironmentLive)).decodeSync(examplesEnvironmentLive) // => examplesEnvironmentLive */
export declare const examplesEnvironmentLive: NonEmptyArray<EnvironmentLive>;
export type EnvironmentName = t.Branded<string, EnvironmentNameBrand>;
export type EnvironmentNameC = t.BrandC<t.StringC, EnvironmentNameBrand>;
export declare const EnvironmentName: EnvironmentNameC;
export type EnvironmentNameBrand = {
    readonly EnvironmentName: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(EnvironmentName)).decodeSync(examplesEnvironmentName) // => examplesEnvironmentName */
export declare const examplesEnvironmentName: NonEmptyArray<EnvironmentName>;
export type EnvironmentDescription = t.Branded<string, EnvironmentDescriptionBrand>;
export type EnvironmentDescriptionC = t.BrandC<t.StringC, EnvironmentDescriptionBrand>;
export declare const EnvironmentDescription: EnvironmentDescriptionC;
export type EnvironmentDescriptionBrand = {
    readonly EnvironmentDescription: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(EnvironmentDescription)).decodeSync(examplesEnvironmentDescription) // => examplesEnvironmentDescription */
export declare const examplesEnvironmentDescription: NonEmptyArray<EnvironmentDescription>;
export type Environment = t.Branded<{
    id?: EnvironmentId;
    live?: EnvironmentLive;
    account?: Accounts_8a1b_.AccountAlias;
    name?: EnvironmentName;
    description?: EnvironmentDescription;
} & {
    id: Defined;
    live: Defined;
    account: Defined;
}, EnvironmentBrand>;
export type EnvironmentC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof EnvironmentId;
        live: typeof EnvironmentLive;
        account: typeof Accounts_8a1b_.AccountAlias;
        name: typeof EnvironmentName;
        description: typeof EnvironmentDescription;
    }>,
    t.TypeC<{
        id: typeof Defined;
        live: typeof Defined;
        account: typeof Defined;
    }>
]>, EnvironmentBrand>;
export declare const Environment: EnvironmentC;
export type EnvironmentBrand = {
    readonly Environment: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Environment)).decodeSync(examplesEnvironment) // => examplesEnvironment */
export declare const examplesEnvironment: NonEmptyArray<Environment>;
export type DevEnvironment = t.Branded<Environment & (({
    live?: false;
} & Record<string, unknown>) & {
    live: Defined;
}), DevEnvironmentBrand>;
export type DevEnvironmentC = t.BrandC<t.IntersectionC<[
    typeof Environment,
    t.IntersectionC<[
        t.IntersectionC<[
            t.PartialC<{
                live: t.LiteralC<false>;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.TypeC<{
            live: typeof Defined;
        }>
    ]>
]>, DevEnvironmentBrand>;
export declare const DevEnvironment: DevEnvironmentC;
export type DevEnvironmentBrand = {
    readonly DevEnvironment: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(DevEnvironment)).decodeSync(examplesDevEnvironment) // => examplesDevEnvironment */
export declare const examplesDevEnvironment: NonEmptyArray<DevEnvironment>;
/** require('io-ts-validator').validator(DevEnvironment).decodeEither({"id":"live","live":true,"account":"live","description":"Live environment"})._tag // => 'Left' */
export type EnvironmentGroupName = t.Branded<string, EnvironmentGroupNameBrand>;
export type EnvironmentGroupNameC = t.BrandC<t.StringC, EnvironmentGroupNameBrand>;
export declare const EnvironmentGroupName: EnvironmentGroupNameC;
export type EnvironmentGroupNameBrand = {
    readonly EnvironmentGroupName: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(EnvironmentGroupName)).decodeSync(examplesEnvironmentGroupName) // => examplesEnvironmentGroupName */
export declare const examplesEnvironmentGroupName: NonEmptyArray<EnvironmentGroupName>;
export type EnvironmentGroupDescription = t.Branded<string, EnvironmentGroupDescriptionBrand>;
export type EnvironmentGroupDescriptionC = t.BrandC<t.StringC, EnvironmentGroupDescriptionBrand>;
export declare const EnvironmentGroupDescription: EnvironmentGroupDescriptionC;
export type EnvironmentGroupDescriptionBrand = {
    readonly EnvironmentGroupDescription: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(EnvironmentGroupDescription)).decodeSync(examplesEnvironmentGroupDescription) // => examplesEnvironmentGroupDescription */
export declare const examplesEnvironmentGroupDescription: NonEmptyArray<EnvironmentGroupDescription>;
export type EnvironmentGroup = t.Branded<{
    name?: EnvironmentGroupName;
    envs?: Array<Environment>;
    description?: EnvironmentGroupDescription;
} & {
    name: Defined;
    envs: Defined;
}, EnvironmentGroupBrand>;
export type EnvironmentGroupC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        name: typeof EnvironmentGroupName;
        envs: t.ArrayC<typeof Environment>;
        description: typeof EnvironmentGroupDescription;
    }>,
    t.TypeC<{
        name: typeof Defined;
        envs: typeof Defined;
    }>
]>, EnvironmentGroupBrand>;
export declare const EnvironmentGroup: EnvironmentGroupC;
export type EnvironmentGroupBrand = {
    readonly EnvironmentGroup: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(EnvironmentGroup)).decodeSync(examplesEnvironmentGroup) // => examplesEnvironmentGroup */
export declare const examplesEnvironmentGroup: NonEmptyArray<EnvironmentGroup>;
export type EnvironmentIndex = t.Branded<Array<EnvironmentGroup>, EnvironmentIndexBrand>;
export type EnvironmentIndexC = t.BrandC<t.ArrayC<typeof EnvironmentGroup>, EnvironmentIndexBrand>;
export declare const EnvironmentIndex: EnvironmentIndexC;
export type EnvironmentIndexBrand = {
    readonly EnvironmentIndex: unique symbol;
};
export type Environments = t.Branded<{
    accounts?: Accounts_8a1b_.AccountIndex;
    index?: EnvironmentIndex;
} & {
    index: Defined;
}, EnvironmentsBrand>;
export type EnvironmentsC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        accounts: typeof Accounts_8a1b_.AccountIndex;
        index: typeof EnvironmentIndex;
    }>,
    t.TypeC<{
        index: typeof Defined;
    }>
]>, EnvironmentsBrand>;
export declare const Environments: EnvironmentsC;
export type EnvironmentsBrand = {
    readonly Environments: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Environments)).decodeSync(examplesEnvironments) // => examplesEnvironments */
export declare const examplesEnvironments: NonEmptyArray<Environments>;
export default Environments;
import "jest";
