import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Accounts_8a1b_ from './accounts';
import * as Environments_71b9_ from './environments';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export type NullBrand = {
    readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export declare const Null: NullC;
export type Null = t.TypeOf<typeof Null>;
export declare const schemaId = "https://schemas.maas.global/environments/synopsis.json";
export type GroupMeta = t.Branded<{
    name?: Environments_71b9_.EnvironmentGroupName;
    description?: Environments_71b9_.EnvironmentGroupDescription;
} & {
    name: Defined;
}, GroupMetaBrand>;
export type GroupMetaC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        name: typeof Environments_71b9_.EnvironmentGroupName;
        description: typeof Environments_71b9_.EnvironmentGroupDescription;
    }>,
    t.TypeC<{
        name: typeof Defined;
    }>
]>, GroupMetaBrand>;
export declare const GroupMeta: GroupMetaC;
export type GroupMetaBrand = {
    readonly GroupMeta: unique symbol;
};
export type UnknownAccount = t.Branded<Null, UnknownAccountBrand>;
export type UnknownAccountC = t.BrandC<typeof Null, UnknownAccountBrand>;
export declare const UnknownAccount: UnknownAccountC;
export type UnknownAccountBrand = {
    readonly UnknownAccount: unique symbol;
};
/** require('io-ts-validator').validator(UnknownAccount).decodeSync(defaultUnknownAccount) // => defaultUnknownAccount */
export declare const defaultUnknownAccount: UnknownAccount;
export type Synopsis = t.Branded<{
    environment?: Environments_71b9_.Environment;
    group?: GroupMeta;
    account?: UnknownAccount | Accounts_8a1b_.Account;
} & {
    environment: Defined;
    group: Defined;
    account: Defined;
}, SynopsisBrand>;
export type SynopsisC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        environment: typeof Environments_71b9_.Environment;
        group: typeof GroupMeta;
        account: t.UnionC<[typeof UnknownAccount, typeof Accounts_8a1b_.Account]>;
    }>,
    t.TypeC<{
        environment: typeof Defined;
        group: typeof Defined;
        account: typeof Defined;
    }>
]>, SynopsisBrand>;
export declare const Synopsis: SynopsisC;
export type SynopsisBrand = {
    readonly Synopsis: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Synopsis)).decodeSync(examplesSynopsis) // => examplesSynopsis */
export declare const examplesSynopsis: NonEmptyArray<Synopsis>;
export default Synopsis;
import "jest";
