import * as t from 'io-ts';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/geojson/geometry.json";
export type Position = t.Branded<[number, number], PositionBrand>;
export type PositionC = t.BrandC<t.TupleC<[t.NumberC, t.NumberC]>, PositionBrand>;
export declare const Position: PositionC;
export type PositionBrand = {
    readonly Position: unique symbol;
};
export type PositionArray = t.Branded<Array<Position>, PositionArrayBrand>;
export type PositionArrayC = t.BrandC<t.ArrayC<typeof Position>, PositionArrayBrand>;
export declare const PositionArray: PositionArrayC;
export type PositionArrayBrand = {
    readonly PositionArray: unique symbol;
};
export type LineString = t.Branded<PositionArray & unknown, LineStringBrand>;
export type LineStringC = t.BrandC<t.IntersectionC<[typeof PositionArray, t.UnknownC]>, LineStringBrand>;
export declare const LineString: LineStringC;
export type LineStringBrand = {
    readonly LineString: unique symbol;
};
export type LinearRing = t.Branded<PositionArray & unknown, LinearRingBrand>;
export type LinearRingC = t.BrandC<t.IntersectionC<[typeof PositionArray, t.UnknownC]>, LinearRingBrand>;
export declare const LinearRing: LinearRingC;
export type LinearRingBrand = {
    readonly LinearRing: unique symbol;
};
export type Polygon = t.Branded<Array<LinearRing>, PolygonBrand>;
export type PolygonC = t.BrandC<t.ArrayC<typeof LinearRing>, PolygonBrand>;
export declare const Polygon: PolygonC;
export type PolygonBrand = {
    readonly Polygon: unique symbol;
};
export type Geometry = t.Branded<Record<string, unknown> & Record<string, unknown> & {
    type: Defined;
    coordinates: Defined;
} & (({
    type?: 'Point';
    coordinates?: Position;
} & Record<string, unknown>) | ({
    type?: 'MultiPoint';
    coordinates?: PositionArray;
} & Record<string, unknown>) | ({
    type?: 'LineString';
    coordinates?: LineString;
} & Record<string, unknown>) | ({
    type?: 'MultiLineString';
    coordinates?: Array<LineString>;
} & Record<string, unknown>) | ({
    type?: 'Polygon';
    coordinates?: Polygon;
} & Record<string, unknown>) | ({
    type?: 'MultiPolygon';
    coordinates?: Array<Polygon>;
} & Record<string, unknown>)), GeometryBrand>;
export type GeometryC = t.BrandC<t.IntersectionC<[
    t.UnknownRecordC,
    t.RecordC<t.StringC, t.UnknownC>,
    t.TypeC<{
        type: typeof Defined;
        coordinates: typeof Defined;
    }>,
    t.UnionC<[
        t.IntersectionC<[
            t.PartialC<{
                type: t.LiteralC<'Point'>;
                coordinates: typeof Position;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.IntersectionC<[
            t.PartialC<{
                type: t.LiteralC<'MultiPoint'>;
                coordinates: typeof PositionArray;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.IntersectionC<[
            t.PartialC<{
                type: t.LiteralC<'LineString'>;
                coordinates: typeof LineString;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.IntersectionC<[
            t.PartialC<{
                type: t.LiteralC<'MultiLineString'>;
                coordinates: t.ArrayC<typeof LineString>;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.IntersectionC<[
            t.PartialC<{
                type: t.LiteralC<'Polygon'>;
                coordinates: typeof Polygon;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.IntersectionC<[
            t.PartialC<{
                type: t.LiteralC<'MultiPolygon'>;
                coordinates: t.ArrayC<typeof Polygon>;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>
    ]>
]>, GeometryBrand>;
export declare const Geometry: GeometryC;
export type GeometryBrand = {
    readonly Geometry: unique symbol;
};
export default Geometry;
