import * as t from 'io-ts';
import * as Address_2d0a_ from '../../../core/components/address';
import * as ApiCommon_16a4_ from '../../../core/components/api-common';
import * as Units_c404_ from '../../../core/components/units';
import * as UnitsGeo_3e31_ from '../../../core/components/units-geo';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/autocomplete/autocomplete-query/request.json";
export type Request = t.Branded<{
    identityId?: Units_c404_.IdentityId;
    payload?: {
        name?: Address_2d0a_.PlaceName;
        lat?: UnitsGeo_3e31_.RelaxedLatitude;
        lon?: UnitsGeo_3e31_.RelaxedLongitude;
        providerHint?: string;
        count?: number;
        radius?: UnitsGeo_3e31_.Distance & unknown;
    } & {
        name: Defined;
        lat: Defined;
        lon: Defined;
    };
    headers?: ApiCommon_16a4_.Headers;
} & Record<string, unknown>, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        identityId: typeof Units_c404_.IdentityId;
        payload: t.IntersectionC<[
            t.PartialC<{
                name: typeof Address_2d0a_.PlaceName;
                lat: typeof UnitsGeo_3e31_.RelaxedLatitude;
                lon: typeof UnitsGeo_3e31_.RelaxedLongitude;
                providerHint: t.StringC;
                count: t.NumberC;
                radius: t.IntersectionC<[typeof UnitsGeo_3e31_.Distance, t.UnknownC]>;
            }>,
            t.TypeC<{
                name: typeof Defined;
                lat: typeof Defined;
                lon: typeof Defined;
            }>
        ]>;
        headers: typeof ApiCommon_16a4_.Headers;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
