import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as UnitsGeo_3e31_ from '../../../core/components/units-geo';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/autocomplete/autocomplete-query/suggestion.json";
export type GoogleMeta = t.Branded<{
    placeId?: string;
}, GoogleMetaBrand>;
export type GoogleMetaC = t.BrandC<t.PartialC<{
    placeId: t.StringC;
}>, GoogleMetaBrand>;
export declare const GoogleMeta: GoogleMetaC;
export type GoogleMetaBrand = {
    readonly GoogleMeta: unique symbol;
};
export type RouterankMeta = t.Branded<{
    id?: string;
    lat?: UnitsGeo_3e31_.RelaxedLatitude;
    lon?: UnitsGeo_3e31_.RelaxedLongitude;
}, RouterankMetaBrand>;
export type RouterankMetaC = t.BrandC<t.PartialC<{
    id: t.StringC;
    lat: typeof UnitsGeo_3e31_.RelaxedLatitude;
    lon: typeof UnitsGeo_3e31_.RelaxedLongitude;
}>, RouterankMetaBrand>;
export declare const RouterankMeta: RouterankMetaC;
export type RouterankMetaBrand = {
    readonly RouterankMeta: unique symbol;
};
export type Suggestion = t.Branded<{
    label?: string;
    addressId?: string;
    meta?: {
        google?: GoogleMeta;
        routerank?: RouterankMeta;
    } & Record<string, unknown>;
} & {
    label: Defined;
    meta: Defined;
}, SuggestionBrand>;
export type SuggestionC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        label: t.StringC;
        addressId: t.StringC;
        meta: t.IntersectionC<[
            t.PartialC<{
                google: typeof GoogleMeta;
                routerank: typeof RouterankMeta;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
    }>,
    t.TypeC<{
        label: typeof Defined;
        meta: typeof Defined;
    }>
]>, SuggestionBrand>;
export declare const Suggestion: SuggestionC;
export type SuggestionBrand = {
    readonly Suggestion: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Suggestion)).decodeSync(examplesSuggestion) // => examplesSuggestion */
export declare const examplesSuggestion: NonEmptyArray<Suggestion>;
export default Suggestion;
import "jest";
