import * as t from 'io-ts';
import * as Booking_4353_ from '../../../core/booking';
import * as BookingMeta_c057_ from '../../../core/booking-meta';
import * as BikeStation_4888_ from '../../../core/components/bike-station';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/bookings/bookings-agency-options/response.json";
export type Option = t.Branded<({
    fares?: Booking_4353_.Fares;
    cost?: Booking_4353_.Cost;
    leg?: Booking_4353_.Leg;
    meta?: BookingMeta_c057_.BookingMeta;
    terms?: Booking_4353_.Terms;
    tspProduct?: {
        id?: string;
    } & Record<string, unknown>;
    configurator?: Booking_4353_.Configurator;
} & Record<string, unknown>) & ((Record<string, unknown> & Record<string, unknown> & {
    leg: Defined;
    terms: Defined;
    product: Defined;
    fares: Defined;
}) | (Record<string, unknown> & Record<string, unknown> & {
    leg: Defined;
    terms: Defined;
    product: Defined;
    configurator: Defined;
})), OptionBrand>;
export type OptionC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            fares: typeof Booking_4353_.Fares;
            cost: typeof Booking_4353_.Cost;
            leg: typeof Booking_4353_.Leg;
            meta: typeof BookingMeta_c057_.BookingMeta;
            terms: typeof Booking_4353_.Terms;
            tspProduct: t.IntersectionC<[
                t.PartialC<{
                    id: t.StringC;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>;
            configurator: typeof Booking_4353_.Configurator;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.UnionC<[
        t.IntersectionC<[
            t.UnknownRecordC,
            t.RecordC<t.StringC, t.UnknownC>,
            t.TypeC<{
                leg: typeof Defined;
                terms: typeof Defined;
                product: typeof Defined;
                fares: typeof Defined;
            }>
        ]>,
        t.IntersectionC<[
            t.UnknownRecordC,
            t.RecordC<t.StringC, t.UnknownC>,
            t.TypeC<{
                leg: typeof Defined;
                terms: typeof Defined;
                product: typeof Defined;
                configurator: typeof Defined;
            }>
        ]>
    ]>
]>, OptionBrand>;
export declare const Option: OptionC;
export type OptionBrand = {
    readonly Option: unique symbol;
};
export type Response = t.Branded<{
    options?: Array<Option>;
    additional?: {
        bikeStations?: Array<BikeStation_4888_.BikeStation>;
    } & Record<string, unknown>;
    debug?: Record<string, unknown>;
} & {
    options: Defined;
}, ResponseBrand>;
export type ResponseC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        options: t.ArrayC<typeof Option>;
        additional: t.IntersectionC<[
            t.PartialC<{
                bikeStations: t.ArrayC<typeof BikeStation_4888_.BikeStation>;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        debug: t.RecordC<t.StringC, t.UnknownC>;
    }>,
    t.TypeC<{
        options: typeof Defined;
    }>
]>, ResponseBrand>;
export declare const Response: ResponseC;
export type ResponseBrand = {
    readonly Response: unique symbol;
};
export default Response;
