import * as t from 'io-ts';
import * as Common_ffba_ from '../../../core/components/common';
import * as Fare_a3ab_ from '../../../core/components/fare';
import * as Units_c404_ from '../../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/bookings/bookings-agency-products/response.json";
export type Product = t.Branded<({
    id?: string;
    agencyId?: string;
    tspProductId?: string;
    name?: string;
    meta?: Record<string, unknown>;
    icon?: Units_c404_.Url;
    fares?: Array<Fare_a3ab_.Fare>;
    description?: string;
} & Record<string, unknown>) & {
    id: Defined;
    agencyId: Defined;
    tspProductId: Defined;
    name: Defined;
    description: Defined;
    icon: Defined;
    fares: Defined;
}, ProductBrand>;
export type ProductC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: t.StringC;
            agencyId: t.StringC;
            tspProductId: t.StringC;
            name: t.StringC;
            meta: t.RecordC<t.StringC, t.UnknownC>;
            icon: typeof Units_c404_.Url;
            fares: t.ArrayC<typeof Fare_a3ab_.Fare>;
            description: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
        agencyId: typeof Defined;
        tspProductId: typeof Defined;
        name: typeof Defined;
        description: typeof Defined;
        icon: typeof Defined;
        fares: typeof Defined;
    }>
]>, ProductBrand>;
export declare const Product: ProductC;
export type ProductBrand = {
    readonly Product: unique symbol;
};
export type Response = t.Branded<{
    agencyId?: Common_ffba_.AgencyId;
    products?: Array<Product>;
} & {
    agencyId: Defined;
    products: Defined;
}, ResponseBrand>;
export type ResponseC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        agencyId: typeof Common_ffba_.AgencyId;
        products: t.ArrayC<typeof Product>;
    }>,
    t.TypeC<{
        agencyId: typeof Defined;
        products: typeof Defined;
    }>
]>, ResponseBrand>;
export declare const Response: ResponseC;
export type ResponseBrand = {
    readonly Response: unique symbol;
};
export default Response;
