import * as t from 'io-ts';
import * as Address_2d0a_ from '../../../core/components/address';
import * as Station_dfde_ from '../../../core/components/station';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/payment-sources/paymentSource.json";
export type PaymentSourceId = t.Branded<string, PaymentSourceIdBrand>;
export type PaymentSourceIdC = t.BrandC<t.StringC, PaymentSourceIdBrand>;
export declare const PaymentSourceId: PaymentSourceIdC;
export type PaymentSourceIdBrand = {
    readonly PaymentSourceId: unique symbol;
};
export type GatewayName = t.Branded<string, GatewayNameBrand>;
export type GatewayNameC = t.BrandC<t.StringC, GatewayNameBrand>;
export declare const GatewayName: GatewayNameC;
export type GatewayNameBrand = {
    readonly GatewayName: unique symbol;
};
export type Type = t.Branded<string, TypeBrand>;
export type TypeC = t.BrandC<t.StringC, TypeBrand>;
export declare const Type: TypeC;
export type TypeBrand = {
    readonly Type: unique symbol;
};
export type Alias = t.Branded<string, AliasBrand>;
export type AliasC = t.BrandC<t.StringC, AliasBrand>;
export declare const Alias: AliasC;
export type AliasBrand = {
    readonly Alias: unique symbol;
};
export type Status = t.Branded<string, StatusBrand>;
export type StatusC = t.BrandC<t.StringC, StatusBrand>;
export declare const Status: StatusC;
export type StatusBrand = {
    readonly Status: unique symbol;
};
export type SetupIntentId = t.Branded<string, SetupIntentIdBrand>;
export type SetupIntentIdC = t.BrandC<t.StringC, SetupIntentIdBrand>;
export declare const SetupIntentId: SetupIntentIdC;
export type SetupIntentIdBrand = {
    readonly SetupIntentId: unique symbol;
};
export type PaymentSource = t.Branded<{
    paymentSourceId?: PaymentSourceId;
    gatewayName?: GatewayName;
    type?: Type;
    expiryYear?: number;
    expiryMonth?: number;
    cardNumbers?: string;
    issuer?: string;
    billingCountry?: Station_dfde_.Country;
    billingZip?: Address_2d0a_.ZipCode;
    isValid?: boolean;
    isDefault?: boolean;
    alias?: Alias;
    status?: Status;
    setupIntentId?: SetupIntentId;
} & {
    paymentSourceId: Defined;
    gatewayName: Defined;
    type: Defined;
    isDefault: Defined;
    status: Defined;
}, PaymentSourceBrand>;
export type PaymentSourceC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        paymentSourceId: typeof PaymentSourceId;
        gatewayName: typeof GatewayName;
        type: typeof Type;
        expiryYear: t.NumberC;
        expiryMonth: t.NumberC;
        cardNumbers: t.StringC;
        issuer: t.StringC;
        billingCountry: typeof Station_dfde_.Country;
        billingZip: typeof Address_2d0a_.ZipCode;
        isValid: t.BooleanC;
        isDefault: t.BooleanC;
        alias: typeof Alias;
        status: typeof Status;
        setupIntentId: typeof SetupIntentId;
    }>,
    t.TypeC<{
        paymentSourceId: typeof Defined;
        gatewayName: typeof Defined;
        type: typeof Defined;
        isDefault: typeof Defined;
        status: typeof Defined;
    }>
]>, PaymentSourceBrand>;
export declare const PaymentSource: PaymentSourceC;
export type PaymentSourceBrand = {
    readonly PaymentSource: unique symbol;
};
