import * as t from 'io-ts';
import * as ApiCommon_16a4_ from '../../../../core/components/api-common';
import * as Units_c404_ from '../../../../core/components/units';
import * as PaymentSource_6d83_ from '../paymentSource';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/payment-sources/update/request.json";
export type Request = t.Branded<{
    identityId?: Units_c404_.IdentityId;
    customerId?: Units_c404_.IdentityId;
    paymentSourceId?: PaymentSource_6d83_.PaymentSourceId;
    payload?: ({
        paymentSource?: {
            isDefault?: true;
            alias?: PaymentSource_6d83_.Alias;
        } & ({
            isDefault: Defined;
        } | {
            alias: Defined;
        });
    } & Record<string, unknown>) & {
        paymentSource: Defined;
    };
    headers?: ApiCommon_16a4_.Headers;
} & {
    identityId: Defined;
    customerId: Defined;
    paymentSourceId: Defined;
    payload: Defined;
    headers: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        identityId: typeof Units_c404_.IdentityId;
        customerId: typeof Units_c404_.IdentityId;
        paymentSourceId: typeof PaymentSource_6d83_.PaymentSourceId;
        payload: t.IntersectionC<[
            t.IntersectionC<[
                t.PartialC<{
                    paymentSource: t.IntersectionC<[
                        t.PartialC<{
                            isDefault: t.LiteralC<true>;
                            alias: typeof PaymentSource_6d83_.Alias;
                        }>,
                        t.UnionC<[
                            t.TypeC<{
                                isDefault: typeof Defined;
                            }>,
                            t.TypeC<{
                                alias: typeof Defined;
                            }>
                        ]>
                    ]>;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>,
            t.TypeC<{
                paymentSource: typeof Defined;
            }>
        ]>;
        headers: typeof ApiCommon_16a4_.Headers;
    }>,
    t.TypeC<{
        identityId: typeof Defined;
        customerId: typeof Defined;
        paymentSourceId: typeof Defined;
        payload: typeof Defined;
        headers: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
