import * as t from 'io-ts';
import * as Address_2d0a_ from '../../core/components/address';
import * as Common_ffba_ from '../../core/components/common';
import * as Units_c404_ from '../../core/components/units';
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/personalData.json";
export type Honorifics = t.Branded<string, HonorificsBrand>;
export type HonorificsC = t.BrandC<t.StringC, HonorificsBrand>;
export declare const Honorifics: HonorificsC;
export type HonorificsBrand = {
    readonly Honorifics: unique symbol;
};
export type FirstName = t.Branded<Common_ffba_.PersonalName, FirstNameBrand>;
export type FirstNameC = t.BrandC<typeof Common_ffba_.PersonalName, FirstNameBrand>;
export declare const FirstName: FirstNameC;
export type FirstNameBrand = {
    readonly FirstName: unique symbol;
};
export type LastName = t.Branded<Common_ffba_.PersonalName, LastNameBrand>;
export type LastNameC = t.BrandC<typeof Common_ffba_.PersonalName, LastNameBrand>;
export declare const LastName: LastNameC;
export type LastNameBrand = {
    readonly LastName: unique symbol;
};
export type FirstNameLocalized = t.Branded<Common_ffba_.PersonalName, FirstNameLocalizedBrand>;
export type FirstNameLocalizedC = t.BrandC<typeof Common_ffba_.PersonalName, FirstNameLocalizedBrand>;
export declare const FirstNameLocalized: FirstNameLocalizedC;
export type FirstNameLocalizedBrand = {
    readonly FirstNameLocalized: unique symbol;
};
export type LastNameLocalized = t.Branded<Common_ffba_.PersonalName, LastNameLocalizedBrand>;
export type LastNameLocalizedC = t.BrandC<typeof Common_ffba_.PersonalName, LastNameLocalizedBrand>;
export declare const LastNameLocalized: LastNameLocalizedC;
export type LastNameLocalizedBrand = {
    readonly LastNameLocalized: unique symbol;
};
export type Sex = t.Branded<string, SexBrand>;
export type SexC = t.BrandC<t.StringC, SexBrand>;
export declare const Sex: SexC;
export type SexBrand = {
    readonly Sex: unique symbol;
};
export type Phone = t.Branded<Common_ffba_.Phone, PhoneBrand>;
export type PhoneC = t.BrandC<typeof Common_ffba_.Phone, PhoneBrand>;
export declare const Phone: PhoneC;
export type PhoneBrand = {
    readonly Phone: unique symbol;
};
export type Email = t.Branded<Common_ffba_.Email, EmailBrand>;
export type EmailC = t.BrandC<typeof Common_ffba_.Email, EmailBrand>;
export declare const Email: EmailC;
export type EmailBrand = {
    readonly Email: unique symbol;
};
export type Address = t.Branded<Address_2d0a_.Address, AddressBrand>;
export type AddressC = t.BrandC<typeof Address_2d0a_.Address, AddressBrand>;
export declare const Address: AddressC;
export type AddressBrand = {
    readonly Address: unique symbol;
};
export type CugHome = t.Branded<string, CugHomeBrand>;
export type CugHomeC = t.BrandC<t.StringC, CugHomeBrand>;
export declare const CugHome: CugHomeC;
export type CugHomeBrand = {
    readonly CugHome: unique symbol;
};
export type City = t.Branded<Address_2d0a_.City, CityBrand>;
export type CityC = t.BrandC<typeof Address_2d0a_.City, CityBrand>;
export declare const City: CityC;
export type CityBrand = {
    readonly City: unique symbol;
};
export type State = t.Branded<Address_2d0a_.State, StateBrand>;
export type StateC = t.BrandC<typeof Address_2d0a_.State, StateBrand>;
export declare const State: StateC;
export type StateBrand = {
    readonly State: unique symbol;
};
export type Country = t.Branded<Address_2d0a_.Country, CountryBrand>;
export type CountryC = t.BrandC<typeof Address_2d0a_.Country, CountryBrand>;
export declare const Country: CountryC;
export type CountryBrand = {
    readonly Country: unique symbol;
};
export type ZipCode = t.Branded<Address_2d0a_.ZipCode, ZipCodeBrand>;
export type ZipCodeC = t.BrandC<typeof Address_2d0a_.ZipCode, ZipCodeBrand>;
export declare const ZipCode: ZipCodeC;
export type ZipCodeBrand = {
    readonly ZipCode: unique symbol;
};
export type Dob = t.Branded<boolean | Units_c404_.IsoDate, DobBrand>;
export type DobC = t.BrandC<t.UnionC<[t.BooleanC, typeof Units_c404_.IsoDate]>, DobBrand>;
export declare const Dob: DobC;
export type DobBrand = {
    readonly Dob: unique symbol;
};
export type Ssid = t.Branded<boolean | Common_ffba_.Ssid, SsidBrand>;
export type SsidC = t.BrandC<t.UnionC<[t.BooleanC, typeof Common_ffba_.Ssid]>, SsidBrand>;
export declare const Ssid: SsidC;
export type SsidBrand = {
    readonly Ssid: unique symbol;
};
export type SsidFi = t.Branded<boolean | Common_ffba_.SsidFI, SsidFiBrand>;
export type SsidFiC = t.BrandC<t.UnionC<[t.BooleanC, typeof Common_ffba_.SsidFI]>, SsidFiBrand>;
export declare const SsidFi: SsidFiC;
export type SsidFiBrand = {
    readonly SsidFi: unique symbol;
};
export type FiscalCodeIt = t.Branded<string, FiscalCodeItBrand>;
export type FiscalCodeItC = t.BrandC<t.StringC, FiscalCodeItBrand>;
export declare const FiscalCodeIt: FiscalCodeItC;
export type FiscalCodeItBrand = {
    readonly FiscalCodeIt: unique symbol;
};
export type ExtCreditIdIt = t.Branded<string, ExtCreditIdItBrand>;
export type ExtCreditIdItC = t.BrandC<t.StringC, ExtCreditIdItBrand>;
export declare const ExtCreditIdIt: ExtCreditIdItC;
export type ExtCreditIdItBrand = {
    readonly ExtCreditIdIt: unique symbol;
};
export type SubscriberType = t.Branded<string, SubscriberTypeBrand>;
export type SubscriberTypeC = t.BrandC<t.StringC, SubscriberTypeBrand>;
export declare const SubscriberType: SubscriberTypeC;
export type SubscriberTypeBrand = {
    readonly SubscriberType: unique symbol;
};
export type ProfileImageUrl = t.Branded<string, ProfileImageUrlBrand>;
export type ProfileImageUrlC = t.BrandC<t.StringC, ProfileImageUrlBrand>;
export declare const ProfileImageUrl: ProfileImageUrlC;
export type ProfileImageUrlBrand = {
    readonly ProfileImageUrl: unique symbol;
};
export type Nationality = t.Branded<string, NationalityBrand>;
export type NationalityC = t.BrandC<t.StringC, NationalityBrand>;
export declare const Nationality: NationalityC;
export type NationalityBrand = {
    readonly Nationality: unique symbol;
};
export type PersonalData = t.Branded<{
    honorifics?: Honorifics;
    firstName?: FirstName;
    lastName?: LastName;
    firstNameLocalized?: FirstNameLocalized;
    lastNameLocalized?: LastNameLocalized;
    sex?: Sex;
    phone?: Phone;
    email?: Email;
    address?: Address;
    cugHome?: CugHome;
    city?: City;
    state?: State;
    country?: Country;
    zipCode?: ZipCode;
    dob?: Dob;
    ssid?: Ssid;
    'ssid-fi'?: SsidFi;
    'fiscalCode-it'?: FiscalCodeIt;
    'extCreditId-it'?: ExtCreditIdIt;
    subscriberType?: SubscriberType;
    profileImageUrl?: ProfileImageUrl;
    nationality?: Nationality;
} & {}, PersonalDataBrand>;
export type PersonalDataC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        honorifics: typeof Honorifics;
        firstName: typeof FirstName;
        lastName: typeof LastName;
        firstNameLocalized: typeof FirstNameLocalized;
        lastNameLocalized: typeof LastNameLocalized;
        sex: typeof Sex;
        phone: typeof Phone;
        email: typeof Email;
        address: typeof Address;
        cugHome: typeof CugHome;
        city: typeof City;
        state: typeof State;
        country: typeof Country;
        zipCode: typeof ZipCode;
        dob: typeof Dob;
        ssid: typeof Ssid;
        'ssid-fi': typeof SsidFi;
        'fiscalCode-it': typeof FiscalCodeIt;
        'extCreditId-it': typeof ExtCreditIdIt;
        subscriberType: typeof SubscriberType;
        profileImageUrl: typeof ProfileImageUrl;
        nationality: typeof Nationality;
    }>,
    t.TypeC<{}>
]>, PersonalDataBrand>;
export declare const PersonalData: PersonalDataC;
export type PersonalDataBrand = {
    readonly PersonalData: unique symbol;
};
export default PersonalData;
