import * as t from 'io-ts';
import * as Address_2d0a_ from '../../../../../core/components/address';
import * as Common_ffba_ from '../../../../../core/components/common';
import * as Units_c404_ from '../../../../../core/components/units';
import * as PersonalDocument_9750_ from '../../../../../core/personal-document';
export type NullBrand = {
    readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export declare const Null: NullC;
export type Null = t.TypeOf<typeof Null>;
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/verification/webhooks/decision/request.json";
export type Request = t.Branded<{
    payload?: ({
        status?: string & ('fail' | 'success');
        verification?: ({
            id?: Units_c404_.Uuid;
            code?: number & (9001 | 9102 | 9103 | 9104 | 9121);
            person?: {
                firstName?: Common_ffba_.PersonalName | Null;
                lastName?: Common_ffba_.PersonalName | Null;
            } & Record<string, unknown>;
            document?: {
                number?: string | Null;
                type?: PersonalDocument_9750_.DocumentType;
                country?: Address_2d0a_.Country;
                validFrom?: Units_c404_.IsoDate | Null;
                validUntil?: Units_c404_.IsoDate | Null;
            } & Record<string, unknown>;
            reason?: string;
            reasonCode?: number | Null;
            status?: string;
            additionalVerifiedData?: Record<string, unknown> & Record<string, unknown>;
            vendorData?: string;
            decisionTime?: string;
            acceptanceTime?: string;
        } & Record<string, unknown>) & {
            id: Defined;
            status: Defined;
            code: Defined;
            person: Defined;
            document: Defined;
        };
    } & Record<string, unknown>) & {
        status: Defined;
        verification: Defined;
    };
    headers?: ({
        'x-signature'?: string;
        'x-auth-client'?: Units_c404_.Uuid;
    } & Record<string, unknown>) & {
        'x-signature': Defined;
        'x-auth-client': Defined;
    };
    technicalData?: {
        ip?: string;
    } & Record<string, unknown>;
    rawPayload?: string;
} & {
    headers: Defined;
    payload: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        payload: t.IntersectionC<[
            t.IntersectionC<[
                t.PartialC<{
                    status: t.IntersectionC<[
                        t.StringC,
                        t.UnionC<[t.LiteralC<'fail'>, t.LiteralC<'success'>]>
                    ]>;
                    verification: t.IntersectionC<[
                        t.IntersectionC<[
                            t.PartialC<{
                                id: typeof Units_c404_.Uuid;
                                code: t.IntersectionC<[
                                    t.NumberC,
                                    t.UnionC<[
                                        t.LiteralC<9001>,
                                        t.LiteralC<9102>,
                                        t.LiteralC<9103>,
                                        t.LiteralC<9104>,
                                        t.LiteralC<9121>
                                    ]>
                                ]>;
                                person: t.IntersectionC<[
                                    t.PartialC<{
                                        firstName: t.UnionC<[
                                            typeof Common_ffba_.PersonalName,
                                            typeof Null
                                        ]>;
                                        lastName: t.UnionC<[
                                            typeof Common_ffba_.PersonalName,
                                            typeof Null
                                        ]>;
                                    }>,
                                    t.RecordC<t.StringC, t.UnknownC>
                                ]>;
                                document: t.IntersectionC<[
                                    t.PartialC<{
                                        number: t.UnionC<[t.StringC, typeof Null]>;
                                        type: typeof PersonalDocument_9750_.DocumentType;
                                        country: typeof Address_2d0a_.Country;
                                        validFrom: t.UnionC<[
                                            typeof Units_c404_.IsoDate,
                                            typeof Null
                                        ]>;
                                        validUntil: t.UnionC<[
                                            typeof Units_c404_.IsoDate,
                                            typeof Null
                                        ]>;
                                    }>,
                                    t.RecordC<t.StringC, t.UnknownC>
                                ]>;
                                reason: t.StringC;
                                reasonCode: t.UnionC<[t.NumberC, typeof Null]>;
                                status: t.StringC;
                                additionalVerifiedData: t.IntersectionC<[
                                    t.UnknownRecordC,
                                    t.RecordC<t.StringC, t.UnknownC>
                                ]>;
                                vendorData: t.StringC;
                                decisionTime: t.StringC;
                                acceptanceTime: t.StringC;
                            }>,
                            t.RecordC<t.StringC, t.UnknownC>
                        ]>,
                        t.TypeC<{
                            id: typeof Defined;
                            status: typeof Defined;
                            code: typeof Defined;
                            person: typeof Defined;
                            document: typeof Defined;
                        }>
                    ]>;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>,
            t.TypeC<{
                status: typeof Defined;
                verification: typeof Defined;
            }>
        ]>;
        headers: t.IntersectionC<[
            t.IntersectionC<[
                t.PartialC<{
                    'x-signature': t.StringC;
                    'x-auth-client': typeof Units_c404_.Uuid;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>,
            t.TypeC<{
                'x-signature': typeof Defined;
                'x-auth-client': typeof Defined;
            }>
        ]>;
        technicalData: t.IntersectionC<[
            t.PartialC<{
                ip: t.StringC;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        rawPayload: t.StringC;
    }>,
    t.TypeC<{
        headers: typeof Defined;
        payload: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
