import * as t from 'io-ts';
import * as Units_c404_ from '../../../../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/verification/webhooks/event/request.json";
export type Request = t.Branded<{
    payload?: {
        id?: Units_c404_.Uuid;
        attemptId?: Units_c404_.Uuid;
        feature?: string;
        code?: number & (7001 | 7002);
        action?: string & ('started' | 'submitted');
    } & {
        id: Defined;
        attemptId: Defined;
        feature: Defined;
        code: Defined;
        action: Defined;
    };
    headers?: ({
        'x-signature'?: string;
        'x-auth-client'?: Units_c404_.Uuid;
    } & Record<string, unknown>) & {
        'x-signature': Defined;
        'x-auth-client': Defined;
    };
    technicalData?: {
        ip?: string;
    } & Record<string, unknown>;
} & {
    headers: Defined;
    payload: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        payload: t.IntersectionC<[
            t.PartialC<{
                id: typeof Units_c404_.Uuid;
                attemptId: typeof Units_c404_.Uuid;
                feature: t.StringC;
                code: t.IntersectionC<[
                    t.NumberC,
                    t.UnionC<[t.LiteralC<7001>, t.LiteralC<7002>]>
                ]>;
                action: t.IntersectionC<[
                    t.StringC,
                    t.UnionC<[t.LiteralC<'started'>, t.LiteralC<'submitted'>]>
                ]>;
            }>,
            t.TypeC<{
                id: typeof Defined;
                attemptId: typeof Defined;
                feature: typeof Defined;
                code: typeof Defined;
                action: typeof Defined;
            }>
        ]>;
        headers: t.IntersectionC<[
            t.IntersectionC<[
                t.PartialC<{
                    'x-signature': t.StringC;
                    'x-auth-client': typeof Units_c404_.Uuid;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>,
            t.TypeC<{
                'x-signature': typeof Defined;
                'x-auth-client': typeof Defined;
            }>
        ]>;
        technicalData: t.IntersectionC<[
            t.PartialC<{
                ip: t.StringC;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
    }>,
    t.TypeC<{
        headers: typeof Defined;
        payload: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
