import * as t from 'io-ts';
import * as ApiCommon_16a4_ from '../../../core/components/api-common';
import * as Units_c404_ from '../../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/virtual-card-issue/request.json";
export type Request = t.Branded<{
    customerId?: Units_c404_.IdentityId;
    payload?: {
        providerName?: string;
        initialBalance?: {
            amount?: number;
            currency?: Units_c404_.Currency;
        } & {
            amount: Defined;
            currency: Defined;
        };
        rollbackOnFailure?: boolean;
    } & {
        providerName: Defined;
        rollbackOnFailure: Defined;
    };
    headers?: ApiCommon_16a4_.Headers;
} & {
    customerId: Defined;
    payload: Defined;
    headers: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        customerId: typeof Units_c404_.IdentityId;
        payload: t.IntersectionC<[
            t.PartialC<{
                providerName: t.StringC;
                initialBalance: t.IntersectionC<[
                    t.PartialC<{
                        amount: t.NumberC;
                        currency: typeof Units_c404_.Currency;
                    }>,
                    t.TypeC<{
                        amount: typeof Defined;
                        currency: typeof Defined;
                    }>
                ]>;
                rollbackOnFailure: t.BooleanC;
            }>,
            t.TypeC<{
                providerName: typeof Defined;
                rollbackOnFailure: typeof Defined;
            }>
        ]>;
        headers: typeof ApiCommon_16a4_.Headers;
    }>,
    t.TypeC<{
        customerId: typeof Defined;
        payload: typeof Defined;
        headers: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
