import * as t from 'io-ts';
import * as ApiCommon_16a4_ from '../../../../core/components/api-common';
import * as Units_c404_ from '../../../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/virtual-cards/add-token-reference/request.json";
export type Request = t.Branded<{
    identityId?: Units_c404_.IdentityId;
    customerId?: Units_c404_.IdentityId;
    virtualCardId?: number;
    payload?: {
        tokenReferenceId?: string;
        added?: Units_c404_.Time;
        deviceType?: string & ('SMARTPHONE' | 'WEARABLE');
        extendedData?: string;
    } & ({
        tokenReferenceId: Defined;
        deviceType: Defined;
    } | {
        extendedData: Defined;
        deviceType: Defined;
    });
    headers?: ApiCommon_16a4_.Headers;
} & {
    identityId: Defined;
    customerId: Defined;
    virtualCardId: Defined;
    payload: Defined;
    headers: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        identityId: typeof Units_c404_.IdentityId;
        customerId: typeof Units_c404_.IdentityId;
        virtualCardId: t.NumberC;
        payload: t.IntersectionC<[
            t.PartialC<{
                tokenReferenceId: t.StringC;
                added: typeof Units_c404_.Time;
                deviceType: t.IntersectionC<[
                    t.StringC,
                    t.UnionC<[t.LiteralC<'SMARTPHONE'>, t.LiteralC<'WEARABLE'>]>
                ]>;
                extendedData: t.StringC;
            }>,
            t.UnionC<[
                t.TypeC<{
                    tokenReferenceId: typeof Defined;
                    deviceType: typeof Defined;
                }>,
                t.TypeC<{
                    extendedData: typeof Defined;
                    deviceType: typeof Defined;
                }>
            ]>
        ]>;
        headers: typeof ApiCommon_16a4_.Headers;
    }>,
    t.TypeC<{
        identityId: typeof Defined;
        customerId: typeof Defined;
        virtualCardId: typeof Defined;
        payload: typeof Defined;
        headers: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
