import * as t from 'io-ts';
import * as ApiCommon_16a4_ from '../../../../core/components/api-common';
import * as Units_c404_ from '../../../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/virtual-cards/provision/request.json";
export type Request = t.Branded<{
    identityId?: Units_c404_.IdentityId;
    customerId?: Units_c404_.IdentityId;
    virtualCardId?: number;
    payload?: {
        certificate?: string;
        nonce?: string;
        nonceSignature?: string;
    } & Record<string, unknown>;
    headers?: ApiCommon_16a4_.Headers;
} & {
    identityId: Defined;
    customerId: Defined;
    virtualCardId: Defined;
    payload: Defined;
    headers: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        identityId: typeof Units_c404_.IdentityId;
        customerId: typeof Units_c404_.IdentityId;
        virtualCardId: t.NumberC;
        payload: t.IntersectionC<[
            t.PartialC<{
                certificate: t.StringC;
                nonce: t.StringC;
                nonceSignature: t.StringC;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        headers: typeof ApiCommon_16a4_.Headers;
    }>,
    t.TypeC<{
        identityId: typeof Defined;
        customerId: typeof Defined;
        virtualCardId: typeof Defined;
        payload: typeof Defined;
        headers: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
