import * as t from 'io-ts';
import * as VirtualCardTokenReference_4b72_ from './virtualCardTokenReference';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/virtual-cards/virtualCard.json";
export type VirtualCard = t.Branded<{
    id?: number;
    providerName?: string;
    providerCardId?: string;
    maskedCardNumber?: string;
    expiryMonth?: number;
    expiryYear?: number;
    status?: string & ('CARD_OK' | 'CARD_BLOCKED');
    tokenReferences?: Array<VirtualCardTokenReference_4b72_.VirtualCardTokenReference>;
} & {
    id: Defined;
    providerName: Defined;
    providerCardId: Defined;
}, VirtualCardBrand>;
export type VirtualCardC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: t.NumberC;
        providerName: t.StringC;
        providerCardId: t.StringC;
        maskedCardNumber: t.StringC;
        expiryMonth: t.NumberC;
        expiryYear: t.NumberC;
        status: t.IntersectionC<[
            t.StringC,
            t.UnionC<[t.LiteralC<'CARD_OK'>, t.LiteralC<'CARD_BLOCKED'>]>
        ]>;
        tokenReferences: t.ArrayC<typeof VirtualCardTokenReference_4b72_.VirtualCardTokenReference>;
    }>,
    t.TypeC<{
        id: typeof Defined;
        providerName: typeof Defined;
        providerCardId: typeof Defined;
    }>
]>, VirtualCardBrand>;
export declare const VirtualCard: VirtualCardC;
export type VirtualCardBrand = {
    readonly VirtualCard: unique symbol;
};
export default VirtualCard;
