import * as t from 'io-ts';
import * as Units_c404_ from '../../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/virtual-cards/virtualCardAccountPosting.json";
export type VirtualCardAccountPosting = t.Branded<{
    id?: Units_c404_.Uuid;
    virtualCardAccountId?: Units_c404_.Uuid;
    date?: Units_c404_.Time;
    direction?: string & ('CREDIT' | 'DEBIT');
    amount?: number;
    currency?: Units_c404_.Currency;
    metadata?: Record<string, unknown> & Record<string, unknown>;
    location?: Record<string, unknown> & Record<string, unknown>;
    providerPostingId?: string;
    created?: Units_c404_.Time;
} & {
    id: Defined;
    virtualCardAccountId: Defined;
    date: Defined;
    amount: Defined;
    currency: Defined;
}, VirtualCardAccountPostingBrand>;
export type VirtualCardAccountPostingC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof Units_c404_.Uuid;
        virtualCardAccountId: typeof Units_c404_.Uuid;
        date: typeof Units_c404_.Time;
        direction: t.IntersectionC<[
            t.StringC,
            t.UnionC<[t.LiteralC<'CREDIT'>, t.LiteralC<'DEBIT'>]>
        ]>;
        amount: t.NumberC;
        currency: typeof Units_c404_.Currency;
        metadata: t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>;
        location: t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>;
        providerPostingId: t.StringC;
        created: typeof Units_c404_.Time;
    }>,
    t.TypeC<{
        id: typeof Defined;
        virtualCardAccountId: typeof Defined;
        date: typeof Defined;
        amount: typeof Defined;
        currency: typeof Defined;
    }>
]>, VirtualCardAccountPostingBrand>;
export declare const VirtualCardAccountPosting: VirtualCardAccountPostingC;
export type VirtualCardAccountPostingBrand = {
    readonly VirtualCardAccountPosting: unique symbol;
};
export default VirtualCardAccountPosting;
