import * as t from 'io-ts';
import * as Common_ffba_ from '../../../core/components/common';
import * as Units_c404_ from '../../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/customers/virtual-cards/virtualCardTokenReference.json";
export type VirtualCardTokenReference = t.Branded<{
    id?: number;
    tokenReferenceId?: string;
    userDevicesId?: number;
    appInstanceId?: Common_ffba_.AppInstanceId;
    walletPlatform?: string & ('APPLE' | 'GOOGLE');
    added?: Units_c404_.Time;
    deviceType?: string & ('SMARTPHONE' | 'WEARABLE');
    hasExtendedData?: boolean;
    extendedData?: string;
} & ({
    id: Defined;
    userDevicesId: Defined;
    appInstanceId: Defined;
    walletPlatform: Defined;
    added: Defined;
    deviceType: Defined;
    hasExtendedData: Defined;
    tokenReferenceId: Defined;
} | {
    id: Defined;
    userDevicesId: Defined;
    appInstanceId: Defined;
    walletPlatform: Defined;
    added: Defined;
    deviceType: Defined;
    hasExtendedData: Defined;
    extendedData: Defined;
}), VirtualCardTokenReferenceBrand>;
export type VirtualCardTokenReferenceC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: t.NumberC;
        tokenReferenceId: t.StringC;
        userDevicesId: t.NumberC;
        appInstanceId: typeof Common_ffba_.AppInstanceId;
        walletPlatform: t.IntersectionC<[
            t.StringC,
            t.UnionC<[t.LiteralC<'APPLE'>, t.LiteralC<'GOOGLE'>]>
        ]>;
        added: typeof Units_c404_.Time;
        deviceType: t.IntersectionC<[
            t.StringC,
            t.UnionC<[t.LiteralC<'SMARTPHONE'>, t.LiteralC<'WEARABLE'>]>
        ]>;
        hasExtendedData: t.BooleanC;
        extendedData: t.StringC;
    }>,
    t.UnionC<[
        t.TypeC<{
            id: typeof Defined;
            userDevicesId: typeof Defined;
            appInstanceId: typeof Defined;
            walletPlatform: typeof Defined;
            added: typeof Defined;
            deviceType: typeof Defined;
            hasExtendedData: typeof Defined;
            tokenReferenceId: typeof Defined;
        }>,
        t.TypeC<{
            id: typeof Defined;
            userDevicesId: typeof Defined;
            appInstanceId: typeof Defined;
            walletPlatform: typeof Defined;
            added: typeof Defined;
            deviceType: typeof Defined;
            hasExtendedData: typeof Defined;
            extendedData: typeof Defined;
        }>
    ]>
]>, VirtualCardTokenReferenceBrand>;
export declare const VirtualCardTokenReference: VirtualCardTokenReferenceC;
export type VirtualCardTokenReferenceBrand = {
    readonly VirtualCardTokenReference: unique symbol;
};
export default VirtualCardTokenReference;
