import * as t from 'io-ts';
import * as Fare_a3ab_ from '../../core/components/fare';
import * as Units_c404_ from '../../core/components/units';
import * as InvoiceUnits_a39a_ from './invoiceUnits';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/invoices/invoiceLineItem.json";
export type InvoiceLineItem = t.Branded<{
    id?: InvoiceUnits_a39a_.InvoiceLineItemId;
    gatewayId?: string;
    invoiceId?: InvoiceUnits_a39a_.InvoiceId;
    type?: string & ('authorization' | 'capture' | 'charge' | 'refund');
    paymentSourceId?: string;
    date?: Units_c404_.Time;
    description?: string;
    amount?: number;
    currency?: Units_c404_.Currency;
    referenceInvoiceLineItemId?: InvoiceUnits_a39a_.InvoiceLineItemId;
    tokenId?: Fare_a3ab_.TokenId;
    token?: Record<string, unknown> & Record<string, unknown>;
} & {
    id: Defined;
    gatewayId: Defined;
    description: Defined;
    amount: Defined;
    currency: Defined;
    type: Defined;
}, InvoiceLineItemBrand>;
export type InvoiceLineItemC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof InvoiceUnits_a39a_.InvoiceLineItemId;
        gatewayId: t.StringC;
        invoiceId: typeof InvoiceUnits_a39a_.InvoiceId;
        type: t.IntersectionC<[
            t.StringC,
            t.UnionC<[
                t.LiteralC<'authorization'>,
                t.LiteralC<'capture'>,
                t.LiteralC<'charge'>,
                t.LiteralC<'refund'>
            ]>
        ]>;
        paymentSourceId: t.StringC;
        date: typeof Units_c404_.Time;
        description: t.StringC;
        amount: t.NumberC;
        currency: typeof Units_c404_.Currency;
        referenceInvoiceLineItemId: typeof InvoiceUnits_a39a_.InvoiceLineItemId;
        tokenId: typeof Fare_a3ab_.TokenId;
        token: t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>;
    }>,
    t.TypeC<{
        id: typeof Defined;
        gatewayId: typeof Defined;
        description: typeof Defined;
        amount: typeof Defined;
        currency: typeof Defined;
        type: typeof Defined;
    }>
]>, InvoiceLineItemBrand>;
export declare const InvoiceLineItem: InvoiceLineItemC;
export type InvoiceLineItemBrand = {
    readonly InvoiceLineItem: unique symbol;
};
