import * as t from 'io-ts';
import * as ApiCommon_16a4_ from '../../../core/components/api-common';
import * as Common_ffba_ from '../../../core/components/common';
import * as CustomerSelection_57c3_ from '../../../core/components/customerSelection';
import * as Message_554d_ from '../../../core/components/message';
import * as ItineraryV2_5f31_ from '../../../core/itineraryV2';
import * as ProductOptionV2_8170_ from '../../../core/product-optionV2';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/itineraries/itinerary-create/request-v2.json";
export type OutwardReturnWrapper = t.Branded<({
    itinerary?: ItineraryV2_5f31_.ItineraryV2;
    customerSelections?: Array<{
        ref?: ProductOptionV2_8170_.Ref;
        customerSelection?: CustomerSelection_57c3_.CustomerSelection;
    } & Record<string, unknown>>;
} & Record<string, unknown>) & {
    itinerary: Defined;
}, OutwardReturnWrapperBrand>;
export type OutwardReturnWrapperC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            itinerary: typeof ItineraryV2_5f31_.ItineraryV2;
            customerSelections: t.ArrayC<t.IntersectionC<[
                t.PartialC<{
                    ref: typeof ProductOptionV2_8170_.Ref;
                    customerSelection: typeof CustomerSelection_57c3_.CustomerSelection;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        itinerary: typeof Defined;
    }>
]>, OutwardReturnWrapperBrand>;
export declare const OutwardReturnWrapper: OutwardReturnWrapperC;
export type OutwardReturnWrapperBrand = {
    readonly OutwardReturnWrapper: unique symbol;
};
export type Body = t.Branded<{
    paymentSourceId?: Common_ffba_.PaymentSourceId;
    outward?: OutwardReturnWrapper;
    return?: OutwardReturnWrapper;
    message?: Message_554d_.Message;
} & {
    outward: Defined;
    paymentSourceId: Defined;
}, BodyBrand>;
export type BodyC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        paymentSourceId: typeof Common_ffba_.PaymentSourceId;
        outward: typeof OutwardReturnWrapper;
        return: typeof OutwardReturnWrapper;
        message: typeof Message_554d_.Message;
    }>,
    t.TypeC<{
        outward: typeof Defined;
        paymentSourceId: typeof Defined;
    }>
]>, BodyBrand>;
export declare const Body: BodyC;
export type BodyBrand = {
    readonly Body: unique symbol;
};
export type RequestV2 = t.Branded<{
    headers?: ApiCommon_16a4_.StandardApiEndpointHeaders;
    requestContext?: ApiCommon_16a4_.ApiGatewayAuthorizedRequestContext;
    body?: Body;
} & {
    headers: Defined;
    requestContext: Defined;
    body: Defined;
}, RequestV2Brand>;
export type RequestV2C = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        headers: typeof ApiCommon_16a4_.StandardApiEndpointHeaders;
        requestContext: typeof ApiCommon_16a4_.ApiGatewayAuthorizedRequestContext;
        body: typeof Body;
    }>,
    t.TypeC<{
        headers: typeof Defined;
        requestContext: typeof Defined;
        body: typeof Defined;
    }>
]>, RequestV2Brand>;
export declare const RequestV2: RequestV2C;
export type RequestV2Brand = {
    readonly RequestV2: unique symbol;
};
export default RequestV2;
