import * as t from 'io-ts';
import * as PaymentParameters_ea40_ from '../../../core/components/payment-parameters';
import * as Itinerary_8303_ from '../../../core/itinerary';
import * as ItineraryV2_5f31_ from '../../../core/itineraryV2';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/itineraries/itinerary-create/response.json";
export type PaymentParameter = t.Branded<{
    avainpay?: PaymentParameters_ea40_.AvainpayPaymentParameters;
    stripe?: PaymentParameters_ea40_.StripePaymentParameters;
} & Record<string, unknown>, PaymentParameterBrand>;
export type PaymentParameterC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        avainpay: typeof PaymentParameters_ea40_.AvainpayPaymentParameters;
        stripe: typeof PaymentParameters_ea40_.StripePaymentParameters;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, PaymentParameterBrand>;
export declare const PaymentParameter: PaymentParameterC;
export type PaymentParameterBrand = {
    readonly PaymentParameter: unique symbol;
};
export type PaymentParameters = t.Branded<PaymentParameter | Array<PaymentParameter>, PaymentParametersBrand>;
export type PaymentParametersC = t.BrandC<t.UnionC<[typeof PaymentParameter, t.ArrayC<typeof PaymentParameter>]>, PaymentParametersBrand>;
export declare const PaymentParameters: PaymentParametersC;
export type PaymentParametersBrand = {
    readonly PaymentParameters: unique symbol;
};
export type Response = t.Branded<(({
    itinerary?: Itinerary_8303_.Itinerary;
    paymentParameters?: PaymentParameters;
} & Record<string, unknown>) & {
    itinerary: Defined;
}) | (({
    outward?: Itinerary_8303_.Itinerary;
    return?: Itinerary_8303_.Itinerary;
    paymentParameters?: PaymentParameters;
} & Record<string, unknown>) & {
    outward: Defined;
}) | (({
    itinerary?: ItineraryV2_5f31_.ItineraryV2;
    paymentParameters?: PaymentParameters;
} & Record<string, unknown>) & {
    itinerary: Defined;
}) | (({
    outward?: ItineraryV2_5f31_.ItineraryV2;
    return?: ItineraryV2_5f31_.ItineraryV2;
    paymentParameters?: PaymentParameters;
} & Record<string, unknown>) & {
    outward: Defined;
}), ResponseBrand>;
export type ResponseC = t.BrandC<t.UnionC<[
    t.IntersectionC<[
        t.IntersectionC<[
            t.PartialC<{
                itinerary: typeof Itinerary_8303_.Itinerary;
                paymentParameters: typeof PaymentParameters;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.TypeC<{
            itinerary: typeof Defined;
        }>
    ]>,
    t.IntersectionC<[
        t.IntersectionC<[
            t.PartialC<{
                outward: typeof Itinerary_8303_.Itinerary;
                return: typeof Itinerary_8303_.Itinerary;
                paymentParameters: typeof PaymentParameters;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.TypeC<{
            outward: typeof Defined;
        }>
    ]>,
    t.IntersectionC<[
        t.IntersectionC<[
            t.PartialC<{
                itinerary: typeof ItineraryV2_5f31_.ItineraryV2;
                paymentParameters: typeof PaymentParameters;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.TypeC<{
            itinerary: typeof Defined;
        }>
    ]>,
    t.IntersectionC<[
        t.IntersectionC<[
            t.PartialC<{
                outward: typeof ItineraryV2_5f31_.ItineraryV2;
                return: typeof ItineraryV2_5f31_.ItineraryV2;
                paymentParameters: typeof PaymentParameters;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>,
        t.TypeC<{
            outward: typeof Defined;
        }>
    ]>
]>, ResponseBrand>;
export declare const Response: ResponseC;
export type ResponseBrand = {
    readonly Response: unique symbol;
};
export default Response;
