import * as t from 'io-ts';
import * as ApiCommon_16a4_ from '../../../core/components/api-common';
import * as Common_ffba_ from '../../../core/components/common';
import * as CustomerSelection_57c3_ from '../../../core/components/customerSelection';
import * as Units_c404_ from '../../../core/components/units';
import * as Itinerary_8303_ from '../../../core/itinerary';
import * as ProductOption_5313_ from '../../../core/product-option';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/itineraries/itinerary-update/request.json";
export type Request = t.Branded<{
    identityId?: Units_c404_.IdentityId;
    itineraryId?: Itinerary_8303_.Id;
    headers?: ApiCommon_16a4_.Headers;
    payload?: {
        paymentSourceId?: Common_ffba_.PaymentSourceId;
        itinerary?: Itinerary_8303_.Itinerary;
        customerSelections?: Array<{
            ref?: ProductOption_5313_.Ref;
            customerSelection?: CustomerSelection_57c3_.CustomerSelection;
        } & Record<string, unknown>>;
    } & {
        itinerary: Defined;
        customerSelections: Defined;
    };
}, RequestBrand>;
export type RequestC = t.BrandC<t.PartialC<{
    identityId: typeof Units_c404_.IdentityId;
    itineraryId: typeof Itinerary_8303_.Id;
    headers: typeof ApiCommon_16a4_.Headers;
    payload: t.IntersectionC<[
        t.PartialC<{
            paymentSourceId: typeof Common_ffba_.PaymentSourceId;
            itinerary: typeof Itinerary_8303_.Itinerary;
            customerSelections: t.ArrayC<t.IntersectionC<[
                t.PartialC<{
                    ref: typeof ProductOption_5313_.Ref;
                    customerSelection: typeof CustomerSelection_57c3_.CustomerSelection;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>>;
        }>,
        t.TypeC<{
            itinerary: typeof Defined;
            customerSelections: typeof Defined;
        }>
    ]>;
}>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
