import * as t from 'io-ts';
import * as ApiCommon_16a4_ from '../../../core/components/api-common';
import * as UnitsGeo_3e31_ from '../../../core/components/units-geo';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/products/products-providers-list/request.json";
export type Payload = t.Branded<{
    lat?: UnitsGeo_3e31_.RelaxedLatitude;
    lon?: UnitsGeo_3e31_.RelaxedLongitude;
    region?: string & ('AT' | 'BE' | 'CH' | 'DE' | 'FI' | 'GB' | 'JP' | 'LU' | 'NL' | 'SG');
}, PayloadBrand>;
export type PayloadC = t.BrandC<t.PartialC<{
    lat: typeof UnitsGeo_3e31_.RelaxedLatitude;
    lon: typeof UnitsGeo_3e31_.RelaxedLongitude;
    region: t.IntersectionC<[
        t.StringC,
        t.UnionC<[
            t.LiteralC<'AT'>,
            t.LiteralC<'BE'>,
            t.LiteralC<'CH'>,
            t.LiteralC<'DE'>,
            t.LiteralC<'FI'>,
            t.LiteralC<'GB'>,
            t.LiteralC<'JP'>,
            t.LiteralC<'LU'>,
            t.LiteralC<'NL'>,
            t.LiteralC<'SG'>
        ]>
    ]>;
}>, PayloadBrand>;
export declare const Payload: PayloadC;
export type PayloadBrand = {
    readonly Payload: unique symbol;
};
export type Request = t.Branded<{
    payload?: Payload;
    headers?: ApiCommon_16a4_.Headers;
} & {
    payload: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        payload: typeof Payload;
        headers: typeof ApiCommon_16a4_.Headers;
    }>,
    t.TypeC<{
        payload: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
