import * as t from 'io-ts';
import * as ApiCommon_16a4_ from '../../../core/components/api-common';
import * as Units_c404_ from '../../../core/components/units';
import * as UnitsGeo_3e31_ from '../../../core/components/units-geo';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/products/products-providers-options/request.json";
export type Payload = t.Branded<({
    lat?: UnitsGeo_3e31_.RelaxedLatitude;
    lon?: UnitsGeo_3e31_.RelaxedLongitude;
} & Record<string, unknown>) & {
    lat: Defined;
    lon: Defined;
}, PayloadBrand>;
export type PayloadC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            lat: typeof UnitsGeo_3e31_.RelaxedLatitude;
            lon: typeof UnitsGeo_3e31_.RelaxedLongitude;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        lat: typeof Defined;
        lon: typeof Defined;
    }>
]>, PayloadBrand>;
export declare const Payload: PayloadC;
export type PayloadBrand = {
    readonly Payload: unique symbol;
};
export type Request = t.Branded<{
    identityId?: Units_c404_.IdentityId;
    payload?: Payload;
    headers?: ApiCommon_16a4_.Headers;
} & {
    identityId: Defined;
    payload: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        identityId: typeof Units_c404_.IdentityId;
        payload: typeof Payload;
        headers: typeof ApiCommon_16a4_.Headers;
    }>,
    t.TypeC<{
        identityId: typeof Defined;
        payload: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
