import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Common_ffba_ from '../../core/components/common';
import * as Fare_a3ab_ from '../../core/components/fare';
import * as PersonalDataAllowItem_b3f0_ from '../../core/components/personalDataAllowItem';
import * as PersonalDataValidation_1572_ from '../../core/components/personalDataValidation';
import * as PersonalDocumentRequiredItem_b279_ from '../../core/components/personalDocumentRequiredItem';
import * as Units_c404_ from '../../core/components/units';
export type NullBrand = {
    readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export declare const Null: NullC;
export type Null = t.TypeOf<typeof Null>;
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/products/provider.json";
export type ProviderFilterOption = t.Branded<({
    value?: string | Null;
    label?: string;
} & Record<string, unknown>) & {
    value: Defined;
    label: Defined;
}, ProviderFilterOptionBrand>;
export type ProviderFilterOptionC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            value: t.UnionC<[t.StringC, typeof Null]>;
            label: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        value: typeof Defined;
        label: typeof Defined;
    }>
]>, ProviderFilterOptionBrand>;
export declare const ProviderFilterOption: ProviderFilterOptionC;
export type ProviderFilterOptionBrand = {
    readonly ProviderFilterOption: unique symbol;
};
export type ProviderFilter = t.Branded<({
    name?: string;
    label?: string;
    default?: ProviderFilterOption | Null;
    selectionOptions?: Array<ProviderFilterOption>;
} & Record<string, unknown>) & {
    name: Defined;
    label: Defined;
}, ProviderFilterBrand>;
export type ProviderFilterC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            name: t.StringC;
            label: t.StringC;
            default: t.UnionC<[typeof ProviderFilterOption, typeof Null]>;
            selectionOptions: t.ArrayC<typeof ProviderFilterOption>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        name: typeof Defined;
        label: typeof Defined;
    }>
]>, ProviderFilterBrand>;
export declare const ProviderFilter: ProviderFilterC;
export type ProviderFilterBrand = {
    readonly ProviderFilter: unique symbol;
};
export type Selection = t.Branded<({
    id?: string;
    name?: string;
    type?: 'oneOf' | 'someOf' | 'allOf' | 'oneOrNoneOf' | 'someOrNoneOf';
    userSelectable?: boolean;
    inputs?: Array<{
        id?: string;
        name?: string;
        type?: 'string' | 'number' | 'boolean' | 'station';
        default?: string | number | boolean;
    } & {
        id: Defined;
        name: Defined;
        type: Defined;
    }>;
} & Record<string, unknown>) & {
    id: Defined;
    name: Defined;
    inputs: Defined;
}, SelectionBrand>;
export type SelectionC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: t.StringC;
            name: t.StringC;
            type: t.UnionC<[
                t.LiteralC<'oneOf'>,
                t.LiteralC<'someOf'>,
                t.LiteralC<'allOf'>,
                t.LiteralC<'oneOrNoneOf'>,
                t.LiteralC<'someOrNoneOf'>
            ]>;
            userSelectable: t.BooleanC;
            inputs: t.ArrayC<t.IntersectionC<[
                t.PartialC<{
                    id: t.StringC;
                    name: t.StringC;
                    type: t.UnionC<[
                        t.LiteralC<'string'>,
                        t.LiteralC<'number'>,
                        t.LiteralC<'boolean'>,
                        t.LiteralC<'station'>
                    ]>;
                    default: t.UnionC<[t.StringC, t.NumberC, t.BooleanC]>;
                }>,
                t.TypeC<{
                    id: typeof Defined;
                    name: typeof Defined;
                    type: typeof Defined;
                }>
            ]>>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
        name: typeof Defined;
        inputs: typeof Defined;
    }>
]>, SelectionBrand>;
export declare const Selection: SelectionC;
export type SelectionBrand = {
    readonly Selection: unique symbol;
};
export type MessageToDriver = t.Branded<({
    message?: ({
        property?: string;
        maxLength?: number;
    } & Record<string, unknown>) & {
        property: Defined;
        maxLength: Defined;
    };
} & Record<string, unknown>) & {
    message: Defined;
}, MessageToDriverBrand>;
export type MessageToDriverC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            message: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        property: t.StringC;
                        maxLength: t.NumberC;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    property: typeof Defined;
                    maxLength: typeof Defined;
                }>
            ]>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        message: typeof Defined;
    }>
]>, MessageToDriverBrand>;
export declare const MessageToDriver: MessageToDriverC;
export type MessageToDriverBrand = {
    readonly MessageToDriver: unique symbol;
};
export type BookingPeriod = t.Branded<({
    searchDefault?: number;
} & Record<string, unknown>) & {
    searchDefault: Defined;
}, BookingPeriodBrand>;
export type BookingPeriodC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            searchDefault: t.NumberC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        searchDefault: typeof Defined;
    }>
]>, BookingPeriodBrand>;
export declare const BookingPeriod: BookingPeriodC;
export type BookingPeriodBrand = {
    readonly BookingPeriod: unique symbol;
};
export type GradualRadiusOption = t.Branded<({
    gradualRadius?: number;
    maxRadius?: number;
} & Record<string, unknown>) & {
    gradualRadius: Defined;
    maxRadius: Defined;
}, GradualRadiusOptionBrand>;
export type GradualRadiusOptionC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            gradualRadius: t.NumberC;
            maxRadius: t.NumberC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        gradualRadius: typeof Defined;
        maxRadius: typeof Defined;
    }>
]>, GradualRadiusOptionBrand>;
export declare const GradualRadiusOption: GradualRadiusOptionC;
export type GradualRadiusOptionBrand = {
    readonly GradualRadiusOption: unique symbol;
};
export type Provider = t.Branded<{
    name?: string;
    agencyId?: Common_ffba_.AgencyId;
    groupId?: string;
    hidden?: boolean;
    branding?: {
        primaryColor?: string;
        secondaryColor?: string;
        icon?: Units_c404_.Url;
        logoSolidColor?: Units_c404_.Url;
        logoFullColor?: Units_c404_.Url;
    } & Record<string, unknown>;
    features?: {
        ticket?: boolean;
        stationsList?: boolean;
        stationsRetrieve?: boolean;
        packagesList?: boolean;
        options?: boolean;
        journeyPlanner?: boolean;
    } & {
        ticket: Defined;
        stationsList: Defined;
        stationsRetrieve: Defined;
    };
    extra?: {
        radius?: {
            fixedFareAmount?: number;
            fixedFareCurrency?: Units_c404_.Currency | Common_ffba_.MetaCurrency | Fare_a3ab_.TokenId;
            maxRadiusMetres?: number;
            description?: string;
        } & {
            fixedFareAmount: Defined;
            fixedFareCurrency: Defined;
            maxRadiusMetres: Defined;
        };
        prebooking?: ({
            isSupported?: boolean;
            minIntervalUntilBooking?: number;
            maxIntervalUntilBooking?: number;
        } & Record<string, unknown>) & {
            isSupported: Defined;
            minIntervalUntilBooking: Defined;
            maxIntervalUntilBooking: Defined;
        };
    };
    personalDataOptionsAllow?: Array<PersonalDataAllowItem_b3f0_.PersonalDataAllowItem>;
    personalDataCreateAllow?: Array<PersonalDataAllowItem_b3f0_.PersonalDataAllowItem>;
    personalDataValidations?: Array<PersonalDataValidation_1572_.PersonalDataValidation>;
    requiredPersonalDocuments?: Array<PersonalDocumentRequiredItem_b279_.PersonalDocumentRequiredItem>;
    optionalParameters?: Array<Selection | MessageToDriver | BookingPeriod | GradualRadiusOption>;
    disruption?: Record<string, unknown> & Record<string, unknown>;
    created?: Units_c404_.Time;
    filters?: Array<ProviderFilter>;
} & {
    name: Defined;
    agencyId: Defined;
    groupId: Defined;
    branding: Defined;
    hidden: Defined;
    features: Defined;
    personalDataOptionsAllow: Defined;
    personalDataCreateAllow: Defined;
    optionalParameters: Defined;
}, ProviderBrand>;
export type ProviderC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        name: t.StringC;
        agencyId: typeof Common_ffba_.AgencyId;
        groupId: t.StringC;
        hidden: t.BooleanC;
        branding: t.IntersectionC<[
            t.PartialC<{
                primaryColor: t.StringC;
                secondaryColor: t.StringC;
                icon: typeof Units_c404_.Url;
                logoSolidColor: typeof Units_c404_.Url;
                logoFullColor: typeof Units_c404_.Url;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>;
        features: t.IntersectionC<[
            t.PartialC<{
                ticket: t.BooleanC;
                stationsList: t.BooleanC;
                stationsRetrieve: t.BooleanC;
                packagesList: t.BooleanC;
                options: t.BooleanC;
                journeyPlanner: t.BooleanC;
            }>,
            t.TypeC<{
                ticket: typeof Defined;
                stationsList: typeof Defined;
                stationsRetrieve: typeof Defined;
            }>
        ]>;
        extra: t.PartialC<{
            radius: t.IntersectionC<[
                t.PartialC<{
                    fixedFareAmount: t.NumberC;
                    fixedFareCurrency: t.UnionC<[
                        typeof Units_c404_.Currency,
                        typeof Common_ffba_.MetaCurrency,
                        typeof Fare_a3ab_.TokenId
                    ]>;
                    maxRadiusMetres: t.NumberC;
                    description: t.StringC;
                }>,
                t.TypeC<{
                    fixedFareAmount: typeof Defined;
                    fixedFareCurrency: typeof Defined;
                    maxRadiusMetres: typeof Defined;
                }>
            ]>;
            prebooking: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        isSupported: t.BooleanC;
                        minIntervalUntilBooking: t.NumberC;
                        maxIntervalUntilBooking: t.NumberC;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    isSupported: typeof Defined;
                    minIntervalUntilBooking: typeof Defined;
                    maxIntervalUntilBooking: typeof Defined;
                }>
            ]>;
        }>;
        personalDataOptionsAllow: t.ArrayC<typeof PersonalDataAllowItem_b3f0_.PersonalDataAllowItem>;
        personalDataCreateAllow: t.ArrayC<typeof PersonalDataAllowItem_b3f0_.PersonalDataAllowItem>;
        personalDataValidations: t.ArrayC<typeof PersonalDataValidation_1572_.PersonalDataValidation>;
        requiredPersonalDocuments: t.ArrayC<typeof PersonalDocumentRequiredItem_b279_.PersonalDocumentRequiredItem>;
        optionalParameters: t.ArrayC<t.UnionC<[
            typeof Selection,
            typeof MessageToDriver,
            typeof BookingPeriod,
            typeof GradualRadiusOption
        ]>>;
        disruption: t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>;
        created: typeof Units_c404_.Time;
        filters: t.ArrayC<typeof ProviderFilter>;
    }>,
    t.TypeC<{
        name: typeof Defined;
        agencyId: typeof Defined;
        groupId: typeof Defined;
        branding: typeof Defined;
        hidden: typeof Defined;
        features: typeof Defined;
        personalDataOptionsAllow: typeof Defined;
        personalDataCreateAllow: typeof Defined;
        optionalParameters: typeof Defined;
    }>
]>, ProviderBrand>;
export declare const Provider: ProviderC;
export type ProviderBrand = {
    readonly Provider: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Provider)).decodeSync(examplesProvider) // => examplesProvider */
export declare const examplesProvider: NonEmptyArray<Provider>;
export default Provider;
