import * as t from 'io-ts';
import * as ApiCommon_16a4_ from '../../../core/components/api-common';
import * as Units_c404_ from '../../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/profile/profile-devices-put/request.json";
export type Request = t.Branded<{
    identityId?: Units_c404_.IdentityId;
    payload?: {
        devicePushToken?: string;
        deviceIdentifier?: Units_c404_.Uuid;
        deviceType?: string & ('iOS' | 'Android');
    } & {
        devicePushToken: Defined;
        deviceIdentifier: Defined;
        deviceType: Defined;
    };
    headers?: ApiCommon_16a4_.Headers;
}, RequestBrand>;
export type RequestC = t.BrandC<t.PartialC<{
    identityId: typeof Units_c404_.IdentityId;
    payload: t.IntersectionC<[
        t.PartialC<{
            devicePushToken: t.StringC;
            deviceIdentifier: typeof Units_c404_.Uuid;
            deviceType: t.IntersectionC<[
                t.StringC,
                t.UnionC<[t.LiteralC<'iOS'>, t.LiteralC<'Android'>]>
            ]>;
        }>,
        t.TypeC<{
            devicePushToken: typeof Defined;
            deviceIdentifier: typeof Defined;
            deviceType: typeof Defined;
        }>
    ]>;
    headers: typeof ApiCommon_16a4_.Headers;
}>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
