import * as t from 'io-ts';
import * as Units_c404_ from '../../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/profile/profile-devices-put/response.json";
export type Device = t.Branded<{
    devicePushToken?: string;
    deviceIdentifier?: Units_c404_.Uuid;
    deviceType?: string & ('iOS' | 'Android');
} & {
    devicePushToken: Defined;
    deviceIdentifier: Defined;
    deviceType: Defined;
}, DeviceBrand>;
export type DeviceC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        devicePushToken: t.StringC;
        deviceIdentifier: typeof Units_c404_.Uuid;
        deviceType: t.IntersectionC<[
            t.StringC,
            t.UnionC<[t.LiteralC<'iOS'>, t.LiteralC<'Android'>]>
        ]>;
    }>,
    t.TypeC<{
        devicePushToken: typeof Defined;
        deviceIdentifier: typeof Defined;
        deviceType: typeof Defined;
    }>
]>, DeviceBrand>;
export declare const Device: DeviceC;
export type DeviceBrand = {
    readonly Device: unique symbol;
};
export type Response = t.Branded<{
    device?: Device;
    debug?: Record<string, unknown> & Record<string, unknown>;
} & {
    device: Defined;
}, ResponseBrand>;
export type ResponseC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        device: typeof Device;
        debug: t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>;
    }>,
    t.TypeC<{
        device: typeof Defined;
    }>
]>, ResponseBrand>;
export declare const Response: ResponseC;
export type ResponseBrand = {
    readonly Response: unique symbol;
};
export default Response;
