import * as t from 'io-ts';
import * as Units_c404_ from '../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export type NullBrand = {
    readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export declare const Null: NullC;
export type Null = t.TypeOf<typeof Null>;
export declare const schemaId = "https://schemas.maas.global/maas-backend/push-notification/request.json";
export type Request = t.Branded<{
    identityId?: Units_c404_.IdentityId;
    title?: string;
    message?: string;
    badge?: number;
    sound?: string;
    severity?: 'Alert' | 'Warning' | 'Information';
    type?: 'ObjectChange' | 'TripActivate' | 'InfoMessage' | 'ZendeskReply' | 'VerificationUpdate' | 'AuthRequired';
    data?: (({
        objectType?: 'Itinerary' | 'Booking';
        ids?: Array<Units_c404_.Uuid>;
    } & Record<string, unknown>) & {
        objectType: Defined;
        ids: Defined;
    }) | Null | string | (({
        objectType?: 'Profile' | 'Subscription';
        ids?: Array<Units_c404_.IdentityId>;
    } & Record<string, unknown>) & {
        objectType: Defined;
        ids: Defined;
    }) | (({
        objectType?: 'Reminder';
        authUrl?: Units_c404_.Url;
    } & Record<string, unknown>) & {
        objectType: Defined;
        authUrl: Defined;
    });
} & {
    identityId: Defined;
    severity: Defined;
    badge: Defined;
    type: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        identityId: typeof Units_c404_.IdentityId;
        title: t.StringC;
        message: t.StringC;
        badge: t.NumberC;
        sound: t.StringC;
        severity: t.UnionC<[
            t.LiteralC<'Alert'>,
            t.LiteralC<'Warning'>,
            t.LiteralC<'Information'>
        ]>;
        type: t.UnionC<[
            t.LiteralC<'ObjectChange'>,
            t.LiteralC<'TripActivate'>,
            t.LiteralC<'InfoMessage'>,
            t.LiteralC<'ZendeskReply'>,
            t.LiteralC<'VerificationUpdate'>,
            t.LiteralC<'AuthRequired'>
        ]>;
        data: t.UnionC<[
            t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        objectType: t.UnionC<[
                            t.LiteralC<'Itinerary'>,
                            t.LiteralC<'Booking'>
                        ]>;
                        ids: t.ArrayC<typeof Units_c404_.Uuid>;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    objectType: typeof Defined;
                    ids: typeof Defined;
                }>
            ]>,
            typeof Null,
            t.StringC,
            t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        objectType: t.UnionC<[
                            t.LiteralC<'Profile'>,
                            t.LiteralC<'Subscription'>
                        ]>;
                        ids: t.ArrayC<typeof Units_c404_.IdentityId>;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    objectType: typeof Defined;
                    ids: typeof Defined;
                }>
            ]>,
            t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        objectType: t.LiteralC<'Reminder'>;
                        authUrl: typeof Units_c404_.Url;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    objectType: typeof Defined;
                    authUrl: typeof Defined;
                }>
            ]>
        ]>;
    }>,
    t.TypeC<{
        identityId: typeof Defined;
        severity: typeof Defined;
        badge: typeof Defined;
        type: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export default Request;
