import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Address_2d0a_ from '../../../core/components/address';
import * as ApiCommon_16a4_ from '../../../core/components/api-common';
import * as SpaceDemand_101a_ from '../../../core/components/spaceDemand';
import * as Station_dfde_ from '../../../core/components/station';
import * as Units_c404_ from '../../../core/components/units';
import * as UnitsGeo_3e31_ from '../../../core/components/units-geo';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/routes/routes-query-v4/request.json";
export type Params = t.Branded<{
    from?: UnitsGeo_3e31_.ShortLocationString;
    fromName?: Address_2d0a_.PlaceName;
    fromAddress?: Address_2d0a_.ComponentAddress;
    fromStationId?: Station_dfde_.Id;
    to?: UnitsGeo_3e31_.ShortLocationString;
    toName?: Address_2d0a_.PlaceName;
    toAddress?: Address_2d0a_.ComponentAddress;
    toStationId?: Station_dfde_.Id;
    leaveAt?: Units_c404_.Time;
    arriveBy?: Units_c404_.Time;
    modeId?: string;
    accessibilityFilter?: boolean;
    bookingIdToExtend?: Units_c404_.Uuid;
    spaceDemand?: SpaceDemand_101a_.SpaceDemandString;
    modes?: string;
} & {
    from: Defined;
    to: Defined;
}, ParamsBrand>;
export type ParamsC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        from: typeof UnitsGeo_3e31_.ShortLocationString;
        fromName: typeof Address_2d0a_.PlaceName;
        fromAddress: typeof Address_2d0a_.ComponentAddress;
        fromStationId: typeof Station_dfde_.Id;
        to: typeof UnitsGeo_3e31_.ShortLocationString;
        toName: typeof Address_2d0a_.PlaceName;
        toAddress: typeof Address_2d0a_.ComponentAddress;
        toStationId: typeof Station_dfde_.Id;
        leaveAt: typeof Units_c404_.Time;
        arriveBy: typeof Units_c404_.Time;
        modeId: t.StringC;
        accessibilityFilter: t.BooleanC;
        bookingIdToExtend: typeof Units_c404_.Uuid;
        spaceDemand: typeof SpaceDemand_101a_.SpaceDemandString;
        modes: t.StringC;
    }>,
    t.TypeC<{
        from: typeof Defined;
        to: typeof Defined;
    }>
]>, ParamsBrand>;
export declare const Params: ParamsC;
export type ParamsBrand = {
    readonly Params: unique symbol;
};
export type Request = t.Branded<({
    queryStringParameters?: Params;
    headers?: ApiCommon_16a4_.Headers;
    requestContext?: ApiCommon_16a4_.ApiGatewayAuthorizedRequestContext;
} & Record<string, unknown>) & {
    headers: Defined;
    queryStringParameters: Defined;
    requestContext: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            queryStringParameters: typeof Params;
            headers: typeof ApiCommon_16a4_.Headers;
            requestContext: typeof ApiCommon_16a4_.ApiGatewayAuthorizedRequestContext;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        headers: typeof Defined;
        queryStringParameters: typeof Defined;
        requestContext: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Request)).decodeSync(examplesRequest) // => examplesRequest */
export declare const examplesRequest: NonEmptyArray<Request>;
export default Request;
import "jest";
