import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Place_de2d_ from '../../../core/components/place';
import * as Error_b620_ from '../../../core/error';
import * as MultimodalPlan_758c_ from '../../../core/multimodal-plan';
import * as MultimodalRoutesMetadata_478d_ from '../../../core/multimodal-routes-metadata';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/routes/routes-query-v4/response.json";
export type RequestParams = t.Branded<{
    from?: Place_de2d_.Place;
    to?: Place_de2d_.Place;
    modeId?: string;
    accessibilityFilter?: boolean;
} & Record<string, unknown>, RequestParamsBrand>;
export type RequestParamsC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        from: typeof Place_de2d_.Place;
        to: typeof Place_de2d_.Place;
        modeId: t.StringC;
        accessibilityFilter: t.BooleanC;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, RequestParamsBrand>;
export declare const RequestParams: RequestParamsC;
export type RequestParamsBrand = {
    readonly RequestParams: unique symbol;
};
export type Response = t.Branded<{
    plan?: MultimodalPlan_758c_.MultimodalPlan;
    requestParams?: RequestParams;
    metadata?: MultimodalRoutesMetadata_478d_.MultimodalRoutesMetadata;
    reasons?: Array<Error_b620_.Reason>;
    debug?: Record<string, unknown> & Record<string, unknown>;
} & {
    plan: Defined;
    requestParams: Defined;
    metadata: Defined;
}, ResponseBrand>;
export type ResponseC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        plan: typeof MultimodalPlan_758c_.MultimodalPlan;
        requestParams: typeof RequestParams;
        metadata: typeof MultimodalRoutesMetadata_478d_.MultimodalRoutesMetadata;
        reasons: t.ArrayC<typeof Error_b620_.Reason>;
        debug: t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>;
    }>,
    t.TypeC<{
        plan: typeof Defined;
        requestParams: typeof Defined;
        metadata: typeof Defined;
    }>
]>, ResponseBrand>;
export declare const Response: ResponseC;
export type ResponseBrand = {
    readonly Response: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Response)).decodeSync(examplesResponse) // => examplesResponse */
export declare const examplesResponse: NonEmptyArray<Response>;
export default Response;
