import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Address_2d0a_ from '../../../core/components/address';
import * as ApiCommon_16a4_ from '../../../core/components/api-common';
import * as SpaceDemand_101a_ from '../../../core/components/spaceDemand';
import * as Station_dfde_ from '../../../core/components/station';
import * as Units_c404_ from '../../../core/components/units';
import * as UnitsGeo_3e31_ from '../../../core/components/units-geo';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/routes/routes-query/request.json";
export type Payload = t.Branded<({
    from?: UnitsGeo_3e31_.ShortLocationString;
    fromName?: Address_2d0a_.PlaceName;
    fromAddress?: Address_2d0a_.ComponentAddress;
    fromStationId?: Station_dfde_.Id;
    to?: UnitsGeo_3e31_.ShortLocationString;
    toName?: Address_2d0a_.PlaceName;
    toAddress?: Address_2d0a_.ComponentAddress;
    toStationId?: Station_dfde_.Id;
    leaveAt?: Units_c404_.Time;
    arriveBy?: Units_c404_.Time;
    leaveAtReturn?: Units_c404_.Time;
    arriveByReturn?: Units_c404_.Time;
    modes?: string & ('PUBLIC_TRANSIT' | 'TAXI' | 'CAR' | 'WALK' | 'BICYCLE' | 'BICYCLE_RENT' | 'SCOOTER');
    transitMode?: string & ('TRAIN' | 'BUS' | 'SUBWAY' | 'TRAM' | 'RAIL');
    options?: Record<string, unknown> & Record<string, unknown>;
    bookingIdToExtend?: Units_c404_.Uuid;
    spaceDemand?: SpaceDemand_101a_.SpaceDemandString;
} & Record<string, UnitsGeo_3e31_.ShortLocationString | Address_2d0a_.PlaceName | Address_2d0a_.ComponentAddress | Station_dfde_.Id | UnitsGeo_3e31_.ShortLocationString | Address_2d0a_.PlaceName | Address_2d0a_.ComponentAddress | Station_dfde_.Id | Units_c404_.Time | Units_c404_.Time | Units_c404_.Time | Units_c404_.Time | (string & ('PUBLIC_TRANSIT' | 'TAXI' | 'CAR' | 'WALK' | 'BICYCLE' | 'BICYCLE_RENT' | 'SCOOTER')) | (string & ('TRAIN' | 'BUS' | 'SUBWAY' | 'TRAM' | 'RAIL')) | (Record<string, unknown> & Record<string, unknown>) | Units_c404_.Uuid | SpaceDemand_101a_.SpaceDemandString | (string | number | boolean)>) & {
    from: Defined;
    to: Defined;
}, PayloadBrand>;
export type PayloadC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            from: typeof UnitsGeo_3e31_.ShortLocationString;
            fromName: typeof Address_2d0a_.PlaceName;
            fromAddress: typeof Address_2d0a_.ComponentAddress;
            fromStationId: typeof Station_dfde_.Id;
            to: typeof UnitsGeo_3e31_.ShortLocationString;
            toName: typeof Address_2d0a_.PlaceName;
            toAddress: typeof Address_2d0a_.ComponentAddress;
            toStationId: typeof Station_dfde_.Id;
            leaveAt: typeof Units_c404_.Time;
            arriveBy: typeof Units_c404_.Time;
            leaveAtReturn: typeof Units_c404_.Time;
            arriveByReturn: typeof Units_c404_.Time;
            modes: t.IntersectionC<[
                t.StringC,
                t.UnionC<[
                    t.LiteralC<'PUBLIC_TRANSIT'>,
                    t.LiteralC<'TAXI'>,
                    t.LiteralC<'CAR'>,
                    t.LiteralC<'WALK'>,
                    t.LiteralC<'BICYCLE'>,
                    t.LiteralC<'BICYCLE_RENT'>,
                    t.LiteralC<'SCOOTER'>
                ]>
            ]>;
            transitMode: t.IntersectionC<[
                t.StringC,
                t.UnionC<[
                    t.LiteralC<'TRAIN'>,
                    t.LiteralC<'BUS'>,
                    t.LiteralC<'SUBWAY'>,
                    t.LiteralC<'TRAM'>,
                    t.LiteralC<'RAIL'>
                ]>
            ]>;
            options: t.IntersectionC<[
                t.UnknownRecordC,
                t.RecordC<t.StringC, t.UnknownC>
            ]>;
            bookingIdToExtend: typeof Units_c404_.Uuid;
            spaceDemand: typeof SpaceDemand_101a_.SpaceDemandString;
        }>,
        t.RecordC<t.StringC, t.UnionC<[
            typeof UnitsGeo_3e31_.ShortLocationString,
            typeof Address_2d0a_.PlaceName,
            typeof Address_2d0a_.ComponentAddress,
            typeof Station_dfde_.Id,
            typeof UnitsGeo_3e31_.ShortLocationString,
            typeof Address_2d0a_.PlaceName,
            typeof Address_2d0a_.ComponentAddress,
            typeof Station_dfde_.Id,
            typeof Units_c404_.Time,
            typeof Units_c404_.Time,
            typeof Units_c404_.Time,
            typeof Units_c404_.Time,
            t.IntersectionC<[
                t.StringC,
                t.UnionC<[
                    t.LiteralC<'PUBLIC_TRANSIT'>,
                    t.LiteralC<'TAXI'>,
                    t.LiteralC<'CAR'>,
                    t.LiteralC<'WALK'>,
                    t.LiteralC<'BICYCLE'>,
                    t.LiteralC<'BICYCLE_RENT'>,
                    t.LiteralC<'SCOOTER'>
                ]>
            ]>,
            t.IntersectionC<[
                t.StringC,
                t.UnionC<[
                    t.LiteralC<'TRAIN'>,
                    t.LiteralC<'BUS'>,
                    t.LiteralC<'SUBWAY'>,
                    t.LiteralC<'TRAM'>,
                    t.LiteralC<'RAIL'>
                ]>
            ]>,
            t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>,
            typeof Units_c404_.Uuid,
            typeof SpaceDemand_101a_.SpaceDemandString,
            t.UnionC<[t.StringC, t.NumberC, t.BooleanC]>
        ]>>
    ]>,
    t.TypeC<{
        from: typeof Defined;
        to: typeof Defined;
    }>
]>, PayloadBrand>;
export declare const Payload: PayloadC;
export type PayloadBrand = {
    readonly Payload: unique symbol;
};
export type Request = t.Branded<({
    identityId?: Units_c404_.IdentityId;
    payload?: Payload;
    headers?: ApiCommon_16a4_.Headers;
} & Record<string, unknown>) & {
    identityId: Defined;
    payload: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            identityId: typeof Units_c404_.IdentityId;
            payload: typeof Payload;
            headers: typeof ApiCommon_16a4_.Headers;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        identityId: typeof Defined;
        payload: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Request)).decodeSync(examplesRequest) // => examplesRequest */
export declare const examplesRequest: NonEmptyArray<Request>;
export default Request;
import "jest";
