import * as t from 'io-ts';
import * as Address_2d0a_ from '../../core/components/address';
import * as Common_ffba_ from '../../core/components/common';
import * as Units_c404_ from '../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/subscriptions/contact.json";
export type IdentityId = t.Branded<Units_c404_.IdentityId, IdentityIdBrand>;
export type IdentityIdC = t.BrandC<typeof Units_c404_.IdentityId, IdentityIdBrand>;
export declare const IdentityId: IdentityIdC;
export type IdentityIdBrand = {
    readonly IdentityId: unique symbol;
};
export type ContactBase = t.Branded<{
    identityId?: IdentityId;
    firstName?: Common_ffba_.PersonalName;
    lastName?: Common_ffba_.PersonalName;
    address?: Address_2d0a_.Address;
    city?: Address_2d0a_.City;
    zipCode?: Address_2d0a_.ZipCode;
    country?: Address_2d0a_.Country;
    phone?: Common_ffba_.Phone;
    email?: Common_ffba_.Email;
} & Record<string, unknown>, ContactBaseBrand>;
export type ContactBaseC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        identityId: typeof IdentityId;
        firstName: typeof Common_ffba_.PersonalName;
        lastName: typeof Common_ffba_.PersonalName;
        address: typeof Address_2d0a_.Address;
        city: typeof Address_2d0a_.City;
        zipCode: typeof Address_2d0a_.ZipCode;
        country: typeof Address_2d0a_.Country;
        phone: typeof Common_ffba_.Phone;
        email: typeof Common_ffba_.Email;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, ContactBaseBrand>;
export declare const ContactBase: ContactBaseC;
export type ContactBaseBrand = {
    readonly ContactBase: unique symbol;
};
export type StripePaymentMethod = t.Branded<({
    type?: string & 'stripe';
    token?: string;
} & Record<string, unknown>) & {
    type: Defined;
    token: Defined;
}, StripePaymentMethodBrand>;
export type StripePaymentMethodC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            type: t.IntersectionC<[t.StringC, t.LiteralC<'stripe'>]>;
            token: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        type: typeof Defined;
        token: typeof Defined;
    }>
]>, StripePaymentMethodBrand>;
export declare const StripePaymentMethod: StripePaymentMethodC;
export type StripePaymentMethodBrand = {
    readonly StripePaymentMethod: unique symbol;
};
export type CreditCardPaymentMethod = t.Branded<({
    type?: string & 'card';
    number?: string;
    expiryMonth?: number;
    expiryYear?: number;
    cvv?: string;
} & Record<string, unknown>) & {
    type: Defined;
    number: Defined;
    expiryMonth: Defined;
    expiryYear: Defined;
    cvv: Defined;
}, CreditCardPaymentMethodBrand>;
export type CreditCardPaymentMethodC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            type: t.IntersectionC<[t.StringC, t.LiteralC<'card'>]>;
            number: t.StringC;
            expiryMonth: t.NumberC;
            expiryYear: t.NumberC;
            cvv: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        type: typeof Defined;
        number: typeof Defined;
        expiryMonth: typeof Defined;
        expiryYear: typeof Defined;
        cvv: typeof Defined;
    }>
]>, CreditCardPaymentMethodBrand>;
export declare const CreditCardPaymentMethod: CreditCardPaymentMethodC;
export type CreditCardPaymentMethodBrand = {
    readonly CreditCardPaymentMethod: unique symbol;
};
export type NewPaymentMethod = t.Branded<StripePaymentMethod | CreditCardPaymentMethod, NewPaymentMethodBrand>;
export type NewPaymentMethodC = t.BrandC<t.UnionC<[typeof StripePaymentMethod, typeof CreditCardPaymentMethod]>, NewPaymentMethodBrand>;
export declare const NewPaymentMethod: NewPaymentMethodC;
export type NewPaymentMethodBrand = {
    readonly NewPaymentMethod: unique symbol;
};
export type NewContact = t.Branded<{
    identityId: Defined;
    phone: Defined;
} & (ContactBase & ({
    paymentMethod?: NewPaymentMethod;
} & Record<string, unknown>)), NewContactBrand>;
export type NewContactC = t.BrandC<t.IntersectionC<[
    t.TypeC<{
        identityId: typeof Defined;
        phone: typeof Defined;
    }>,
    t.IntersectionC<[
        typeof ContactBase,
        t.IntersectionC<[
            t.PartialC<{
                paymentMethod: typeof NewPaymentMethod;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>
    ]>
]>, NewContactBrand>;
export declare const NewContact: NewContactC;
export type NewContactBrand = {
    readonly NewContact: unique symbol;
};
export type ContactUpdate = t.Branded<{
    identityId: Defined;
} & (ContactBase & ({
    paymentMethod?: NewPaymentMethod;
} & Record<string, unknown>)), ContactUpdateBrand>;
export type ContactUpdateC = t.BrandC<t.IntersectionC<[
    t.TypeC<{
        identityId: typeof Defined;
    }>,
    t.IntersectionC<[
        typeof ContactBase,
        t.IntersectionC<[
            t.PartialC<{
                paymentMethod: typeof NewPaymentMethod;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>
    ]>
]>, ContactUpdateBrand>;
export declare const ContactUpdate: ContactUpdateC;
export type ContactUpdateBrand = {
    readonly ContactUpdate: unique symbol;
};
export type PaymentMethodResponse = t.Branded<({
    type?: string;
    valid?: boolean;
} & Record<string, unknown>) & {
    type: Defined;
    valid: Defined;
}, PaymentMethodResponseBrand>;
export type PaymentMethodResponseC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            type: t.StringC;
            valid: t.BooleanC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        type: typeof Defined;
        valid: typeof Defined;
    }>
]>, PaymentMethodResponseBrand>;
export declare const PaymentMethodResponse: PaymentMethodResponseC;
export type PaymentMethodResponseBrand = {
    readonly PaymentMethodResponse: unique symbol;
};
export type ContactResponse = t.Branded<{
    identityId: Defined;
    phone: Defined;
} & (ContactBase & ({
    paymentMethod?: PaymentMethodResponse;
} & Record<string, unknown>)), ContactResponseBrand>;
export type ContactResponseC = t.BrandC<t.IntersectionC<[
    t.TypeC<{
        identityId: typeof Defined;
        phone: typeof Defined;
    }>,
    t.IntersectionC<[
        typeof ContactBase,
        t.IntersectionC<[
            t.PartialC<{
                paymentMethod: typeof PaymentMethodResponse;
            }>,
            t.RecordC<t.StringC, t.UnknownC>
        ]>
    ]>
]>, ContactResponseBrand>;
export declare const ContactResponse: ContactResponseC;
export type ContactResponseBrand = {
    readonly ContactResponse: unique symbol;
};
export type Contact = t.Branded<unknown, ContactBrand>;
export type ContactC = t.BrandC<t.UnknownC, ContactBrand>;
export declare const Contact: ContactC;
export type ContactBrand = {
    readonly Contact: unique symbol;
};
export default Contact;
