import * as t from 'io-ts';
import * as Cost_250f_ from '../../core/components/cost';
import * as Units_c404_ from '../../core/components/units';
import * as Subscription_b8eb_ from './subscription';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/subscriptions/pricing.json";
export type LineItem = t.Branded<{
    id?: Subscription_b8eb_.SubscriptionItemId;
    type?: string;
    description?: string;
    quantity?: number;
    unitPrice?: Cost_250f_.Cost;
} & {
    id: Defined;
    type: Defined;
    description: Defined;
    quantity: Defined;
    unitPrice: Defined;
}, LineItemBrand>;
export type LineItemC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof Subscription_b8eb_.SubscriptionItemId;
        type: t.StringC;
        description: t.StringC;
        quantity: t.NumberC;
        unitPrice: typeof Cost_250f_.Cost;
    }>,
    t.TypeC<{
        id: typeof Defined;
        type: typeof Defined;
        description: typeof Defined;
        quantity: typeof Defined;
        unitPrice: typeof Defined;
    }>
]>, LineItemBrand>;
export declare const LineItem: LineItemC;
export type LineItemBrand = {
    readonly LineItem: unique symbol;
};
export type Discount = t.Branded<{
    description?: string;
    discount?: Cost_250f_.Cost;
} & {
    description: Defined;
    discount: Defined;
}, DiscountBrand>;
export type DiscountC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        description: t.StringC;
        discount: typeof Cost_250f_.Cost;
    }>,
    t.TypeC<{
        description: typeof Defined;
        discount: typeof Defined;
    }>
]>, DiscountBrand>;
export declare const Discount: DiscountC;
export type DiscountBrand = {
    readonly Discount: unique symbol;
};
export type Terms = t.Branded<({
    validity?: ({
        startTime?: Units_c404_.Time;
        endTime?: Units_c404_.Time;
    } & Record<string, unknown>) & {
        startTime: Defined;
        endTime: Defined;
    };
} & Record<string, unknown>) & {
    validity: Defined;
}, TermsBrand>;
export type TermsC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            validity: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        startTime: typeof Units_c404_.Time;
                        endTime: typeof Units_c404_.Time;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    startTime: typeof Defined;
                    endTime: typeof Defined;
                }>
            ]>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        validity: typeof Defined;
    }>
]>, TermsBrand>;
export declare const Terms: TermsC;
export type TermsBrand = {
    readonly Terms: unique symbol;
};
export type Pricing = t.Branded<{
    lineItems?: Array<LineItem>;
    discounts?: Array<Discount>;
    total?: Cost_250f_.Cost;
    terms?: Terms;
} & {
    lineItems: Defined;
    total: Defined;
}, PricingBrand>;
export type PricingC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        lineItems: t.ArrayC<typeof LineItem>;
        discounts: t.ArrayC<typeof Discount>;
        total: typeof Cost_250f_.Cost;
        terms: typeof Terms;
    }>,
    t.TypeC<{
        lineItems: typeof Defined;
        total: typeof Defined;
    }>
]>, PricingBrand>;
export declare const Pricing: PricingC;
export type PricingBrand = {
    readonly Pricing: unique symbol;
};
export default Pricing;
