import * as t from 'io-ts';
import * as State_2db3_ from '../../core/components/state';
import * as StateLog_4daf_ from '../../core/components/state-log';
import * as Units_c404_ from '../../core/components/units';
import * as Subscription_b8eb_ from './subscription';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/subscriptions/subscription-intent.json";
export type PlanId = t.Branded<string, PlanIdBrand>;
export type PlanIdC = t.BrandC<t.StringC, PlanIdBrand>;
export declare const PlanId: PlanIdC;
export type PlanIdBrand = {
    readonly PlanId: unique symbol;
};
export type CouponId = t.Branded<string, CouponIdBrand>;
export type CouponIdC = t.BrandC<t.StringC, CouponIdBrand>;
export declare const CouponId: CouponIdC;
export type CouponIdBrand = {
    readonly CouponId: unique symbol;
};
export type SubscriptionIntentCreate = t.Branded<({
    planId?: PlanId;
    planAddons?: Array<Subscription_b8eb_.Addon>;
    planCoupons?: Array<CouponId>;
    state?: State_2db3_.SubscriptionIntentState;
} & Record<string, unknown>) & {
    planId: Defined;
    planAddons: Defined;
}, SubscriptionIntentCreateBrand>;
export type SubscriptionIntentCreateC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            planId: typeof PlanId;
            planAddons: t.ArrayC<typeof Subscription_b8eb_.Addon>;
            planCoupons: t.ArrayC<typeof CouponId>;
            state: typeof State_2db3_.SubscriptionIntentState;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        planId: typeof Defined;
        planAddons: typeof Defined;
    }>
]>, SubscriptionIntentCreateBrand>;
export declare const SubscriptionIntentCreate: SubscriptionIntentCreateC;
export type SubscriptionIntentCreateBrand = {
    readonly SubscriptionIntentCreate: unique symbol;
};
export type SubscriptionIntentBase = t.Branded<{
    id?: Units_c404_.Uuid;
    identityId?: Units_c404_.IdentityId;
    subscriptionId?: Units_c404_.IdentityId;
    nextPlanId?: PlanId;
    nextPlanAddons?: Array<Subscription_b8eb_.Addon>;
    nextPlanCoupons?: Array<CouponId>;
    prevPlanId?: PlanId;
    prevPlanAddons?: Array<Subscription_b8eb_.Addon>;
    state?: State_2db3_.SubscriptionIntentState;
    stateLog?: StateLog_4daf_.StateLog;
    created?: Units_c404_.Time;
    modified?: Units_c404_.Time;
} & {
    identityId: Defined;
    subscriptionId: Defined;
    nextPlanId: Defined;
    nextPlanAddons: Defined;
}, SubscriptionIntentBaseBrand>;
export type SubscriptionIntentBaseC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof Units_c404_.Uuid;
        identityId: typeof Units_c404_.IdentityId;
        subscriptionId: typeof Units_c404_.IdentityId;
        nextPlanId: typeof PlanId;
        nextPlanAddons: t.ArrayC<typeof Subscription_b8eb_.Addon>;
        nextPlanCoupons: t.ArrayC<typeof CouponId>;
        prevPlanId: typeof PlanId;
        prevPlanAddons: t.ArrayC<typeof Subscription_b8eb_.Addon>;
        state: typeof State_2db3_.SubscriptionIntentState;
        stateLog: typeof StateLog_4daf_.StateLog;
        created: typeof Units_c404_.Time;
        modified: typeof Units_c404_.Time;
    }>,
    t.TypeC<{
        identityId: typeof Defined;
        subscriptionId: typeof Defined;
        nextPlanId: typeof Defined;
        nextPlanAddons: typeof Defined;
    }>
]>, SubscriptionIntentBaseBrand>;
export declare const SubscriptionIntentBase: SubscriptionIntentBaseC;
export type SubscriptionIntentBaseBrand = {
    readonly SubscriptionIntentBase: unique symbol;
};
export type AddonId = t.Branded<string, AddonIdBrand>;
export type AddonIdC = t.BrandC<t.StringC, AddonIdBrand>;
export declare const AddonId: AddonIdC;
export type AddonIdBrand = {
    readonly AddonId: unique symbol;
};
export type SubscriptionIntent = t.Branded<unknown, SubscriptionIntentBrand>;
export type SubscriptionIntentC = t.BrandC<t.UnknownC, SubscriptionIntentBrand>;
export declare const SubscriptionIntent: SubscriptionIntentC;
export type SubscriptionIntentBrand = {
    readonly SubscriptionIntent: unique symbol;
};
export default SubscriptionIntent;
