import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Cost_250f_ from '../../core/components/cost';
import * as PointCost_5d0d_ from '../../core/components/point-cost';
import * as SubscriptionChangeState_e96c_ from '../../core/components/subscriptionChangeState';
import * as Units_c404_ from '../../core/components/units';
import * as Region_ad49_ from '../../core/region';
import * as Contact_56e9_ from './contact';
import * as SubscriptionAddress_8e26_ from './subscriptionAddress';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/subscriptions/subscription.json";
export type SubscriptionItemId = t.Branded<string, SubscriptionItemIdBrand>;
export type SubscriptionItemIdC = t.BrandC<t.StringC, SubscriptionItemIdBrand>;
export declare const SubscriptionItemId: SubscriptionItemIdC;
export type SubscriptionItemIdBrand = {
    readonly SubscriptionItemId: unique symbol;
};
export type Price = t.Branded<Cost_250f_.Cost, PriceBrand>;
export type PriceC = t.BrandC<typeof Cost_250f_.Cost, PriceBrand>;
export declare const Price: PriceC;
export type PriceBrand = {
    readonly Price: unique symbol;
};
export type Plan = t.Branded<({
    id?: SubscriptionItemId;
    name?: string;
    description?: string;
    price?: Price;
} & Record<string, unknown>) & {
    id: Defined;
}, PlanBrand>;
export type PlanC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: typeof SubscriptionItemId;
            name: t.StringC;
            description: t.StringC;
            price: typeof Price;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
    }>
]>, PlanBrand>;
export declare const Plan: PlanC;
export type PlanBrand = {
    readonly Plan: unique symbol;
};
export type Quantity = t.Branded<number, QuantityBrand>;
export type QuantityC = t.BrandC<t.NumberC, QuantityBrand>;
export declare const Quantity: QuantityC;
export type QuantityBrand = {
    readonly Quantity: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Quantity)).decodeSync(examplesQuantity) // => examplesQuantity */
export declare const examplesQuantity: NonEmptyArray<Quantity>;
/** require('io-ts-validator').validator(Quantity).decodeEither(200001)._tag // => 'Left' */
/** require('io-ts-validator').validator(Quantity).decodeSync(defaultQuantity) // => defaultQuantity */
export declare const defaultQuantity: Quantity;
/** require('io-ts-validator').validator(Quantity).decodeSync(minimumQuantity) // => minimumQuantity */
export declare const minimumQuantity: Quantity;
/** require('io-ts-validator').validator(Quantity).decodeSync(maximumQuantity) // => maximumQuantity */
export declare const maximumQuantity: Quantity;
export type Addon = t.Branded<({
    id?: SubscriptionItemId;
    name?: string;
    description?: string;
    quantity?: Quantity;
    unitPrice?: Price;
    image?: Units_c404_.Url;
    virtualCardIssue?: ({
        providerName?: string;
    } & Record<string, unknown>) & {
        providerName: Defined;
    };
    productProviderIds?: Array<string>;
} & Record<string, unknown>) & {
    id: Defined;
    quantity: Defined;
}, AddonBrand>;
export type AddonC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: typeof SubscriptionItemId;
            name: t.StringC;
            description: t.StringC;
            quantity: typeof Quantity;
            unitPrice: typeof Price;
            image: typeof Units_c404_.Url;
            virtualCardIssue: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        providerName: t.StringC;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    providerName: typeof Defined;
                }>
            ]>;
            productProviderIds: t.ArrayC<t.StringC>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
        quantity: typeof Defined;
    }>
]>, AddonBrand>;
export declare const Addon: AddonC;
export type AddonBrand = {
    readonly Addon: unique symbol;
};
export type Coupon = t.Branded<({
    id?: SubscriptionItemId;
    name?: string;
    description?: string;
} & Record<string, unknown>) & {
    id: Defined;
}, CouponBrand>;
export type CouponC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            id: typeof SubscriptionItemId;
            name: t.StringC;
            description: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        id: typeof Defined;
    }>
]>, CouponBrand>;
export declare const Coupon: CouponC;
export type CouponBrand = {
    readonly Coupon: unique symbol;
};
export type Benefit = t.Branded<({
    name?: string;
    cycles?: number;
    startTime?: Units_c404_.Time;
} & Record<string, unknown>) & {
    name: Defined;
}, BenefitBrand>;
export type BenefitC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            name: t.StringC;
            cycles: t.NumberC;
            startTime: typeof Units_c404_.Time;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        name: typeof Defined;
    }>
]>, BenefitBrand>;
export declare const Benefit: BenefitC;
export type BenefitBrand = {
    readonly Benefit: unique symbol;
};
export type Terms = t.Branded<({
    activated?: Units_c404_.Time;
    modified?: Units_c404_.Time;
    validity?: ({
        startTime?: Units_c404_.Time;
        endTime?: Units_c404_.Time;
    } & Record<string, unknown>) & {
        startTime: Defined;
        endTime: Defined;
    };
    scheduledChanges?: boolean;
} & Record<string, unknown>) & {
    validity: Defined;
}, TermsBrand>;
export type TermsC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            activated: typeof Units_c404_.Time;
            modified: typeof Units_c404_.Time;
            validity: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        startTime: typeof Units_c404_.Time;
                        endTime: typeof Units_c404_.Time;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    startTime: typeof Defined;
                    endTime: typeof Defined;
                }>
            ]>;
            scheduledChanges: t.BooleanC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        validity: typeof Defined;
    }>
]>, TermsBrand>;
export declare const Terms: TermsC;
export type TermsBrand = {
    readonly Terms: unique symbol;
};
export type SubscriptionBase = t.Branded<{
    id?: Contact_56e9_.IdentityId;
    customerId?: Contact_56e9_.IdentityId;
    plan?: Plan;
    addons?: Array<Addon>;
    coupons?: Array<Coupon>;
    benefits?: Array<Benefit>;
    terms?: Terms;
    pointCost?: PointCost_5d0d_.PointCost;
    region?: Region_ad49_.Region;
    shippingAddress?: SubscriptionAddress_8e26_.SubscriptionAddress;
    availability?: Record<string, unknown>;
    name?: string;
    description?: string;
    meta?: Record<string, unknown>;
    level?: number;
    wmpGrant?: number;
    creditGrant?: number;
    creditCurrency?: Units_c404_.Currency;
    active?: boolean;
    hidden?: boolean;
    selectable?: boolean;
    topUpId?: string;
    changeState?: SubscriptionChangeState_e96c_.SubscriptionChangeState;
    cycles?: number;
} & Record<string, unknown>, SubscriptionBaseBrand>;
export type SubscriptionBaseC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof Contact_56e9_.IdentityId;
        customerId: typeof Contact_56e9_.IdentityId;
        plan: typeof Plan;
        addons: t.ArrayC<typeof Addon>;
        coupons: t.ArrayC<typeof Coupon>;
        benefits: t.ArrayC<typeof Benefit>;
        terms: typeof Terms;
        pointCost: typeof PointCost_5d0d_.PointCost;
        region: typeof Region_ad49_.Region;
        shippingAddress: typeof SubscriptionAddress_8e26_.SubscriptionAddress;
        availability: t.RecordC<t.StringC, t.UnknownC>;
        name: t.StringC;
        description: t.StringC;
        meta: t.RecordC<t.StringC, t.UnknownC>;
        level: t.NumberC;
        wmpGrant: t.NumberC;
        creditGrant: t.NumberC;
        creditCurrency: typeof Units_c404_.Currency;
        active: t.BooleanC;
        hidden: t.BooleanC;
        selectable: t.BooleanC;
        topUpId: t.StringC;
        changeState: typeof SubscriptionChangeState_e96c_.SubscriptionChangeState;
        cycles: t.NumberC;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>, SubscriptionBaseBrand>;
export declare const SubscriptionBase: SubscriptionBaseC;
export type SubscriptionBaseBrand = {
    readonly SubscriptionBase: unique symbol;
};
export type Subscription = t.Branded<SubscriptionBase & (Record<string, unknown> & {
    plan: Defined;
    addons: Defined;
    coupons: Defined;
    changeState: Defined;
}), SubscriptionBrand>;
export type SubscriptionC = t.BrandC<t.IntersectionC<[
    typeof SubscriptionBase,
    t.IntersectionC<[
        t.RecordC<t.StringC, t.UnknownC>,
        t.TypeC<{
            plan: typeof Defined;
            addons: typeof Defined;
            coupons: typeof Defined;
            changeState: typeof Defined;
        }>
    ]>
]>, SubscriptionBrand>;
export declare const Subscription: SubscriptionC;
export type SubscriptionBrand = {
    readonly Subscription: unique symbol;
};
export type SubscriptionCreatePayload = t.Branded<SubscriptionBase & (Record<string, unknown> & {
    plan: Defined;
    addons: Defined;
}), SubscriptionCreatePayloadBrand>;
export type SubscriptionCreatePayloadC = t.BrandC<t.IntersectionC<[
    typeof SubscriptionBase,
    t.IntersectionC<[
        t.RecordC<t.StringC, t.UnknownC>,
        t.TypeC<{
            plan: typeof Defined;
            addons: typeof Defined;
        }>
    ]>
]>, SubscriptionCreatePayloadBrand>;
export declare const SubscriptionCreatePayload: SubscriptionCreatePayloadC;
export type SubscriptionCreatePayloadBrand = {
    readonly SubscriptionCreatePayload: unique symbol;
};
export type SubscriptionUpdatePayload = t.Branded<SubscriptionBase & (Record<string, unknown> & {}), SubscriptionUpdatePayloadBrand>;
export type SubscriptionUpdatePayloadC = t.BrandC<t.IntersectionC<[
    typeof SubscriptionBase,
    t.IntersectionC<[t.RecordC<t.StringC, t.UnknownC>, t.TypeC<{}>]>
]>, SubscriptionUpdatePayloadBrand>;
export declare const SubscriptionUpdatePayload: SubscriptionUpdatePayloadC;
export type SubscriptionUpdatePayloadBrand = {
    readonly SubscriptionUpdatePayload: unique symbol;
};
