import * as t from 'io-ts';
import * as Common_ffba_ from '../../core/components/common';
import * as PersonalDataAllowItem_b3f0_ from '../../core/components/personalDataAllowItem';
import * as PersonalDataValidation_1572_ from '../../core/components/personalDataValidation';
import * as Subscription_b8eb_ from './subscription';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/subscriptions/subscriptionOption.json";
export type SubscriptionAdditions = t.Branded<({
    discounts?: Array<unknown>;
    requiredAuthorizations?: Array<Common_ffba_.AgencyId>;
    regionDefault?: boolean;
    personalDataCreateAllow?: Array<PersonalDataAllowItem_b3f0_.PersonalDataAllowItem>;
    personalDataValidations?: Array<PersonalDataValidation_1572_.PersonalDataValidation>;
} & Record<string, unknown>) & {
    plan: Defined;
    pointCost: Defined;
    addons: Defined;
    coupons: Defined;
    requiredAuthorizations: Defined;
    regionDefault: Defined;
}, SubscriptionAdditionsBrand>;
export type SubscriptionAdditionsC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            discounts: t.UnknownArrayC;
            requiredAuthorizations: t.ArrayC<typeof Common_ffba_.AgencyId>;
            regionDefault: t.BooleanC;
            personalDataCreateAllow: t.ArrayC<typeof PersonalDataAllowItem_b3f0_.PersonalDataAllowItem>;
            personalDataValidations: t.ArrayC<typeof PersonalDataValidation_1572_.PersonalDataValidation>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        plan: typeof Defined;
        pointCost: typeof Defined;
        addons: typeof Defined;
        coupons: typeof Defined;
        requiredAuthorizations: typeof Defined;
        regionDefault: typeof Defined;
    }>
]>, SubscriptionAdditionsBrand>;
export declare const SubscriptionAdditions: SubscriptionAdditionsC;
export type SubscriptionAdditionsBrand = {
    readonly SubscriptionAdditions: unique symbol;
};
export type SubscriptionOption = t.Branded<Subscription_b8eb_.SubscriptionBase & SubscriptionAdditions, SubscriptionOptionBrand>;
export type SubscriptionOptionC = t.BrandC<t.IntersectionC<[
    typeof Subscription_b8eb_.SubscriptionBase,
    typeof SubscriptionAdditions
]>, SubscriptionOptionBrand>;
export declare const SubscriptionOption: SubscriptionOptionC;
export type SubscriptionOptionBrand = {
    readonly SubscriptionOption: unique symbol;
};
export default SubscriptionOption;
