import * as t from 'io-ts';
import * as Booking_4353_ from '../../../core/booking';
import * as CustomerSelection_57c3_ from '../../../core/components/customerSelection';
export declare const schemaId = "https://schemas.maas.global/maas-backend/tsp-auth/verify/definitions.json";
export type VerificationFailureKey = t.Branded<string & ('UNKNOWN_ERROR' | 'NO_TOKEN_FOR_THE_USER' | 'INVALID_USER_TOKEN' | 'INVALID_USER' | 'EMPTY_PRODUCTS' | 'VERIFICATION_FAILURE'), VerificationFailureKeyBrand>;
export type VerificationFailureKeyC = t.BrandC<t.IntersectionC<[
    t.StringC,
    t.UnionC<[
        t.LiteralC<'UNKNOWN_ERROR'>,
        t.LiteralC<'NO_TOKEN_FOR_THE_USER'>,
        t.LiteralC<'INVALID_USER_TOKEN'>,
        t.LiteralC<'INVALID_USER'>,
        t.LiteralC<'EMPTY_PRODUCTS'>,
        t.LiteralC<'VERIFICATION_FAILURE'>
    ]>
]>, VerificationFailureKeyBrand>;
export declare const VerificationFailureKey: VerificationFailureKeyC;
export type VerificationFailureKeyBrand = {
    readonly VerificationFailureKey: unique symbol;
};
export type VerifiedProducts = t.Branded<Array<{
    id?: Booking_4353_.TspId;
    verified?: boolean;
} & Record<string, unknown>>, VerifiedProductsBrand>;
export type VerifiedProductsC = t.BrandC<t.ArrayC<t.IntersectionC<[
    t.PartialC<{
        id: typeof Booking_4353_.TspId;
        verified: t.BooleanC;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>>, VerifiedProductsBrand>;
export declare const VerifiedProducts: VerifiedProductsC;
export type VerifiedProductsBrand = {
    readonly VerifiedProducts: unique symbol;
};
export type ProductsNeededVerification = t.Branded<Array<{
    id?: Booking_4353_.TspId;
    customerSelection?: CustomerSelection_57c3_.CustomerSelection;
} & Record<string, unknown>>, ProductsNeededVerificationBrand>;
export type ProductsNeededVerificationC = t.BrandC<t.ArrayC<t.IntersectionC<[
    t.PartialC<{
        id: typeof Booking_4353_.TspId;
        customerSelection: typeof CustomerSelection_57c3_.CustomerSelection;
    }>,
    t.RecordC<t.StringC, t.UnknownC>
]>>, ProductsNeededVerificationBrand>;
export declare const ProductsNeededVerification: ProductsNeededVerificationC;
export type ProductsNeededVerificationBrand = {
    readonly ProductsNeededVerification: unique symbol;
};
export type Definitions = t.Branded<unknown, DefinitionsBrand>;
export type DefinitionsC = t.BrandC<t.UnknownC, DefinitionsBrand>;
export declare const Definitions: DefinitionsC;
export type DefinitionsBrand = {
    readonly Definitions: unique symbol;
};
export default Definitions;
