import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Booking_4353_ from '../../../core/booking';
import * as BookingMeta_c057_ from '../../../core/booking-meta';
import * as ApiCommon_16a4_ from '../../../core/components/api-common';
import * as CustomerSelection_57c3_ from '../../../core/components/customerSelection';
import * as I18n_b70d_ from '../../../core/components/i18n';
import * as Units_c404_ from '../../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/webhooks/webhooks-bookings-create/request.json";
export type Request = t.Branded<{
    payload?: ({
        identityId?: Units_c404_.IdentityId;
        locale?: I18n_b70d_.Locale;
        option?: ({
            cost?: Booking_4353_.Cost;
            leg?: Booking_4353_.Leg;
            meta?: BookingMeta_c057_.BookingMeta;
            terms?: Booking_4353_.Terms;
            tspProduct?: {
                id?: string;
            } & Record<string, unknown>;
            configurator?: Booking_4353_.Configurator;
        } & Record<string, unknown>) & ((Record<string, unknown> & Record<string, unknown> & {
            leg: Defined;
            terms: Defined;
            cost: Defined;
            meta: Defined;
        }) | (Record<string, unknown> & Record<string, unknown> & {
            leg: Defined;
            terms: Defined;
            cost: Defined;
            meta: Defined;
            configurator: Defined;
        }));
        customerSelection?: CustomerSelection_57c3_.CustomerSelection;
    } & Record<string, unknown>) & {
        option: Defined;
        identityId: Defined;
        locale: Defined;
    };
    headers?: ApiCommon_16a4_.Headers;
} & {
    payload: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        payload: t.IntersectionC<[
            t.IntersectionC<[
                t.PartialC<{
                    identityId: typeof Units_c404_.IdentityId;
                    locale: typeof I18n_b70d_.Locale;
                    option: t.IntersectionC<[
                        t.IntersectionC<[
                            t.PartialC<{
                                cost: typeof Booking_4353_.Cost;
                                leg: typeof Booking_4353_.Leg;
                                meta: typeof BookingMeta_c057_.BookingMeta;
                                terms: typeof Booking_4353_.Terms;
                                tspProduct: t.IntersectionC<[
                                    t.PartialC<{
                                        id: t.StringC;
                                    }>,
                                    t.RecordC<t.StringC, t.UnknownC>
                                ]>;
                                configurator: typeof Booking_4353_.Configurator;
                            }>,
                            t.RecordC<t.StringC, t.UnknownC>
                        ]>,
                        t.UnionC<[
                            t.IntersectionC<[
                                t.UnknownRecordC,
                                t.RecordC<t.StringC, t.UnknownC>,
                                t.TypeC<{
                                    leg: typeof Defined;
                                    terms: typeof Defined;
                                    cost: typeof Defined;
                                    meta: typeof Defined;
                                }>
                            ]>,
                            t.IntersectionC<[
                                t.UnknownRecordC,
                                t.RecordC<t.StringC, t.UnknownC>,
                                t.TypeC<{
                                    leg: typeof Defined;
                                    terms: typeof Defined;
                                    cost: typeof Defined;
                                    meta: typeof Defined;
                                    configurator: typeof Defined;
                                }>
                            ]>
                        ]>
                    ]>;
                    customerSelection: typeof CustomerSelection_57c3_.CustomerSelection;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>,
            t.TypeC<{
                option: typeof Defined;
                identityId: typeof Defined;
                locale: typeof Defined;
            }>
        ]>;
        headers: typeof ApiCommon_16a4_.Headers;
    }>,
    t.TypeC<{
        payload: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Request)).decodeSync(examplesRequest) // => examplesRequest */
export declare const examplesRequest: NonEmptyArray<Request>;
export default Request;
import "jest";
