import * as t from 'io-ts';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/webhooks/webhooks-payments/gateway/avainpay.json";
export type Request = t.Branded<({
    payload?: ({
        action_str?: string;
        data_type?: string;
        log_list?: Array<unknown>;
        trans_map?: {
            system_time?: number;
            nonce?: string;
            signature?: string;
        } & Record<string, unknown>;
        request_map?: Record<string, unknown> & Record<string, unknown>;
    } & Record<string, unknown>) & {
        action_str: Defined;
        data_type: Defined;
    };
    headers?: {
        'Set-Cookie'?: string;
    } & Record<string, unknown>;
    params?: ({
        gatewayName?: string & 'avainpay';
    } & Record<string, unknown>) & {
        gatewayName: Defined;
    };
} & Record<string, unknown>) & {
    params: Defined;
    payload: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            payload: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        action_str: t.StringC;
                        data_type: t.StringC;
                        log_list: t.UnknownArrayC;
                        trans_map: t.IntersectionC<[
                            t.PartialC<{
                                system_time: t.NumberC;
                                nonce: t.StringC;
                                signature: t.StringC;
                            }>,
                            t.RecordC<t.StringC, t.UnknownC>
                        ]>;
                        request_map: t.IntersectionC<[
                            t.UnknownRecordC,
                            t.RecordC<t.StringC, t.UnknownC>
                        ]>;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    action_str: typeof Defined;
                    data_type: typeof Defined;
                }>
            ]>;
            headers: t.IntersectionC<[
                t.PartialC<{
                    'Set-Cookie': t.StringC;
                }>,
                t.RecordC<t.StringC, t.UnknownC>
            ]>;
            params: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        gatewayName: t.IntersectionC<[t.StringC, t.LiteralC<'avainpay'>]>;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    gatewayName: typeof Defined;
                }>
            ]>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        params: typeof Defined;
        payload: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export type Avainpay = t.Branded<unknown, AvainpayBrand>;
export type AvainpayC = t.BrandC<t.UnknownC, AvainpayBrand>;
export declare const Avainpay: AvainpayC;
export type AvainpayBrand = {
    readonly Avainpay: unique symbol;
};
export default Avainpay;
