import * as t from 'io-ts';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/maas-backend/webhooks/webhooks-payments/gateway/stripe.json";
export type Request = t.Branded<({
    payload?: ({
        id?: string;
        type?: string;
        data?: {
            object?: {
                id?: string;
                amount?: number;
                amount_capturable?: number;
                amount_received?: number;
                charges?: {
                    data?: Array<{
                        id?: string;
                        object?: string;
                        amount?: number;
                        amount_refunded?: number;
                    } & Record<string, unknown>>;
                } & Record<string, unknown>;
            } & Record<string, unknown>;
        } & Record<string, unknown>;
    } & Record<string, unknown>) & {
        type: Defined;
        id: Defined;
        data: Defined;
    };
    params?: ({
        gatewayName?: string & 'stripe';
    } & Record<string, unknown>) & {
        gatewayName: Defined;
    };
} & Record<string, unknown>) & {
    params: Defined;
    payload: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            payload: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        id: t.StringC;
                        type: t.StringC;
                        data: t.IntersectionC<[
                            t.PartialC<{
                                object: t.IntersectionC<[
                                    t.PartialC<{
                                        id: t.StringC;
                                        amount: t.NumberC;
                                        amount_capturable: t.NumberC;
                                        amount_received: t.NumberC;
                                        charges: t.IntersectionC<[
                                            t.PartialC<{
                                                data: t.ArrayC<t.IntersectionC<[
                                                    t.PartialC<{
                                                        id: t.StringC;
                                                        object: t.StringC;
                                                        amount: t.NumberC;
                                                        amount_refunded: t.NumberC;
                                                    }>,
                                                    t.RecordC<t.StringC, t.UnknownC>
                                                ]>>;
                                            }>,
                                            t.RecordC<t.StringC, t.UnknownC>
                                        ]>;
                                    }>,
                                    t.RecordC<t.StringC, t.UnknownC>
                                ]>;
                            }>,
                            t.RecordC<t.StringC, t.UnknownC>
                        ]>;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    type: typeof Defined;
                    id: typeof Defined;
                    data: typeof Defined;
                }>
            ]>;
            params: t.IntersectionC<[
                t.IntersectionC<[
                    t.PartialC<{
                        gatewayName: t.IntersectionC<[t.StringC, t.LiteralC<'stripe'>]>;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>
                ]>,
                t.TypeC<{
                    gatewayName: typeof Defined;
                }>
            ]>;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        params: typeof Defined;
        payload: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
export type Stripe = t.Branded<unknown, StripeBrand>;
export type StripeC = t.BrandC<t.UnknownC, StripeBrand>;
export declare const Stripe: StripeC;
export type StripeBrand = {
    readonly Stripe: unique symbol;
};
export default Stripe;
