import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Booking_4353_ from '../../core/booking';
import * as BookingMeta_c057_ from '../../core/booking-meta';
import * as BookingOption_9a80_ from '../../core/booking-option';
import * as Configurator_2e96_ from '../../core/components/configurator';
import * as CustomerSelection_57c3_ from '../../core/components/customerSelection';
import * as Customer_c745_ from '../../core/customer';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/tsp/booking-create/request.json";
export type Request = t.Branded<({
    leg?: BookingOption_9a80_.Leg;
    meta?: BookingMeta_c057_.BookingMeta;
    terms?: Booking_4353_.Terms;
    customer?: Customer_c745_.Customer;
    tspProduct?: BookingOption_9a80_.TspProduct;
    configurator?: Configurator_2e96_.Configurator;
    customerSelection?: CustomerSelection_57c3_.CustomerSelection;
} & Record<string, unknown>) & {
    leg: Defined;
    meta: Defined;
    terms: Defined;
    customer: Defined;
    tspProduct: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            leg: typeof BookingOption_9a80_.Leg;
            meta: typeof BookingMeta_c057_.BookingMeta;
            terms: typeof Booking_4353_.Terms;
            customer: typeof Customer_c745_.Customer;
            tspProduct: typeof BookingOption_9a80_.TspProduct;
            configurator: typeof Configurator_2e96_.Configurator;
            customerSelection: typeof CustomerSelection_57c3_.CustomerSelection;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        leg: typeof Defined;
        meta: typeof Defined;
        terms: typeof Defined;
        customer: typeof Defined;
        tspProduct: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Request)).decodeSync(examplesRequest) // => examplesRequest */
export declare const examplesRequest: NonEmptyArray<Request>;
export default Request;
