import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Booking_4353_ from '../../core/booking';
import * as BookingMeta_c057_ from '../../core/booking-meta';
import * as BookingOption_9a80_ from '../../core/booking-option';
import * as Configurator_2e96_ from '../../core/components/configurator';
import * as CustomerSelection_57c3_ from '../../core/components/customerSelection';
import * as State_2db3_ from '../../core/components/state';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/tsp/booking-create/response.json";
export type Response = t.Branded<{
    tspId?: Booking_4353_.TspId;
    state?: State_2db3_.BookingState;
    cost?: Booking_4353_.Cost;
    leg?: BookingOption_9a80_.Leg;
    meta?: BookingMeta_c057_.BookingMeta;
    terms?: Booking_4353_.Terms;
    token?: Booking_4353_.Token;
    tspProduct?: BookingOption_9a80_.TspProduct;
    configurator?: Configurator_2e96_.Configurator;
    customerSelection?: CustomerSelection_57c3_.CustomerSelection;
    customer?: BookingOption_9a80_.Customer;
} & {
    tspId: Defined;
    state: Defined;
    meta: Defined;
    terms: Defined;
    token: Defined;
    tspProduct: Defined;
}, ResponseBrand>;
export type ResponseC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        tspId: typeof Booking_4353_.TspId;
        state: typeof State_2db3_.BookingState;
        cost: typeof Booking_4353_.Cost;
        leg: typeof BookingOption_9a80_.Leg;
        meta: typeof BookingMeta_c057_.BookingMeta;
        terms: typeof Booking_4353_.Terms;
        token: typeof Booking_4353_.Token;
        tspProduct: typeof BookingOption_9a80_.TspProduct;
        configurator: typeof Configurator_2e96_.Configurator;
        customerSelection: typeof CustomerSelection_57c3_.CustomerSelection;
        customer: typeof BookingOption_9a80_.Customer;
    }>,
    t.TypeC<{
        tspId: typeof Defined;
        state: typeof Defined;
        meta: typeof Defined;
        terms: typeof Defined;
        token: typeof Defined;
        tspProduct: typeof Defined;
    }>
]>, ResponseBrand>;
export declare const Response: ResponseC;
export type ResponseBrand = {
    readonly Response: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Response)).decodeSync(examplesResponse) // => examplesResponse */
export declare const examplesResponse: NonEmptyArray<Response>;
/** require('io-ts-validator').validator(Response).decodeEither({"customer":{"firstName":"John","lastName":"Doe","phone":109381023,"email":"john.doe@example.com"}})._tag // => 'Left' */
export default Response;
import "jest";
