import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Booking_4353_ from '../../core/booking';
import * as Address_2d0a_ from '../../core/components/address';
import * as Common_ffba_ from '../../core/components/common';
import * as TravelMode_5e34_ from '../../core/components/travel-mode';
import * as Units_c404_ from '../../core/components/units';
import * as UnitsGeo_3e31_ from '../../core/components/units-geo';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/tsp/booking-options-list/request.json";
export type Request = t.Branded<({
    mode?: TravelMode_5e34_.TravelMode;
    startTime?: Units_c404_.Time;
    endTime?: Units_c404_.Time;
    from?: UnitsGeo_3e31_.ShortLocationString;
    fromName?: Address_2d0a_.PlaceName | string;
    fromAddress?: Address_2d0a_.ComponentAddress | string;
    fromRadius?: UnitsGeo_3e31_.Distance;
    to?: UnitsGeo_3e31_.ShortLocationString | string;
    toName?: Address_2d0a_.PlaceName | string;
    toAddress?: Address_2d0a_.ComponentAddress | string;
    toRadius?: UnitsGeo_3e31_.Distance;
    distance?: UnitsGeo_3e31_.Distance;
    extraOptions?: string;
    tspProductIds?: string;
    tspIdToExtend?: Booking_4353_.TspId;
    purchasingAppInstanceId?: Common_ffba_.AppInstanceId;
} & Record<string, TravelMode_5e34_.TravelMode | Units_c404_.Time | Units_c404_.Time | UnitsGeo_3e31_.ShortLocationString | (Address_2d0a_.PlaceName | string) | (Address_2d0a_.ComponentAddress | string) | UnitsGeo_3e31_.Distance | (UnitsGeo_3e31_.ShortLocationString | string) | (Address_2d0a_.PlaceName | string) | (Address_2d0a_.ComponentAddress | string) | UnitsGeo_3e31_.Distance | UnitsGeo_3e31_.Distance | string | string | Booking_4353_.TspId | Common_ffba_.AppInstanceId | (string | number | boolean)> & Record<string, unknown>) & {
    startTime: Defined;
    from: Defined;
}, RequestBrand>;
export type RequestC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            mode: typeof TravelMode_5e34_.TravelMode;
            startTime: typeof Units_c404_.Time;
            endTime: typeof Units_c404_.Time;
            from: typeof UnitsGeo_3e31_.ShortLocationString;
            fromName: t.UnionC<[typeof Address_2d0a_.PlaceName, t.StringC]>;
            fromAddress: t.UnionC<[typeof Address_2d0a_.ComponentAddress, t.StringC]>;
            fromRadius: typeof UnitsGeo_3e31_.Distance;
            to: t.UnionC<[typeof UnitsGeo_3e31_.ShortLocationString, t.StringC]>;
            toName: t.UnionC<[typeof Address_2d0a_.PlaceName, t.StringC]>;
            toAddress: t.UnionC<[typeof Address_2d0a_.ComponentAddress, t.StringC]>;
            toRadius: typeof UnitsGeo_3e31_.Distance;
            distance: typeof UnitsGeo_3e31_.Distance;
            extraOptions: t.StringC;
            tspProductIds: t.StringC;
            tspIdToExtend: typeof Booking_4353_.TspId;
            purchasingAppInstanceId: typeof Common_ffba_.AppInstanceId;
        }>,
        t.RecordC<t.StringC, t.UnionC<[
            typeof TravelMode_5e34_.TravelMode,
            typeof Units_c404_.Time,
            typeof Units_c404_.Time,
            typeof UnitsGeo_3e31_.ShortLocationString,
            t.UnionC<[typeof Address_2d0a_.PlaceName, t.StringC]>,
            t.UnionC<[typeof Address_2d0a_.ComponentAddress, t.StringC]>,
            typeof UnitsGeo_3e31_.Distance,
            t.UnionC<[typeof UnitsGeo_3e31_.ShortLocationString, t.StringC]>,
            t.UnionC<[typeof Address_2d0a_.PlaceName, t.StringC]>,
            t.UnionC<[typeof Address_2d0a_.ComponentAddress, t.StringC]>,
            typeof UnitsGeo_3e31_.Distance,
            typeof UnitsGeo_3e31_.Distance,
            t.StringC,
            t.StringC,
            typeof Booking_4353_.TspId,
            typeof Common_ffba_.AppInstanceId,
            t.UnionC<[t.StringC, t.NumberC, t.BooleanC]>
        ]>>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        startTime: typeof Defined;
        from: typeof Defined;
    }>
]>, RequestBrand>;
export declare const Request: RequestC;
export type RequestBrand = {
    readonly Request: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Request)).decodeSync(examplesRequest) // => examplesRequest */
export declare const examplesRequest: NonEmptyArray<Request>;
export default Request;
