import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Booking_4353_ from '../../core/booking';
import * as Terms_bb95_ from '../../core/components/terms';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/tsp/booking-receipt/response.json";
export type TspReceipt = t.Branded<{
    cost?: Booking_4353_.Cost;
    terms?: Terms_bb95_.Terms;
} & {
    cost: Defined;
    terms: Defined;
}, TspReceiptBrand>;
export type TspReceiptC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        cost: typeof Booking_4353_.Cost;
        terms: typeof Terms_bb95_.Terms;
    }>,
    t.TypeC<{
        cost: typeof Defined;
        terms: typeof Defined;
    }>
]>, TspReceiptBrand>;
export declare const TspReceipt: TspReceiptC;
export type TspReceiptBrand = {
    readonly TspReceipt: unique symbol;
};
export type Response = t.Branded<{
    tspId?: Booking_4353_.TspId;
    cost?: Booking_4353_.Cost;
    receipt?: TspReceipt;
} & {
    tspId: Defined;
    receipt: Defined;
}, ResponseBrand>;
export type ResponseC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        tspId: typeof Booking_4353_.TspId;
        cost: typeof Booking_4353_.Cost;
        receipt: typeof TspReceipt;
    }>,
    t.TypeC<{
        tspId: typeof Defined;
        receipt: typeof Defined;
    }>
]>, ResponseBrand>;
export declare const Response: ResponseC;
export type ResponseBrand = {
    readonly Response: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Response)).decodeSync(examplesResponse) // => examplesResponse */
export declare const examplesResponse: NonEmptyArray<Response>;
export default Response;
import "jest";
