import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import * as Units_c404_ from '../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/tsp/booking-ticket/response.json";
export type Response = t.Branded<({
    ticket?: string;
    type?: string & ('html' | 'pdf' | 'svg' | 'png');
    contentType?: string & ('application/pdf' | 'image/svg+xml' | 'image/png' | 'text/html');
    refreshAt?: Units_c404_.Time;
} & Record<string, unknown>) & {
    ticket: Defined;
    type: Defined;
    contentType: Defined;
}, ResponseBrand>;
export type ResponseC = t.BrandC<t.IntersectionC<[
    t.IntersectionC<[
        t.PartialC<{
            ticket: t.StringC;
            type: t.IntersectionC<[
                t.StringC,
                t.UnionC<[
                    t.LiteralC<'html'>,
                    t.LiteralC<'pdf'>,
                    t.LiteralC<'svg'>,
                    t.LiteralC<'png'>
                ]>
            ]>;
            contentType: t.IntersectionC<[
                t.StringC,
                t.UnionC<[
                    t.LiteralC<'application/pdf'>,
                    t.LiteralC<'image/svg+xml'>,
                    t.LiteralC<'image/png'>,
                    t.LiteralC<'text/html'>
                ]>
            ]>;
            refreshAt: typeof Units_c404_.Time;
        }>,
        t.RecordC<t.StringC, t.UnknownC>
    ]>,
    t.TypeC<{
        ticket: typeof Defined;
        type: typeof Defined;
        contentType: typeof Defined;
    }>
]>, ResponseBrand>;
export declare const Response: ResponseC;
export type ResponseBrand = {
    readonly Response: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Response)).decodeSync(examplesResponse) // => examplesResponse */
export declare const examplesResponse: NonEmptyArray<Response>;
export default Response;
