import * as t from 'io-ts';
import * as Booking_4353_ from '../../core/booking';
import * as BookingMeta_c057_ from '../../core/booking-meta';
import * as BookingOption_9a80_ from '../../core/booking-option';
import * as Error_b620_ from '../../core/error';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/tsp/webhooks-bookings-update/remote-request.json";
export type RemoteRequest = t.Branded<{
    tspId?: Booking_4353_.TspId;
    cost?: Booking_4353_.Cost;
    state?: 'RESERVED' | 'CONFIRMED' | 'ARRIVED' | 'ACTIVATED' | 'EXPIRED' | 'CANCELLED' | 'REJECTED';
    leg?: BookingOption_9a80_.LegDelta;
    meta?: BookingMeta_c057_.BookingMeta;
    terms?: Booking_4353_.Terms;
    token?: Booking_4353_.Token;
    reason?: Error_b620_.Reason;
} & {
    tspId: Defined;
    state: Defined;
}, RemoteRequestBrand>;
export type RemoteRequestC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        tspId: typeof Booking_4353_.TspId;
        cost: typeof Booking_4353_.Cost;
        state: t.UnionC<[
            t.LiteralC<'RESERVED'>,
            t.LiteralC<'CONFIRMED'>,
            t.LiteralC<'ARRIVED'>,
            t.LiteralC<'ACTIVATED'>,
            t.LiteralC<'EXPIRED'>,
            t.LiteralC<'CANCELLED'>,
            t.LiteralC<'REJECTED'>
        ]>;
        leg: typeof BookingOption_9a80_.LegDelta;
        meta: typeof BookingMeta_c057_.BookingMeta;
        terms: typeof Booking_4353_.Terms;
        token: typeof Booking_4353_.Token;
        reason: typeof Error_b620_.Reason;
    }>,
    t.TypeC<{
        tspId: typeof Defined;
        state: typeof Defined;
    }>
]>, RemoteRequestBrand>;
export declare const RemoteRequest: RemoteRequestC;
export type RemoteRequestBrand = {
    readonly RemoteRequest: unique symbol;
};
export default RemoteRequest;
