import * as t from 'io-ts';
import * as Booking_4353_ from '../../core/booking';
import * as BookingMeta_c057_ from '../../core/booking-meta';
import * as BookingOption_9a80_ from '../../core/booking-option';
import * as Units_c404_ from '../../core/components/units';
export type Defined = {} | null;
export declare class DefinedType extends t.Type<Defined> {
    readonly _tag: 'DefinedType';
    constructor();
}
export type DefinedC = {} & DefinedType;
export declare const Defined: DefinedC;
export declare const schemaId = "https://schemas.maas.global/tsp/webhooks-bookings-update/remote-response.json";
export type BookingDelta = t.Branded<{
    id?: Units_c404_.Uuid;
    tspId?: Booking_4353_.TspId;
    cost?: Booking_4353_.Cost;
    state?: 'RESERVED' | 'CONFIRMED' | 'ACTIVATED' | 'EXPIRED' | 'CANCELLED' | 'REJECTED';
    leg?: BookingOption_9a80_.Leg;
    meta?: BookingMeta_c057_.BookingMeta;
    terms?: Booking_4353_.Terms;
    token?: Booking_4353_.Token;
    customer?: BookingOption_9a80_.Customer;
} & {
    tspId: Defined;
    state: Defined;
}, BookingDeltaBrand>;
export type BookingDeltaC = t.BrandC<t.IntersectionC<[
    t.PartialC<{
        id: typeof Units_c404_.Uuid;
        tspId: typeof Booking_4353_.TspId;
        cost: typeof Booking_4353_.Cost;
        state: t.UnionC<[
            t.LiteralC<'RESERVED'>,
            t.LiteralC<'CONFIRMED'>,
            t.LiteralC<'ACTIVATED'>,
            t.LiteralC<'EXPIRED'>,
            t.LiteralC<'CANCELLED'>,
            t.LiteralC<'REJECTED'>
        ]>;
        leg: typeof BookingOption_9a80_.Leg;
        meta: typeof BookingMeta_c057_.BookingMeta;
        terms: typeof Booking_4353_.Terms;
        token: typeof Booking_4353_.Token;
        customer: typeof BookingOption_9a80_.Customer;
    }>,
    t.TypeC<{
        tspId: typeof Defined;
        state: typeof Defined;
    }>
]>, BookingDeltaBrand>;
export declare const BookingDelta: BookingDeltaC;
export type BookingDeltaBrand = {
    readonly BookingDelta: unique symbol;
};
export type RemoteResponse = t.Branded<{
    booking?: BookingDelta;
    debug?: Record<string, unknown>;
}, RemoteResponseBrand>;
export type RemoteResponseC = t.BrandC<t.PartialC<{
    booking: typeof BookingDelta;
    debug: t.RecordC<t.StringC, t.UnknownC>;
}>, RemoteResponseBrand>;
export declare const RemoteResponse: RemoteResponseC;
export type RemoteResponseBrand = {
    readonly RemoteResponse: unique symbol;
};
export default RemoteResponse;
