"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.version = exports.fields = exports.groups = exports.separator = void 0;
var P = __importStar(require("maasglobal-prelude-ts"));
var Tuple_ = __importStar(require("../../../../_private/tuple"));
exports.separator = '-';
var groups = function (uuid) {
    return P.pipe(uuid.split(exports.separator), Tuple_.fromArray(5), P.Option_.getOrElse(function () {
        // eslint-disable-next-line fp/no-throw
        throw new Error('Uuid has more than five groups');
    }));
};
exports.groups = groups;
var fields = function (uuid) {
    return P.pipe((0, exports.groups)(uuid), function (_a) {
        var _b = __read(_a, 5), timeLow = _b[0], timeMid = _b[1], timeHiAndVersion = _b[2], clockSeq = _b[3], node = _b[4];
        return P.pipe(clockSeq.split(P.string_.empty), P.Array_.chunksOf(2), P.Array_.map(function (chunk) { return chunk.join(P.string_.empty); }), Tuple_.fromArray(2), P.Option_.getOrElse(function () {
            // eslint-disable-next-line fp/no-throw
            throw new Error('Uuid ClockSeq hi/lo not 2x2 hex long');
        }), function (_a) {
            var _b = __read(_a, 2), clockSeqHiAndReserved = _b[0], clockSeqLow = _b[1];
            return ({
                timeLow: timeLow,
                timeMid: timeMid,
                timeHiAndVersion: timeHiAndVersion,
                clockSeqHiAndReserved: clockSeqHiAndReserved,
                clockSeqLow: clockSeqLow,
                node: node,
            });
        });
    });
};
exports.fields = fields;
var version = function (uuid) {
    return P.pipe((0, exports.fields)(uuid), function (_a) {
        var timeHiAndVersion = _a.timeHiAndVersion;
        return parseInt(timeHiAndVersion.charAt(0), 16);
    });
};
exports.version = version;
