/*

undefined
Configurator schema common definitions

!!! AUTO GENERATED BY IOTSFJS REFRAIN FROM MANUAL EDITING !!!
See https://www.npmjs.com/package/io-ts-from-json-schema

*/

import * as t from 'io-ts';

import * as BookingMeta_c057_ from '../booking-meta';
import * as Cost_250f_ from './cost';
import * as Fare_a3ab_ from './fare';
import * as Terms_bb95_ from './terms';

export type Defined = {} | null;
export class DefinedType extends t.Type<Defined> {
  readonly _tag: 'DefinedType' = 'DefinedType';
  constructor() {
    super(
      'defined',
      (u): u is Defined => typeof u !== 'undefined',
      (u, c) => (this.is(u) ? t.success(u) : t.failure(u, c)),
      t.identity,
    );
  }
}
export type DefinedC = {} & DefinedType;
export const Defined: DefinedC = new DefinedType();

export const schemaId =
  'https://schemas.maas.global/core/components/configuratorCommon.json';

// Choice
// A choice for one customization
export type Choice = t.Branded<
  ({
    id?: string;
    name?: string;
    description?: string;
    default?: boolean;
    cost?: Cost_250f_.Cost;
    fares?: Array<Fare_a3ab_.Fare>;
    terms?: Terms_bb95_.Terms;
    unmodifiedTerms?: Terms_bb95_.Terms;
    meta?: BookingMeta_c057_.BookingMeta;
  } & Record<string, unknown>) & {
    id: Defined;
    name: Defined;
    default: Defined;
  },
  ChoiceBrand
>;
export type ChoiceC = t.BrandC<
  t.IntersectionC<
    [
      t.IntersectionC<
        [
          t.PartialC<{
            id: t.StringC;
            name: t.StringC;
            description: t.StringC;
            default: t.BooleanC;
            cost: typeof Cost_250f_.Cost;
            fares: t.ArrayC<typeof Fare_a3ab_.Fare>;
            terms: typeof Terms_bb95_.Terms;
            unmodifiedTerms: typeof Terms_bb95_.Terms;
            meta: typeof BookingMeta_c057_.BookingMeta;
          }>,
          t.RecordC<t.StringC, t.UnknownC>,
        ]
      >,
      t.TypeC<{
        id: typeof Defined;
        name: typeof Defined;
        default: typeof Defined;
      }>,
    ]
  >,
  ChoiceBrand
>;
export const Choice: ChoiceC = t.brand(
  t.intersection([
    t.intersection([
      t.partial({
        id: t.string,
        name: t.string,
        description: t.string,
        default: t.boolean,
        cost: Cost_250f_.Cost,
        fares: t.array(Fare_a3ab_.Fare),
        terms: Terms_bb95_.Terms,
        unmodifiedTerms: Terms_bb95_.Terms,
        meta: BookingMeta_c057_.BookingMeta,
      }),
      t.record(t.string, t.unknown),
    ]),
    t.type({
      id: Defined,
      name: Defined,
      default: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    ({
      id?: string;
      name?: string;
      description?: string;
      default?: boolean;
      cost?: Cost_250f_.Cost;
      fares?: Array<Fare_a3ab_.Fare>;
      terms?: Terms_bb95_.Terms;
      unmodifiedTerms?: Terms_bb95_.Terms;
      meta?: BookingMeta_c057_.BookingMeta;
    } & Record<string, unknown>) & {
      id: Defined;
      name: Defined;
      default: Defined;
    },
    ChoiceBrand
  > => true,
  'Choice',
);
export type ChoiceBrand = {
  readonly Choice: unique symbol;
};

// Config
// A customization to the booking option
export type Config = t.Branded<
  ({
    type?: 'oneOf' | 'someOf' | 'allOf' | 'oneOrNoneOf' | 'someOrNoneOf';
    name?: string;
    description?: string;
    choices?: Array<Choice>;
  } & Record<string, unknown>) & {
    type: Defined;
    name: Defined;
    choices: Defined;
  },
  ConfigBrand
>;
export type ConfigC = t.BrandC<
  t.IntersectionC<
    [
      t.IntersectionC<
        [
          t.PartialC<{
            type: t.UnionC<
              [
                t.LiteralC<'oneOf'>,
                t.LiteralC<'someOf'>,
                t.LiteralC<'allOf'>,
                t.LiteralC<'oneOrNoneOf'>,
                t.LiteralC<'someOrNoneOf'>,
              ]
            >;
            name: t.StringC;
            description: t.StringC;
            choices: t.ArrayC<typeof Choice>;
          }>,
          t.RecordC<t.StringC, t.UnknownC>,
        ]
      >,
      t.TypeC<{
        type: typeof Defined;
        name: typeof Defined;
        choices: typeof Defined;
      }>,
    ]
  >,
  ConfigBrand
>;
export const Config: ConfigC = t.brand(
  t.intersection([
    t.intersection([
      t.partial({
        type: t.union([
          t.literal('oneOf'),
          t.literal('someOf'),
          t.literal('allOf'),
          t.literal('oneOrNoneOf'),
          t.literal('someOrNoneOf'),
        ]),
        name: t.string,
        description: t.string,
        choices: t.array(Choice),
      }),
      t.record(t.string, t.unknown),
    ]),
    t.type({
      type: Defined,
      name: Defined,
      choices: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    ({
      type?: 'oneOf' | 'someOf' | 'allOf' | 'oneOrNoneOf' | 'someOrNoneOf';
      name?: string;
      description?: string;
      choices?: Array<Choice>;
    } & Record<string, unknown>) & {
      type: Defined;
      name: Defined;
      choices: Defined;
    },
    ConfigBrand
  > => true,
  'Config',
);
export type ConfigBrand = {
  readonly Config: unique symbol;
};

// Text
// Generic text field to pass information from user
export type Text = t.Branded<
  ({
    type?: 'text';
    name?: string;
    description?: string;
    input?: string;
  } & Record<string, unknown>) & {
    type: Defined;
    name: Defined;
  },
  TextBrand
>;
export type TextC = t.BrandC<
  t.IntersectionC<
    [
      t.IntersectionC<
        [
          t.PartialC<{
            type: t.LiteralC<'text'>;
            name: t.StringC;
            description: t.StringC;
            input: t.StringC;
          }>,
          t.RecordC<t.StringC, t.UnknownC>,
        ]
      >,
      t.TypeC<{
        type: typeof Defined;
        name: typeof Defined;
      }>,
    ]
  >,
  TextBrand
>;
export const Text: TextC = t.brand(
  t.intersection([
    t.intersection([
      t.partial({
        type: t.literal('text'),
        name: t.string,
        description: t.string,
        input: t.string,
      }),
      t.record(t.string, t.unknown),
    ]),
    t.type({
      type: Defined,
      name: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    ({
      type?: 'text';
      name?: string;
      description?: string;
      input?: string;
    } & Record<string, unknown>) & {
      type: Defined;
      name: Defined;
    },
    TextBrand
  > => true,
  'Text',
);
export type TextBrand = {
  readonly Text: unique symbol;
};

// ConfiguratorCommon
// The default export. More information at the top.
export type ConfiguratorCommon = t.Branded<unknown, ConfiguratorCommonBrand>;
export type ConfiguratorCommonC = t.BrandC<t.UnknownC, ConfiguratorCommonBrand>;
export const ConfiguratorCommon: ConfiguratorCommonC = t.brand(
  t.unknown,
  (x): x is t.Branded<unknown, ConfiguratorCommonBrand> => true,
  'ConfiguratorCommon',
);
export type ConfiguratorCommonBrand = {
  readonly ConfiguratorCommon: unique symbol;
};

export default ConfiguratorCommon;

// Success
