/*

undefined
MaaS station schemas

!!! AUTO GENERATED BY IOTSFJS REFRAIN FROM MANUAL EDITING !!!
See https://www.npmjs.com/package/io-ts-from-json-schema

*/

import * as t from 'io-ts';

import * as Address_2d0a_ from './address';
import * as Common_ffba_ from './common';
import * as TravelMode_5e34_ from './travel-mode';
import * as Units_c404_ from './units';
import * as UnitsGeo_3e31_ from './units-geo';

export const schemaId = 'https://schemas.maas.global/core/components/station.json';

// Id
// The purpose of this remains a mystery
export type Id = t.Branded<string, IdBrand>;
export type IdC = t.BrandC<t.StringC, IdBrand>;
export const Id: IdC = t.brand(
  t.string,
  (x): x is t.Branded<string, IdBrand> =>
    (typeof x !== 'string' || x.length >= 1) && (typeof x !== 'string' || x.length <= 64),
  'Id',
);
export type IdBrand = {
  readonly Id: unique symbol;
};

// Code
// The purpose of this remains a mystery
export type Code = t.Branded<string, CodeBrand>;
export type CodeC = t.BrandC<t.StringC, CodeBrand>;
export const Code: CodeC = t.brand(
  t.string,
  (x): x is t.Branded<string, CodeBrand> => true,
  'Code',
);
export type CodeBrand = {
  readonly Code: unique symbol;
};

// Name
// The purpose of this remains a mystery
export type Name = t.Branded<string, NameBrand>;
export type NameC = t.BrandC<t.StringC, NameBrand>;
export const Name: NameC = t.brand(
  t.string,
  (x): x is t.Branded<string, NameBrand> => true,
  'Name',
);
export type NameBrand = {
  readonly Name: unique symbol;
};

// Location
// The purpose of this remains a mystery
export type Location = t.Branded<UnitsGeo_3e31_.ShortLocationString, LocationBrand>;
export type LocationC = t.BrandC<
  typeof UnitsGeo_3e31_.ShortLocationString,
  LocationBrand
>;
export const Location: LocationC = t.brand(
  UnitsGeo_3e31_.ShortLocationString,
  (x): x is t.Branded<UnitsGeo_3e31_.ShortLocationString, LocationBrand> => true,
  'Location',
);
export type LocationBrand = {
  readonly Location: unique symbol;
};

// Address
// The purpose of this remains a mystery
export type Address = t.Branded<Address_2d0a_.Address, AddressBrand>;
export type AddressC = t.BrandC<typeof Address_2d0a_.Address, AddressBrand>;
export const Address: AddressC = t.brand(
  Address_2d0a_.Address,
  (x): x is t.Branded<Address_2d0a_.Address, AddressBrand> => true,
  'Address',
);
export type AddressBrand = {
  readonly Address: unique symbol;
};

// City
// The purpose of this remains a mystery
export type City = t.Branded<Address_2d0a_.City, CityBrand>;
export type CityC = t.BrandC<typeof Address_2d0a_.City, CityBrand>;
export const City: CityC = t.brand(
  Address_2d0a_.City,
  (x): x is t.Branded<Address_2d0a_.City, CityBrand> => true,
  'City',
);
export type CityBrand = {
  readonly City: unique symbol;
};

// Country
// The purpose of this remains a mystery
export type Country = t.Branded<Address_2d0a_.Country, CountryBrand>;
export type CountryC = t.BrandC<typeof Address_2d0a_.Country, CountryBrand>;
export const Country: CountryC = t.brand(
  Address_2d0a_.Country,
  (x): x is t.Branded<Address_2d0a_.Country, CountryBrand> => true,
  'Country',
);
export type CountryBrand = {
  readonly Country: unique symbol;
};

// AgencyId
// The purpose of this remains a mystery
export type AgencyId = t.Branded<Common_ffba_.AgencyId, AgencyIdBrand>;
export type AgencyIdC = t.BrandC<typeof Common_ffba_.AgencyId, AgencyIdBrand>;
export const AgencyId: AgencyIdC = t.brand(
  Common_ffba_.AgencyId,
  (x): x is t.Branded<Common_ffba_.AgencyId, AgencyIdBrand> => true,
  'AgencyId',
);
export type AgencyIdBrand = {
  readonly AgencyId: unique symbol;
};

// OpeningHours
// Opening hour of the station, object format is left for TSP to decide
export type OpeningHours = t.Branded<
  Record<string, unknown> & Record<string, unknown>,
  OpeningHoursBrand
>;
export type OpeningHoursC = t.BrandC<
  t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>,
  OpeningHoursBrand
>;
export const OpeningHours: OpeningHoursC = t.brand(
  t.intersection([t.UnknownRecord, t.record(t.string, t.unknown)]),
  (
    x,
  ): x is t.Branded<
    Record<string, unknown> & Record<string, unknown>,
    OpeningHoursBrand
  > => true,
  'OpeningHours',
);
export type OpeningHoursBrand = {
  readonly OpeningHours: unique symbol;
};

// Facilities
// Station facilities, including services and features
export type Facilities = t.Branded<Array<string>, FacilitiesBrand>;
export type FacilitiesC = t.BrandC<t.ArrayC<t.StringC>, FacilitiesBrand>;
export const Facilities: FacilitiesC = t.brand(
  t.array(t.string),
  (x): x is t.Branded<Array<string>, FacilitiesBrand> => true,
  'Facilities',
);
export type FacilitiesBrand = {
  readonly Facilities: unique symbol;
};

// Services
// What agency and mode of transport will occupy this station
export type Services = t.Branded<Array<TravelMode_5e34_.TravelMode>, ServicesBrand>;
export type ServicesC = t.BrandC<
  t.ArrayC<typeof TravelMode_5e34_.TravelMode>,
  ServicesBrand
>;
export const Services: ServicesC = t.brand(
  t.array(TravelMode_5e34_.TravelMode),
  (x): x is t.Branded<Array<TravelMode_5e34_.TravelMode>, ServicesBrand> => true,
  'Services',
);
export type ServicesBrand = {
  readonly Services: unique symbol;
};

// Timetables
// Timetable for passing by / originating transports
export type Timetables = t.Branded<
  Array<
    {
      id?: string;
      mode?: TravelMode_5e34_.TravelMode;
      name?: string;
      longName?: string;
      schedule?: Units_c404_.Time;
      realtime?: Units_c404_.Time;
      isRealtime?: boolean;
    } & Record<string, unknown>
  >,
  TimetablesBrand
>;
export type TimetablesC = t.BrandC<
  t.ArrayC<
    t.IntersectionC<
      [
        t.PartialC<{
          id: t.StringC;
          mode: typeof TravelMode_5e34_.TravelMode;
          name: t.StringC;
          longName: t.StringC;
          schedule: typeof Units_c404_.Time;
          realtime: typeof Units_c404_.Time;
          isRealtime: t.BooleanC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>,
      ]
    >
  >,
  TimetablesBrand
>;
export const Timetables: TimetablesC = t.brand(
  t.array(
    t.intersection([
      t.partial({
        id: t.string,
        mode: TravelMode_5e34_.TravelMode,
        name: t.string,
        longName: t.string,
        schedule: Units_c404_.Time,
        realtime: Units_c404_.Time,
        isRealtime: t.boolean,
      }),
      t.record(t.string, t.unknown),
    ]),
  ),
  (
    x,
  ): x is t.Branded<
    Array<
      {
        id?: string;
        mode?: TravelMode_5e34_.TravelMode;
        name?: string;
        longName?: string;
        schedule?: Units_c404_.Time;
        realtime?: Units_c404_.Time;
        isRealtime?: boolean;
      } & Record<string, unknown>
    >,
    TimetablesBrand
  > => true,
  'Timetables',
);
export type TimetablesBrand = {
  readonly Timetables: unique symbol;
};

// Zone
// Geofencing zone defined by provider that the station is within
export type Zone = t.Branded<number | string, ZoneBrand>;
export type ZoneC = t.BrandC<t.UnionC<[t.NumberC, t.StringC]>, ZoneBrand>;
export const Zone: ZoneC = t.brand(
  t.union([t.number, t.string]),
  (x): x is t.Branded<number | string, ZoneBrand> => true,
  'Zone',
);
export type ZoneBrand = {
  readonly Zone: unique symbol;
};

// PlatformCode
// Platform number
export type PlatformCode = t.Branded<number | string, PlatformCodeBrand>;
export type PlatformCodeC = t.BrandC<t.UnionC<[t.NumberC, t.StringC]>, PlatformCodeBrand>;
export const PlatformCode: PlatformCodeC = t.brand(
  t.union([t.number, t.string]),
  (x): x is t.Branded<number | string, PlatformCodeBrand> => true,
  'PlatformCode',
);
export type PlatformCodeBrand = {
  readonly PlatformCode: unique symbol;
};

// Station
// The default export. More information at the top.
export type Station = t.Branded<
  Record<string, unknown> & Record<string, unknown>,
  StationBrand
>;
export type StationC = t.BrandC<
  t.IntersectionC<[t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]>,
  StationBrand
>;
export const Station: StationC = t.brand(
  t.intersection([t.UnknownRecord, t.record(t.string, t.unknown)]),
  (x): x is t.Branded<Record<string, unknown> & Record<string, unknown>, StationBrand> =>
    true,
  'Station',
);
export type StationBrand = {
  readonly Station: unique symbol;
};

export default Station;

// Success
