/*

undefined
MaaS customer schema

!!! AUTO GENERATED BY IOTSFJS REFRAIN FROM MANUAL EDITING !!!
See https://www.npmjs.com/package/io-ts-from-json-schema

*/

import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import { nonEmptyArray } from 'io-ts-types/lib/nonEmptyArray';

import * as Address_2d0a_ from './components/address';
import * as Common_ffba_ from './components/common';
import * as Fare_a3ab_ from './components/fare';
import * as I18n_b70d_ from './components/i18n';
import * as Units_c404_ from './components/units';
import * as PersonalDocument_9750_ from './personal-document';

export type Defined = {} | null;
export class DefinedType extends t.Type<Defined> {
  readonly _tag: 'DefinedType' = 'DefinedType';
  constructor() {
    super(
      'defined',
      (u): u is Defined => typeof u !== 'undefined',
      (u, c) => (this.is(u) ? t.success(u) : t.failure(u, c)),
      t.identity,
    );
  }
}
export type DefinedC = {} & DefinedType;
export const Defined: DefinedC = new DefinedType();

export type NullBrand = {
  readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export const Null: NullC = t.brand(
  t.unknown,
  (n): n is t.Branded<unknown, NullBrand> => n === null,
  'Null',
);
export type Null = t.TypeOf<typeof Null>;

export const schemaId = 'https://schemas.maas.global/core/customer.json';

// Customer
// The default export. More information at the top.
export type Customer = t.Branded<
  {
    identityId?: Units_c404_.IdentityId;
    honorifics?: string;
    firstName?: Common_ffba_.PersonalName;
    lastName?: Common_ffba_.PersonalName;
    firstNameLocalized?: Common_ffba_.PersonalName;
    lastNameLocalized?: Common_ffba_.PersonalName;
    sex?: string;
    phone?: Common_ffba_.Phone;
    email?: Common_ffba_.Email;
    address?: Address_2d0a_.Address;
    city?: Address_2d0a_.City;
    state?: Address_2d0a_.State;
    country?: Address_2d0a_.Country;
    zipCode?: Address_2d0a_.ZipCode;
    locale?: I18n_b70d_.Locale;
    appInstanceId?: Common_ffba_.AppInstanceId;
    opaqueId?: Common_ffba_.OpaqueId;
    opaqueIdShort?: Common_ffba_.OpaqueIdShort;
    clientId?: Common_ffba_.ClientId;
    dob?: boolean | Units_c404_.IsoDate;
    ssid?: boolean | Common_ffba_.Ssid;
    'ssid-fi'?: boolean | Common_ffba_.SsidFI;
    documents?: Array<PersonalDocument_9750_.PersonalDocument>;
    balances?: Record<
      string,
      | (({
          currency?: Units_c404_.Currency | Common_ffba_.MetaCurrencyWMP;
          amount?: number;
        } & Record<string, unknown>) & {
          currency: Defined;
          amount: Defined;
        })
      | (({
          currency?: Common_ffba_.MetaCurrencyTOKEN | Fare_a3ab_.TokenId;
          tokenId?: Fare_a3ab_.TokenId;
          amount?: number | Null;
        } & Record<string, unknown>) & {
          currency: Defined;
          tokenId: Defined;
          amount: Defined;
        })
    >;
    referral?: {
      code?: string;
    } & Record<string, unknown>;
    subscriberType?: string;
    authToken?: Common_ffba_.EncodedQueryParam;
    cugHome?: string;
  },
  CustomerBrand
>;
export type CustomerC = t.BrandC<
  t.PartialC<{
    identityId: typeof Units_c404_.IdentityId;
    honorifics: t.StringC;
    firstName: typeof Common_ffba_.PersonalName;
    lastName: typeof Common_ffba_.PersonalName;
    firstNameLocalized: typeof Common_ffba_.PersonalName;
    lastNameLocalized: typeof Common_ffba_.PersonalName;
    sex: t.StringC;
    phone: typeof Common_ffba_.Phone;
    email: typeof Common_ffba_.Email;
    address: typeof Address_2d0a_.Address;
    city: typeof Address_2d0a_.City;
    state: typeof Address_2d0a_.State;
    country: typeof Address_2d0a_.Country;
    zipCode: typeof Address_2d0a_.ZipCode;
    locale: typeof I18n_b70d_.Locale;
    appInstanceId: typeof Common_ffba_.AppInstanceId;
    opaqueId: typeof Common_ffba_.OpaqueId;
    opaqueIdShort: typeof Common_ffba_.OpaqueIdShort;
    clientId: typeof Common_ffba_.ClientId;
    dob: t.UnionC<[t.BooleanC, typeof Units_c404_.IsoDate]>;
    ssid: t.UnionC<[t.BooleanC, typeof Common_ffba_.Ssid]>;
    'ssid-fi': t.UnionC<[t.BooleanC, typeof Common_ffba_.SsidFI]>;
    documents: t.ArrayC<typeof PersonalDocument_9750_.PersonalDocument>;
    balances: t.RecordC<
      t.StringC,
      t.UnionC<
        [
          t.IntersectionC<
            [
              t.IntersectionC<
                [
                  t.PartialC<{
                    currency: t.UnionC<
                      [typeof Units_c404_.Currency, typeof Common_ffba_.MetaCurrencyWMP]
                    >;
                    amount: t.NumberC;
                  }>,
                  t.RecordC<t.StringC, t.UnknownC>,
                ]
              >,
              t.TypeC<{
                currency: typeof Defined;
                amount: typeof Defined;
              }>,
            ]
          >,
          t.IntersectionC<
            [
              t.IntersectionC<
                [
                  t.PartialC<{
                    currency: t.UnionC<
                      [typeof Common_ffba_.MetaCurrencyTOKEN, typeof Fare_a3ab_.TokenId]
                    >;
                    tokenId: typeof Fare_a3ab_.TokenId;
                    amount: t.UnionC<[t.NumberC, typeof Null]>;
                  }>,
                  t.RecordC<t.StringC, t.UnknownC>,
                ]
              >,
              t.TypeC<{
                currency: typeof Defined;
                tokenId: typeof Defined;
                amount: typeof Defined;
              }>,
            ]
          >,
        ]
      >
    >;
    referral: t.IntersectionC<
      [
        t.PartialC<{
          code: t.StringC;
        }>,
        t.RecordC<t.StringC, t.UnknownC>,
      ]
    >;
    subscriberType: t.StringC;
    authToken: typeof Common_ffba_.EncodedQueryParam;
    cugHome: t.StringC;
  }>,
  CustomerBrand
>;
export const Customer: CustomerC = t.brand(
  t.partial({
    identityId: Units_c404_.IdentityId,
    honorifics: t.string,
    firstName: Common_ffba_.PersonalName,
    lastName: Common_ffba_.PersonalName,
    firstNameLocalized: Common_ffba_.PersonalName,
    lastNameLocalized: Common_ffba_.PersonalName,
    sex: t.string,
    phone: Common_ffba_.Phone,
    email: Common_ffba_.Email,
    address: Address_2d0a_.Address,
    city: Address_2d0a_.City,
    state: Address_2d0a_.State,
    country: Address_2d0a_.Country,
    zipCode: Address_2d0a_.ZipCode,
    locale: I18n_b70d_.Locale,
    appInstanceId: Common_ffba_.AppInstanceId,
    opaqueId: Common_ffba_.OpaqueId,
    opaqueIdShort: Common_ffba_.OpaqueIdShort,
    clientId: Common_ffba_.ClientId,
    dob: t.union([t.boolean, Units_c404_.IsoDate]),
    ssid: t.union([t.boolean, Common_ffba_.Ssid]),
    'ssid-fi': t.union([t.boolean, Common_ffba_.SsidFI]),
    documents: t.array(PersonalDocument_9750_.PersonalDocument),
    balances: t.record(
      t.string,
      t.union([
        t.intersection([
          t.intersection([
            t.partial({
              currency: t.union([Units_c404_.Currency, Common_ffba_.MetaCurrencyWMP]),
              amount: t.number,
            }),
            t.record(t.string, t.unknown),
          ]),
          t.type({
            currency: Defined,
            amount: Defined,
          }),
        ]),
        t.intersection([
          t.intersection([
            t.partial({
              currency: t.union([Common_ffba_.MetaCurrencyTOKEN, Fare_a3ab_.TokenId]),
              tokenId: Fare_a3ab_.TokenId,
              amount: t.union([t.number, Null]),
            }),
            t.record(t.string, t.unknown),
          ]),
          t.type({
            currency: Defined,
            tokenId: Defined,
            amount: Defined,
          }),
        ]),
      ]),
    ),
    referral: t.intersection([
      t.partial({
        code: t.string,
      }),
      t.record(t.string, t.unknown),
    ]),
    subscriberType: t.string,
    authToken: Common_ffba_.EncodedQueryParam,
    cugHome: t.string,
  }),
  (
    x,
  ): x is t.Branded<
    {
      identityId?: Units_c404_.IdentityId;
      honorifics?: string;
      firstName?: Common_ffba_.PersonalName;
      lastName?: Common_ffba_.PersonalName;
      firstNameLocalized?: Common_ffba_.PersonalName;
      lastNameLocalized?: Common_ffba_.PersonalName;
      sex?: string;
      phone?: Common_ffba_.Phone;
      email?: Common_ffba_.Email;
      address?: Address_2d0a_.Address;
      city?: Address_2d0a_.City;
      state?: Address_2d0a_.State;
      country?: Address_2d0a_.Country;
      zipCode?: Address_2d0a_.ZipCode;
      locale?: I18n_b70d_.Locale;
      appInstanceId?: Common_ffba_.AppInstanceId;
      opaqueId?: Common_ffba_.OpaqueId;
      opaqueIdShort?: Common_ffba_.OpaqueIdShort;
      clientId?: Common_ffba_.ClientId;
      dob?: boolean | Units_c404_.IsoDate;
      ssid?: boolean | Common_ffba_.Ssid;
      'ssid-fi'?: boolean | Common_ffba_.SsidFI;
      documents?: Array<PersonalDocument_9750_.PersonalDocument>;
      balances?: Record<
        string,
        | (({
            currency?: Units_c404_.Currency | Common_ffba_.MetaCurrencyWMP;
            amount?: number;
          } & Record<string, unknown>) & {
            currency: Defined;
            amount: Defined;
          })
        | (({
            currency?: Common_ffba_.MetaCurrencyTOKEN | Fare_a3ab_.TokenId;
            tokenId?: Fare_a3ab_.TokenId;
            amount?: number | Null;
          } & Record<string, unknown>) & {
            currency: Defined;
            tokenId: Defined;
            amount: Defined;
          })
      >;
      referral?: {
        code?: string;
      } & Record<string, unknown>;
      subscriberType?: string;
      authToken?: Common_ffba_.EncodedQueryParam;
      cugHome?: string;
    },
    CustomerBrand
  > => true,
  'Customer',
);
export type CustomerBrand = {
  readonly Customer: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Customer)).decodeSync(examplesCustomer) // => examplesCustomer */
export const examplesCustomer: NonEmptyArray<Customer> = [
  {
    identityId: 'eu-west-1:4828507e-683f-41bf-9d87-689808fbf958',
    id: 1234,
    favoriteLocations: [],
    phone: '+358407654321',
    email: 'bob.customer@example.com',
    honorifics: 'mr',
    sex: 'male',
    firstName: 'Bob',
    lastName: 'Customer',
    created: 1553687004207,
    modified: 1553688004207,
    paymentMethod: { type: 'unknown', valid: false },
    subscriptionInstance: {
      id: 10,
      name: 'Whim to Go',
      plan: { id: 'fi-whim-payg_v2' },
      addons: { '0': 'eur-whim-rollover-100_v1', '1': 'fi-whim-car' },
      region: {
        id: 'fi-helsinki',
        name: 'Helsinki Region',
        active: true,
        hidden: false,
        created: '2019-03-27T14:00:00.12345+00:00',
        zipCode: '00100',
        currency: 'EUR',
        location: { lat: 60.1699, lon: 24.9384 },
        geometryId: 2,
        countryCode: 'FI',
        countryDefault: true,
      },
      coupons: [],
      topUpId: 'fi-whim-top-up',
      wmpGrant: 0,
      pointCost: 0.01,
      description: 'Pay for each trip as you go',
    },
    balances: {
      WMP: { currency: 'WMP', amount: 1234, type: 'charge' },
      EUR: { currency: 'EUR', amount: 100, type: 'charge' },
      'cx-test-token_v2': {
        currency: 'TOKEN',
        tokenId: 'cx-test-token_v2',
        amount: 1,
        type: 'charge',
      },
      'cx-test-token_v3': {
        currency: 'cx-test-token_v3',
        tokenId: 'cx-test-token_v3',
        amount: 1,
        type: 'charge',
      },
    },
    referral: { code: 'XXXX-XXXX-XXXX-XXXX' },
    regionId: 'fi-helsinki',
    region: {
      id: 'fi-helsinki',
      name: 'Helsinki Region',
      countryCode: 'FI',
      countryDefault: true,
      zipCode: '00100',
      location: { lat: 60.1699, lon: 24.9384 },
      active: true,
      hidden: false,
      geometryId: 2,
      created: 1553687004207,
      modified: 0,
      currency: 'EUR',
    },
  },
  {
    balances: {
      WMP: { currency: 'WMP', amount: 10 },
      'cx-token-test-foo-bar_v2': {
        currency: 'TOKEN',
        tokenId: 'cx-token-test-foo-bar_v2',
        amount: 1,
      },
    },
  },
] as unknown as NonEmptyArray<Customer>;

export default Customer;

// Success

import "jest"
const __expect: jest.Expect = expect

    describe("examplesCustomer", () => {
      it("examplesCustomer", () => {
        __expect(require("io-ts-validator").validator(nonEmptyArray(Customer)).decodeSync(examplesCustomer)).toEqual(examplesCustomer)})
    })
  