/*

undefined
MaaS user profiles as returned by our API

!!! AUTO GENERATED BY IOTSFJS REFRAIN FROM MANUAL EDITING !!!
See https://www.npmjs.com/package/io-ts-from-json-schema

*/

import * as t from 'io-ts';

import * as Address_2d0a_ from './components/address';
import * as Common_ffba_ from './components/common';
import * as Fare_a3ab_ from './components/fare';
import * as Place_de2d_ from './components/place';
import * as PointCost_5d0d_ from './components/point-cost';
import * as Units_c404_ from './components/units';
import * as Region_ad49_ from './region';

export type Defined = {} | null;
export class DefinedType extends t.Type<Defined> {
  readonly _tag: 'DefinedType' = 'DefinedType';
  constructor() {
    super(
      'defined',
      (u): u is Defined => typeof u !== 'undefined',
      (u, c) => (this.is(u) ? t.success(u) : t.failure(u, c)),
      t.identity,
    );
  }
}
export type DefinedC = {} & DefinedType;
export const Defined: DefinedC = new DefinedType();

export const schemaId = 'https://schemas.maas.global/core/profile.json';

// BookingOptionsReference
// The purpose of this remains a mystery
export type BookingOptionsReference = t.Branded<number, BookingOptionsReferenceBrand>;
export type BookingOptionsReferenceC = t.BrandC<t.NumberC, BookingOptionsReferenceBrand>;
export const BookingOptionsReference: BookingOptionsReferenceC = t.brand(
  t.number,
  (x): x is t.Branded<number, BookingOptionsReferenceBrand> => Number.isInteger(x),
  'BookingOptionsReference',
);
export type BookingOptionsReferenceBrand = {
  readonly BookingOptionsReference: unique symbol;
};
/** require('io-ts-validator').validator(BookingOptionsReference).decodeSync(minimumBookingOptionsReference) // => minimumBookingOptionsReference */
export const minimumBookingOptionsReference: BookingOptionsReference =
  0 as unknown as BookingOptionsReference;

// SubscriptionInstance
// The purpose of this remains a mystery
export type SubscriptionInstance = t.Branded<
  ({
    id?: BookingOptionsReference | Units_c404_.IdentityId;
    name?: string;
    plan?: {
      id?: string;
    } & {
      id: Defined;
    };
    addons?: Array<string>;
    coupons?: Array<string>;
    wmpGrant?: number;
    creditGrant?: number;
    creditCurrency?: Units_c404_.Currency;
    level?: number;
    active?: boolean;
    pointCost?: PointCost_5d0d_.PointCost;
    description?: string;
    availability?: number;
  } & Record<string, unknown>) & {
    plan: Defined;
    addons: Defined;
    coupons: Defined;
    pointCost: Defined;
  },
  SubscriptionInstanceBrand
>;
export type SubscriptionInstanceC = t.BrandC<
  t.IntersectionC<
    [
      t.IntersectionC<
        [
          t.PartialC<{
            id: t.UnionC<[typeof BookingOptionsReference, typeof Units_c404_.IdentityId]>;
            name: t.StringC;
            plan: t.IntersectionC<
              [
                t.PartialC<{
                  id: t.StringC;
                }>,
                t.TypeC<{
                  id: typeof Defined;
                }>,
              ]
            >;
            addons: t.ArrayC<t.StringC>;
            coupons: t.ArrayC<t.StringC>;
            wmpGrant: t.NumberC;
            creditGrant: t.NumberC;
            creditCurrency: typeof Units_c404_.Currency;
            level: t.NumberC;
            active: t.BooleanC;
            pointCost: typeof PointCost_5d0d_.PointCost;
            description: t.StringC;
            availability: t.NumberC;
          }>,
          t.RecordC<t.StringC, t.UnknownC>,
        ]
      >,
      t.TypeC<{
        plan: typeof Defined;
        addons: typeof Defined;
        coupons: typeof Defined;
        pointCost: typeof Defined;
      }>,
    ]
  >,
  SubscriptionInstanceBrand
>;
export const SubscriptionInstance: SubscriptionInstanceC = t.brand(
  t.intersection([
    t.intersection([
      t.partial({
        id: t.union([BookingOptionsReference, Units_c404_.IdentityId]),
        name: t.string,
        plan: t.intersection([
          t.partial({
            id: t.string,
          }),
          t.type({
            id: Defined,
          }),
        ]),
        addons: t.array(t.string),
        coupons: t.array(t.string),
        wmpGrant: t.number,
        creditGrant: t.number,
        creditCurrency: Units_c404_.Currency,
        level: t.number,
        active: t.boolean,
        pointCost: PointCost_5d0d_.PointCost,
        description: t.string,
        availability: t.number,
      }),
      t.record(t.string, t.unknown),
    ]),
    t.type({
      plan: Defined,
      addons: Defined,
      coupons: Defined,
      pointCost: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    ({
      id?: BookingOptionsReference | Units_c404_.IdentityId;
      name?: string;
      plan?: {
        id?: string;
      } & {
        id: Defined;
      };
      addons?: Array<string>;
      coupons?: Array<string>;
      wmpGrant?: number;
      creditGrant?: number;
      creditCurrency?: Units_c404_.Currency;
      level?: number;
      active?: boolean;
      pointCost?: PointCost_5d0d_.PointCost;
      description?: string;
      availability?: number;
    } & Record<string, unknown>) & {
      plan: Defined;
      addons: Defined;
      coupons: Defined;
      pointCost: Defined;
    },
    SubscriptionInstanceBrand
  > => true,
  'SubscriptionInstance',
);
export type SubscriptionInstanceBrand = {
  readonly SubscriptionInstance: unique symbol;
};

// Profile
// The default export. More information at the top.
export type Profile = t.Branded<
  {
    id?: number;
    identityId?: Units_c404_.IdentityId;
    phone?: Common_ffba_.Phone;
    email?: Common_ffba_.Email;
    firstName?: Common_ffba_.PersonalName;
    lastName?: Common_ffba_.PersonalName;
    city?: Address_2d0a_.City;
    country?: Address_2d0a_.Country;
    zipCode?: Address_2d0a_.ZipCode;
    regionId?: string;
    region?: Region_ad49_.Region;
    profileImageUrl?: string;
    favoriteLocations?: Array<Place_de2d_.Place>;
    paymentMethod?: ({
      type?: string & ('unknown' | 'card' | 'stripe');
      valid?: boolean;
      maskedNumber?: string;
      network?: string;
      issuer?: string;
      expiry?: Units_c404_.Time;
    } & Record<string, unknown>) & {
      type: Defined;
      valid: Defined;
    };
    subscription?: Record<string, unknown> & Record<string, unknown>;
    subscriptionInstance?: SubscriptionInstance;
    balances?: Array<Fare_a3ab_.Fare>;
    created?: Units_c404_.Time;
    modified?: Units_c404_.Time;
  } & {
    identityId: Defined;
    phone: Defined;
    favoriteLocations: Defined;
    paymentMethod: Defined;
    subscriptionInstance: Defined;
    balances: Defined;
  },
  ProfileBrand
>;
export type ProfileC = t.BrandC<
  t.IntersectionC<
    [
      t.PartialC<{
        id: t.NumberC;
        identityId: typeof Units_c404_.IdentityId;
        phone: typeof Common_ffba_.Phone;
        email: typeof Common_ffba_.Email;
        firstName: typeof Common_ffba_.PersonalName;
        lastName: typeof Common_ffba_.PersonalName;
        city: typeof Address_2d0a_.City;
        country: typeof Address_2d0a_.Country;
        zipCode: typeof Address_2d0a_.ZipCode;
        regionId: t.StringC;
        region: typeof Region_ad49_.Region;
        profileImageUrl: t.StringC;
        favoriteLocations: t.ArrayC<typeof Place_de2d_.Place>;
        paymentMethod: t.IntersectionC<
          [
            t.IntersectionC<
              [
                t.PartialC<{
                  type: t.IntersectionC<
                    [
                      t.StringC,
                      t.UnionC<
                        [t.LiteralC<'unknown'>, t.LiteralC<'card'>, t.LiteralC<'stripe'>]
                      >,
                    ]
                  >;
                  valid: t.BooleanC;
                  maskedNumber: t.StringC;
                  network: t.StringC;
                  issuer: t.StringC;
                  expiry: typeof Units_c404_.Time;
                }>,
                t.RecordC<t.StringC, t.UnknownC>,
              ]
            >,
            t.TypeC<{
              type: typeof Defined;
              valid: typeof Defined;
            }>,
          ]
        >;
        subscription: t.IntersectionC<
          [t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]
        >;
        subscriptionInstance: typeof SubscriptionInstance;
        balances: t.ArrayC<typeof Fare_a3ab_.Fare>;
        created: typeof Units_c404_.Time;
        modified: typeof Units_c404_.Time;
      }>,
      t.TypeC<{
        identityId: typeof Defined;
        phone: typeof Defined;
        favoriteLocations: typeof Defined;
        paymentMethod: typeof Defined;
        subscriptionInstance: typeof Defined;
        balances: typeof Defined;
      }>,
    ]
  >,
  ProfileBrand
>;
export const Profile: ProfileC = t.brand(
  t.intersection([
    t.partial({
      id: t.number,
      identityId: Units_c404_.IdentityId,
      phone: Common_ffba_.Phone,
      email: Common_ffba_.Email,
      firstName: Common_ffba_.PersonalName,
      lastName: Common_ffba_.PersonalName,
      city: Address_2d0a_.City,
      country: Address_2d0a_.Country,
      zipCode: Address_2d0a_.ZipCode,
      regionId: t.string,
      region: Region_ad49_.Region,
      profileImageUrl: t.string,
      favoriteLocations: t.array(Place_de2d_.Place),
      paymentMethod: t.intersection([
        t.intersection([
          t.partial({
            type: t.intersection([
              t.string,
              t.union([t.literal('unknown'), t.literal('card'), t.literal('stripe')]),
            ]),
            valid: t.boolean,
            maskedNumber: t.string,
            network: t.string,
            issuer: t.string,
            expiry: Units_c404_.Time,
          }),
          t.record(t.string, t.unknown),
        ]),
        t.type({
          type: Defined,
          valid: Defined,
        }),
      ]),
      subscription: t.intersection([t.UnknownRecord, t.record(t.string, t.unknown)]),
      subscriptionInstance: SubscriptionInstance,
      balances: t.array(Fare_a3ab_.Fare),
      created: Units_c404_.Time,
      modified: Units_c404_.Time,
    }),
    t.type({
      identityId: Defined,
      phone: Defined,
      favoriteLocations: Defined,
      paymentMethod: Defined,
      subscriptionInstance: Defined,
      balances: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    {
      id?: number;
      identityId?: Units_c404_.IdentityId;
      phone?: Common_ffba_.Phone;
      email?: Common_ffba_.Email;
      firstName?: Common_ffba_.PersonalName;
      lastName?: Common_ffba_.PersonalName;
      city?: Address_2d0a_.City;
      country?: Address_2d0a_.Country;
      zipCode?: Address_2d0a_.ZipCode;
      regionId?: string;
      region?: Region_ad49_.Region;
      profileImageUrl?: string;
      favoriteLocations?: Array<Place_de2d_.Place>;
      paymentMethod?: ({
        type?: string & ('unknown' | 'card' | 'stripe');
        valid?: boolean;
        maskedNumber?: string;
        network?: string;
        issuer?: string;
        expiry?: Units_c404_.Time;
      } & Record<string, unknown>) & {
        type: Defined;
        valid: Defined;
      };
      subscription?: Record<string, unknown> & Record<string, unknown>;
      subscriptionInstance?: SubscriptionInstance;
      balances?: Array<Fare_a3ab_.Fare>;
      created?: Units_c404_.Time;
      modified?: Units_c404_.Time;
    } & {
      identityId: Defined;
      phone: Defined;
      favoriteLocations: Defined;
      paymentMethod: Defined;
      subscriptionInstance: Defined;
      balances: Defined;
    },
    ProfileBrand
  > => true,
  'Profile',
);
export type ProfileBrand = {
  readonly Profile: unique symbol;
};

export default Profile;

// Success

import "jest"
const __expect: jest.Expect = expect

    describe("minimumBookingOptionsReference", () => {
      it("minimumBookingOptionsReference", () => {
        __expect(require("io-ts-validator").validator(BookingOptionsReference).decodeSync(minimumBookingOptionsReference)).toEqual(minimumBookingOptionsReference)})
    })
  