/*

undefined
Experimental synopsis that combines an environment with related information

!!! AUTO GENERATED BY IOTSFJS REFRAIN FROM MANUAL EDITING !!!
See https://www.npmjs.com/package/io-ts-from-json-schema

*/

import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import { nonEmptyArray } from 'io-ts-types/lib/nonEmptyArray';

import * as Accounts_8a1b_ from './accounts';
import * as Environments_71b9_ from './environments';

export type Defined = {} | null;
export class DefinedType extends t.Type<Defined> {
  readonly _tag: 'DefinedType' = 'DefinedType';
  constructor() {
    super(
      'defined',
      (u): u is Defined => typeof u !== 'undefined',
      (u, c) => (this.is(u) ? t.success(u) : t.failure(u, c)),
      t.identity,
    );
  }
}
export type DefinedC = {} & DefinedType;
export const Defined: DefinedC = new DefinedType();

export type NullBrand = {
  readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export const Null: NullC = t.brand(
  t.unknown,
  (n): n is t.Branded<unknown, NullBrand> => n === null,
  'Null',
);
export type Null = t.TypeOf<typeof Null>;

export const schemaId = 'https://schemas.maas.global/environments/synopsis.json';

// GroupMeta
// The purpose of this remains a mystery
export type GroupMeta = t.Branded<
  {
    name?: Environments_71b9_.EnvironmentGroupName;
    description?: Environments_71b9_.EnvironmentGroupDescription;
  } & {
    name: Defined;
  },
  GroupMetaBrand
>;
export type GroupMetaC = t.BrandC<
  t.IntersectionC<
    [
      t.PartialC<{
        name: typeof Environments_71b9_.EnvironmentGroupName;
        description: typeof Environments_71b9_.EnvironmentGroupDescription;
      }>,
      t.TypeC<{
        name: typeof Defined;
      }>,
    ]
  >,
  GroupMetaBrand
>;
export const GroupMeta: GroupMetaC = t.brand(
  t.intersection([
    t.partial({
      name: Environments_71b9_.EnvironmentGroupName,
      description: Environments_71b9_.EnvironmentGroupDescription,
    }),
    t.type({
      name: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    {
      name?: Environments_71b9_.EnvironmentGroupName;
      description?: Environments_71b9_.EnvironmentGroupDescription;
    } & {
      name: Defined;
    },
    GroupMetaBrand
  > => true,
  'GroupMeta',
);
export type GroupMetaBrand = {
  readonly GroupMeta: unique symbol;
};

// UnknownAccount
// The environment configuration file is missing the account information
export type UnknownAccount = t.Branded<Null, UnknownAccountBrand>;
export type UnknownAccountC = t.BrandC<typeof Null, UnknownAccountBrand>;
export const UnknownAccount: UnknownAccountC = t.brand(
  Null,
  (x): x is t.Branded<Null, UnknownAccountBrand> => true,
  'UnknownAccount',
);
export type UnknownAccountBrand = {
  readonly UnknownAccount: unique symbol;
};
/** require('io-ts-validator').validator(UnknownAccount).decodeSync(defaultUnknownAccount) // => defaultUnknownAccount */
export const defaultUnknownAccount: UnknownAccount = null as unknown as UnknownAccount;

// Synopsis
// The default export. More information at the top.
export type Synopsis = t.Branded<
  {
    environment?: Environments_71b9_.Environment;
    group?: GroupMeta;
    account?: UnknownAccount | Accounts_8a1b_.Account;
  } & {
    environment: Defined;
    group: Defined;
    account: Defined;
  },
  SynopsisBrand
>;
export type SynopsisC = t.BrandC<
  t.IntersectionC<
    [
      t.PartialC<{
        environment: typeof Environments_71b9_.Environment;
        group: typeof GroupMeta;
        account: t.UnionC<[typeof UnknownAccount, typeof Accounts_8a1b_.Account]>;
      }>,
      t.TypeC<{
        environment: typeof Defined;
        group: typeof Defined;
        account: typeof Defined;
      }>,
    ]
  >,
  SynopsisBrand
>;
export const Synopsis: SynopsisC = t.brand(
  t.intersection([
    t.partial({
      environment: Environments_71b9_.Environment,
      group: GroupMeta,
      account: t.union([UnknownAccount, Accounts_8a1b_.Account]),
    }),
    t.type({
      environment: Defined,
      group: Defined,
      account: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    {
      environment?: Environments_71b9_.Environment;
      group?: GroupMeta;
      account?: UnknownAccount | Accounts_8a1b_.Account;
    } & {
      environment: Defined;
      group: Defined;
      account: Defined;
    },
    SynopsisBrand
  > => true,
  'Synopsis',
);
export type SynopsisBrand = {
  readonly Synopsis: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Synopsis)).decodeSync(examplesSynopsis) // => examplesSynopsis */
export const examplesSynopsis: NonEmptyArray<Synopsis> = [
  {
    environment: {
      id: 'production',
      live: true,
      account: 'production',
      description: 'Production environment',
    },
    group: { name: 'Core Environments' },
    account: {
      id: '001234567890',
      name: 'Example Account',
      description: 'This account is but an example account',
    },
  },
  {
    environment: {
      id: 'testing',
      live: false,
      account: 'testing',
      description: 'Testing environment',
    },
    group: { name: 'Core Environments' },
    account: { id: '101234567890' },
  },
  {
    environment: {
      id: 'fantasy-topping',
      live: false,
      account: 'testing',
      name: 'Fantasy Topping',
      description: 'Add support for pizza customization',
    },
    group: { name: 'Development Environments' },
    account: { id: '101234567890' },
  },
] as unknown as NonEmptyArray<Synopsis>;

export default Synopsis;

// Success
