/*

undefined
Request schema for webhook verification decision

!!! AUTO GENERATED BY IOTSFJS REFRAIN FROM MANUAL EDITING !!!
See https://www.npmjs.com/package/io-ts-from-json-schema

*/

import * as t from 'io-ts';

import * as Address_2d0a_ from '../../../../../core/components/address';
import * as Common_ffba_ from '../../../../../core/components/common';
import * as Units_c404_ from '../../../../../core/components/units';
import * as PersonalDocument_9750_ from '../../../../../core/personal-document';

export type NullBrand = {
  readonly Null: unique symbol;
};
export type NullC = t.BrandC<t.UnknownC, NullBrand>;
export const Null: NullC = t.brand(
  t.unknown,
  (n): n is t.Branded<unknown, NullBrand> => n === null,
  'Null',
);
export type Null = t.TypeOf<typeof Null>;

export type Defined = {} | null;
export class DefinedType extends t.Type<Defined> {
  readonly _tag: 'DefinedType' = 'DefinedType';
  constructor() {
    super(
      'defined',
      (u): u is Defined => typeof u !== 'undefined',
      (u, c) => (this.is(u) ? t.success(u) : t.failure(u, c)),
      t.identity,
    );
  }
}
export type DefinedC = {} & DefinedType;
export const Defined: DefinedC = new DefinedType();

export const schemaId =
  'https://schemas.maas.global/maas-backend/customers/verification/webhooks/decision/request.json';

// Request
// The default export. More information at the top.
export type Request = t.Branded<
  {
    payload?: ({
      status?: string & ('fail' | 'success');
      verification?: ({
        id?: Units_c404_.Uuid;
        code?: number & (9001 | 9102 | 9103 | 9104 | 9121);
        person?: {
          firstName?: Common_ffba_.PersonalName | Null;
          lastName?: Common_ffba_.PersonalName | Null;
        } & Record<string, unknown>;
        document?: {
          number?: string | Null;
          type?: PersonalDocument_9750_.DocumentType;
          country?: Address_2d0a_.Country;
          validFrom?: Units_c404_.IsoDate | Null;
          validUntil?: Units_c404_.IsoDate | Null;
        } & Record<string, unknown>;
        reason?: string;
        reasonCode?: number | Null;
        status?: string;
        additionalVerifiedData?: Record<string, unknown> & Record<string, unknown>;
        vendorData?: string;
        decisionTime?: string;
        acceptanceTime?: string;
      } & Record<string, unknown>) & {
        id: Defined;
        status: Defined;
        code: Defined;
        person: Defined;
        document: Defined;
      };
    } & Record<string, unknown>) & {
      status: Defined;
      verification: Defined;
    };
    headers?: ({
      'x-signature'?: string;
      'x-auth-client'?: Units_c404_.Uuid;
    } & Record<string, unknown>) & {
      'x-signature': Defined;
      'x-auth-client': Defined;
    };
    technicalData?: {
      ip?: string;
    } & Record<string, unknown>;
    rawPayload?: string;
  } & {
    headers: Defined;
    payload: Defined;
  },
  RequestBrand
>;
export type RequestC = t.BrandC<
  t.IntersectionC<
    [
      t.PartialC<{
        payload: t.IntersectionC<
          [
            t.IntersectionC<
              [
                t.PartialC<{
                  status: t.IntersectionC<
                    [t.StringC, t.UnionC<[t.LiteralC<'fail'>, t.LiteralC<'success'>]>]
                  >;
                  verification: t.IntersectionC<
                    [
                      t.IntersectionC<
                        [
                          t.PartialC<{
                            id: typeof Units_c404_.Uuid;
                            code: t.IntersectionC<
                              [
                                t.NumberC,
                                t.UnionC<
                                  [
                                    t.LiteralC<9001>,
                                    t.LiteralC<9102>,
                                    t.LiteralC<9103>,
                                    t.LiteralC<9104>,
                                    t.LiteralC<9121>,
                                  ]
                                >,
                              ]
                            >;
                            person: t.IntersectionC<
                              [
                                t.PartialC<{
                                  firstName: t.UnionC<
                                    [typeof Common_ffba_.PersonalName, typeof Null]
                                  >;
                                  lastName: t.UnionC<
                                    [typeof Common_ffba_.PersonalName, typeof Null]
                                  >;
                                }>,
                                t.RecordC<t.StringC, t.UnknownC>,
                              ]
                            >;
                            document: t.IntersectionC<
                              [
                                t.PartialC<{
                                  number: t.UnionC<[t.StringC, typeof Null]>;
                                  type: typeof PersonalDocument_9750_.DocumentType;
                                  country: typeof Address_2d0a_.Country;
                                  validFrom: t.UnionC<
                                    [typeof Units_c404_.IsoDate, typeof Null]
                                  >;
                                  validUntil: t.UnionC<
                                    [typeof Units_c404_.IsoDate, typeof Null]
                                  >;
                                }>,
                                t.RecordC<t.StringC, t.UnknownC>,
                              ]
                            >;
                            reason: t.StringC;
                            reasonCode: t.UnionC<[t.NumberC, typeof Null]>;
                            status: t.StringC;
                            additionalVerifiedData: t.IntersectionC<
                              [t.UnknownRecordC, t.RecordC<t.StringC, t.UnknownC>]
                            >;
                            vendorData: t.StringC;
                            decisionTime: t.StringC;
                            acceptanceTime: t.StringC;
                          }>,
                          t.RecordC<t.StringC, t.UnknownC>,
                        ]
                      >,
                      t.TypeC<{
                        id: typeof Defined;
                        status: typeof Defined;
                        code: typeof Defined;
                        person: typeof Defined;
                        document: typeof Defined;
                      }>,
                    ]
                  >;
                }>,
                t.RecordC<t.StringC, t.UnknownC>,
              ]
            >,
            t.TypeC<{
              status: typeof Defined;
              verification: typeof Defined;
            }>,
          ]
        >;
        headers: t.IntersectionC<
          [
            t.IntersectionC<
              [
                t.PartialC<{
                  'x-signature': t.StringC;
                  'x-auth-client': typeof Units_c404_.Uuid;
                }>,
                t.RecordC<t.StringC, t.UnknownC>,
              ]
            >,
            t.TypeC<{
              'x-signature': typeof Defined;
              'x-auth-client': typeof Defined;
            }>,
          ]
        >;
        technicalData: t.IntersectionC<
          [
            t.PartialC<{
              ip: t.StringC;
            }>,
            t.RecordC<t.StringC, t.UnknownC>,
          ]
        >;
        rawPayload: t.StringC;
      }>,
      t.TypeC<{
        headers: typeof Defined;
        payload: typeof Defined;
      }>,
    ]
  >,
  RequestBrand
>;
export const Request: RequestC = t.brand(
  t.intersection([
    t.partial({
      payload: t.intersection([
        t.intersection([
          t.partial({
            status: t.intersection([
              t.string,
              t.union([t.literal('fail'), t.literal('success')]),
            ]),
            verification: t.intersection([
              t.intersection([
                t.partial({
                  id: Units_c404_.Uuid,
                  code: t.intersection([
                    t.number,
                    t.union([
                      t.literal(9001),
                      t.literal(9102),
                      t.literal(9103),
                      t.literal(9104),
                      t.literal(9121),
                    ]),
                  ]),
                  person: t.intersection([
                    t.partial({
                      firstName: t.union([Common_ffba_.PersonalName, Null]),
                      lastName: t.union([Common_ffba_.PersonalName, Null]),
                    }),
                    t.record(t.string, t.unknown),
                  ]),
                  document: t.intersection([
                    t.partial({
                      number: t.union([t.string, Null]),
                      type: PersonalDocument_9750_.DocumentType,
                      country: Address_2d0a_.Country,
                      validFrom: t.union([Units_c404_.IsoDate, Null]),
                      validUntil: t.union([Units_c404_.IsoDate, Null]),
                    }),
                    t.record(t.string, t.unknown),
                  ]),
                  reason: t.string,
                  reasonCode: t.union([t.number, Null]),
                  status: t.string,
                  additionalVerifiedData: t.intersection([
                    t.UnknownRecord,
                    t.record(t.string, t.unknown),
                  ]),
                  vendorData: t.string,
                  decisionTime: t.string,
                  acceptanceTime: t.string,
                }),
                t.record(t.string, t.unknown),
              ]),
              t.type({
                id: Defined,
                status: Defined,
                code: Defined,
                person: Defined,
                document: Defined,
              }),
            ]),
          }),
          t.record(t.string, t.unknown),
        ]),
        t.type({
          status: Defined,
          verification: Defined,
        }),
      ]),
      headers: t.intersection([
        t.intersection([
          t.partial({
            'x-signature': t.string,
            'x-auth-client': Units_c404_.Uuid,
          }),
          t.record(t.string, t.unknown),
        ]),
        t.type({
          'x-signature': Defined,
          'x-auth-client': Defined,
        }),
      ]),
      technicalData: t.intersection([
        t.partial({
          ip: t.string,
        }),
        t.record(t.string, t.unknown),
      ]),
      rawPayload: t.string,
    }),
    t.type({
      headers: Defined,
      payload: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    {
      payload?: ({
        status?: string & ('fail' | 'success');
        verification?: ({
          id?: Units_c404_.Uuid;
          code?: number & (9001 | 9102 | 9103 | 9104 | 9121);
          person?: {
            firstName?: Common_ffba_.PersonalName | Null;
            lastName?: Common_ffba_.PersonalName | Null;
          } & Record<string, unknown>;
          document?: {
            number?: string | Null;
            type?: PersonalDocument_9750_.DocumentType;
            country?: Address_2d0a_.Country;
            validFrom?: Units_c404_.IsoDate | Null;
            validUntil?: Units_c404_.IsoDate | Null;
          } & Record<string, unknown>;
          reason?: string;
          reasonCode?: number | Null;
          status?: string;
          additionalVerifiedData?: Record<string, unknown> & Record<string, unknown>;
          vendorData?: string;
          decisionTime?: string;
          acceptanceTime?: string;
        } & Record<string, unknown>) & {
          id: Defined;
          status: Defined;
          code: Defined;
          person: Defined;
          document: Defined;
        };
      } & Record<string, unknown>) & {
        status: Defined;
        verification: Defined;
      };
      headers?: ({
        'x-signature'?: string;
        'x-auth-client'?: Units_c404_.Uuid;
      } & Record<string, unknown>) & {
        'x-signature': Defined;
        'x-auth-client': Defined;
      };
      technicalData?: {
        ip?: string;
      } & Record<string, unknown>;
      rawPayload?: string;
    } & {
      headers: Defined;
      payload: Defined;
    },
    RequestBrand
  > => true,
  'Request',
);
export type RequestBrand = {
  readonly Request: unique symbol;
};

export default Request;

// Success
