/*

undefined
MaaS subscription schema

!!! AUTO GENERATED BY IOTSFJS REFRAIN FROM MANUAL EDITING !!!
See https://www.npmjs.com/package/io-ts-from-json-schema

*/

import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import { nonEmptyArray } from 'io-ts-types/lib/nonEmptyArray';

import * as Cost_250f_ from '../../core/components/cost';
import * as PointCost_5d0d_ from '../../core/components/point-cost';
import * as SubscriptionChangeState_e96c_ from '../../core/components/subscriptionChangeState';
import * as Units_c404_ from '../../core/components/units';
import * as Region_ad49_ from '../../core/region';
import * as Contact_56e9_ from './contact';
import * as SubscriptionAddress_8e26_ from './subscriptionAddress';

export type Defined = {} | null;
export class DefinedType extends t.Type<Defined> {
  readonly _tag: 'DefinedType' = 'DefinedType';
  constructor() {
    super(
      'defined',
      (u): u is Defined => typeof u !== 'undefined',
      (u, c) => (this.is(u) ? t.success(u) : t.failure(u, c)),
      t.identity,
    );
  }
}
export type DefinedC = {} & DefinedType;
export const Defined: DefinedC = new DefinedType();

export const schemaId =
  'https://schemas.maas.global/maas-backend/subscriptions/subscription.json';

// SubscriptionItemId
// Identifier for matching the plans (Chargebee compat.)
export type SubscriptionItemId = t.Branded<string, SubscriptionItemIdBrand>;
export type SubscriptionItemIdC = t.BrandC<t.StringC, SubscriptionItemIdBrand>;
export const SubscriptionItemId: SubscriptionItemIdC = t.brand(
  t.string,
  (x): x is t.Branded<string, SubscriptionItemIdBrand> =>
    typeof x !== 'string' || x.match(RegExp('^[^\\s\\/]{1,50}$', 'u')) !== null,
  'SubscriptionItemId',
);
export type SubscriptionItemIdBrand = {
  readonly SubscriptionItemId: unique symbol;
};

// Price
// The purpose of this remains a mystery
export type Price = t.Branded<Cost_250f_.Cost, PriceBrand>;
export type PriceC = t.BrandC<typeof Cost_250f_.Cost, PriceBrand>;
export const Price: PriceC = t.brand(
  Cost_250f_.Cost,
  (x): x is t.Branded<Cost_250f_.Cost, PriceBrand> => true,
  'Price',
);
export type PriceBrand = {
  readonly Price: unique symbol;
};

// Plan
// Customer subscription plan
export type Plan = t.Branded<
  ({
    id?: SubscriptionItemId;
    name?: string;
    description?: string;
    price?: Price;
  } & Record<string, unknown>) & {
    id: Defined;
  },
  PlanBrand
>;
export type PlanC = t.BrandC<
  t.IntersectionC<
    [
      t.IntersectionC<
        [
          t.PartialC<{
            id: typeof SubscriptionItemId;
            name: t.StringC;
            description: t.StringC;
            price: typeof Price;
          }>,
          t.RecordC<t.StringC, t.UnknownC>,
        ]
      >,
      t.TypeC<{
        id: typeof Defined;
      }>,
    ]
  >,
  PlanBrand
>;
export const Plan: PlanC = t.brand(
  t.intersection([
    t.intersection([
      t.partial({
        id: SubscriptionItemId,
        name: t.string,
        description: t.string,
        price: Price,
      }),
      t.record(t.string, t.unknown),
    ]),
    t.type({
      id: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    ({
      id?: SubscriptionItemId;
      name?: string;
      description?: string;
      price?: Price;
    } & Record<string, unknown>) & {
      id: Defined;
    },
    PlanBrand
  > => true,
  'Plan',
);
export type PlanBrand = {
  readonly Plan: unique symbol;
};

// Quantity
// The purpose of this remains a mystery
export type Quantity = t.Branded<number, QuantityBrand>;
export type QuantityC = t.BrandC<t.NumberC, QuantityBrand>;
export const Quantity: QuantityC = t.brand(
  t.number,
  (x): x is t.Branded<number, QuantityBrand> =>
    (typeof x !== 'number' || x <= 200000) && Number.isInteger(x),
  'Quantity',
);
export type QuantityBrand = {
  readonly Quantity: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Quantity)).decodeSync(examplesQuantity) // => examplesQuantity */
export const examplesQuantity: NonEmptyArray<Quantity> = [
  0, 151280, 200000,
] as unknown as NonEmptyArray<Quantity>;
// NEGATIVE Test Case: over maximum
/** require('io-ts-validator').validator(Quantity).decodeEither(200001)._tag // => 'Left' */
/** require('io-ts-validator').validator(Quantity).decodeSync(defaultQuantity) // => defaultQuantity */
export const defaultQuantity: Quantity = 1 as unknown as Quantity;
/** require('io-ts-validator').validator(Quantity).decodeSync(minimumQuantity) // => minimumQuantity */
export const minimumQuantity: Quantity = 0 as unknown as Quantity;
/** require('io-ts-validator').validator(Quantity).decodeSync(maximumQuantity) // => maximumQuantity */
export const maximumQuantity: Quantity = 200000 as unknown as Quantity;

// Addon
// Customer subscription add-ons
export type Addon = t.Branded<
  ({
    id?: SubscriptionItemId;
    name?: string;
    description?: string;
    quantity?: Quantity;
    unitPrice?: Price;
    image?: Units_c404_.Url;
    virtualCardIssue?: ({
      providerName?: string;
    } & Record<string, unknown>) & {
      providerName: Defined;
    };
    productProviderIds?: Array<string>;
  } & Record<string, unknown>) & {
    id: Defined;
    quantity: Defined;
  },
  AddonBrand
>;
export type AddonC = t.BrandC<
  t.IntersectionC<
    [
      t.IntersectionC<
        [
          t.PartialC<{
            id: typeof SubscriptionItemId;
            name: t.StringC;
            description: t.StringC;
            quantity: typeof Quantity;
            unitPrice: typeof Price;
            image: typeof Units_c404_.Url;
            virtualCardIssue: t.IntersectionC<
              [
                t.IntersectionC<
                  [
                    t.PartialC<{
                      providerName: t.StringC;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>,
                  ]
                >,
                t.TypeC<{
                  providerName: typeof Defined;
                }>,
              ]
            >;
            productProviderIds: t.ArrayC<t.StringC>;
          }>,
          t.RecordC<t.StringC, t.UnknownC>,
        ]
      >,
      t.TypeC<{
        id: typeof Defined;
        quantity: typeof Defined;
      }>,
    ]
  >,
  AddonBrand
>;
export const Addon: AddonC = t.brand(
  t.intersection([
    t.intersection([
      t.partial({
        id: SubscriptionItemId,
        name: t.string,
        description: t.string,
        quantity: Quantity,
        unitPrice: Price,
        image: Units_c404_.Url,
        virtualCardIssue: t.intersection([
          t.intersection([
            t.partial({
              providerName: t.string,
            }),
            t.record(t.string, t.unknown),
          ]),
          t.type({
            providerName: Defined,
          }),
        ]),
        productProviderIds: t.array(t.string),
      }),
      t.record(t.string, t.unknown),
    ]),
    t.type({
      id: Defined,
      quantity: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    ({
      id?: SubscriptionItemId;
      name?: string;
      description?: string;
      quantity?: Quantity;
      unitPrice?: Price;
      image?: Units_c404_.Url;
      virtualCardIssue?: ({
        providerName?: string;
      } & Record<string, unknown>) & {
        providerName: Defined;
      };
      productProviderIds?: Array<string>;
    } & Record<string, unknown>) & {
      id: Defined;
      quantity: Defined;
    },
    AddonBrand
  > => true,
  'Addon',
);
export type AddonBrand = {
  readonly Addon: unique symbol;
};

// Coupon
// Additional coupon that may provide discounts
export type Coupon = t.Branded<
  ({
    id?: SubscriptionItemId;
    name?: string;
    description?: string;
  } & Record<string, unknown>) & {
    id: Defined;
  },
  CouponBrand
>;
export type CouponC = t.BrandC<
  t.IntersectionC<
    [
      t.IntersectionC<
        [
          t.PartialC<{
            id: typeof SubscriptionItemId;
            name: t.StringC;
            description: t.StringC;
          }>,
          t.RecordC<t.StringC, t.UnknownC>,
        ]
      >,
      t.TypeC<{
        id: typeof Defined;
      }>,
    ]
  >,
  CouponBrand
>;
export const Coupon: CouponC = t.brand(
  t.intersection([
    t.intersection([
      t.partial({
        id: SubscriptionItemId,
        name: t.string,
        description: t.string,
      }),
      t.record(t.string, t.unknown),
    ]),
    t.type({
      id: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    ({
      id?: SubscriptionItemId;
      name?: string;
      description?: string;
    } & Record<string, unknown>) & {
      id: Defined;
    },
    CouponBrand
  > => true,
  'Coupon',
);
export type CouponBrand = {
  readonly Coupon: unique symbol;
};

// Benefit
// Additional information about benefit used to purchase subscription
export type Benefit = t.Branded<
  ({
    name?: string;
    cycles?: number;
    startTime?: Units_c404_.Time;
  } & Record<string, unknown>) & {
    name: Defined;
  },
  BenefitBrand
>;
export type BenefitC = t.BrandC<
  t.IntersectionC<
    [
      t.IntersectionC<
        [
          t.PartialC<{
            name: t.StringC;
            cycles: t.NumberC;
            startTime: typeof Units_c404_.Time;
          }>,
          t.RecordC<t.StringC, t.UnknownC>,
        ]
      >,
      t.TypeC<{
        name: typeof Defined;
      }>,
    ]
  >,
  BenefitBrand
>;
export const Benefit: BenefitC = t.brand(
  t.intersection([
    t.intersection([
      t.partial({
        name: t.string,
        cycles: t.number,
        startTime: Units_c404_.Time,
      }),
      t.record(t.string, t.unknown),
    ]),
    t.type({
      name: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    ({
      name?: string;
      cycles?: number;
      startTime?: Units_c404_.Time;
    } & Record<string, unknown>) & {
      name: Defined;
    },
    BenefitBrand
  > => true,
  'Benefit',
);
export type BenefitBrand = {
  readonly Benefit: unique symbol;
};

// Terms
// Terms related to this subscription
export type Terms = t.Branded<
  ({
    activated?: Units_c404_.Time;
    modified?: Units_c404_.Time;
    validity?: ({
      startTime?: Units_c404_.Time;
      endTime?: Units_c404_.Time;
    } & Record<string, unknown>) & {
      startTime: Defined;
      endTime: Defined;
    };
    scheduledChanges?: boolean;
  } & Record<string, unknown>) & {
    validity: Defined;
  },
  TermsBrand
>;
export type TermsC = t.BrandC<
  t.IntersectionC<
    [
      t.IntersectionC<
        [
          t.PartialC<{
            activated: typeof Units_c404_.Time;
            modified: typeof Units_c404_.Time;
            validity: t.IntersectionC<
              [
                t.IntersectionC<
                  [
                    t.PartialC<{
                      startTime: typeof Units_c404_.Time;
                      endTime: typeof Units_c404_.Time;
                    }>,
                    t.RecordC<t.StringC, t.UnknownC>,
                  ]
                >,
                t.TypeC<{
                  startTime: typeof Defined;
                  endTime: typeof Defined;
                }>,
              ]
            >;
            scheduledChanges: t.BooleanC;
          }>,
          t.RecordC<t.StringC, t.UnknownC>,
        ]
      >,
      t.TypeC<{
        validity: typeof Defined;
      }>,
    ]
  >,
  TermsBrand
>;
export const Terms: TermsC = t.brand(
  t.intersection([
    t.intersection([
      t.partial({
        activated: Units_c404_.Time,
        modified: Units_c404_.Time,
        validity: t.intersection([
          t.intersection([
            t.partial({
              startTime: Units_c404_.Time,
              endTime: Units_c404_.Time,
            }),
            t.record(t.string, t.unknown),
          ]),
          t.type({
            startTime: Defined,
            endTime: Defined,
          }),
        ]),
        scheduledChanges: t.boolean,
      }),
      t.record(t.string, t.unknown),
    ]),
    t.type({
      validity: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    ({
      activated?: Units_c404_.Time;
      modified?: Units_c404_.Time;
      validity?: ({
        startTime?: Units_c404_.Time;
        endTime?: Units_c404_.Time;
      } & Record<string, unknown>) & {
        startTime: Defined;
        endTime: Defined;
      };
      scheduledChanges?: boolean;
    } & Record<string, unknown>) & {
      validity: Defined;
    },
    TermsBrand
  > => true,
  'Terms',
);
export type TermsBrand = {
  readonly Terms: unique symbol;
};

// SubscriptionBase
// The purpose of this remains a mystery
export type SubscriptionBase = t.Branded<
  {
    id?: Contact_56e9_.IdentityId;
    customerId?: Contact_56e9_.IdentityId;
    plan?: Plan;
    addons?: Array<Addon>;
    coupons?: Array<Coupon>;
    benefits?: Array<Benefit>;
    terms?: Terms;
    pointCost?: PointCost_5d0d_.PointCost;
    region?: Region_ad49_.Region;
    shippingAddress?: SubscriptionAddress_8e26_.SubscriptionAddress;
    availability?: Record<string, unknown>;
    name?: string;
    description?: string;
    meta?: Record<string, unknown>;
    level?: number;
    wmpGrant?: number;
    creditGrant?: number;
    creditCurrency?: Units_c404_.Currency;
    active?: boolean;
    hidden?: boolean;
    selectable?: boolean;
    topUpId?: string;
    changeState?: SubscriptionChangeState_e96c_.SubscriptionChangeState;
    cycles?: number;
  } & Record<string, unknown>,
  SubscriptionBaseBrand
>;
export type SubscriptionBaseC = t.BrandC<
  t.IntersectionC<
    [
      t.PartialC<{
        id: typeof Contact_56e9_.IdentityId;
        customerId: typeof Contact_56e9_.IdentityId;
        plan: typeof Plan;
        addons: t.ArrayC<typeof Addon>;
        coupons: t.ArrayC<typeof Coupon>;
        benefits: t.ArrayC<typeof Benefit>;
        terms: typeof Terms;
        pointCost: typeof PointCost_5d0d_.PointCost;
        region: typeof Region_ad49_.Region;
        shippingAddress: typeof SubscriptionAddress_8e26_.SubscriptionAddress;
        availability: t.RecordC<t.StringC, t.UnknownC>;
        name: t.StringC;
        description: t.StringC;
        meta: t.RecordC<t.StringC, t.UnknownC>;
        level: t.NumberC;
        wmpGrant: t.NumberC;
        creditGrant: t.NumberC;
        creditCurrency: typeof Units_c404_.Currency;
        active: t.BooleanC;
        hidden: t.BooleanC;
        selectable: t.BooleanC;
        topUpId: t.StringC;
        changeState: typeof SubscriptionChangeState_e96c_.SubscriptionChangeState;
        cycles: t.NumberC;
      }>,
      t.RecordC<t.StringC, t.UnknownC>,
    ]
  >,
  SubscriptionBaseBrand
>;
export const SubscriptionBase: SubscriptionBaseC = t.brand(
  t.intersection([
    t.partial({
      id: Contact_56e9_.IdentityId,
      customerId: Contact_56e9_.IdentityId,
      plan: Plan,
      addons: t.array(Addon),
      coupons: t.array(Coupon),
      benefits: t.array(Benefit),
      terms: Terms,
      pointCost: PointCost_5d0d_.PointCost,
      region: Region_ad49_.Region,
      shippingAddress: SubscriptionAddress_8e26_.SubscriptionAddress,
      availability: t.record(t.string, t.unknown),
      name: t.string,
      description: t.string,
      meta: t.record(t.string, t.unknown),
      level: t.number,
      wmpGrant: t.number,
      creditGrant: t.number,
      creditCurrency: Units_c404_.Currency,
      active: t.boolean,
      hidden: t.boolean,
      selectable: t.boolean,
      topUpId: t.string,
      changeState: SubscriptionChangeState_e96c_.SubscriptionChangeState,
      cycles: t.number,
    }),
    t.record(t.string, t.unknown),
  ]),
  (
    x,
  ): x is t.Branded<
    {
      id?: Contact_56e9_.IdentityId;
      customerId?: Contact_56e9_.IdentityId;
      plan?: Plan;
      addons?: Array<Addon>;
      coupons?: Array<Coupon>;
      benefits?: Array<Benefit>;
      terms?: Terms;
      pointCost?: PointCost_5d0d_.PointCost;
      region?: Region_ad49_.Region;
      shippingAddress?: SubscriptionAddress_8e26_.SubscriptionAddress;
      availability?: Record<string, unknown>;
      name?: string;
      description?: string;
      meta?: Record<string, unknown>;
      level?: number;
      wmpGrant?: number;
      creditGrant?: number;
      creditCurrency?: Units_c404_.Currency;
      active?: boolean;
      hidden?: boolean;
      selectable?: boolean;
      topUpId?: string;
      changeState?: SubscriptionChangeState_e96c_.SubscriptionChangeState;
      cycles?: number;
    } & Record<string, unknown>,
    SubscriptionBaseBrand
  > => true,
  'SubscriptionBase',
);
export type SubscriptionBaseBrand = {
  readonly SubscriptionBase: unique symbol;
};

// Subscription
// The purpose of this remains a mystery
export type Subscription = t.Branded<
  SubscriptionBase &
    (Record<string, unknown> & {
      plan: Defined;
      addons: Defined;
      coupons: Defined;
      changeState: Defined;
    }),
  SubscriptionBrand
>;
export type SubscriptionC = t.BrandC<
  t.IntersectionC<
    [
      typeof SubscriptionBase,
      t.IntersectionC<
        [
          t.RecordC<t.StringC, t.UnknownC>,
          t.TypeC<{
            plan: typeof Defined;
            addons: typeof Defined;
            coupons: typeof Defined;
            changeState: typeof Defined;
          }>,
        ]
      >,
    ]
  >,
  SubscriptionBrand
>;
export const Subscription: SubscriptionC = t.brand(
  t.intersection([
    SubscriptionBase,
    t.intersection([
      t.record(t.string, t.unknown),
      t.type({
        plan: Defined,
        addons: Defined,
        coupons: Defined,
        changeState: Defined,
      }),
    ]),
  ]),
  (
    x,
  ): x is t.Branded<
    SubscriptionBase &
      (Record<string, unknown> & {
        plan: Defined;
        addons: Defined;
        coupons: Defined;
        changeState: Defined;
      }),
    SubscriptionBrand
  > => true,
  'Subscription',
);
export type SubscriptionBrand = {
  readonly Subscription: unique symbol;
};

// SubscriptionCreatePayload
// The purpose of this remains a mystery
export type SubscriptionCreatePayload = t.Branded<
  SubscriptionBase &
    (Record<string, unknown> & {
      plan: Defined;
      addons: Defined;
    }),
  SubscriptionCreatePayloadBrand
>;
export type SubscriptionCreatePayloadC = t.BrandC<
  t.IntersectionC<
    [
      typeof SubscriptionBase,
      t.IntersectionC<
        [
          t.RecordC<t.StringC, t.UnknownC>,
          t.TypeC<{
            plan: typeof Defined;
            addons: typeof Defined;
          }>,
        ]
      >,
    ]
  >,
  SubscriptionCreatePayloadBrand
>;
export const SubscriptionCreatePayload: SubscriptionCreatePayloadC = t.brand(
  t.intersection([
    SubscriptionBase,
    t.intersection([
      t.record(t.string, t.unknown),
      t.type({
        plan: Defined,
        addons: Defined,
      }),
    ]),
  ]),
  (
    x,
  ): x is t.Branded<
    SubscriptionBase &
      (Record<string, unknown> & {
        plan: Defined;
        addons: Defined;
      }),
    SubscriptionCreatePayloadBrand
  > => true,
  'SubscriptionCreatePayload',
);
export type SubscriptionCreatePayloadBrand = {
  readonly SubscriptionCreatePayload: unique symbol;
};

// SubscriptionUpdatePayload
// The purpose of this remains a mystery
export type SubscriptionUpdatePayload = t.Branded<
  SubscriptionBase & (Record<string, unknown> & {}),
  SubscriptionUpdatePayloadBrand
>;
export type SubscriptionUpdatePayloadC = t.BrandC<
  t.IntersectionC<
    [
      typeof SubscriptionBase,
      t.IntersectionC<[t.RecordC<t.StringC, t.UnknownC>, t.TypeC<{}>]>,
    ]
  >,
  SubscriptionUpdatePayloadBrand
>;
export const SubscriptionUpdatePayload: SubscriptionUpdatePayloadC = t.brand(
  t.intersection([
    SubscriptionBase,
    t.intersection([t.record(t.string, t.unknown), t.type({})]),
  ]),
  (
    x,
  ): x is t.Branded<
    SubscriptionBase & (Record<string, unknown> & {}),
    SubscriptionUpdatePayloadBrand
  > => true,
  'SubscriptionUpdatePayload',
);
export type SubscriptionUpdatePayloadBrand = {
  readonly SubscriptionUpdatePayload: unique symbol;
};

// Success
