/*

undefined
Response schema for creating a booking through a TSP adapter

!!! AUTO GENERATED BY IOTSFJS REFRAIN FROM MANUAL EDITING !!!
See https://www.npmjs.com/package/io-ts-from-json-schema

*/

import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import { nonEmptyArray } from 'io-ts-types/lib/nonEmptyArray';

import * as Booking_4353_ from '../../core/booking';
import * as BookingMeta_c057_ from '../../core/booking-meta';
import * as BookingOption_9a80_ from '../../core/booking-option';
import * as Configurator_2e96_ from '../../core/components/configurator';
import * as CustomerSelection_57c3_ from '../../core/components/customerSelection';
import * as State_2db3_ from '../../core/components/state';

export type Defined = {} | null;
export class DefinedType extends t.Type<Defined> {
  readonly _tag: 'DefinedType' = 'DefinedType';
  constructor() {
    super(
      'defined',
      (u): u is Defined => typeof u !== 'undefined',
      (u, c) => (this.is(u) ? t.success(u) : t.failure(u, c)),
      t.identity,
    );
  }
}
export type DefinedC = {} & DefinedType;
export const Defined: DefinedC = new DefinedType();

export const schemaId = 'https://schemas.maas.global/tsp/booking-create/response.json';

// Response
// The default export. More information at the top.
export type Response = t.Branded<
  {
    tspId?: Booking_4353_.TspId;
    state?: State_2db3_.BookingState;
    cost?: Booking_4353_.Cost;
    leg?: BookingOption_9a80_.Leg;
    meta?: BookingMeta_c057_.BookingMeta;
    terms?: Booking_4353_.Terms;
    token?: Booking_4353_.Token;
    tspProduct?: BookingOption_9a80_.TspProduct;
    configurator?: Configurator_2e96_.Configurator;
    customerSelection?: CustomerSelection_57c3_.CustomerSelection;
    customer?: BookingOption_9a80_.Customer;
  } & {
    tspId: Defined;
    state: Defined;
    meta: Defined;
    terms: Defined;
    token: Defined;
    tspProduct: Defined;
  },
  ResponseBrand
>;
export type ResponseC = t.BrandC<
  t.IntersectionC<
    [
      t.PartialC<{
        tspId: typeof Booking_4353_.TspId;
        state: typeof State_2db3_.BookingState;
        cost: typeof Booking_4353_.Cost;
        leg: typeof BookingOption_9a80_.Leg;
        meta: typeof BookingMeta_c057_.BookingMeta;
        terms: typeof Booking_4353_.Terms;
        token: typeof Booking_4353_.Token;
        tspProduct: typeof BookingOption_9a80_.TspProduct;
        configurator: typeof Configurator_2e96_.Configurator;
        customerSelection: typeof CustomerSelection_57c3_.CustomerSelection;
        customer: typeof BookingOption_9a80_.Customer;
      }>,
      t.TypeC<{
        tspId: typeof Defined;
        state: typeof Defined;
        meta: typeof Defined;
        terms: typeof Defined;
        token: typeof Defined;
        tspProduct: typeof Defined;
      }>,
    ]
  >,
  ResponseBrand
>;
export const Response: ResponseC = t.brand(
  t.intersection([
    t.partial({
      tspId: Booking_4353_.TspId,
      state: State_2db3_.BookingState,
      cost: Booking_4353_.Cost,
      leg: BookingOption_9a80_.Leg,
      meta: BookingMeta_c057_.BookingMeta,
      terms: Booking_4353_.Terms,
      token: Booking_4353_.Token,
      tspProduct: BookingOption_9a80_.TspProduct,
      configurator: Configurator_2e96_.Configurator,
      customerSelection: CustomerSelection_57c3_.CustomerSelection,
      customer: BookingOption_9a80_.Customer,
    }),
    t.type({
      tspId: Defined,
      state: Defined,
      meta: Defined,
      terms: Defined,
      token: Defined,
      tspProduct: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    {
      tspId?: Booking_4353_.TspId;
      state?: State_2db3_.BookingState;
      cost?: Booking_4353_.Cost;
      leg?: BookingOption_9a80_.Leg;
      meta?: BookingMeta_c057_.BookingMeta;
      terms?: Booking_4353_.Terms;
      token?: Booking_4353_.Token;
      tspProduct?: BookingOption_9a80_.TspProduct;
      configurator?: Configurator_2e96_.Configurator;
      customerSelection?: CustomerSelection_57c3_.CustomerSelection;
      customer?: BookingOption_9a80_.Customer;
    } & {
      tspId: Defined;
      state: Defined;
      meta: Defined;
      terms: Defined;
      token: Defined;
      tspProduct: Defined;
    },
    ResponseBrand
  > => true,
  'Response',
);
export type ResponseBrand = {
  readonly Response: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Response)).decodeSync(examplesResponse) // => examplesResponse */
export const examplesResponse: NonEmptyArray<Response> = [
  {
    leg: {
      from: {
        name: 'Siltasaarenkatu 1, Helsinki',
        address:
          'streetName:Siltasaarenkatu|streetNumber:1|city:Helsinki|zipCode:00530|country:Suomi',
        lat: 60.177252,
        lon: 24.950388,
      },
      to: {
        name: 'Ida Aalbergin tie 3, Helsinki',
        address:
          'streetName:Ida%20Aalbergin%20tie|streetNumber:1|city:Helsinki|zipCode:00400|country:Suomi',
        lat: 60.231538,
        lon: 24.892568,
      },
      startTime: 1572440451838,
      endTime: 1572441571838,
      mode: 'TAXI',
      departureDelay: 900000,
    },
    customer: {
      email: 'test@example.com',
      phone: '+358400001010',
      locale: 'en',
      clientId: 'whim',
      lastName: 'Tester',
      opaqueId: 'cafecaca',
      firstName: 'Test',
    },
    state: 'RESERVED',
    tspId: 'deadbeefdeadbeefdeadcafebeef',
    terms: {
      reusable: false,
      validity: { endTime: 1572355249017, startTime: 1572355193128 },
      reconcilable: false,
    },
    tspProduct: { id: 'testtaxi1-product1' },
    meta: {
      MODE_TAXI: {
        driver: {},
        taxiCenter: { name: 'Taksi Test1', phone: '+358400001010' },
        vehicleType: 'any',
      },
    },
    cost: { amount: 22, currency: 'EUR' },
    tspProductId: 'testtaxi1-product1',
    token: {},
  },
  {
    state: 'RESERVED',
    cost: { amount: 25428, currency: 'EUR' },
    terms: {},
    token: { type: 'SECURITY_CODE', value: '8b422bc40' },
    meta: {
      MODE_CAR: {
        image: 'https://www.sixt.de/php/fleet/vehicleimage?grp=XXAR&liso=FI&uci=1142',
        name: 'Mercedes-Maybach S-Class',
        description: 'Special Special, Automatic transmission',
        car: {
          passengers: 4,
          doors: [2, 3],
          luggage: [2, 2],
          transmission: 'manual',
          fuel: 'unspecified',
          classification: 'MBMN',
        },
      },
      success: true,
      id: '9841002737',
      security_code: '8b422bc40',
      price: 25428,
      reservation: {
        number: '9841002737',
        security_code: '8b422bc40',
        days: 30,
        currency: 'EUR',
        total: 25428,
        driver: {
          company: false,
          first_name: 'John',
          last_name: 'Doe',
          phone: '010 2345678',
        },
        car: {
          group: 'XXAR',
          examples: ['Mercedes-Maybach S-Class'],
          max_passengers: 4,
          doors: 4,
          image: 'https://www.sixt.de/php/fleet/vehicleimage?grp=XXAR&liso=FI&uci=1142',
          transmission: 'automatic',
          air_conditioning: true,
          restrictions: { minimum_age: 28, minimum_license_age: 5 },
          navigation: { available: true, included: false },
          baggage: { big: 2, small: 2 },
        },
        pickup: {
          station: 1142,
          amadeus_code: 'HELC01',
          date_time: '2016-09-16T13:00:00',
        },
        dropoff: {
          station: 1142,
          amadeus_code: 'HELC01',
          date_time: '2016-10-16T13:00:00',
        },
        out_of_hours: {
          pickup: { is_out_of_hours: false, details: null },
          dropoff: {
            is_out_of_hours: true,
            details:
              'Please park the Sixt vehicle outside of the gates in any Veho parking place. The keybox is located next to the entrance on Suuntajankatu street side.',
          },
        },
      },
    },
    tspProduct: { id: 'Sixt-xxar' },
    leg: {
      startTime: 1474020000000,
      endTime: 1476612000000,
      from: { lat: 60.204605, lon: 25.047902 },
      to: { lat: 60.204605, lon: 25.047902 },
      mode: 'CAR',
    },
    tspId: '9841002737',
  },
] as unknown as NonEmptyArray<Response>;
// NEGATIVE Test Case: Missing required fields [leg, customer, token] etc...
/** require('io-ts-validator').validator(Response).decodeEither({"customer":{"firstName":"John","lastName":"Doe","phone":109381023,"email":"john.doe@example.com"}})._tag // => 'Left' */

export default Response;

// Success

import "jest"
const __expect: jest.Expect = expect

    describe("examplesResponse", () => {
      it("examplesResponse", () => {
        __expect(require("io-ts-validator").validator(nonEmptyArray(Response)).decodeSync(examplesResponse)).toEqual(examplesResponse)})
    })
  

    describe("doctest", () => {
      it("doctest", () => {
        __expect(require("io-ts-validator").validator(Response).decodeEither({ "customer": { "firstName": "John", "lastName": "Doe", "phone": 109381023, "email": "john.doe@example.com" } })._tag).toEqual('Left')})
    })
  