/*

undefined
Request schema for getting options from a TSP adapter.

!!! AUTO GENERATED BY IOTSFJS REFRAIN FROM MANUAL EDITING !!!
See https://www.npmjs.com/package/io-ts-from-json-schema

*/

import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';
import * as t from 'io-ts';
import { nonEmptyArray } from 'io-ts-types/lib/nonEmptyArray';

import * as Booking_4353_ from '../../core/booking';
import * as Address_2d0a_ from '../../core/components/address';
import * as Common_ffba_ from '../../core/components/common';
import * as TravelMode_5e34_ from '../../core/components/travel-mode';
import * as Units_c404_ from '../../core/components/units';
import * as UnitsGeo_3e31_ from '../../core/components/units-geo';

export type Defined = {} | null;
export class DefinedType extends t.Type<Defined> {
  readonly _tag: 'DefinedType' = 'DefinedType';
  constructor() {
    super(
      'defined',
      (u): u is Defined => typeof u !== 'undefined',
      (u, c) => (this.is(u) ? t.success(u) : t.failure(u, c)),
      t.identity,
    );
  }
}
export type DefinedC = {} & DefinedType;
export const Defined: DefinedC = new DefinedType();

export const schemaId =
  'https://schemas.maas.global/tsp/booking-options-list/request.json';

// Request
// The default export. More information at the top.
export type Request = t.Branded<
  ({
    mode?: TravelMode_5e34_.TravelMode;
    startTime?: Units_c404_.Time;
    endTime?: Units_c404_.Time;
    from?: UnitsGeo_3e31_.ShortLocationString;
    fromName?: Address_2d0a_.PlaceName | string;
    fromAddress?: Address_2d0a_.ComponentAddress | string;
    fromRadius?: UnitsGeo_3e31_.Distance;
    to?: UnitsGeo_3e31_.ShortLocationString | string;
    toName?: Address_2d0a_.PlaceName | string;
    toAddress?: Address_2d0a_.ComponentAddress | string;
    toRadius?: UnitsGeo_3e31_.Distance;
    distance?: UnitsGeo_3e31_.Distance;
    extraOptions?: string;
    tspProductIds?: string;
    tspIdToExtend?: Booking_4353_.TspId;
    purchasingAppInstanceId?: Common_ffba_.AppInstanceId;
  } & Record<
    string,
    | TravelMode_5e34_.TravelMode
    | Units_c404_.Time
    | Units_c404_.Time
    | UnitsGeo_3e31_.ShortLocationString
    | (Address_2d0a_.PlaceName | string)
    | (Address_2d0a_.ComponentAddress | string)
    | UnitsGeo_3e31_.Distance
    | (UnitsGeo_3e31_.ShortLocationString | string)
    | (Address_2d0a_.PlaceName | string)
    | (Address_2d0a_.ComponentAddress | string)
    | UnitsGeo_3e31_.Distance
    | UnitsGeo_3e31_.Distance
    | string
    | string
    | Booking_4353_.TspId
    | Common_ffba_.AppInstanceId
    | (string | number | boolean)
  > &
    Record<string, unknown>) & {
    startTime: Defined;
    from: Defined;
  },
  RequestBrand
>;
export type RequestC = t.BrandC<
  t.IntersectionC<
    [
      t.IntersectionC<
        [
          t.PartialC<{
            mode: typeof TravelMode_5e34_.TravelMode;
            startTime: typeof Units_c404_.Time;
            endTime: typeof Units_c404_.Time;
            from: typeof UnitsGeo_3e31_.ShortLocationString;
            fromName: t.UnionC<[typeof Address_2d0a_.PlaceName, t.StringC]>;
            fromAddress: t.UnionC<[typeof Address_2d0a_.ComponentAddress, t.StringC]>;
            fromRadius: typeof UnitsGeo_3e31_.Distance;
            to: t.UnionC<[typeof UnitsGeo_3e31_.ShortLocationString, t.StringC]>;
            toName: t.UnionC<[typeof Address_2d0a_.PlaceName, t.StringC]>;
            toAddress: t.UnionC<[typeof Address_2d0a_.ComponentAddress, t.StringC]>;
            toRadius: typeof UnitsGeo_3e31_.Distance;
            distance: typeof UnitsGeo_3e31_.Distance;
            extraOptions: t.StringC;
            tspProductIds: t.StringC;
            tspIdToExtend: typeof Booking_4353_.TspId;
            purchasingAppInstanceId: typeof Common_ffba_.AppInstanceId;
          }>,
          t.RecordC<
            t.StringC,
            t.UnionC<
              [
                typeof TravelMode_5e34_.TravelMode,
                typeof Units_c404_.Time,
                typeof Units_c404_.Time,
                typeof UnitsGeo_3e31_.ShortLocationString,
                t.UnionC<[typeof Address_2d0a_.PlaceName, t.StringC]>,
                t.UnionC<[typeof Address_2d0a_.ComponentAddress, t.StringC]>,
                typeof UnitsGeo_3e31_.Distance,
                t.UnionC<[typeof UnitsGeo_3e31_.ShortLocationString, t.StringC]>,
                t.UnionC<[typeof Address_2d0a_.PlaceName, t.StringC]>,
                t.UnionC<[typeof Address_2d0a_.ComponentAddress, t.StringC]>,
                typeof UnitsGeo_3e31_.Distance,
                typeof UnitsGeo_3e31_.Distance,
                t.StringC,
                t.StringC,
                typeof Booking_4353_.TspId,
                typeof Common_ffba_.AppInstanceId,
                t.UnionC<[t.StringC, t.NumberC, t.BooleanC]>,
              ]
            >
          >,
          t.RecordC<t.StringC, t.UnknownC>,
        ]
      >,
      t.TypeC<{
        startTime: typeof Defined;
        from: typeof Defined;
      }>,
    ]
  >,
  RequestBrand
>;
export const Request: RequestC = t.brand(
  t.intersection([
    t.intersection([
      t.partial({
        mode: TravelMode_5e34_.TravelMode,
        startTime: Units_c404_.Time,
        endTime: Units_c404_.Time,
        from: UnitsGeo_3e31_.ShortLocationString,
        fromName: t.union([Address_2d0a_.PlaceName, t.string]),
        fromAddress: t.union([Address_2d0a_.ComponentAddress, t.string]),
        fromRadius: UnitsGeo_3e31_.Distance,
        to: t.union([UnitsGeo_3e31_.ShortLocationString, t.string]),
        toName: t.union([Address_2d0a_.PlaceName, t.string]),
        toAddress: t.union([Address_2d0a_.ComponentAddress, t.string]),
        toRadius: UnitsGeo_3e31_.Distance,
        distance: UnitsGeo_3e31_.Distance,
        extraOptions: t.string,
        tspProductIds: t.string,
        tspIdToExtend: Booking_4353_.TspId,
        purchasingAppInstanceId: Common_ffba_.AppInstanceId,
      }),
      t.record(
        t.string,
        t.union([
          TravelMode_5e34_.TravelMode,
          Units_c404_.Time,
          Units_c404_.Time,
          UnitsGeo_3e31_.ShortLocationString,
          t.union([Address_2d0a_.PlaceName, t.string]),
          t.union([Address_2d0a_.ComponentAddress, t.string]),
          UnitsGeo_3e31_.Distance,
          t.union([UnitsGeo_3e31_.ShortLocationString, t.string]),
          t.union([Address_2d0a_.PlaceName, t.string]),
          t.union([Address_2d0a_.ComponentAddress, t.string]),
          UnitsGeo_3e31_.Distance,
          UnitsGeo_3e31_.Distance,
          t.string,
          t.string,
          Booking_4353_.TspId,
          Common_ffba_.AppInstanceId,
          t.union([t.string, t.number, t.boolean]),
        ]),
      ),
      t.record(t.string, t.unknown),
    ]),
    t.type({
      startTime: Defined,
      from: Defined,
    }),
  ]),
  (
    x,
  ): x is t.Branded<
    ({
      mode?: TravelMode_5e34_.TravelMode;
      startTime?: Units_c404_.Time;
      endTime?: Units_c404_.Time;
      from?: UnitsGeo_3e31_.ShortLocationString;
      fromName?: Address_2d0a_.PlaceName | string;
      fromAddress?: Address_2d0a_.ComponentAddress | string;
      fromRadius?: UnitsGeo_3e31_.Distance;
      to?: UnitsGeo_3e31_.ShortLocationString | string;
      toName?: Address_2d0a_.PlaceName | string;
      toAddress?: Address_2d0a_.ComponentAddress | string;
      toRadius?: UnitsGeo_3e31_.Distance;
      distance?: UnitsGeo_3e31_.Distance;
      extraOptions?: string;
      tspProductIds?: string;
      tspIdToExtend?: Booking_4353_.TspId;
      purchasingAppInstanceId?: Common_ffba_.AppInstanceId;
    } & Record<
      string,
      | TravelMode_5e34_.TravelMode
      | Units_c404_.Time
      | Units_c404_.Time
      | UnitsGeo_3e31_.ShortLocationString
      | (Address_2d0a_.PlaceName | string)
      | (Address_2d0a_.ComponentAddress | string)
      | UnitsGeo_3e31_.Distance
      | (UnitsGeo_3e31_.ShortLocationString | string)
      | (Address_2d0a_.PlaceName | string)
      | (Address_2d0a_.ComponentAddress | string)
      | UnitsGeo_3e31_.Distance
      | UnitsGeo_3e31_.Distance
      | string
      | string
      | Booking_4353_.TspId
      | Common_ffba_.AppInstanceId
      | (string | number | boolean)
    > &
      Record<string, unknown>) & {
      startTime: Defined;
      from: Defined;
    },
    RequestBrand
  > => true,
  'Request',
);
export type RequestBrand = {
  readonly Request: unique symbol;
};
/** require('io-ts-validator').validator(nonEmptyArray(Request)).decodeSync(examplesRequest) // => examplesRequest */
export const examplesRequest: NonEmptyArray<Request> = [
  {
    mode: 'TAXI',
    startTime: 1475850000000,
    endTime: 1475860000000,
    from: '-60.00,24.00',
    to: '+60.05,-24.05',
    fromRadius: 100,
    toRadius: 10,
  },
] as unknown as NonEmptyArray<Request>;

export default Request;

// Success

import "jest"
const __expect: jest.Expect = expect

    describe("examplesRequest", () => {
      it("examplesRequest", () => {
        __expect(require("io-ts-validator").validator(nonEmptyArray(Request)).decodeSync(examplesRequest)).toEqual(examplesRequest)})
    })
  